-- -------------------
--                  --
--    hg19heatmap   --
--                  --
-- -------------------
drop table if exists config;
create table config (
  bbiPath text not null,
  2bitFile text not null,
  defaultTracks text not null,
  defaultMdcategory varchar(255) not null,
  defaultGenelist text not null,
  defaultCustombigwig varchar(255) not null,
  defaultCustombigbed varchar(255) not null,
  defaultCustombam varchar(255) not null,
  defaultPosition varchar(255) not null,
  defaultDecor0 text null,
  defaultDecor8 text null,
  defaultScaffold text null,
  sampleHub text null,
  ideogram_wiggle1 varchar(255) null,
  ideogram_wiggle2 varchar(255) null,
  hasGene boolean not null,
  allowJuxtaposition boolean not null,
  keggSpeciesCode varchar(255) not null,
  information text not null,
  chromSizeFile varchar(255) not null
);
insert into config values(
'/home/xzhou/data/hg19/bigWig/',
'/home/xzhou/data/hg19/hg19.2bit',
-- "/srv/epgg/data/data/subtleKnife/hg19/",
-- "/srv/epgg/data/data/subtleKnife/hg19.2bit",
"GSM450236,GSM428286,GSM613907,GSM613837,GSM613829,GSM493626,GSM613920,GSM613901,GSM543011,GSM543016,GSM456941,GSM613859,GSM613853,GSM613847,GSM543019,GSM669607,GSM613913,GSM543025,GSM537665,GSM537626,GSM669893,GSM669889,GSM613874,GSM537622,GSM537632,GSM486711,GSM486709,GSM537664,GSM537625,GSM669894,GSM669886,GSM613875,GSM537635,GSM537654,GSM486712,GSM486710,",
"DNA Methylation,Histone Mark,ES/iPS Cells,Breast,Blood,Institution",
"CYP4Z1\\nCYP2A7\\nCYP2A6\\nCYP3A4\\nCYP1A1\\nCYP4V2\\nCYP51A1\\nCYP2C19\\nCYP26B1\\nCYP11B2\\nCYP24A1\\nCYP4B1\\nCYP2C8",
"http://epigenomegateway.wustl.edu/browser/hg19/sample.bigWig",
"http://epigenomegateway.wustl.edu/browser/hg19/sample.bigBed",
"http://epigenomegateway.wustl.edu/browser/hg19/hg19sample.bam",
"chr10,21000000,chr10,26000001",
"knownGene,full,",
\N,
"chr1,chr2,chr3,chr4,chr5,chr6,chr7,chr8,chr9,chr10,chr11,chr12,chr13,chr14,chr15,chr16,chr17,chr18,chr19,chr20,chr21,chr22,chrX,chrY,chrM",
"http://remc.wustl.edu/xzhou/hub.txt",
"knownGene,0",
\N,
true,
true,
"hsa",
"Assembly version|hg19|Sequence source|<a href=http://hgdownload.cse.ucsc.edu/goldenPath/hg19/bigZips/ target=_blank>UCSC browser</a>|Date parsed|June 1, 2011|Chromosomes|25|Contigs & misc|68|Total bases|3,137,144,693|Logo art|<a href=http://turing.iimas.unam.mx/~cgg/gallery/EverybodysHive.html target=_blank>link</a>",
"/srv/epgg/data/data/subtleKnife/hg19.chromSize"
);


-- grouping types on genomic features
-- table name defined in macro: TBN_GF_GRP
drop table if exists gfGrouping;
create table gfGrouping (
  id TINYINT not null primary key,
  name char(50) not null
);
insert into gfGrouping values (2, "Genes");
-- insert into gfGrouping values (3, "non-coding RNA");
insert into gfGrouping values (4, "RepeatMasker");
insert into gfGrouping values (6, "Sequence conservation");
insert into gfGrouping values (5, "Others");


-- for genomic features that can be used as horizontal axis
-- each type of gf (except genome) will have a corresponding covering table


-- for stuff that can be plotted as decorative tracks (no genome)
-- the grp is also from gfGrouping table
-- filetype: 0: server bigBed, 2: server bigWig
-- name will be used to compose bbi file "name.bigBed"
drop table if exists decorInfo;
create table decorInfo (
  name char(50) not null primary key,
  printname char(100) not null,
  parent char(50) null,
  grp tinyint not null,
  fileType tinyint not null,
  hasStruct tinyint null,
  queryUrl varchar(255) null
);
insert into decorInfo values('knownGene','UCSC genes',\N,2,0,1,'http://genome.ucsc.edu/cgi-bin/hgGene?hgg_type=knownGene&db=hg19&hgg_gene=');
insert into decorInfo values('knownGenepromoter','promoters (UCSC genes)','knownGene',2,0,0,\N);
insert into decorInfo values('knownGeneutr3',"3' UTRs (UCSC genes)",'knownGene',2,0,0,\N);
insert into decorInfo values('knownGeneutr5',"5' UTRs (UCSC genes)",'knownGene',2,0,0,\N);
insert into decorInfo values('knownGeneexons','exons (UCSC genes)','knownGene',2,0,0,\N);
insert into decorInfo values('knownGeneintrons','introns (UCSC genes)','knownGene',2,0,0,\N);

insert into decorInfo values('refGene','RefSeq genes',\N,2,0,1,'http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=Search&db=Nucleotide&doptcmdl=GenBank&term=');
insert into decorInfo values('refGenepromoter','promoters (RefSeq genes)','refGene',2,0,0,\N);
insert into decorInfo values('refGeneutr3',"3' UTRs (RefSeq genes)",'refGene',2,0,0,\N);
insert into decorInfo values('refGeneutr5',"5' UTRs (RefSeq genes)",'refGene',2,0,0,\N);
insert into decorInfo values('refGeneexons','exons (RefSeq genes)','refGene',2,0,0,\N);
insert into decorInfo values('refGeneintrons','introns (RefSeq genes)','refGene',2,0,0,\N);
insert into decorInfo values('ensGene','Ensembl genes',\N,2,0,1,'http://www.ensembl.org/Homo_sapiens/geneview?gene=');
insert into decorInfo values('ensGenepromoter','promoters (Ensembl genes)','ensGene',2,0,0,\N);
insert into decorInfo values('ensGeneutr3',"3' UTRs (Ensembl genes)",'ensGene',2,0,0,\N);
insert into decorInfo values('ensGeneutr5',"5' UTRs (Ensembl genes)",'ensGene',2,0,0,\N);
insert into decorInfo values('ensGeneexons','exons (Ensembl genes)','ensGene',2,0,0,\N);
insert into decorInfo values('ensGeneintrons','introns (Ensembl genes)','ensGene',2,0,0,\N);
insert into decorInfo values('gencodev11Gene','ENCODE/GENCODE genes v11',\N,2,0,1,'http://www.ensembl.org/Homo_sapiens/Transcript/Summary?db=core;t=');
insert into decorInfo values('gencodev11Genepromoter','promoters (ENCODE/GENCODE v11)','gencodev11Gene',2,0,0,\N);
insert into decorInfo values('gencodev11Geneutr3',"3' UTRs (ENCODE/GENCODE v11)",'gencodev11Gene',2,0,0,\N);
insert into decorInfo values('gencodev11Geneutr5',"5' UTRs (ENCODE/GENCODE v11)",'gencodev11Gene',2,0,0,\N);
insert into decorInfo values('gencodev11Geneexons','exons (ENCODE/GENCODE v11)','gencodev11Gene',2,0,0,\N);
insert into decorInfo values('gencodev11Geneintrons','introns (ENCODE/GENCODE v11)','gencodev11Gene',2,0,0,\N);
/*
insert into decorInfo values('ccdsGene','CCDS genes',\N,2,0,1,'http://www.ncbi.nlm.nih.gov/CCDS/CcdsBrowse.cgi?REQUEST=CCDS&BUILDS=ALLBUILDS&DATA=');
insert into decorInfo values('ccdsGeneexons','exons (CCDS genes)','ccdsGene',2,0,0,\N);
insert into decorInfo values('ccdsGeneintrons','introns (CCDS genes)','ccdsGene',2,0,0,\N);
insert into decorInfo values('vegaGene','Vega genes',\N,2,0,1,'http://vega.sanger.ac.uk/Homo_sapiens/geneview?gene=');
insert into decorInfo values('vegaGenepromoter','promoters (Vega genes)','vegaGene',2,0,0,\N);
insert into decorInfo values('vegaGeneutr3',"3' UTRs (Vega genes)",'vegaGene',2,0,0,\N);
insert into decorInfo values('vegaGeneutr5',"5' UTRs (Vega genes)",'vegaGene',2,0,0,\N);
insert into decorInfo values('vegaGeneexons','exons (Vega genes)','vegaGene',2,0,0,\N);
insert into decorInfo values('vegaGeneintrons','introns (Vega genes)','vegaGene',2,0,0,\N);
*/


insert into decorInfo values ('RNA','RNA',\N, 4, 0, 0,\N);
insert into decorInfo values ('RNAsrpRNA','srpRNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('RNArRNA','rRNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('RNAsnRNA','snRNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('RNAtRNA','tRNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('RNAscRNA','scRNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('RNARNA','RNA (RNA)',"RNA", 4, 0, 0,\N);
insert into decorInfo values ('DNA','DNA transposon',\N, 4, 0, 0,\N);
insert into decorInfo values ('DNAMerlin','Merlin (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNATcMar','TcMar (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNATcMar?','TcMar? (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAhAT-Tip100','hAT-Tip100 (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAhAT-Charlie','hAT-Charlie (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNATcMar-Mariner','TcMar-Mariner (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAMuDR','MuDR (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNADNA','DNA (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAPiggyBac','PiggyBac (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAPiggyBac?','PiggyBac? (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNATcMar-Tc2','TcMar-Tc2 (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAhAT-Blackjack','hAT-Blackjack (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNATcMar-Tigger','TcMar-Tigger (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAhAT','hAT (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('DNAhAT?','hAT? (DNA transposon)',"DNA", 4, 0, 0,\N);
insert into decorInfo values ('SINE','SINE', \N,4, 0, 0,\N);
insert into decorInfo values ('SINEMIR','MIR (SINE)', "SINE",4, 0, 0,\N);
insert into decorInfo values ('SINESINE','SINE (SINE)', "SINE",4, 0, 0,\N);
insert into decorInfo values ('SINEDeu','Deu (SINE)', "SINE",4, 0, 0,\N);
insert into decorInfo values ('SINEtRNA','tRNA (SINE)', "SINE",4, 0, 0,\N);
insert into decorInfo values ('SINEAlu','Alu (SINE)', "SINE",4, 0, 0,\N);
insert into decorInfo values ('LINE','LINE', \N,4, 0, 0,\N);
insert into decorInfo values ('LINERTE','RTE (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINERTE-BovB','RTE-BovB (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINEL2','L2 (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINEL1','L1 (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINEL1?','L1? (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINEDong-R4','Dong-R4 (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LINECR1','CR1 (LINE)', "LINE",4, 0, 0,\N);
insert into decorInfo values ('LTR','LTR', \N,4, 0, 0,\N);
insert into decorInfo values ('LTRERV','ERV (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRLTR','LTR (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRERVL','ERVL (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRERVL?','ERVL? (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRERVK','ERVK (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRERVL-MaLR','ERVL-MaLR (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRGypsy','Gypsy (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRGypsy?','Gypsy? (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('LTRERV1','ERV1 (LTR)', "LTR",4, 0, 0,\N);
insert into decorInfo values ('Low_complexity','low complexity', \N,4, 0, 0,\N);
insert into decorInfo values ('Satellite','satellite', \N,4, 0, 0,\N);
insert into decorInfo values ('SatelliteSatellite','Satellite (satellite)', "Satellite",4, 0, 0,\N);
insert into decorInfo values ('Satellitecentr','centr (satellite)', "Satellite",4, 0, 0,\N);
insert into decorInfo values ('Satelliteacro','acro (satellite)', "Satellite",4, 0, 0,\N);
insert into decorInfo values ('Satellitetelo','telo (satellite)', "Satellite",4, 0, 0,\N);
insert into decorInfo values ('Simple_repeat','simple repeat', \N,4, 0, 0,\N);
insert into decorInfo values ('Other','other repeats', \N,4, 0, 0,\N);
insert into decorInfo values ('Unknown','unknown', \N,4, 0, 0,\N);

insert into decorInfo values ('vertebratephastCons46way', 'vertebrate PhastCons', \N,6,8,0,\N);
insert into decorInfo values ('primatephastCons46way', 'primate PhastCons', \N,6,8,0,\N);
insert into decorInfo values ('placentalphastCons46way', 'placental PhastCons', \N,6,8,0,\N);
insert into decorInfo values ('vertebratephyloP46way', 'vertebrate PhyloP', \N,6,8,0,\N);
insert into decorInfo values ('primatephyloP46way', 'primate PhyloP', \N,6,8,0,\N);
insert into decorInfo values ('placentalphyloP46way', 'placental PhyloP', \N,6,8,0,\N);

insert into decorInfo values ('wgRna',"sno/miRNA",\N, 5, 0, 0,\N);
insert into decorInfo values ('cpgisland','CpG island', \N,5, 0, 0,\N);
insert into decorInfo values ('gc5Base','GC percent', \N,5, 8, 0,\N);




-- insert into decorInfo values ('masked','masked region', 5, 0);
-- insert into decorInfo values ('mappability','mappability', 5, 0);



-- grant ALL on hg19heatmap.session to 'nobody@localhost';
-- grant ALL on hg19heatmap.collateitemlist to 'nobody@localhost';


-- metadata related
/*
drop table if exists trackDetail;
create table trackDetail (
  name varchar(255) not null primary key,
  label varchar(255) not null,
  detail text null,
  geoAccession char(20) null,
  hasBAM boolean not null
);
load data local infile "trackDetail_roadmap" into table trackDetail;
load data local infile "trackDetail_remc5" into table trackDetail;
load data local infile "trackDetail_encode" into table trackDetail;
load data local infile "trackDetail_encode2" into table trackDetail;
load data local infile "trackDetail_test" into table trackDetail;
*/

-- new trackDetail from here

drop table if exists track2Label;
create table track2Label (
  name varchar(255) not null primary key,
  label text null
);
load data local infile 'track2Label_roadmap' into table track2Label;
load data local infile 'track2Label_encode' into table track2Label;

drop table if exists track2ProcessInfo;
create table track2ProcessInfo (
  name varchar(255) not null primary key,
  detail text null
);
load data local infile 'track2ProcessInfo_roadmap' into table track2ProcessInfo;
load data local infile 'track2ProcessInfo_encode' into table track2ProcessInfo;

drop table if exists track2BamInfo;
create table track2BamInfo (
  name varchar(255) not null,
  bamfile varchar(255) not null,
  bamfilelabel varchar(255) not null
);
load data local infile "track2BamInfo_roadmap" into table track2BamInfo;
load data local infile "track2BamInfo_encode" into table track2BamInfo;
load data local infile "track2BamInfo_test" into table track2BamInfo;

drop table if exists track2Detail;
create table track2Detail (
  name varchar(255) not null primary key,
  detail text null
);
load data local infile 'track2Detail_roadmap' into table track2Detail;
load data local infile 'track2Detail_encode' into table track2Detail;

drop table if exists track2GEO;
create table track2GEO (
  name varchar(255) not null primary key,
  geo char(20) not null
);
load data local infile 'track2GEO_roadmap' into table track2GEO;
load data local infile 'track2GEO_encode' into table track2GEO;

drop table if exists track2VersionInfo;
create table track2VersionInfo (
  name varchar(255) not null primary key,
  info varchar(255) not null
);
load data local infile 'track2VersionInfo_roadmap' into table track2VersionInfo;
load data local infile 'track2VersionInfo_encode' into table track2VersionInfo;

-- new trackDetail end here

-- trackAnnotation table here

drop table if exists trackAnnotation;
create table trackAnnotation (
  name varchar(255) not null primary key,
  attridx varchar(255) not null
);
load data local infile "trackAnnotation_roadmap" into table trackAnnotation;
load data local infile "trackAnnotation_remc5" into table trackAnnotation;
load data local infile "trackAnnotation_encode" into table trackAnnotation;
load data local infile "trackAnnotation_encode2" into table trackAnnotation;

drop table if exists metadataVocabulary;
create table metadataVocabulary (
  child varchar(255) not null,
  parent varchar(255) not null
);
load data local infile "metadataVocabulary" into table metadataVocabulary;

drop table if exists trackAttr2idx;
create table trackAttr2idx (
  idx varchar(255) not null primary key,
  attr varchar(255) not null,
  note varchar(255) null,
  description text null
);
load data local infile "trackAttr2idx" into table trackAttr2idx;


drop table if exists tempURL;
create table tempURL (
  session varchar(100) not null,
  offset INT unsigned not null,
  urlpiece text not null
);


drop table if exists dataset;
create table dataset (
  tablename varchar(255) not null,
  logo varchar(255) null,
  name varchar(255) not null,
  url varchar(255) null,
  description text not null
);
load data local infile "dataset" into table dataset;

drop table if exists roadmapepigenome;
create table roadmapepigenome (
  tkname varchar(255) not null
);
load data local infile "roadmap" into table roadmapepigenome;
load data local infile "remc5" into table roadmapepigenome;

drop table if exists mock;
create table mock (
  tkname varchar(255) not null
);
load data local infile "mock" into table mock;

drop table if exists encode;
create table encode(
  tkname varchar(255) not null
);
load data local infile "encode" into table encode;
load data local infile "encode2" into table encode;

drop table if exists scaffoldInfo;
create table scaffoldInfo (
  parent varchar(255) not null,
  child varchar(255) not null,
  childLength int unsigned not null
);
load data local infile "scaffoldInfo" into table scaffoldInfo;

drop table if exists cytoband;
create table cytoband (
  id int null auto_increment primary key,
  chrom char(20) not null,
  start int not null,
  stop int not null,
  name char(20) not null,
  colorIdx int not null
);
load data local infile "cytoband" into table cytoband;

/*
DROP TABLE IF EXISTS `rmsk`;
CREATE TABLE `rmsk` (
  `bin` smallint(5) unsigned NOT NULL default '0',
  `swScore` int(10) unsigned NOT NULL default '0',
  `milliDiv` int(10) unsigned NOT NULL default '0',
  `milliDel` int(10) unsigned NOT NULL default '0',
  `milliIns` int(10) unsigned NOT NULL default '0',
  `genoName` varchar(255) NOT NULL default '',
  `genoStart` int(10) unsigned NOT NULL default '0',
  `genoEnd` int(10) unsigned NOT NULL default '0',
  `genoLeft` int(11) NOT NULL default '0',
  `strand` char(1) NOT NULL default '',
  `repName` varchar(255) NOT NULL default '',
  `repClass` varchar(255) NOT NULL default '',
  `repFamily` varchar(255) NOT NULL default '',
  `repStart` int(11) NOT NULL default '0',
  `repEnd` int(11) NOT NULL default '0',
  `repLeft` int(11) NOT NULL default '0',
  `id` char(1) NOT NULL default '',
  KEY `genoName` (`genoName`(14),`bin`)
);
load data local infile 'rmsk.txt' into table rmsk;
*/

