import sys
import os

if len(sys.argv) != 3:
	print '''Usage: {0} <UCSC rmsk.txt> <chr size file> output to current dir
	one bigBed per class, one bigBed file per family
	make sure this script contains all class name
	To get class, run cut -f12 rmsk.txt|sort -u'''.format(sys.argv[0])
	sys.exit()


rmsk, chrsize = sys.argv[1:]
'''
a few xxRNA classes will be merged to RNA class, and each will have its own bigbed file

other classes will have their own bigbed, and one bigbed for each of its family
'''


fout = {}

if False:
	print 'reading how many RNA classes are there...'
	rnaclasses = set()
	with open(rmsk) as fin:
		for line in fin:
			lst = line.split('\t')
			if not lst[5].startswith('chr'):
				continue
			if 'RNA' in lst[11]:
				rnaclasses.add(lst[11])
	print 'RNA classes are', rnaclasses
	print 'generating bed files...'
	fout0 = open('RNA.bed','w')
	id0 = 0
	for f in rnaclasses:
		fout[f] = [open('RNA'+f+'.bed','w'), 0]

	with open(rmsk) as fin:
		for line in fin:
			lst = line.split('\t')
			if not lst[5].startswith('chr'):
				continue
			if lst[11] in rnaclasses:
				fout0.write('{0[5]}\t{0[6]}\t{0[7]}\t{0[10]}\t{1}\t{0[9]}\n'.format(lst, id0))
				id0 += 1
				fout[lst[11]][0].write('{0[5]}\t{0[6]}\t{0[7]}\t{0[10]}\t{1}\t{0[9]}\n'.format(lst, fout[lst[11]][1]))
				fout[lst[11]][1] += 1

	fout0.close()
	os.system('bedSort RNA.bed RNA.bed')
	os.system('bedToBigBed RNA.bed {0} RNA.bigBed'.format(chrsize))
	for f in rnaclasses:
		fout[f][0].close()
		os.system('bedSort RNA{0}.bed RNA{0}.bed'.format(f))
		os.system('bedToBigBed RNA{0}.bed {1} RNA{0}.bigBed'.format(f,chrsize))


# done with RNA


#classes = set(['SINE', 'LINE', 'LTR', 'DNA', 'Simple_repeat', 'Low_complexity', 'Satellite', 'Other', 'Unknown'])
classes = set(['DNA', 'LINE', 'Low_complexity', 'LTR', 'Other', 'RC', 'RNA', 'rRNA', 'Satellite', 'Simple_repeat', 'Unknown'])

f2c = {} # family to class

print 'surveying family-to-class...'
with open(sys.argv[1]) as fin:
	for line in fin:
		lst = line.split('\t')
		if not lst[5].startswith('chr'):
			continue
		classname = lst[11]
		if '?' in lst[11]:
			classname = lst[11].replace('?','')
		if classname in classes:
			f2c[lst[12]] = classname
if True:
	# print c2f for scrutiny
	c2f = {}
	for c in classes: c2f[c] = []
	for f in f2c:
		c2f[f2c[f]].append(f)
	for c in c2f:
		print '{0} ---> {1}'.format(c,' '.join(c2f[c]))
	print

foutc = {}
for c in classes:
	foutc[c] = [open(c+'.bed','w'), 0, c]
fout = {}
for f in f2c:
	fout[f] = [open(f2c[f]+f+'.bed','w'), 0, f2c[f]+f]
print 'generating bed files...'
skip1 = 0
skip2 = 0
foutskip = open('skip.bed','w')
with open(sys.argv[1]) as fin:
	for line in fin:
		lst = line.split('\t')
		if not lst[5].startswith('chr'):
			skip1 += 1
			continue
		classname = lst[11]
		if '?' in lst[11]:
			classname = lst[11].replace('?','')
		if lst[12] in f2c and classname in classes:
			# this family
			fout[lst[12]][0].write('{0[5]}\t{0[6]}\t{0[7]}\t{0[10]}\t{1}\t{0[9]}\n'.format(lst, fout[lst[12]][1]))
			fout[lst[12]][1] += 1
			# its class
			foutc[classname][0].write('{0[5]}\t{0[6]}\t{0[7]}\t{0[10]}\t{1}\t{0[9]}\n'.format(lst, foutc[classname][1]))
			foutc[classname][1] += 1
		else:
			foutskip.write('{0[5]}\t{0[6]}\t{0[7]}\t{0[10]}\t{1}\n'.format(lst,classname))
			skip2 += 1
foutskip.close()

for f in fout:
	fout[f][0].close()
	cmd = 'bedSort {0}.bed {0}.bed'.format(fout[f][2])
	print cmd
	os.system(cmd)
	cmd = 'bedToBigBed {0}.bed {1} {0}.bigBed'.format(fout[f][2], chrsize)
	print cmd
	os.system(cmd)
	print
for f in foutc:
	foutc[f][0].close()
	cmd = 'bedSort {0}.bed {0}.bed'.format(foutc[f][2])
	print cmd
	os.system(cmd)
	cmd = 'bedToBigBed {0}.bed {1} {0}.bigBed'.format(foutc[f][2], chrsize)
	print cmd
	os.system(cmd)
	print

if skip1 > 0:
	print '{0} items skipped for not having "chrN" location'.format(skip1)
if skip2 > 0:
	print '{0} items skipped and writen to file "skip.bed", verify them to be RNA classes'.format(skip2)
