/**************************
	This file is copyrighted, but license is hereby granted for personal,
	academic, and non-profit use.
	Commercial users should contact twang@genetics.wustl.edu for permission.
 **************************/


var dbInfo = {}; // info on current db
//var dblist = [];
var urllenlimit = 4000; // url string length limit
var sessionId;
var statusId = 1;
var hmSpan; // serves viewbox width, and width of two hiding wings
var ordinaryTrackHeight = 50;
var densitydecorpaddingtop = 3; // density decor track padding top...
var leftColumnWidth = 110;
var tkAttrColumnWidth = 18;
var regionSpacing = {width:1,color:'#ccc'};
var thinStackHeight = 2;
var fullStackHeight = 9;
var ideoHeight = 14; // for plotting ideogram
var cbarHeight = 9;

// aligators, aligators, more aligators
var colorCentral = {longlst:["rgb(255,255,0)",
    "rgb(255,153,0)","rgb(51,102,255)","rgb(255,102,255)","rgb(51,153,0)",
    "rgb(255,204,0)","rgb(0,153,255)","rgb(255,153,255)","rgb(0,204,0)",
    "rgb(255,102,0)","rgb(0,51,255)","rgb(255,51,255)","rgb(51,102,0)",
    "rgb(255,0,0)","rgb(0,204,255)","rgb(255,204,255)","rgb(51,255,0)",
    "rgb(51,153,153)","rgb(153,0,102)","rgb(153,204,51)","rgb(204,102,102)",
    "rgb(143,143,255)","rgb(82,82,255)","rgb(255,82,171)","rgb(214,0,111)",
    "rgb(162,82,255)","rgb(134,20,255)","rgb(214,104,0)","rgb(0,11,214)",
    "rgb(102,51,51)","rgb(176,99,176)","rgb(102,51,102)","rgb(184,46,0)",
    "rgb(245,61,0)","rgb(184,138,0)","rgb(0,138,184)","rgb(100,61,255)",
    "rgb(153,0,0)","rgb(153,77,0)","rgb(214,107,0)","rgb(153,153,0)"
    ],
    foreground:'#000000',
    };
// cytoband, monotonic color
var cytoBandColor = [
	255, // gneg
	180, // gpos25
	120, // gpos50
	60, // gpos75
	0, // gpos100
	0, // gvar
	180, // stalk
	142, // gpos33
	57 // gpos66
	];
var cytoWordColor = [0,0,255,255,255,255,0,255,255];
var centromereColor = "rgb(141,64,52)";
var BLUE = "rgb(52,84,141)";
var GREEN = "rgb(0,153,0)";
var GREEN2 = "rgb(0,128,85)";
var YELLOW = "#FFF9D2";
var GRAY = "#aaa";
var Lpurple = "#AA839C"; // light purple, manual button bg color
var SRED = "#9e004f"; // soft red
var BLUE2 = "#004f9e"; // soft blue
var ntbcolor = {g:'#3899c7', c:'#e05144', t:'#9238c7', a:'#89c738', n:'#858585'};

var filetype2verbal = ['bigBed', 'custom bigBed', 'bigWig', 'custom bigWig', 'BAM', 'custom BAM', 'pwc log ratio', 'htest pvalues', 'bigWig'];

// metadata, see "data structure.dia"
var mdvidx2attr = {}; 
var mdvattr2idx = {};
var mdvc2p = {};
var mdvp2c = {};
var mdvroot = [];
// those that are on show, 
var mdcategoryOnshow = [];
var tsmdc_rows = []; // each element: [attr name, padding, img src]
var tsmdc_cols = [];
/**** temporary data holder used during new custom track submission ****/

var hmtk = {
    mdanno:{}, // annotation for all tracks, key: track name, val: hash of attr idx
    show:{objlst:[], // todo replace tkLst
          namelst:{} // todo replace tkNameLst
	 },
    custom:{}, // key: custom bigwig track name, val: hash of info
    tolabel:{} // huge hash storing name->label for all tracks in current data sets
    };
var tracklabelholder;
var tkNameLst = []; // for ordering tracks
var tkselectionlst = []; // upon doing track selection, are list of those in trackselectionmenu
// for track selection 2D grid, everytime it is changed, table will need to be regenerated

// custom metadata
var custmdhash = {};

/****    DOM objects that are frequently used
   need a clean up
 ****/
var scalebar = {};
var mdselect = {}; // metadata selector panel
var msgconsole; // message console (but not text area anymore)
var pica; // loves zipping around
var picasays;
var menu; // context menu created by right click
var indicator;
var indicator2;
var palette;
var palette;
var floatingtoolbox;
var mdcholder;
var viewbox; // the <div> holding hmCanvas
var tkAttrHolder; // holding track annotation canvas for each track
var tksSmallmenu;
var rulercanvas;
var minichrcanvasdiv; // holding minichr canvas
var minichrrulerdiv; // holding minichr canvas
var minichrindicator; // blue box over minichr canvas indicating dsp
//var moveTrackCanvas; // rightmost canvas for moving individual tracks
var tkselect = {which:0, // context
    grp:0,  // for selecting hmtk for pwc or htest (which group to go to)
    decor:{}}; // hmtk selection pop-up panel
var gsselect = {which:0}; // gene struct selection stuff
var vrearrangeUtil = {which:1}; // vertical rearrange utils



/***  global variables that govern browser run state  ***/
var scaffold = {p2c:{}, c2p:{}, len:{}, seq2tr:{}, toadd:{}};
var chrLen = {}; // key: chr name, val: length
var tkLst = []; // list of heatmap track objects

/* quantitative track configuration
   a little bit redundant...
   once user made changes in the ftb control panel,
   corresponding attribute will be updated in qtc,
   as well as attribute name be set to qtc.changed,
   then qtc values will be copied over to the qtc object of target component
 */
var qtc = {
    which:0, // look at qtc_update() for values
    slider:'',
    changed:'', // attribute name that has been changed
    pr:255,pg:0,pb:0, // positive color
    nr:0,ng:0,nb:230, // negative color
    pth:'#800000', // positive threshold color
    nth:'#000099', // negative threshold color
    thtype:0, // 0/1/2
    thmin:0,thmax:10,thpercentile:95,
    uselog:false,
    logtype:1, // 1/2/3
    height:20,
    };
/* default quantitative track style, will be copied over to their instances
   note height is for **plot height** not including top/bottom padding!
 */
var defaultQtcStyle = {
    // server hmtk of filetype 2
    heatmap:{pr:255,pg:0,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
             thtype:0,thmin:0,thmax:10,thpercentile:90,uselog:false,logtype:1,height:10},
    // custom hmtk of filetype 3
    ft3:{pr:0,pg:0,pb:230,nr:255,ng:0,nb:0,pth:'#ffff00',nth:'#800000',
             thtype:0,thmin:0,thmax:10,thpercentile:90,uselog:false,logtype:1,height:10},
    // bev tracks (bigwig or bigbed)
    bev:{pr:115,pg:0,pb:230,nr:179,ng:0,nb:179,pth:'#4d0099',nth:'#4D004d',
             thtype:2,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:30},
    // following configs are meant for decor, so no custom bigwig
    ft0:{pr:0,pg:77,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
             thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
    ft1:{pr:0,pg:77,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
             thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
    ft8:{pr:115,pg:0,pb:230,nr:179,ng:0,nb:179,pth:'#400080',nth:'#4d004d',
             thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
    ft4:{pr:255,pg:0,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
             thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
    ft5:{pr:255,pg:0,pb:0,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
             thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:50},
}

/********
   bird's eye view

   track canvas's height will be .qtc.height, with no padding
   but will have 4px top margin

   "data" points to a hash of tracks
       key: track name
       value: {}
	    'data': the data vector, addressed by chr name
	    'qtc': qtrack config param collector
	    'tr': <tr> in bev_dataregistry
	    'min', 'max': threshold values
	    'minspan', 'maxspan': place to write threshold values in <tr>
	    'canvas':{'chr1':<canvas>,...}
   "ongoing" indicates the track that's been computed
        could be undefined, to indicate that all vectors are under focus...
   "pressedChr" the chr name that is used for zoom in
   'scfd' is a partial replicate of global object scaffold
 */
var bev = {data:{},ongoing:'',pressedChr:'',scfd:{hash:{},order:{},plotlen:{},seq2tr:{},toadd:{}} };
var regionLst = []; // master global variable
var decorGrouping = []; // [group id, group name], ...
var decorInfo = {};
/* key: gf name
   val: {}
      label: 'print name'
      parent: might be undefined, use 'parent' in decorInfo to check
      grp: group id (-1 for custom track)
      fileType: 0/1/2/3/4/5
      hasStruct: 0/1
      queryUrl: directly append gene name after it
      mode: hide/thin/full/density/show
      tksentry: used as a hook to this track's <td> element in track selection panel

   serves as registry for all decor tracks (bigbed and bigwig)
   when a custom bigbed is uploaded, it will be in there
   even if the track is closed, it shall not be removed
   only if it is explicitly removed by user, shall its record be removed from here
 */

var datasetLst = []; // list of dataset sql table names
var entire = {length:0, 
              spnum:0, 
	      summarySize:0, 
	      atbplevel:false,
	      bpwidth:0,
	      MAXbpwidth:10,
	      // record genesetview.lst, used for drawing minichrcanvas in itemlist mode
	      // each element is a list
	      // [item name, dstart, dstop]
	      };
var correlation = {targetft:-1, // target track file type, universal
	where:0, // in case of bigwig, it need to know whether is 0 heatmap or 1 decor it belongs to
	targetname:'', // target track name
	rawdata:[],
	rankeddata:[],
        qtc:{pr:255,pg:50,pb:50,nr:50,ng:50,nb:255,pth:'#800000',nth:'#000099'},
	inuse:false};
var corrHolder; // whatever holding correlation canvas
// border position are absolute (chromosome name, not region index)
var border = {lname:'',lpos:0,rname:0,rpos:0};
// left wing, start, stop, right wing
var dspBoundary = {lwrlpx:0,lwidx:0,
                   lwr:0,lws:0,
                   vstartr:0,vstarts:0,
		   vstopr:0,vstops:0,
		   rwr:0,rws:0};
var move = {processing:false,
            direction:null, // l/r, null for indicating not moving
	    merge:false, // if new data should be merged with old data for the same region
	    offsetShift:0, // use when merge is true, only for stack decor
	    styleLeft:0, // .style.left for movables
	    oldpos:0,
	    moved:false,
	    mousex:0};
var ideogram = {
	band:[], 
	chr:null, 
	cytoband:{}, 
	minihash:{},
	minirulerhash:{},
	longhash:{},
	minicanvaswidth:0,
	minicanvasheight:14,
	minirulerheight:15,
	wiggle1:{ // the wiggle plot with same width as minicanvas and on the top
	    name:null,filetype:-1,url:null,label:null,
	    qtc:{pr:136,pg:163,pb:137,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
	         thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:20}
	},
	wiggle2:{ // the wiggle plot on the bottom
	    name:null,filetype:-1,url:null,label:null,
	    qtc:{pr:148,pg:176,pb:176,nr:0,ng:0,nb:230,pth:'#800000',nth:'#000099',
                 thtype:0,thmin:0,thmax:10,thpercentile:95,uselog:false,logtype:1,height:20}
	},
	previous:[],
	cross:{sf:0,lenlst:[],namelst:[],}
	};
var htest = {pvalue:[],
             inuse:false,
	     grpnum:0,
	     // only pcolor, ncolor are effective
             qtc:{pr:255,pg:77,pb:77,
	          nr:255,ng:77,nb:77,
		  pth:'#b30000',nth:'#b30000',thtype:0,uselog:true,logtype:3,height:50}, 
	     };
/* pairwise comparison central object */
var pwc = {
    inuse:false, 
    qtc:{pr:230,pg:0,pb:0, nr:0,ng:204,nb:0,
	 pth:'#800000',nth:'#008000',
	 thtype:0,thmin:-3,thmax:3,thpercentile:95,
	 uselog:false,logtype:1,
	 height:50},
    gtn1:[], gtn2:[],
    };
var decorCanvasHash = {}; // stores run time data, once track is closed, it will be removed
var juxtaposition = {type:0, 
                     what:'genome', 
		     note:'genome'}; // see doc
var geneplot = {type:'',data:[], genenum:0,
		canvasX:0, canvasY:0, // absolute position of clustering heatmap
		dendroX:0, dendroY:0, // ... of clustering dendrogram
		ccrd:{}, // cluster coord hash {x:{y:id}}, for clicking on dendrogram
		'for':0, // determines where the panel should go to 0: gene set view, 1: custom bigbed
		forTkname:'', // the custom bigbed track name
	}; // for gene plot following gene set view
var genesetview = {
    flanking:[],
    ideogram_stroke:'#1F3D7A',
    ideogram_fill5:'#85E094', // 5' upstream
    ideogram_fill3:'#E39F91', // 3' downstream
    minichr_filla:'#a3a3a3',
    minichr_fillb:'#c96',
    minichr_text:'white',
    lst:[], // item region [name, chr, start, stop, plotlen], this is ALL of them not merely in dsp
    lstsf:0, // scaling factor from bplen to plot len
    lstholder:'', // item list holder table
};



/***  flags   ***/
var gflag = {
    savingstatus:false, // instruct cgi to do decoding on saved URL
    minichrjumping:false,
    hasgene:true,
    allowjuxtaposition:true,
    cpmove:{dom:null,oldx:0,oldy:0},
    hmtkunderfocus:null, // for getting info on a track
    // for custom track to be submitted [name, label, url]
    customtmp:{name:null,label:null,url:null,mode:null,servermd:{},custmd:{}},
    // for processing urlparam when loading the page
    urlparam:{usingsession:false,willcontinue:false},
    };
var helpmsgshowing = false;
var sortTrackIdx = 0;
var currentPathway; // kegg pathway ID currently been displayed
var urloffset = 0;
var mdnotooltip = false; // don't pop up tooltip when dragging metadata color block



// variables used for placing tooltip...
var iiX = 0; // for hm canvas
var iiiX; // for track attribute canvas
var iiY = 0;




/*** tiny generic functions ***/
function neatstr(num) {
    // float number to neat string
    var s = num.toFixed(2);
    var lst = s.split('.');
    if(lst[1] == '00') {
        return lst[0];
    } else {
        return s;
    }
}
function lightencolor(rgb,perc) {
    // lighten color, higher percentage means lighter color
    return "rgb("+(rgb[0]+parseInt((255-rgb[0])*perc))+","+(rgb[1]+parseInt((255-rgb[1])*perc))+","+(rgb[2]+parseInt((255-rgb[2])*perc))+")";
}
function darkencolor(rgb,perc) {
    // darken color, higher percentage means darker color
    var p = 1-perc;
    return "rgb("+parseInt(rgb[0]*p)+","+parseInt(rgb[1]*p)+","+parseInt(rgb[2]*p)+")";
}
function colorstr2int(what) {
    // accepts #aabbcc or rgb(12,23,34)
    var c = [0,0,0];
    if(what.charAt(0) == "#") {
    	if(what.length == 4) {
	    c[0] = parseInt(what.charAt(1)+what.charAt(1), 16);
	    c[1] = parseInt(what.charAt(2)+what.charAt(2), 16);
	    c[2] = parseInt(what.charAt(3)+what.charAt(3), 16);
	} else {
	    c[0] = parseInt(what.substr(1,2), 16);
	    c[1] = parseInt(what.substr(3,2), 16);
	    c[2] = parseInt(what.substr(5,2), 16);
	}
    } else {
        var lst = what.split(',');
	c[0] = parseInt(lst[0].split('(')[1]);
	c[1] = parseInt(lst[1]);
	c[2] = parseInt(lst[2]);
    }
    return c;
}
function arrayMin(arr) {
    if(arr.length == 0) fatalError('arrayMin: zero length array');
    var s = arr[0];
    for(var i=1; i<arr.length; i++) {
        if(s > arr[i]) s = arr[i];
    }
    return s;
}
function arrayMean(arr) {
    if(arr.length == 0) fatalError("arrayMean: zero length array");
    var s = 0;
    for(var i=0; i<arr.length; i++)
        s += arr[i];
    return s/arr.length;
}
function arrayMax(arr) {
    if(arr.length == 0) fatalError("arrayMax: zero length array");
    var s = 0;
    for(var i=0; i<arr.length; i++) {
        if(s < arr[i])
	    s = arr[i];
    }
    return s;
}
function thinginlist(thing, lst) {
    for(var i=0; i<lst.length; i++) {
        if(lst[i] == thing) return true;
    }
    return false;
}
function getArrIdx(thing, lst) {
    // return -1 if thing is not found
    if(lst.length == 0) return -1;
    for(var i=0; i<lst.length; i++) {
        if(lst[i] == thing) return i;
    }
    return -1;
}
function stringLstIsIdentical(lst1, lst2) {
    if(lst1.length != lst2.length)
        return false;
    for(var i=0; i<lst1.length; i++) {
        if(lst1[i] != lst2[i])
	    return false;
    }
    return true;
}
function hashisempty(h) {
    for(var k in h)
        return false;
    return true;
}


function cloakPage() {
    var c = document.getElementById("pagecloak");
    c.style.display = "block";
    c.style.height = document.body.offsetHeight;
    c.style.width = document.body.clientWidth + document.body.scrollLeft;
}
function atfinestlevel() {
    // tells if at finest level, if so, will not carry zoom in
    return entire.atbplevel && (entire.bpwidth>=entire.MAXbpwidth);
}
function getPointCoord(rid, spid) {
    /* rid: regionLst index
       spid: summary point, or pixel number, relative offset at this region start
       based on info in regionLst and current zoom level, return coordinate (integer)
     */
    if(entire.atbplevel)
        return regionLst[rid][3] + parseInt(spid/entire.bpwidth);
    else
        return regionLst[rid][3] + parseInt(regionLst[rid][7]*spid);
}
function getTrackIdxByMousepos(y) {
    // get track index by Y position of mouse (event.clientY)
    y += document.body.scrollTop - iiY;
    var cumulative = 0;
    for(var i=0; i<tkLst.length; i++) {
        if(y <= cumulative) {
	    return i==0 ? 0 : i-1;
	}
	cumulative += tkLst[i].qtc.height;
    }
    return tkLst.length-1;
}
function getTkidxByname(what) {
    // return -1 for not found
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].name == what)
	    return i;
    }
    return -1;
}
function findTrackByName(what) {
    // return track object, null for not found
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].name == what)
	    return tkLst[i];
    }
    return null;
}
function placeIndicator3(x,y,w,h) {
    // place indicator3 at a place (x,y) with resizing (w,h)
    indicator3.style.left = x;
    indicator3.style.top = y;
    var d = indicator3.firstChild;
    d.style.width = w;
    d.style.height = h;
    var dd = d.firstChild;
    dd.style.width = w;
    dd.style.height = h;
    dd = d.childNodes[1];
    dd.style.width = w;
    dd.style.height = h;
    dd = d.childNodes[2];
    dd.style.width = w;
    dd.style.height = h;
    dd = d.childNodes[3];
    dd.style.width = w;
    dd.style.height = h;
    indicator3.style.display = "block";
}
function placeIndicator3_menuTklst() {
    // place indicator3 over groups of tracks in menu.trackIdxLst
    // generalize?
    var h=0; // sum of height of spanned tracks
    var firsttrackidx = 1000; // index of first spanned track
    for(i=0; i<menu.trackIdxLst.length; i++) {
	var k = menu.trackIdxLst[i];
	h += tkLst[k].qtc.height;
	if(firsttrackidx > k)
	    firsttrackidx = k;
    }
    placeIndicator3(iiX,
	            iiY+sumTrackHeight(firsttrackidx),
	            hmSpan+mdcategoryOnshow.length*tkAttrColumnWidth,
	            h);
}
function placeIndicator3_menuDecor() {
    // place indicator3 over a decor track
    // decor is in 
    if(!(menu.decorname in decorCanvasHash))
        return;
    var viewbox = decorCanvasHash[menu.decorname].viewbox;
    placeIndicator3(leftColumnWidth,
                    absolutePosition(viewbox)[1],
		    hmSpan,
		    parseInt(viewbox.style.height)
	            );
}
function decorIsGene(decorname) {
    // see if decor belongs to "Genes" group
    var genegrpid;
    for(var i=0; i<decorGrouping.length; i++) {
        if(decorGrouping[i][1] == "Genes")
	    genegrpid = decorGrouping[i][0];
    }
    if(decorname in decorInfo) {
        if(decorInfo[decorname].grp == genegrpid)
	    return true;
    }
    return false;
}
function decorIsRepeat(decorname) {
    /* see if decor belongs to "RepeatMasker" group
       for arabidopsis, no rmsk.txt file is available and the repeat track
       won't have this group name to escape
     */
    var grpid;
    for(var i=0; i<decorGrouping.length; i++) {
        if(decorGrouping[i][1] == "RepeatMasker") {grpid = decorGrouping[i][0]; break;}
    }
    if(decorname in decorInfo) {
        if(decorInfo[decorname].grp == grpid)
	    return true;
    }
    return false;
}


/* code by google
   This function scales the submitted values so that
   maxVal becomes the highest value.
 */
var simpleEncoding = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
function simpleEncode(valueArray,maxValue) {
    var chartData = [];
    for (var i = 0; i < valueArray.length; i++) {
        var currentValue = valueArray[i];
	if (!isNaN(currentValue) && currentValue >= 0) {
	    chartData.push(simpleEncoding.charAt(Math.round((simpleEncoding.length-1) * 
	    currentValue / maxValue)));
	} else {
	    chartData.push('_');
	}
    }
    return chartData.join('');
}
// Same as simple encoding, but for extended encoding.
var EXTENDED_MAP= 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-.';
var EXTENDED_MAP_LENGTH = EXTENDED_MAP.length;
function extendedEncode(arrVals, maxVal) { var chartData = ''; for(i = 0, len = arrVals.length; i < len; i++) { var numericVal = new Number(arrVals[i]); var scaledVal = Math.floor(EXTENDED_MAP_LENGTH * EXTENDED_MAP_LENGTH * numericVal / maxVal); if(scaledVal > (EXTENDED_MAP_LENGTH * EXTENDED_MAP_LENGTH) - 1) { chartData += ".."; } else if (scaledVal < 0) { chartData += '__'; } else { var quotient = Math.floor(scaledVal / EXTENDED_MAP_LENGTH); var remainder = scaledVal - EXTENDED_MAP_LENGTH * quotient; chartData += EXTENDED_MAP.charAt(quotient) + EXTENDED_MAP.charAt(remainder); } } return chartData; }




/* age-old, generic operations on DOM elements */
function checkInputByvalue(radioName, value) {
    // works for both radio and checkbox
    var lst = document.getElementsByName(radioName);
    if(lst.length == 0)
        fatalError("checkInputByvalue: unknown <input> name");
    for(var i=0; i<lst.length; i++) {
        if(lst[i].value == value) {
	    lst[i].checked = true;
	    return;
        }
    }
    fatalError("checkInputByvalue: unknown value '"+value+"' for "+radioName);
}
function checkChildRadio(event) { // not used?
    event.target.childNodes[0].checked = true;
}
function copylst_childnodes(domobj) {
    var lst = [];
    for(var i=0; i<domobj.childNodes.length; i++)
        lst.push(domobj.childNodes[i]);
    return lst;
}
function getSelectValueById(what) {
    var tag = document.getElementById(what);
    if(tag == null) fatalError(what+' not found as select');
    if(tag.type != 'select-one')
        fatalError(what+' not found for a select tag');
    return tag.options[tag.selectedIndex].value;
}
function getValue_by_radioName(what) {
    // a set of radio button sharing same name
    // return the one selected
    var tag_lst = document.getElementsByName(what);
    if(tag_lst.length == 0) fatalError("radio button with name "+what+" not found.");
    for(var i=0; i<tag_lst.length; i++) {
	if(tag_lst[i].checked)
            return tag_lst[i].value;
    }
    fatalError("None of the options were checked for radio button "+what);
}
function getClass_by_radioName(what) {
    var lst = document.getElementsByName(what);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].checked) return lst[i].className;
    }
    fatalError("None of the options were checked for radio button "+what);
}
function getAlt_by_radioName(what) {
    var tag_lst = document.getElementsByName(what);
    if(tag_lst.length == 0) fatalError("radio button with name "+what+" not found.");
    for(var i=0; i<tag_lst.length; i++) {
	if(tag_lst[i].checked)
            return tag_lst[i].alt;
    }
    fatalError("None of the options were checked for radio button "+what);
}
function changeSelectByValue(arg, value) {
    /* change .selectedIndex of a <select> by given value
       return 1 for success, -1 for failure
       first argument could be string (<select> id), or dom object
     */
    var s = arg;
    if(typeof(s) == "string") {
        s = document.getElementById(arg);
	if(s == null)
	    return -1;
    }
    if(s.tagName != 'SELECT') {
        print2console('changeSelectByValue: target object is not <select>',2);
	return -1;
    }
    var lst = s.options;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].value == value) {
	    s.selectedIndex = i;
	    return 1;
	}
    }
    return -1;
}


/***************************
  small targeted functions 
 ***************************/
function closeappPanel() {
    document.getElementById('appPanel').style.display = 'none';
    document.body.removeEventListener('mouseup', closeappPanel, false);
    //document.getElementById('lbutt_apps').disabled = false;
}
function launchappPanel(event) {
    var p = document.getElementById('appPanel');
    p.style.display = 'block';
    if(event.clientX+p.clientWidth > document.body.clientWidth)
        p.style.left = document.body.clientWidth - p.clientWidth-20;
    else
	p.style.left = event.clientX+20;
    p.style.top = event.clientY-60;
    document.body.addEventListener('mouseup', closeappPanel, false);
    //event.target.disabled = true;
}
function toggle3(event) {
    // show/hide species menu by clicking on <td> on banner
    var holder = document.getElementById('bait3');
    holder.style.display = 'block';
    var pos = absolutePosition(event.target.parentNode.parentNode);
    holder.style.left = pos[0]-7;
    document.body.addEventListener('mousedown', toggle3_2, false);
}
function toggle3_2() {document.getElementById('bait3').style.display='none';}
function toggle4() {
    // "advanced" options for regenerating track selection grid layout
    var bait = document.getElementById("bait4");
    var hook = document.getElementById("hook4");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.innerHTML = "hide configure panel";
	hook.style.backgroundColor = '#858585';
	hook.style.color = 'white';
    } else {
        bait.style.display = "none";
	hook.innerHTML = "configure track selection panel";
	hook.style.backgroundColor = '';
	hook.style.color = '';
    }
}
function toggle5() {
    // use server metadata to annotate custom bigwig
    var bait = document.getElementById("bait5");
    var hook = document.getElementById("hook5");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.innerHTML = "&uarr; hide";
    } else {
        bait.style.display = "none";
	hook.innerHTML = "&darr; use metadata vocabulary provided here";
    }
}
function toggle6() {
    // use server metadata to annotate custom bigwig
    var bait = document.getElementById("bait6");
    var hook = document.getElementById("hook6");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.style.display = 'none';
    } else {
        bait.style.display = "none";
	hook.style.display = 'block';
    }
}
function toggle7() {
    //floatingtoolbox.style.height = "auto";
    var bait = document.getElementById("bait7");
    var hook = document.getElementById("hook7");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.className = "shortcutbutMD";
    } else {
        bait.style.display = "none";
	hook.className = "shortcutbut";
    }
}
function toggle8() {
    var bait = document.getElementById("bait8");
    var hook = document.getElementById("hook8");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.innerHTML = "hide data sets";
	hook.style.backgroundColor = '#858585';
	hook.style.color = 'white';
    } else {
        bait.style.display = "none";
	hook.innerHTML = "show data sets";
	hook.style.backgroundColor = '';
	hook.style.color = '';
    }
}
function toggle9() {
    var bait=document.getElementById("bait9");
    var hook = document.getElementById("hook9");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.style.display = "none";
    } else {
        bait.style.display = "none";
	hook.style.display = "block";
    }
}
function toggle10() {
    var bait=document.getElementById("bait10");
    var hook = document.getElementById("hook10");
    if(bait.style.display == "none") {
        bait.style.display = "block";
	hook.style.display = "none";
    } else {
        bait.style.display = "none";
	hook.style.display = "block";
    }
}
function toggle14() {
    var hook = document.getElementById("hook14");
    var bait = document.getElementById("bait14");
    if(bait.style.display == "none") {
        hook.style.display = "none";
	bait.style.display = "block";
    } else {
        hook.style.display = "block";
	bait.style.display = "none";
    }
}
function toggle15() {
    // called by changing "apply to all tracks" checkbox in qtc panel
    var usingall = document.getElementById("qtc_alltrackcheckbox").checked;
    if(qtc.which==1 || qtc.which==2) {
        // on heatmap tracks
	if(usingall) {
	    // all hm tracks
	    var c = absolutePosition(viewbox);
	    placeIndicator3(c[0], c[1], viewbox.clientWidth, viewbox.clientHeight);
	} else {
	    // only those selected by menu
	    if(menu.context == 1)
		highlighttrack(menu.iY, 3);
	    else if(menu.context == 2)
		placeIndicator3_menuTklst();
	}
    } else if(qtc.which == 8) {
        // on bev tracks
	if(usingall) {
	    for(var vn in bev.data) {
	        if(bev.data[vn].onshow) {
		    bev.data[vn].tr.childNodes[3].style.backgroundColor = Lpurple;
		}
	    }
	} else {
	    for(var vn in bev.data) {
	        if(bev.data[vn].onshow) {
		    bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
		}
	    }
	    bev.data[bev.ongoing].tr.childNodes[3].style.backgroundColor = Lpurple;
	}
    }
}
function toggle16() {
    var bait = document.getElementById("bait16");
    if(bait.style.display == "none") {
        bait.style.display = "table";
    } else {
        bait.style.display = "none";
    }
}
function toggle17() {
    var bait = document.getElementById("bait17");
    var hook = document.getElementById("hook17");
    if(bait.style.display == "none") {
        bait.style.display = "table";
	hook.innerHTML = 'Hide management table';
    } else {
        bait.style.display = "none";
	hook.innerHTML = 'Manage displayed tracks';
    }
}
function toggle18() {
    // bev panel
    var bait = document.getElementById("bait18");
    var hook = document.getElementById("hook18");
    if(bait.style.display == "none") {
        cloakPage();
	hook.className = "shortcutbutMD";
        bait.style.display = "block";
	bait.style.top = 100+document.body.scrollTop;
    } else {
	document.getElementById("pagecloak").style.display = "none";
        bait.style.display = "none";
	hook.className = "shortcutbut";
	document.getElementById("ftb_qtCfgdiv").style.display = "none";
    }
}
function toggle19(event) {
    var p = document.getElementById("bait19");
    if(p.style.display == 'none') {
        p.style.display = "block";
	event.target.innerHTML = "&#10005;";
    } else {
        p.style.display = "none";
	event.target.innerHTML = "help";
    }
}
function toggle20(event) {
    // show/hide children decors by clicking on button
    var hook = event.target;
    var bait = event.target.parentNode.parentNode.nextSibling;
    if(bait.style.display == "none") {
        bait.style.display = "table-row";
	hook.innerHTML = " &uarr; ";
	hook.className = "shortcutbutMD";
    } else {
        bait.style.display = "none";
	hook.innerHTML = " &darr; ";
	hook.className = "shortcutbut";
    }
}
function toggle21(event) {
    var butt = event.target;
    var ul = document.getElementById("geneplothelpmsg");
    if(ul.style.display == "none") {
        butt.innerHTML = "&#10005;";
	ul.style.display = "block";
    } else {
        butt.innerHTML = "having trouble?";
	ul.style.display = "none";
    }
}
function toggle22(event) {
    // push button of gsv items in lstholder
    var tr = event.target.parentNode.parentNode;
    if(tr.marked) {
        tr.style.backgroundColor = "white";
	event.target.innerHTML = "&#10005;";
	event.target.title = 'mark for removal';
	tr.marked = false;
    } else {
        tr.style.backgroundColor = "#e0e0e0";
	event.target.innerHTML = "&#10004;";
	event.target.title = 'unmark';
	tr.marked = true;
    }
}
function toggle23(event) {
    var d = document.getElementById("zerosdgeneholder");
    if(d.style.display == 'none') {
        event.target.innerHTML = "hide";
	d.style.display = "block";
    } else {
        event.target.innerHTML = "show";
	d.style.display = "none";
    }
}
function toggle24(event) {
    var s1 = document.getElementById("geneplot_s4_h_span");
    var s2 = document.getElementById("geneplot_s4_k_span");
    if(event.target.selectedIndex == 0) {
        s1.style.display = 'inline'
	s2.style.display = 'none'
    } else {
        s1.style.display = 'none'
	s2.style.display = 'inline'
    }
}
function toggle25() {
    // bigbed generator
    var hook = document.getElementById('hook25');
    var bait = document.getElementById('bait25');
    if(bait.style.display == 'none') {
        cloakPage();
	hook.className = "shortcutbutMD";
        bait.style.display = "block";
	bait.style.top = 100+document.body.scrollTop;
    } else {
	document.getElementById("pagecloak").style.display = "none";
        bait.style.display = "none";
	hook.className = "shortcutbut";
    }
}
function toggle26(doupdate) {
    // change qtrack threshold type
    var v = getValue_by_radioName('qtc_thresholdradio');
    var d1 = document.getElementById('qtc_thresholdradio_fixdiv');
    var d2 = document.getElementById('qtc_rulerdiv');
    var s1 = document.getElementById('qtc_percentile_span');
    var s2 = document.getElementById('qtc_pth');
    var s3 = document.getElementById('qtc_nth');
    qtc.thtype = parseInt(v);
    if(v == 0) {
        // automatic scale
        d1.style.display = 'none';
	d2.style.display = 'none';
	s1.style.display = 'none';
	s2.style.display = 'none';
	s3.style.display = 'none';
	if(doupdate) {
	    qtc.changed = 'thtype';
	    qtc_update();
	}
    } else if(v == 1) {
        // fixed scale
	d1.style.display = 'block';
        d2.style.display = 'none';
	s1.style.display = 'none';
	s2.style.display = 'block';
	s3.style.display = 'block';
    } else if(v == 2) {
        // percentile
	d1.style.display = 'none';
        d2.style.display = 'block';
	s1.style.display = 'inline';
	s2.style.display = 'block';
	s3.style.display = 'block';
	if(doupdate) {
	    qtc.changed = 'thtype';
	    qtc.thpercentile = parseInt(document.getElementById('qtc_percentile').innerHTML);
	    qtc_update();
	}
    }
}
function toggle27() {
    var hook = document.getElementById('hook27');
    if(msgconsole.style.display == "none") {
        msgconsole.style.display = "block";
        msgconsole.scrollTop = 9999; // dummy
	hook.innerHTML = 'Hide message';
	hook.style.backgroundColor = '';
	hook.style.color = '';
    } else {
        msgconsole.style.display = "none";
	hook.innerHTML = 'Show message';
	hook.style.backgroundColor = '#858585';
	hook.style.color = 'white';
    }
}
function toggle28(event) {
    // called by clicking the checkbox controling ideogram display
    var bait = event.target.nextSibling;
    if(event.target.selectedIndex == 0) {
        bait.style.display = "inline";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "block";
    } else {
        bait.style.display = "none";
	for(var cn in bev.scfd.hash)
	    document.getElementById("bevideogram_"+cn).style.display = "none";
    }
}
function toggle29() {
    // toggle qtrack log checkbox
    var check = document.getElementById('hook29').checked;
    document.getElementById('bait29').style.display = check ? 'block' : 'none';
    qtc.changed = 'uselog';
    qtc.uselog = check;
    if(check) {
        qtc.logtype = parseInt(getValue_by_radioName('qtc_log'));
    }
    qtc_update();
}
function toggle30() {
    // changing qtrack log radiobutton
    //qtc.changed = 'logtype';
    qtc.changed = 'uselog';
    qtc.logtype = parseInt(getValue_by_radioName('qtc_log'));
    qtc_update();
}
function toggle31(event) {
    /* push button of scaffold sequences to mark for removal
       in case of a to-be-added one, simply remove it
       need to tell which scaffold holder is using
     */
    var tr = event.target.parentNode.parentNode;
    var holderid = parseInt(tr.parentNode.parentNode.getAttribute('holderid'));
    if(holderid!=1 && holderid!=2)
        fatalError('toggle31: unknown holderid');

    if(tr.marked) {
        tr.style.backgroundColor = 'white';
	event.target.innerHTML = '&#10005;';
	event.target.title = 'mark for removal';
	tr.marked = false;
    } else {
        if(holderid == 1) {
	    if(tr.seq in scaffold.toadd) {
	        // this seq is pending for adding, just remove it
		scaffold.cpholder.firstChild.removeChild(tr);
		delete scaffold.seq2tr[tr.seq];
		delete scaffold.toadd[tr.seq];
		return;
	    }
	} else {
	    if(tr.seq in bev.scfd.toadd) {
		bev.scfd.holder.firstChild.removeChild(tr);
		delete bev.scfd.seq2tr[tr.seq];
		delete bev.scfd.toadd[tr.seq];
		return;
	    }
	}
        tr.style.backgroundColor = '#e0e0e0';
	event.target.innerHTML = '&#10004;';
	event.target.title = 'unmark';
	tr.marked = true;
    }
    if(holderid == 1) {
	scaffold.updatebutt.style.display = 'inline';
	scaffold.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('scaffold_cancelbutt').style.display = 'inline';
    } else {
        bev.scfd.updatebutt.style.display = 'inline';
	bev.scfd.updatebutt.style.backgroundColor = '#e0e0e0';
	document.getElementById('genomebevscfd_cancelbutt').style.display = 'inline';
    }
}
function toggle32(event) {
    /* called by clicking on <span> within <li>
       for hmtk facet browsing panel (one criterion state)
       <li> should have <ul> as its next sibling
     */
    var span = event.target;
    var ul = span.parentNode.nextSibling;
    if(ul.tagName != 'UL') {
        span = event.target.parentNode;
	ul = span.parentNode.nextSibling;
	if(ul.tagName != 'UL')
	    fatalError('toggle32: could not find UL as next sibling');
    }
    var hidden = ul.style.display == 'none';
    var term = span.getAttribute('term');
    if(hidden) {
        var wlst = [];
        for(var i=0; i<mdvp2c[term].length; i++)
	    wlst.push(trackselectionoption_onecriteria(mdvp2c[term][i]));
        ul.innerHTML = wlst.join('');
	ul.style.display = "block";
	span.firstChild.innerHTML = '&#8863;';
    } else {
        stripChild(ul, 0);
	ul.style.display = "none";
	span.firstChild.innerHTML = '&#8862;';
    }
}
function toggle34() {
    var bait = document.getElementById('bait34');
    var hook = document.getElementById('hook34');
    if(bait.style.display == 'block') {
        bait.style.display = 'none';
        hook.style.webkitTransform = 'rotate(90deg)';
        hook.style.mozTransform = 'rotate(90deg)';
	hook.title = 'reveal';
    } else {
        bait.style.display = 'block';
        hook.style.webkitTransform = 'rotate(-90deg)';
        hook.style.mozTransform = 'rotate(-90deg)';
	hook.title = 'fold';
    }
}
function toggle35() {
    var bait = document.getElementById('bait35');
    var hook = document.getElementById('hook35');
    if(bait.style.display == 'block') {
        bait.style.display = 'none';
        hook.style.webkitTransform = 'rotate(90deg)';
        hook.style.mozTransform = 'rotate(90deg)';
	hook.title = 'reveal';
    } else {
        bait.style.display = 'block';
        hook.style.webkitTransform = 'rotate(-90deg)';
        hook.style.mozTransform = 'rotate(-90deg)';
	hook.title = 'fold';
    }
}
function toggle36() {
    var hook = document.getElementById('hook36');
    var bait = document.getElementById('bait36');
    if(bait.style.display == 'none') {
        bait.style.display = 'table-row';
	hook.style.display = 'none';
    } else {
        bait.style.display = 'none';
	hook.style.display = 'inline';
    }
}
function toggle37() {
    var hook = document.getElementById('hook37');
    var bait = document.getElementById('bait37');
    if(bait.style.display == 'none') {
        bait.style.display = 'table-row';
	hook.style.display = 'none';
    } else {
        bait.style.display = 'none';
	hook.style.display = 'inline';
    }
}
function toggle38() {
    var hook = document.getElementById('hook38');
    var bait = document.getElementById('bait38');
    if(bait.style.display == 'none') {
        bait.style.display = 'table-row';
	hook.style.display = 'none';
    } else {
        bait.style.display = 'none';
	hook.style.display = 'inline';
    }
}




/* associated with Information table */
function resize_informationTable() {
    // call after stuffing things into trackdetailtable
    var table = document.getElementById('trackdetailtable');
    var d = table.parentNode;
    if(table.clientHeight > 250) {
        d.style.height = 250;
	d.style.overflowY = "scroll";
    } else {
        d.style.height = "auto";
	d.style.overflowY = "auto";
    }
}
function displayGenomeInfo() {
    // called by clicking button, display info about this genome
    ajax2('getgenomeinfo=on&dbName='+dbInfo.name,function(text){
        document.getElementById('simpleinfoWrapper').style.display = 'block';
	var table = document.getElementById('trackdetailtable');
	stripChild(table, 0);
        var lst = text.split('|');
	var color = '#ededed';
	for(var i=0; i<lst.length; i+=2) {
	    var tr = table.insertRow(-1);
	    tr.style.backgroundColor = color;
	    color = color=='transparent' ? '#ededed' : 'transparent';
	    tr.insertCell(0).innerHTML = lst[i];
	    tr.insertCell(1).innerHTML = lst[i+1];
	}
	resize_informationTable();
    });
    //setTimeout("toggle3(0)", 50);
}
function trackdetailAddonerow(text1, text2, holder, color) {
    // make a row to hold text1 and text2 in two <td>
    var tr = holder.insertRow(-1);
    var td = tr.insertCell(0);
    td.style.fontSize = "12px";
    td.style.backgroundColor = color;
    // attribute name uses underscore in place of space, replace that
    td.innerHTML = text1.replace(/\_/g, " ");
    tr.appendChild(td);
    td = tr.insertCell(1);
    td.style.fontSize = "12px";
    td.style.backgroundColor = color;
    td.innerHTML = text2;
    tr.appendChild(td);
    holder.appendChild(tr);
}
function trackInfo_filluptable(holder, text) {
    if(text == "NULL") {
	var span = document.createElement('span');
	span.innerHTML = 'No information available';
	holder.appendChild(span);
	return;
    }
    var div = document.createElement('div');
    var table = document.createElement('table');
    table.cellSpacing=1;
    var color = "#f2f2f2";
    var lst = text.split('; ');
    for(var i=0; i<lst.length; i++) {
	var lst2 = lst[i].split('=');
	color = color=="white" ? "#f2f2f2" : "white";
	trackdetailAddonerow(lst2[0], lst2[1], table, color);
    }
    div.appendChild(table);
    div.style.width = 320;
    holder.appendChild(div);
    if(table.clientHeight > 200) {
	div.style.height = 200;
	div.style.overflowY = 'scroll';
    } else {
	div.style.height = 'auto';
	div.style.overflowY = 'auto';
    }
    div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
}
function getOnetrackdetails() {
    /* display detail of one hmtk track in floating toolbox
       variable argument
       - by clicking on track label div on left of hmCanvas
         arg is event object
       - hmtk track name
     */
    if(arguments[0] == undefined)
        return;
    var tkname;
    if(typeof(arguments[0]) == "string")
        tkname = arguments[0];
    else
        tkname = arguments[0].target.tkname;
    gflag.hmtkunderfocus = tkname;
    ajax("tkname="+tkname+'&dbName='+dbInfo.name+"&gettrackdetails=on", function(data) {
        var w = document.getElementById("hmtkdetailwrapper");
	w.style.display = "block";
	var trlst = [];
	trlst[0] = document.getElementById('hmtkdetailtr_general');
	trlst[0].style.display = 'table-row';
	trlst[1] = document.getElementById('hmtkdetailtr_processing');
	trlst[1].style.display = 'none';
	trlst[2] = document.getElementById('hmtkdetailtr_other');
	trlst[2].style.display = 'none';
	trlst[3] = document.getElementById('hmtkdetailtr_geo');
	trlst[3].style.display = 'none';
	trlst[4] = document.getElementById('hmtkdetailtr_bam');
	trlst[4].style.display = 'none';

	// 0 general
	var holder = trlst[0].firstChild;
	stripChild(holder, 0);
	trackInfo_filluptable(holder, data.general);

	// 1 processing
	holder = trlst[1].firstChild;
	stripChild(holder, 0);
	trackInfo_filluptable(holder, data.processing);

	// 2 other version
	holder = trlst[2].firstChild;
	stripChild(holder, 0);
	if(data.other.length > 1) {
	    var div = document.createElement('div');
	    var table = document.createElement('table');
	    table.cellSpacing=1;
	    var color = "#f2f2f2";
	    for(var i=0; i<data.other.length; i++) {
	        var thisitem = data.other[i];
		if(thisitem[0] == gflag.hmtkunderfocus) continue;
		var tr = table.insertRow(-1);
		color = color=="white" ? "#f2f2f2" : "white";
		tr.style.backgroundColor = color;
		tr.insertCell(0).innerHTML = thisitem[2]+'<div style="color:#858585;">'+thisitem[1]+'</div>';
		var td = tr.insertCell(1);
		td.vAlign = 'middle';
		td.innerHTML = '<button onclick=hmtk_mightAddOne("'+thisitem[0]+'")>use</button>';
	    }
	    div.appendChild(table);
	    div.style.width = 320;
	    holder.appendChild(div);
	    if(table.clientHeight > 200) {
		div.style.height = 200;
		div.style.overflowY = 'scroll';
	    } else {
		div.style.height = 'auto';
		div.style.overflowY = 'auto';
	    }
	    div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
	} else {
	    var s = document.createElement('span');
	    s.innerHTML = "This track doesn't have other versions";
	    holder.appendChild(s);
	}

	// 3 geo
	holder = trlst[3].firstChild;
	stripChild(holder, 0);
	if(data.geo == 'NULL') {
	    var s = document.createElement('span');
	    s.innerHTML = "This track is not associated with a<br>GEO accession number";
	    holder.appendChild(s);
	} else {
	    var div = document.createElement('div');
	    div.style.textAlign = 'center';
	    div.innerHTML = '<button onclick="window.open(\'http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc='+data.geo+'\')"><img src=images/geo.png style="vertical-align:-5px;"> '+data.geo+'</button><br><br><span style="color:#858585;">click to view details in GEO database</span>';
	    holder.appendChild(div);
	}

	// 4 bam
	holder = trlst[4].firstChild;
	stripChild(holder, 0);
	if(data.bam.length == 0) {
	    var s = document.createElement('span');
	    s.innerHTML = "This track doesn't have read alignment data";
	    holder.appendChild(s);
	} else {
	    var div = document.createElement('div');
	    var table = document.createElement('table');
	    table.cellSpacing=1;
	    var color = "#f2f2f2";
	    for(var i=0; i<data.bam.length; i++) {
	        var thisitem = data.bam[i];
		var tr = table.insertRow(-1);
		color = color=="white" ? "#f2f2f2" : "white";
		tr.style.backgroundColor = color;
		tr.insertCell(0).innerHTML = thisitem[1];
		tr.insertCell(1).innerHTML = '<button tkname='+thisitem[0]+' onclick=ajaxAddOneServerbam(event)>show</button>';
	    }
	    div.appendChild(table);
	    div.style.width = 320;
	    holder.appendChild(div);
	    if(table.clientHeight > 200) {
		div.style.height = 200;
		div.style.overflowY = 'scroll';
	    } else {
		div.style.height = 'auto';
		div.style.overflowY = 'auto';
	    }
	    div.style.overflowX = table.clientWidth>320 ? 'scroll' : 'auto';
	}
    });
}
function hmtkdetailheader_click(event) {
    document.getElementById('hmtkdetailtr_general').style.display = 'none';
    document.getElementById('hmtkdetailtr_processing').style.display = 'none';
    document.getElementById('hmtkdetailtr_other').style.display = 'none';
    document.getElementById('hmtkdetailtr_geo').style.display = 'none';
    document.getElementById('hmtkdetailtr_bam').style.display = 'none';
    document.getElementById('hmtkdetailtr_'+event.target.getAttribute('foo')).style.display = 'block';
}


/* open manual functions and wrappers */
function openManual(what) {
    // called by clicking question mark sign
    window.open(window.location.href+"manual/#"+what);
}
function openManual_customtrack(event) {
    /* jumps to a chapter about one custom track file type
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href+"manual/#b-c-"+what);
}
function openManual_config(event) {
    /* jumps to a chapter, either config or misc functions
       event.target is ? button, .what is which chapter (cust track type) to go to
     */
    var what = event.target.what;
    if(what == undefined)
        what = "a"; // default is first one whatsoever
    window.open(window.location.href+"manual/#g-"+what);
}


/* QTC
   quantitative track plot functions 
 */
function qtc2json(q) {
    var lst = [];
    for(var attr in q) {
        var v = q[attr];
        lst.push('\\"'+attr+'\\":'+(typeof(v)=='string'?'\\"'+v+'\\"':v));
    }
    return '{'+lst.join(',')+'}';
}
function qtc_sliderMD(event) {
    // selection of percentile
    event.preventDefault();
    qtc.slider.x = event.clientX;
    document.body.addEventListener("mousemove", qtc_sliderM, false);
    document.body.addEventListener("mouseup", qtc_sliderMU, false);
}
function qtc_sliderM(event) {
    var x = event.clientX;
    var oldx = qtc.slider.x;
    var l = parseInt(qtc.slider.style.left);
    if((x>oldx && l>=100) || (x<oldx && l<=0))
        return;
    qtc.slider.style.left = l + x-oldx;
    l = parseInt(qtc.slider.style.left);
    if(l > 100)
	qtc.slider.style.left = 100;
    else if(l<0)
	qtc.slider.style.left = 0;
    document.getElementById("qtc_percentile").innerHTML = parseInt(qtc.slider.style.left);
    qtc.slider.x = event.clientX;
}
function qtc_sliderMU() {
    document.body.removeEventListener("mousemove", qtc_sliderM, false);
    document.body.removeEventListener("mouseup", qtc_sliderMU, false);
    qtc.thpercentile = parseInt(document.getElementById("qtc_percentile").innerHTML);
    qtc.changed = 'thtype';
    qtc_update();
}
function qtc_slider_moveleft(howmany) {
    // move qtc slider left by a number of percentile
    var n = parseInt(qtc.slider.style.left);
    var f = undefined;
    if(n >= howmany)
        f = n - howmany;
    else if(n > 0)
        f = 0;
    if(f != undefined) {
        qtc.slider.style.left = f;
        document.getElementById("qtc_percentile").innerHTML = f;
	qtc.thpercentile = f;
        qtc.changed = 'thtype';
        qtc_update();
    }
}
function qtc_slider_moveright(howmany) {
    // move qtc slider left by a number of percentile
    var n = parseInt(qtc.slider.style.left);
    var f = undefined;
    if(n+howmany <= 100)
        f = n + howmany;
    else if(n < 100)
        f = 100;
    if(f != undefined) {
        qtc.slider.style.left = f;
        document.getElementById("qtc_percentile").innerHTML = f;
	qtc.thpercentile = f;
        qtc.changed = 'thtype';
        qtc_update();
    }
}
function drawVerticalAxis(qtconfig, canvas, maxv, minv, pointup, plotcolor) {
    /* but don't works for htest
       canvas width is always leftColumnWidth
       has padding on top/bottom of densitydecorpaddingtop

       params:
          qtconfig: qtc object
	  canvas: dom object
	  maxv, minv: max/min values to be plotted, if spans 0, 0 will be plotted if enough space is there
	  pointup: boolean, if true, bigger value is on top
	  plotcolor: plot color
     */
    var ctx = canvas.getContext('2d');
    var canvash = canvas.height;
    ctx.font = "bold 8pt Sans-serif";
    ctx.fillStyle = plotcolor;
    var ploth = canvash-2*densitydecorpaddingtop-1;
    // max,min labels
    var maxlabel, minlabel;
    if(qtconfig.uselog) {
        var tmp = (qtconfig.logtype==1)?Math.pow(2,maxv):((qtconfig.logtype==2)?Math.exp(maxv):Math.pow(10,maxv));
	maxlabel = tmp.toExponential(2);
        tmp = (qtconfig.logtype==1)?Math.pow(2,minv):((qtconfig.logtype==2)?Math.exp(minv):Math.pow(10,minv));
	minlabel = tmp.toExponential(2);
    } else {
        maxlabel = neatstr(maxv);
        minlabel = neatstr(minv);
    }
    ctx.fillText(maxlabel, leftColumnWidth-12-ctx.measureText(maxlabel).width, pointup?8:canvash); // max
    ctx.fillText(minlabel, leftColumnWidth-12-ctx.measureText(minlabel).width, pointup?canvash:8); // min
    ctx.fillRect(leftColumnWidth-8,densitydecorpaddingtop,4,1); // tick on top
    ctx.fillRect(leftColumnWidth-8,canvash-densitydecorpaddingtop-1,4,1); // tick on bottom
    ctx.fillRect(leftColumnWidth-4,3,1,ploth+1); // vertical line
    if(maxv>0 && minv<0) {
	// need to mark out where's zero
	var zeroh = densitydecorpaddingtop+ (pointup ? maxv/(maxv-minv) : (-minv)/(maxv-minv)) * ploth;
	ctx.fillRect(leftColumnWidth-8,zeroh,4,1); // zero tick
	// see if zero can be printed
	zeroh += 4; // now it's y position of digit 0
	// avoid top/bottom string, string height is 10px?
	if(zeroh <= 20)
	    ctx.fillText(0, leftColumnWidth-18, 20);
	else if(zeroh >= canvash-10)
	    ctx.fillText(0, leftColumnWidth-18, canvash-10);
	else
	    ctx.fillText(0, leftColumnWidth-18, zeroh);
    }
}
function qtc_setfixscale() {
    var t = document.getElementById('qtc_fix_min');
    if(t.value.length == 0) {
        print2console('Missing min value', 2);
	return;
    }
    var min = parseFloat(t.value);
    if(isNaN(min)) {
        print2console('Invalid min value', 2);
	return;
    }
    t = document.getElementById('qtc_fix_max');
    if(t.value.length == 0) {
        print2console('Missing max value', 2);
	return;
    }
    var max = parseFloat(t.value);
    if(isNaN(max)) {
        print2console('Invalid max value', 2);
	return;
    }
    if(min >= max) {
        print2console('Max must be greater than min',2);
	return;
    }
    qtc.thmin=min; qtc.thmax=max;
    qtc.changed = 'thtype';
    qtc_update();
}
function qtrack_getthreshold(data, qtconfig) {
    /* figure out threshold for a quantitative track for plotting
       qtconfig is qtc object of the track
       compute for positive/negative data separately
       if not using threshold, use max value
     */
    if(qtconfig.thtype == 1) {
        return [qtconfig.thmax, qtconfig.thmin];
    }
    var pth; // positive threshold value
    var nth; // negative
    if(qtconfig.thtype == 2) {
        // use percentile
        var plst = []; var nlst = [];
        for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	    var start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
	    var stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	    for(var j=start; j<stop; j++) {
	        var v = data[i][j];
		if(isNaN(v) || v==Infinity || v==-Infinity) {
		} else if(v > 0) {
		    plst.push(v);
		} else if(v < 0) {
		    nlst.push(v);
		}
	    }
	}
	if(plst.length > 0) {
	    plst.sort(numSort);
	    var n = parseInt(plst.length*qtconfig.thpercentile/100);
	    if(n >= plst.length)
	        n = plst.length - 1;
	    pth = plst[n];
	} else {
	    pth = 0;
	}
	if(nlst.length > 0) {
	    nlst.sort(numSort);
	    var n = parseInt(nlst.length * (100-qtconfig.thpercentile)/100);
	    if(n < 0) n = 0;
	    nth = nlst[n];
	} else {
	    nth = 0;
	}
    } else if(qtconfig.thtype == 0){
        // auto scale
        pth=0; nth=0;
        for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	    var start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
	    var stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	    for(var j=start; j<stop; j++) {
	        var v = data[i][j];
		if(isNaN(v) || v==Infinity || v==-Infinity) {
		} else if(v > 0) {
		    if(v > pth) pth = v;
	        } else {
		    if(v < nth) nth = v;
		}
	    }
	}
    } else {
        fatalError("qtrack_getthreshold: unknown threshold type");
    }
    return [pth, nth];
}
function qtrack_plotwiggle(data, ctx, qtconfig, pthvalue, nthvalue, unitwidth) {
    /* positive/negative threshold values are precomputed
       as they will usually be used to plot scale
       canvas will have padding at top/bottom
     */
    var ploth = qtconfig.height;
    var xoffset = dspBoundary.lwidx;
    var baselinev = 0; // baseline value (always 0...)
    var baseliney = 0; // baseline y position
    var usebaseline = false;
    if(baselinev>=nthvalue && baselinev<=pthvalue) {
        usebaseline = true;
    }
    if(usebaseline) {
	if(nthvalue == 0) {
	    baseliney = ploth+densitydecorpaddingtop-1;
	} else if(pthvalue == 0) {
	    baseliney = densitydecorpaddingtop;
	} else {
	    baseliney = densitydecorpaddingtop + (pthvalue/(pthvalue-nthvalue))*ploth;
	}
    }
    var pcolor = "rgb("+qtconfig.pr+","+qtconfig.pg+","+qtconfig.pb+")";
    var ncolor = "rgb("+qtconfig.nr+","+qtconfig.ng+","+qtconfig.nb+")";
    var usethreshold = (qtconfig.thtype != 0);
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(j=start; j<stop; j++) {
	    var v = data[i][j];
	    var barh;
	    if(isNaN(v)) {
	        // do nothing
	    } else if(v == Infinity) {
	        ctx.fillStyle = "#B5B5B5";
		if(usebaseline) {
		    ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, baseliney-densitydecorpaddingtop);
		} else {
		    ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, ploth);
		}
	    } else if(v == -Infinity) {
	        ctx.fillStyle = "#B5B5B5";
		if(usebaseline) {
		    ctx.fillRect(xoffset, baseliney, unitwidth, ploth+densitydecorpaddingtop-baseliney);
		} else {
		    ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, ploth);
		}
	    } else if(usebaseline) {
	        // valid baseline, between pthvalue and nthvalue
	        if(v > baselinev) {
		    if(usethreshold && v>=pthvalue) {
			barh = baseliney - densitydecorpaddingtop;
			ctx.fillStyle = qtconfig.pth;
		    } else {
			barh = (baseliney-densitydecorpaddingtop)*v/pthvalue;
			ctx.fillStyle = pcolor;
		    }
		    ctx.fillRect(xoffset, baseliney-barh, unitwidth, barh);
		} else if(v < baselinev) {
		    if(usethreshold && v<=nthvalue) {
			barh = ploth+densitydecorpaddingtop-baseliney;
			ctx.fillStyle = qtconfig.nth;
		    } else {
			barh = (ploth+densitydecorpaddingtop-baseliney)*v/nthvalue;
			ctx.fillStyle = ncolor;
		    }
		    ctx.fillRect(xoffset, baseliney, unitwidth, barh);
		}
	    } else {
	        // no valid baseline (pth and nth all >0 or <0)
		if(v > 0 && v > nthvalue) {
		    if(v >= pthvalue) {
		        // full fill
			ctx.fillStyle = qtconfig.pth;
		        ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, ploth);
		    } else {
		        // half fill, bar pointing upward
			barh = ploth*(v-nthvalue)/(pthvalue-nthvalue);
			ctx.fillStyle = pcolor;
		        ctx.fillRect(xoffset, densitydecorpaddingtop+ploth-barh, unitwidth, barh);
		    }
		} else if(v<0 && v<pthvalue) {
		    if(v <= nthvalue) {
		        // full fill
			ctx.fillStyle = qtconfig.nth;
		        ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, ploth);
		    } else {
		        // half fill, bar pointing downward
			barh = ploth*(pthvalue-v)/(pthvalue-nthvalue);
			ctx.fillStyle = ncolor;
		        ctx.fillRect(xoffset, densitydecorpaddingtop, unitwidth, barh);
		    }
		}
	    }
	    xoffset += unitwidth;
	}
	ctx.fillStyle = regionSpacing.color;
	ctx.fillRect(xoffset, 0, regionSpacing.width, ploth);
	xoffset += regionSpacing.width;
    }
}
function qtrack_plotheatmap(data, ctx, qtconfig, pthvalue, nthvalue, unitwidth) {
    var ploth = qtconfig.height;
    var xoffset = dspBoundary.lwidx;
    var baselinev = 0; // baseline value (always 0...)
    var usethreshold = (qtconfig.thtype!=0);
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(j=start; j<stop; j++) {
	    var v = data[i][j];
	    if(v > baselinev) {
	        if(usethreshold && v>=pthvalue) {
		    ctx.fillStyle = qtconfig.pth;
		} else {
		    var f = (pthvalue-v)/pthvalue; // factor
		    ctx.fillStyle = "rgb("+parseInt((255-qtconfig.pr)*f+qtconfig.pr)+","+
		            parseInt((255-qtconfig.pg)*f+qtconfig.pg)+","+
		            parseInt((255-qtconfig.pb)*f+qtconfig.pb)+")";
		}
		ctx.fillRect(xoffset, 0, unitwidth, ploth);
	    } else if(v < baselinev) {
	        if(usethreshold && v<=nthvalue) {
		    ctx.fillStyle = qtconfig.nth;
		} else {
		    var f = (nthvalue-v)/nthvalue; // factor
		    ctx.fillStyle = "rgb("+parseInt((255-qtconfig.nr)*f+qtconfig.nr)+","+
		            parseInt((255-qtconfig.ng)*f+qtconfig.ng)+","+
		            parseInt((255-qtconfig.nb)*f+qtconfig.nb)+")";
		}
		ctx.fillRect(xoffset, 0, unitwidth, ploth);
	    }
	    xoffset += unitwidth;
	}
	ctx.fillStyle = regionSpacing.color;
	ctx.fillRect(xoffset, 0, regionSpacing.width, ploth);
	xoffset += regionSpacing.width;
    }
}
function qtcpanel_setdisplay(thisqtc,pcolor,ncolor,scale,log,pvcut,tkh,alltk,what,which,pcname,ncname) {
    // turn on qtrack config panel and set appearance by values in thisqtc
    qtc.which = which;
    document.getElementById("ftb_qtCfgdiv").style.display = "block";
    document.getElementById("qtc_what").innerHTML = what;
    document.getElementById("qtc_pcolordiv").style.display = pcolor ? "inline-block" : "none";
    document.getElementById("qtc_ncolordiv").style.display = ncolor ? "inline-block" : "none";
    document.getElementById("qtc_pcolor").innerHTML = pcname;
    document.getElementById("qtc_ncolor").innerHTML = ncname;
    document.getElementById("qtc_logdiv").style.display = log ? "block" : "none";
    document.getElementById("qtc_pvcutoff").style.display = pvcut ? "block" : "none";
    document.getElementById("qtc_tkhdiv").style.display = tkh ? "block" : "none";
    document.getElementById("qtc_alltrackdiv").style.display = alltk ? "block" : "none";
    document.getElementById("qtc_alltrackcheckbox").checked = false;

    if(thisqtc == null) {
        // called by right clicking on metadata heatmap
	document.getElementById("qtc_scalediv").style.display = "block";
	checkInputByvalue('qtc_thresholdradio', '0');
	toggle26(false);
	return;
    }
    // following config panel according to qtc object values
    if(pvcut) {
        changeSelectByValue('pvcutoff', thisqtc.pvcutoff.toString());
	document.getElementById('htest_clc').style.backgroundColor = thisqtc.pvccolor;
    }
    if(scale) {
        // allow configuring scale and threshold
	document.getElementById("qtc_scalediv").style.display = "block";
	checkInputByvalue('qtc_thresholdradio', thisqtc.thtype.toString());
	toggle26(false);
	document.getElementById('qtc_fix_min').value = thisqtc.thmin;
	document.getElementById('qtc_fix_max').value = thisqtc.thmax;
	document.getElementById('qtc_percentile').innerHTML = thisqtc.thpercentile;
	document.getElementById('qtc_slider').style.left = thisqtc.thpercentile;
    } else {
	document.getElementById("qtc_scalediv").style.display = "none";
	checkInputByvalue('qtc_thresholdradio', '0');
	toggle26(false);
    }

    if(pcolor) {
        // positive color
	var c = "rgb("+thisqtc.pr+","+thisqtc.pg+","+thisqtc.pb+")";
	document.getElementById("qtc_pcolor").style.backgroundColor = c;
	document.getElementById("qtc_pcolordiv").style.backgroundColor = c;
        document.getElementById("qtc_pth").style.backgroundColor = thisqtc.pth;
    }
    if(ncolor) {
        // negative color
	var c = "rgb("+thisqtc.nr+","+thisqtc.ng+","+thisqtc.nb+")";
	document.getElementById("qtc_ncolor").style.backgroundColor = c;
	document.getElementById("qtc_ncolordiv").style.backgroundColor = c;
        document.getElementById("qtc_nth").style.backgroundColor = thisqtc.nth;
    }
    if(log) {
        document.getElementById('hook29').checked = thisqtc.uselog;
	toggle29();
	checkInputByvalue('qtc_log', thisqtc.logtype.toString());
    }
    if(tkh) {
        changeSelectByValue('qtc_tkh', thisqtc.height.toString());
    }
}



function mdshowhide(event){
    /* called by clicking on <span> inside <li>, which is non-leaf metadata term
       <li>'s next sibling must be <ul>, and will show/hide it
     */
    var ul = event.target.parentNode.nextSibling;
    if(ul==null)
        fatalError('mdshowhide: next sibling is null');
    var icon;
    if(ul.tagName == 'UL') {
        // clicked on text, ul found
	icon = event.target.firstChild;
    } else {
        // clicked on icon
        icon = event.target;
        ul = event.target.parentNode.parentNode.nextSibling;
	if(ul.tagName != 'UL')
            fatalError('mdshowhide: <ul> not found');
    }
    if(ul.style.display == 'none') {
	ul.style.display = "block";
	icon.innerHTML = '&#8863;';
    } else {
	ul.style.display = 'none';
	icon.innerHTML = '&#8862;';
    }
}
function absolutePosition(obj) {
    var c = [0,0];
    if(obj.offsetParent) {
        var o2 = obj;
	do {
	    c[0] += o2.offsetLeft;
	    c[1] += o2.offsetTop;
	} while(o2 = o2.offsetParent);
    }
    return c;
}
function findPos() {
    iiX = iiY = iiiX = 0;
    var t = absolutePosition(viewbox);
    iiX = t[0];
    iiY = t[1];
    t = absolutePosition(tkAttrHolder);
    iiiX = t[0];
}
function stripChild(holder, what) {
    // if what==0, strip all children
    if(what == undefined) fatalError("stripChild requires two arguments");
    var L = holder.childNodes.length;
    if(what == 0) {
        while(holder.hasChildNodes()) {
	    holder.removeChild(holder.lastChild);
	}
    } else {
        for(var i=what; i<L; i++) 
	    holder.removeChild(holder.lastChild);
    }
}
function controlpanelclick(what) {
    // called by clicking navigation buttons
    // first hide everybody, then toggle on the one clicked
    document.getElementById('tgt_geneset').style.display = 'none';
    document.getElementById('cpbar_geneset').className = 'n3';
    document.getElementById('tgt_juxtapose').style.display = 'none';
    document.getElementById('cpbar_juxtapose').className = 'n3';
    document.getElementById('tgt_scaffold').style.display = 'none';
    document.getElementById('cpbar_scaffold').className = 'n3';
    document.getElementById('tgt_decor').style.display = 'none';
    document.getElementById('cpbar_decor').className = 'n3';
    document.getElementById('tgt_chooseTrack').style.display = 'none';
    document.getElementById('cpbar_chooseTrack').className = 'n3';
    document.getElementById('tgt_corr').style.display = 'none';
    document.getElementById('cpbar_corr').className = 'n3';
    document.getElementById('tgt_htest').style.display = 'none';
    document.getElementById('cpbar_htest').className = 'n3';
    document.getElementById('tgt_pairwiseCompare').style.display = 'none';
    document.getElementById('cpbar_pairwiseCompare').className = 'n3';
    document.getElementById('tgt_customTrack').style.display = 'none';
    document.getElementById('cpbar_customTrack').className = 'n3';
    //document.getElementById('tgt_metadata').style.display = 'none';
    //document.getElementById('cpbar_metadata').className = 'n3';
    document.getElementById('tgt_session').style.display = 'none';
    document.getElementById('cpbar_session').className = 'n3';
    document.getElementById('tgt_config').style.display = 'none';
    document.getElementById('cpbar_config').className = 'n3';

    document.getElementById('tgt_'+what).style.display = 'block';
    document.getElementById('cpbar_'+what).className = 'n2';

    setTimeout('foldcpButtgrps("'+what+'")', 500);

    /* metadata panel insert
    if(what == 'metadata') {
	mdcolormap_invokemds();
    }
    */
}
function foldcpButtgrps(what) {
    // fold control panel button groups
    if(what!="corr" && what!="htest" && what!="pairwiseCompare") {
        if(document.getElementById("bait9").style.display == "block")
	    toggle9();
    }
    if(what!="chooseTrack" && what!="decor" && what!="customTrack") {
        if(document.getElementById("bait10").style.display == "block")
	    toggle10();
    }
    if(what!="geneset" && what!="juxtapose" && what!="scaffold") {
        if(document.getElementById("bait14").style.display == "block")
	    toggle14();
    }
}
function tabclick_customtrack(filetype) {
    document.getElementById("customtrackwrapper_1").style.display = "none";
    document.getElementById("customtracktab_1").className = "cptaboff";
    document.getElementById("customtrackwrapper_3").style.display = "none";
    document.getElementById("customtracktab_3").className = "cptaboff";
    document.getElementById("customtrackwrapper_5").style.display = "none";
    document.getElementById("customtracktab_5").className = "cptaboff";
    document.getElementById("customtrackwrapper_100").style.display = "none";
    document.getElementById("customtracktab_100").className = "cptaboff";
    document.getElementById("customtrackwrapper_101").style.display = "none";
    document.getElementById("customtracktab_101").className = "cptaboff";
    document.getElementById("customtrackwrapper_"+filetype).style.display = "block";
    document.getElementById("customtracktab_"+filetype).className = "cptabon";
    // set this info for manual page button
    var manualbt = document.getElementById("manualbt_customtrack");
    if(filetype == 3)
        manualbt.what = "a";
    else if(filetype == 1)
        manualbt.what = "b";
    else if(filetype == 5)
        manualbt.what = "c";
}
function tabclick_config(what) {
    document.getElementById("configwrapper_config").style.display = "none";
    document.getElementById("configtab_config").className = "cptaboff";
    document.getElementById("configwrapper_misc").style.display = "none";
    document.getElementById("configtab_misc").className = "cptaboff";
    document.getElementById("configwrapper_"+what).style.display = "block";
    document.getElementById("configtab_"+what).className = "cptabon";
    // tell manual page button
    var manualbt = document.getElementById("manualbt_config");
    if(what == "config")
        manualbt.what = "a";
    else
        manualbt.what = "b";
}
function tabclick_geneset(what) {
    // what kind of geneset to submit
    document.getElementById("genesetwrapper_custom").style.display = "none";
    document.getElementById("genesettab_custom").className = "cptaboff";
    document.getElementById("genesetwrapper_kegg").style.display = "none";
    document.getElementById("genesettab_kegg").className = "cptaboff";
    document.getElementById("genesetwrapper_"+what).style.display = "block";
    document.getElementById("genesettab_"+what).className = "cptabon";
}
function tabclick_geneset2(what) {
    // available operations after submitting geneset
    document.getElementById("geneset2wrapper_addremove").style.display = "none";
    document.getElementById("geneset2tab_addremove").className = "cptaboff";
    document.getElementById("geneset2wrapper_changepart").style.display = "none";
    document.getElementById("geneset2tab_changepart").className = "cptaboff";
    document.getElementById("geneset2wrapper_sort").style.display = "none";
    document.getElementById("geneset2tab_sort").className = "cptaboff";
    //document.getElementById("geneset2wrapper_geneplot").style.display = "none";
    //document.getElementById("geneset2tab_geneplot").className = "cptaboff";
    document.getElementById("geneset2wrapper_"+what).style.display = "block";
    document.getElementById("geneset2tab_"+what).className = "cptabon";
    if(what == 'sort') {
        document.getElementById('genesetsortby0').checked = true;
	genesetsortbyChangeoption();
    }
}





/*********************************
      operations on
      positions & coordinates
 *********************************/
function getDspStat() {
    // return array for saving status, see dbSchema.dia
    var startr = regionLst[dspBoundary.vstartr];
    var stopr = regionLst[dspBoundary.vstopr];
    if(juxtaposition.type==0 || juxtaposition.type==1 || juxtaposition.type==2) {
        return [startr[0],
	        parseInt(startr[3]+startr[7]*dspBoundary.vstarts),
		stopr[0],
		parseInt(stopr[3]+stopr[7]*dspBoundary.vstops)];
    } else if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return [startr[6],
	        parseInt(startr[3]+startr[7]*dspBoundary.vstarts),
		stopr[6],
		parseInt(stopr[3]+stopr[7]*dspBoundary.vstops)];
    } else {
        fatalError("getDspStat: wrong juxtaposition.type");
    }
}
function atLeftBorder() {
    // see if leftmost point in regionLst is at left border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[0][6]==border.lname) && (regionLst[0][3]<=border.lpos);
    } else {
        return (regionLst[0][0]==border.lname) && (regionLst[0][3]<=border.lpos);
    }
}
function atRightBorder() {
    // see if rightmost point in regionLst is at right border
    var r = regionLst[regionLst.length-1];
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (r[6]==border.rname) && (r[4]>=border.rpos);
    } else {
        return (r[0]==border.rname) && (r[4]>=border.rpos);
    }
}
function leftwingAtborder() {
    // if left wing is at left border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.lwr][6]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    } else {
        return (regionLst[dspBoundary.lwr][0]==border.lname) && (regionLst[dspBoundary.lwr][3]<=border.lpos);
    }
}
function rightwingAtborder() {
    // if right wing is at right border
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        return (regionLst[dspBoundary.rwr][6]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    } else {
        return (regionLst[dspBoundary.rwr][0]==border.rname) && (regionLst[dspBoundary.rwr][4]>=border.rpos);
    }
}
function computeEntireLength() {
    // regionLst[i][5] # summary points or plotting width must be already made
    entire.length = 0;
    entire.spnum = 0;
    for(var i=0; i<regionLst.length; i++) {
        entire.length += regionLst[i][4]-regionLst[i][3];
	entire.spnum += regionLst[i][5];
    }
    // spnum also contains region spacing
    entire.spnum += regionLst.length-1;
}
function regionLstSPseekright(rid, spid, spnum) {
    /* on regionLst seek to right from given point by a number of summary points
       - rid: index of start region, in regionLst
       - spid: start point in this region, if atbplevel, should be coordinate, else, sp number
       - spnum: # of pixels to seek

       count spacing between regions
       return array of [region index, number]
       if atbplevel, "number" is coordinate, else, is sp number
     */
    if(rid<0 || spid<0) fatalError('regionLstSPseekright: negative param ('+rid+', '+spid+')');
    if(spnum == 0) return [rid, spid];
    if(entire.atbplevel) {
        // spid is .vstarts, vstops, should be # of bp
        for(var i=rid; i<regionLst.length; i++) {
	    if(spnum <= 0) {
	        if(i==0) fatalError("regionLstSPseekright: irregularity (atbplevel)...");
	        return [i-1, regionLst[i-1][4]-regionLst[i-1][3]-1];
	    }
	    var start = (i==rid) ? spid : 0;
	    var remain = (regionLst[i][4]-regionLst[i][3]-start) * entire.bpwidth;
	    if(remain >= spnum)
	        return [i, start+parseInt(spnum/entire.bpwidth)];
	    spnum -= remain + regionSpacing.width;
	}
	i = regionLst.length-1;
	return [i, regionLst[i][4]-regionLst[i][3]-1];
    }
    for(var i=rid; i<regionLst.length; i++) {
	if(spnum <= 0) {
	    if(i == 0) fatalError("regionLstSPseekright: irregularity...");
	    return [i-1, regionLst[i-1][5]-1];
	}
	var start = (i==rid) ? spid : 0;
	var remain = regionLst[i][5] - start;
        if(remain >= spnum)
	    return [i, start+spnum-1]; // FIXME patch of -1
	spnum -= remain + regionSpacing.width;
    }
    i = regionLst.length-1;
    return [i, regionLst[i][5]-1];
}
function regionLstSPseekleft(rid, spid, spnum) {
    /* on regionLst seek to left by a number of summary points
     */
    if(rid<0 || spid<0) fatalError('regionLstSPseekleft: negative param ('+rid+', '+spid+')');
    if(spnum == 0) return [rid, spid];
    if(entire.atbplevel) {
        for(var i=rid; i>=0; i--) {
	    if(spnum <= 0) {
	        if(i == regionLst.length-1) fatalError("regionLstSPseekleft: irregularity (atbplevel) ...");
		return [i+1, 0];
	    }
	    var stop = (i==rid) ? spid : (regionLst[i][4]-regionLst[i][3]-1);
	    if(stop*entire.bpwidth >= spnum)
	        return [i, stop-parseInt(spnum/entire.bpwidth)];
	    spnum -= stop*entire.bpwidth + regionSpacing.width;
	}
	return [0,0];
    }
    for(var i=rid; i>=0; i--) {
	if(spnum <= 0) {
	    if(i == regionLst.length-1) fatalError("regionLstSPseekleft: irregularity...");
	    return [i+1, 0];
	}
	var stop = (i==rid) ? spid+1 : regionLst[i][5];
        if(stop >= spnum)
	    return [i, stop-spnum];
	spnum -= stop + regionSpacing.width;
    }
    // not exhausted, tolerate
    return [0, 0];
}
function updatePixelSpanLength() {
    // go over regionLst, calculate size of region spanned by one pixel, store that, update using average
    if(entire.atbplevel) {
        // entire.summarySize won't be used...
        document.getElementById('onepixelspanlength').innerHTML = "One base pair spans "+entire.bpwidth+" pixels";
    } else {
        var total = 0;
        for(var i=0; i<regionLst.length; i++)
	    total += regionLst[i][7];
        entire.summarySize = total / regionLst.length; // will be used in move...
	var sp;
	if(entire.summarySize>5)
	    sp = Math.floor(entire.summarySize);
	else {
	    var n = new Number(entire.summarySize);
	    sp = n.toPrecision(2);
	}
        document.getElementById('onepixelspanlength').innerHTML = "One pixel spans "+sp+" base pairs";
    }
}
function updateDsp() {
    // updates information about heatmap view (dsp, tracks)
    var li = document.getElementById("howmanytracks");
    var a=0,b=0;
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].isCustom) b++;
	else a++;
    }
    if(a+b == 0) {
        li.innerHTML = "no track on display";
    } else {
        if(a > 0) 
	    li.innerHTML = '<b>'+a+"</b> track"+(a==1?"":"s");
	else
	    li.innerHTML = "no server track"
	if(b > 0) li.innerHTML += ", "+b+" custom track"+(b==1?"":"s");
    }

    li = document.getElementById("startatwhere");
    var r = regionLst[dspBoundary.vstartr];
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        if(juxtaposition.type == 3)
            startatwhere.innerHTML = "start at gene/region: ";
	else if(juxtaposition.type == 4)
            startatwhere.innerHTML = "start at gene: ";
	else if(juxtaposition.type == 5)
            startatwhere.innerHTML = "start at contig: ";
	else
            startatwhere.innerHTML = "start at darkMatter: ";
        startatwhere.innerHTML += r[6];
    } else {
        startatwhere.innerHTML = "start: "+r[0]+' '+(entire.atbplevel?(regionLst[dspBoundary.vstartr][3]+dspBoundary.vstarts):getPointCoord(dspBoundary.vstartr,dspBoundary.vstarts));
    }
    li = document.getElementById("stopatwhere");
    r = regionLst[dspBoundary.vstopr];
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        if(juxtaposition.type == 3)
            stopatwhere.innerHTML = "stop at gene/region: ";
        else if(juxtaposition.type == 4)
            stopatwhere.innerHTML = "stop at gene: ";
        else if(juxtaposition.type == 5)
            stopatwhere.innerHTML = "stop at contig: ";
        else
            stopatwhere.innerHTML = "stop at darkMatter: ";
        stopatwhere.innerHTML += r[6];
    } else {
        stopatwhere.innerHTML = "stop: "+r[0]+' '+(entire.atbplevel?(regionLst[dspBoundary.vstopr][3]+dspBoundary.vstops):getPointCoord(dspBoundary.vstopr,dspBoundary.vstops));
    }
}
function updateDspBoundary() {
    /* requires:
          move.styleLeft 
	  regionLst, where [5] region plot width must be ready
     */
    var t = regionLstSPseekright(0, 0, -move.styleLeft);
    dspBoundary.vstartr = t[0];
    dspBoundary.vstarts = t[1];
    t = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, hmSpan);
    dspBoundary.vstopr = t[0];
    dspBoundary.vstops = t[1];
    t = regionLstSPseekright(dspBoundary.vstopr, dspBoundary.vstops, hmSpan);
    dspBoundary.rwr = t[0];
    dspBoundary.rws = t[1];
    t = regionLstSPseekleft(dspBoundary.vstartr, dspBoundary.vstarts, hmSpan);
    dspBoundary.lwr = t[0];
    dspBoundary.lws = t[1];
    /*
    if(entire.atbplevel) {
        // make +/-1 adjustment?
        dspBoundary.lws = getPointCoord(dspBoundary.lwr, dspBoundary.lws) 
		- regionLst[dspBoundary.lwr][3];
        dspBoundary.vstarts = getPointCoord(dspBoundary.vstartr, dspBoundary.vstarts) 
		- regionLst[dspBoundary.vstartr][3];
	dspBoundary.vstops = getPointCoord(dspBoundary.vstopr, dspBoundary.vstops) 
		- regionLst[dspBoundary.vstopr][3];
	dspBoundary.rws = getPointCoord(dspBoundary.rwr, dspBoundary.rws) 
		- regionLst[dspBoundary.rwr][3];
    }
    */
    dspBoundary.lwidx = 0;
    dspBoundary.lwrlpx = 0;
    for(var i=0; i<dspBoundary.lwr; i++) {
        dspBoundary.lwidx += regionLst[i][5] + regionSpacing.width;
	dspBoundary.lwrlpx += regionLst[i][5] + regionSpacing.width;
    }
    dspBoundary.lwidx += dspBoundary.lws * (entire.atbplevel ? entire.bpwidth : 1);
}
function mayUpdateBorder(data) {
    if('border' in data) mustUpdateBorder(data);
}
function mustUpdateBorder(data) {
    if(!('border' in data)) fatalError("mustUpdateBorder: border trigger missing");
    border.lname = data['border'][0];
    border.lpos = data['border'][1];
    border.rname = data['border'][2];
    border.rpos = data['border'][3];
}
function setMovablePosition(cleft) {
    // set all movable parts here...
    if(cleft > 0)
        cleft = 0;
    else if(cleft < hmSpan - entire.spnum)
        cleft = hmSpan - entire.spnum;
    move.styleLeft = cleft;
    for(var i=0; i<tkLst.length; i++)
        tkLst[i].hmC.style.left = cleft;
    ideogram.canvas.style.left = cleft;
    if(rulercanvas.style.display != 'none')
        rulercanvas.style.left = cleft;
    for(var gf in decorCanvasHash)
        decorCanvasHash[gf].canvas.style.left = cleft;
    if(htest.inuse)
        htest.canvas.style.left = cleft;
    pwc.canvas.style.left = cleft;
}
function viewboxMD(event) { // down
    if(event.button != 0) return;
    event.preventDefault();
    move.oldpos = move.styleLeft;
    tooltiphide();
    viewbox.removeEventListener("mousemove", tooltipmove, false);
    viewbox.removeEventListener("mouseover", tooltipshow, false);
    viewbox.removeEventListener("mouseout", tooltiphide, false);
    document.body.addEventListener("mousemove", viewboxM, false);
    document.body.addEventListener("mouseup", viewboxMU, false);
    move.mousex = event.clientX;
    move.moved = true;
}
function viewboxM(event) { // move
    if(entire.atbplevel) {
        // escape move distance that is smaller than bpwidth
        var moved = event.clientX - move.mousex;
	if(Math.abs(moved) >= entire.bpwidth) {
	    setMovablePosition(move.styleLeft + parseInt(moved/entire.bpwidth)*entire.bpwidth);
	    move.mousex = event.clientX;
	}
    } else {
        setMovablePosition(move.styleLeft + event.clientX - move.mousex);
        move.mousex = event.clientX;
    }
}
function viewboxMUreturn() {
    // bunch of stuff repeatedly get called
    viewbox.addEventListener("mousemove", tooltipmove, false);
    viewbox.addEventListener("mouseover", tooltipshow, false);
    viewbox.addEventListener("mouseout", tooltiphide, false);
    document.body.removeEventListener("mousemove", viewboxM, false);
    document.body.removeEventListener("mouseup", viewboxMU, false);
}
function viewboxMU() { // up
    /* waah
       move left: newly exposed regions are on left (drag canvas to right)
       move right: newly exposed regions on right (drag canvas to left)
       don't pump data, keep them all in buffer until zoom in level changed
     */
    if(!move.moved) {
        // but this should be accident
        viewboxMUreturn();
        return;
    }
    move.moved = false;
    if(move.processing) {
        viewboxMUreturn();
        return;
    }
    move.direction = null;
    if(atLeftBorder() && atRightBorder()) {
        // simplest case
	updateDspBoundary();
	updateDsp();
	for(var gf in decorCanvasHash)
	    drawDecorCanvas(gf);
	drawHmCanvas();
	minichrcanvas_setindicator();
	if(correlation.inuse)
	    computeCorr();
	if(pwc.inuse) pwc_compute();
    } else if(move.styleLeft > move.oldpos) {
        /*** drag canvas to right ***/
	/* see if number of summary points beyond move.styleLeft is below hmSpan */
	if(-move.styleLeft <= hmSpan) {
            if(atLeftBorder()) {
	        updateDspBoundary();
	        updateDsp();
	        computeEntireLength();
	        drawHmCanvas();
	        drawIdeogramCanvas();
	        for(var gf in decorCanvasHash)
	            drawDecorCanvas(gf);
	        if(htest.inuse) drawHtestCanvas();
	        if(correlation.inuse)
		    computeCorr();
	        if(pwc.inuse) pwc_compute();
	    } else {
	        // request data
		move.direction = 'l';
	        move.processing = true;
                var moveSize = move.styleLeft - move.oldpos;
		var moveDist;
		if(entire.atbplevel)
		    moveDist = parseInt(moveSize/entire.bpwidth);
		else
		    moveDist = parseInt(moveSize * entire.summarySize);
		cloak2(viewbox);
                ajaxX(displayedRegionParamMove()+hmtkChoice()+decorParams()+corrParam()+htestParams()+'&summarySize='+moveSize+'&distance='+moveDist+'&move='+move.direction+(entire.atbplevel?'&atbplevel=on':''));
	    }
	} else {
	    // at leisure, there's still spare space on left, no ajax
	    //if(ideogram.chr != null) minichrcanvas_setindicator();
	    updateDspBoundary();
	    updateDsp();
	    drawHmCanvas();
	    drawIdeogramCanvas();
	    if(correlation.inuse)
	        computeCorr();
	    for(var gf in decorCanvasHash)
	        drawDecorCanvas(gf);
	    if(pwc.inuse) pwc_compute();
	}
    } else if(move.styleLeft < move.oldpos) {
        /*** drag canvas to left ***/
	/* see if number of summary points beyond hmSpan-move.styleLeft is below hmSpan */
	if(entire.spnum-(hmSpan-move.styleLeft) <= hmSpan) {
	    if(atRightBorder()) {
	        updateDspBoundary();
	        updateDsp();
	        for(i=0; i<tkLst.length; i++)
	            tkLst[i].hmC.style.left = move.styleLeft;
	        ideogram.canvas.style.left = move.styleLeft;
	        for(var gf in decorCanvasHash)
	            decorCanvasHash[gf].canvas.style.left = move.styleLeft;
	        computeEntireLength();
	        drawHmCanvas();
	        drawIdeogramCanvas();
	        for(var gf in decorCanvasHash)
	            drawDecorCanvas(gf);
	        if(correlation.inuse)
		    computeCorr();
	        if(htest.inuse) drawHtestCanvas();
	        if(pwc.inuse) pwc_compute();
	    } else {
	        // request data
		move.direction = 'r';
	        move.processing = true;
                var moveSize = move.oldpos - move.styleLeft;
		var moveDist;
		if(entire.atbplevel)
		    moveDist = parseInt(moveSize/entire.bpwidth);
		else
		    moveDist = parseInt(moveSize*entire.summarySize);
		cloak2(viewbox);
                ajaxX(displayedRegionParamMove()+hmtkChoice()+decorParams()+corrParam()+htestParams()+'&summarySize='+moveSize+'&distance='+moveDist+'&move='+move.direction+(entire.atbplevel?'&atbplevel=on':''));
	    }
	} else {
	    // at leisure, no ajax
	    //if(ideogram.chr != null) minichrcanvas_setindicator();
	    updateDspBoundary();
	    updateDsp();
	    drawHmCanvas();
	    if(correlation.inuse)
	        computeCorr();
	    for(var gf in decorCanvasHash)
	        drawDecorCanvas(gf);
	    drawIdeogramCanvas();
	    if(pwc.inuse) pwc_compute();
	}
    }
    viewboxMUreturn();
}

function moveMergeNumericaldata(source, sink) {
    var oldlen = sink.length;
    var newlen = source.length;
    if(move.direction == null) {
        // replace old sink data with new data
	for(var i=0; i<newlen; i++)
	    sink[i] = source[i];
	if(oldlen > newlen) {
	    for(i=0; i<newlen-oldlen; i++)
	        sink.pop();
	}
    } else if(move.direction == 'l') {
	if(move.merge) {
	    var lastr = source[newlen-1];
	    sink[0] = lastr.concat(sink[0]);
	    source.pop();
	}
	for(var i=newlen-2; i>=0; i--)
	    sink.unshift(source[i]);
    } else {
	if(move.merge) {
	    sink[oldlen-1] = sink[oldlen-1].concat(source[0]);
	    source.shift();
	}
	for(var i=0; i<source.length; i++)
	    sink.push(source[i]);
    }
}




/*******************************
     CGI parameter composing
     these functions must return something, 
     or else "undefined" will show up in param string...
 *******************************/

function displayedRegionParam() {
    /* only boundary within viewbox will be returned:
           start: .vstartr .vstarts
	   stop:  .vstopr  .vstops
       will be used in case of dsp zoom in level is changed:

       variable arg: start coord of first region, stop coord of last region
       to cope with zoom in

       - zoom out
       - zoom in (image area select)
       - change collation type

       total number of summary points will not be provided
     */
    var r1 = regionLst[dspBoundary.vstartr];
    var r2 = regionLst[dspBoundary.vstopr];
    var param = 'dbName='+dbInfo.name;
    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        if(juxtaposition.type==3) {
            param += "&itemlist=on"+gss_param(1)+"&statusId="+statusId+'&startChr='+r1[6]+'&stopChr='+r2[6];
	} else if(juxtaposition.type == 4) {
            param += "&itemlist=on"+gss_param(2)+"&statusId="+statusId+'&startChr='+r1[6]+'&stopChr='+r2[6];
	} else if(juxtaposition.type == 5) {
            param += "&itemlist=on&iscontig=on&statusId="+statusId+'&startChr='+r1[6]+'&stopChr='+r2[6];
	} else {
	    fatalError("displayedRegionParam: unknown juxtaposition.type value");
	}
    } else {
        param += '&gftype='+juxtaposition.what+'&startChr='+r1[0]+'&stopChr='+r2[0];
	if(juxtaposition.type==2) 
	    param += '&gfiscustom=on';
    }

    if(arguments[0]!=undefined && arguments[1]!=undefined) {
        return param + "&startCoord=" + arguments[0] + "&stopCoord=" + arguments[1];
    } else {
        return param + "&startCoord=" + 
	    (entire.atbplevel?(r1[3]+dspBoundary.vstarts):getPointCoord(dspBoundary.vstartr,dspBoundary.vstarts))
	    + "&stopCoord=" + 
	    (entire.atbplevel?(r2[3]+dspBoundary.vstops):getPointCoord(dspBoundary.vstopr,dspBoundary.vstops));
    }
}
function displayedRegionParamMove() {
    var lastr = regionLst[regionLst.length-1];
    var jt = juxtaposition.type;
    if(jt==3 || jt==4 || jt==5) {
        var samestring = "itemlist=on&startChr="+regionLst[0][6]+
	       "&startCoord="+regionLst[0][3]+
	       "&stopChr="+lastr[6]+
	       "&stopCoord="+lastr[4]+
	       "&session="+sessionId+
	       "&statusId="+statusId+
	       "&sptotalnum="+(entire.spnum-regionLst.length+1)+
	       "&dbName="+dbInfo.name;
        if(jt==3) {
            return samestring+gss_param(1);
	} else if(jt==4) {
            return samestring+gss_param(2);
	} else if(jt== 5) {
            return samestring+"&iscontig=on";
	} else {
	    fatalError("displayedRegionParamMove: unknown juxtaposition.type value");
	}
    }
    //var gf = getValue_by_radioName('gftype');
    var gf = juxtaposition.what;
    var gfparam = 'gftype='+gf;
    if(jt == 2) 
        gfparam += '&gfiscustom=on';
    return gfparam +
               "&startChr=" + regionLst[0][0] +
               "&startCoord=" + regionLst[0][3] +
               "&stopChr=" + lastr[0] +
               "&stopCoord=" + lastr[4] +
	       "&sptotalnum="+ (entire.spnum-regionLst.length+1)+
	       "&dbName="+dbInfo.name;
}
function displayedRegionParamPrecise() {
    /* use in operations that doesn't change dsp at all,
       will return summary size of each region joined by comman,
       goal is to precisely replicate dsp currently on client side

       - add server/custom bigwig tracks
       - add server/custom bigbed tracks
       - htest
       - correlation with bigbed density
       - get data
     */
    var jt = juxtaposition.type;
    if(jt==3 || jt==4 || jt==5) {
        // only need to pass spnum of each item, but no need to pass item name, start/stop
	// as that's already in database
        var sizelst = []; // spnum in each item
        for(var i=0; i<regionLst.length; i++) 
	    sizelst.push(regionLst[i][5]);
	var lastr = regionLst[regionLst.length - 1];
	var samestring = "itemlist=on&startChr="+regionLst[0][6]+
	        "&startCoord="+regionLst[0][3]+
	        "&stopChr="+lastr[6]+
	        "&stopCoord="+lastr[4]+
	        "&statusId="+statusId+
	        "&sptotalnum="+ (entire.atbplevel?entire.length:(entire.spnum-i)) +
	        "&allrss=" + sizelst.join(',')+
		"&dbName=" + dbInfo.name;
	if(jt==3) {
            return samestring+gss_param(1);
	} else if(jt==4) {
            return samestring+gss_param(2);
	} else if(jt== 5) {
	    return samestring+"&iscontig=on";
	} else {
	    fatalError("displayedRegionParamPrecise: unknown juxtaposition.type value");
	}
    }
    // by passing exact information on each region in collation mode (chr, start/stop, spnum)
    // it saves a lot of computing on server side, so it's necessary
    var gf = juxtaposition.what;
    var gfparam = 'gftype='+gf;
    if(jt== 2) gfparam += '&gfiscustom=on';
    var lst = [];
    for(var i=0; i<regionLst.length; i++) {
	var r = regionLst[i];
	lst.push(r[0]+','+r[1]+','+r[2]+','+(entire.atbplevel ? (r[4]-r[3]) : r[5]));
    }
    return gfparam +
	   "&regionLst=" + lst.join(',') +
           "&startCoord=" + regionLst[0][3] +
           "&stopCoord=" + regionLst[regionLst.length-1][4] +
	   "&dbName="+dbInfo.name;
}
function serverTrackChoice() {
    var lst = [];
    for(var i=0; i<tkLst.length; i++) {
        if(!tkLst[i].isCustom) {
	    if(htest.inuse)
	        lst.push(tkLst[i].name+'='+document.getElementById(tkLst[i].name+"htestgrpselect").selectedIndex);
	    else
	        lst.push(tkLst[i].name+'=on');
	}
    }
    if(lst.length > 0)
        return '&'+lst.join('&');
    return '';
}
function customTrackChoice() {
    var lst = [];
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].isCustom) {
	    if(htest.inuse) {
	        lst.push(tkLst[i].url+'|'+tkLst[i].name+'|'+document.getElementById(tkLst[i].name+"htestgrpselect").selectedIndex);
	    } else {
	        lst.push(tkLst[i].url+'|'+tkLst[i].name);
	    }
	}
    }
    if(lst.length > 0)
        return '&custom='+lst.join(',');
    return '';
}
function hmtkChoice() {
    /* heatmap track choice param
       currently have server/custom bigwig
       should be able to accommondate other track types
     */
    var ft2 = [];
    var ft3 = [];
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].isCustom) {
	    ft3.push(tkLst[i].url);
	    ft3.push(tkLst[i].name);
	} else {
	    ft2.push(tkLst[i].name);
	}
    }
    return (ft2.length>0 ? "&hmtk2="+ft2.join(",") : "") +
           (ft3.length>0 ? "&hmtk3="+ft3.join(",") : "");
}
function hmtkChoice_htest() {
    // only track participating htest
    var alltk = [];
    for(var i=1; i<=htest.grpnum; i++) {
        alltk = alltk.concat(htest["gtn"+i]);
    }
    var ft2 = [];
    var ft3 = [];
    for(var i=0; i<alltk.length; i++) {
        var obj = findTrackByName(alltk[i]);
        if(obj.isCustom) {
	    ft3.push(obj.url);
	    ft3.push(obj.name);
	} else {
	    ft2.push(obj.name);
	}
    }
    return (ft2.length>0 ? "&hmtk2="+ft2.join(",") : "") +
           (ft3.length>0 ? "&hmtk3="+ft3.join(",") : "");
}
function decorParams() {
    // decor, grouped by file type
    // ASSume decor bigwig can only be 8
    // todo server bam not supported
    var decor0=[], decor1=[], decor8=[], decor4=[], decor5=[];
    for(var gf in decorCanvasHash) {
        var mode = decorInfo[gf].mode;
        var url = decorInfo[gf].url;
        switch(decorInfo[gf].fileType) {
	    case 0: 
	        // server bigbed
	        decor0.push(gf+','+mode);
		break;
	    case 1: 
	        // custom bigbed
	        decor1.push(gf+','+decorInfo[gf].label+','+url+','+mode);
		break;
	    case 8:
	    	// server bigwig
		decor8.push(gf+','+mode);
		break;
	    case 4:
	    	// server BAM (for future use...)
		decor4.push(gf+','+mode);
		break;
	    case 5:
	    	// custom BAM
		decor5.push(gf+','+decorInfo[gf].label+','+url+','+mode);
		break;
	    default:
	        fatalError("decorParams: unknown decor file type");
	}
    }
    return ((decor0.length>0) ? '&decor0='+decor0.join(',') : '') +
           ((decor1.length>0) ? '&decor1='+decor1.join(',') : '') +
           ((decor8.length>0) ? '&decor8='+decor8.join(',') : '') +
           ((decor4.length>0) ? '&decor4='+decor4.join(',') : '') +
           ((decor5.length>0) ? '&decor5='+decor5.join(',') : '');
}
function decorRenderingParams() {
    /* make a hash, key: decor name, val: hash of rendering param
       for saving status
       todo server bam is skipped!
     */
    var lst = ['{'];
    for(var gf in decorCanvasHash) {
        if(decorInfo[gf].fileType == 4)
	    continue;
        lst.push("\\\""+gf+"\\\":{");
	lst.push("\\\"textcolor\\\":\\\""+decorCanvasHash[gf].textcolor+"\\\",");
	lst.push("\\\"fontsize\\\":\\\""+decorCanvasHash[gf].fontsize+"\\\",");
	lst.push("\\\"fontfamily\\\":\\\""+decorCanvasHash[gf].fontfamily+"\\\",");
	lst.push("\\\"fontbold\\\":"+decorCanvasHash[gf].fontbold+",");
	lst.push("\\\"bedcolor\\\":\\\""+decorCanvasHash[gf].bedcolor+"\\\",");
	lst.push("\\\"forwardcolor\\\":\\\""+decorCanvasHash[gf].forwardcolor+"\\\",");
	lst.push("\\\"reversecolor\\\":\\\""+decorCanvasHash[gf].reversecolor+"\\\",");
	lst.push("\\\"mismatchcolor\\\":\\\""+decorCanvasHash[gf].mismatchcolor+"\\\",");
	lst.push("},");
    }
    lst.push('}');
    return lst.join('');
}

function corrParam() {
    /* if doing inter-track correlation, no need to interact with CGI,
       and will return empty string
     */
    if(!correlation.inuse)
        return "";
    var tname = correlation.targetname;
    switch(correlation.targetft)
    {
    case 0: // bigbed
        if(tname in decorCanvasHash && decorInfo[tname].mode=="density")
	    return "";
        return "&corrft=0&correlation="+tname;
    case 1: // bigbed (c)
        if(tname in decorCanvasHash && decorInfo[tname].mode=="density")
	    return "";
        return "&corrft=1&correlation="+escape(decorInfo[tname].url);
    case 2: // bigwig
	// heatmap TODO do we need to care if the track is displayed?
	return "";
    case 3: // bigwig (c) TODO allow track not to be displayed
        return "";
    case 8:
	// decor
	if(tname in decorCanvasHash)
	    return "";
	return "&corrft=8&correlation="+tname;
    case 4: // bam
        if(tname in decorCanvasHash && decorInfo[tname].mode=="density")
	    return "";
        return "&corrft=4&correlation="+tname;
    case 5: // bam (c)
        if(tname in decorCanvasHash && decorInfo[tname].mode=="density")
	    return "";
        return "&corrft=5&correlation="+escape(decorInfo[tname].url);
    default:
        fatalError("corrParam: unknown file type");
    }
}
function cloak(holder) {
    // images/loading.gif size: 128x128
    var c = document.createElement('div');
    c.name = 'cloak';
    c.style.position = 'absolute';
    c.style.left = 0;
    c.style.top = 0;
    c.style.backgroundColor = 'white';
    c.style.opacity = 0.6;
    c.style.height = holder.clientHeight;
    c.style.width = holder.clientWidth;
    var img = document.createElement("img");
    img.src = "images/loading.gif";
    if(holder.clientHeight > 128)
        c.style.paddingTop = (holder.clientHeight-128)/2;
    c.style.paddingLeft = (holder.clientWidth-128)/2;
    c.appendChild(img);
    holder.appendChild(c);
}
function cloak2(holder) {
    // only add the roller image
    var img = document.createElement("img");
    img.src = "images/loading.gif";
    img.name = "cloak";
    img.style.position = "absolute";
    if(holder.clientHeight > 128)
        img.style.top = (holder.clientHeight-128)/2;
    else
        img.style.top = 0;
    img.style.left = (holder.clientWidth-128)/2;
    img.style.opacity = 0.4;
    holder.appendChild(img);
}
function unveil(holder) {
    var c = holder.lastChild;
    if(c!=null && c.id!=undefined && c.name=='cloak')
	holder.removeChild(c);
}




/***************************
     fundamental ajax/json routines
 ***************************/
function computeMovableLeft(startRegionIdx, startRegionCoord) {
    /* parameters defines start point (left start of heatmap viewbox):
       startRegionIdx: regionLst index
       startRegionCoord: actual genomic coordinate in that region

       anything on the left of this point will be hidden from display,
       so need to compute their plot length, which is move.styleLeft
     */
    if(startRegionCoord < regionLst[startRegionIdx][3])
        fatalError("computeMovableLeft: startRegionCoord ("+startRegionCoord+") < region dstart ("+regionLst[startRegionIdx][3]+")");

    move.styleLeft = 0;

    if(entire.atbplevel) {
        for(var i=0; i<startRegionIdx; i++)
	    move.styleLeft += entire.bpwidth*(regionLst[i][4]-regionLst[i][3])+regionSpacing.width;
	move.styleLeft += entire.bpwidth*(startRegionCoord-regionLst[startRegionIdx][3]);
    } else {
        // regions before start region
        for(var i=0; i<startRegionIdx; i++)
            move.styleLeft += regionLst[i][5] + regionSpacing.width;
        // add number of summary points in this region before point
        move.styleLeft += parseInt((startRegionCoord-regionLst[startRegionIdx][3])/regionLst[startRegionIdx][7]);
    }
    move.styleLeft = 0-move.styleLeft;
}
function jsonMakeRegionLst(data) {
    /* update regionLst, 
       handles moves (beware operations apply to different context)
       compute summary size for each region
       special attention to computeMovableLeft()
     */
    if(!('regionLst' in data)) fatalError("jsonMakeRegionLst: regionLst missing");
    var in_gsv = juxtaposition.type==3 || juxtaposition.type==4;
    if(move.direction == null) {
        regionLst = data['regionLst'];
	if(in_gsv) {
	    // need to store geneset flanking
	    genesetview.flanking = data.gsvflanking;
	}
    } else {
        /* special attention --
           move.styleLeft has been set to a new value during move,
	   where .style.left of all movable components were set to it.
	   If moved to right, .styleLeft won't need to be changed,
	   but if moved to left, it has to be changed to accommondate new data.

	   1. find current view region start by setting
	      dspBoundary.vstartr .vstarts using old regionLst
	   2. update regionLst
	      if .vstartr==0, and move to left, and merge: need to shift .vstartr .vstarts
	   3. build dspBoundary
	 */
	// make new start point
	var tmpr = regionLstSPseekright(0,0,-move.styleLeft);
	dspBoundary.vstartr = tmpr[0];
	dspBoundary.vstarts = tmpr[1];
	// update regionLst
	var newlst = data['regionLst'];
        if(move.direction == 'l') {
            if(move.merge) {
	        var lastr = newlst[newlst.length-1];
	        regionLst[0][3] = lastr[3]; // dstart
	        regionLst[0][5] += lastr[5]; // # summary points
		if(dspBoundary.vstartr == 0) {
		    // update .vstarts, beware the differential treatment
		    dspBoundary.vstarts += entire.atbplevel?(lastr[4]-lastr[3]):lastr[5];
		}
	        newlst.pop();
	    }
	    regionLst = newlst.concat(regionLst);
	    // shift startRegionIdx
	    dspBoundary.vstartr += newlst.length;
	    if(in_gsv) {
	        newlst = data.gsvflanking;
		if(newlst.length > 1) {
		    genesetview.flanking = newlst.slice(0,newlst.length-1).concat(genesetview.flanking);
		}
	    }
        } else {
            if(move.merge) {
	        var firstr = newlst[0];
	        var lastr = regionLst[regionLst.length-1];
	        lastr[4] = firstr[4]; // dstop
	        lastr[5] += firstr[5]; // # summary points
	        newlst.shift();
	    }
	    regionLst = regionLst.concat(newlst);
	    if(in_gsv) {
	        newlst = data.gsvflanking;
		if(newlst.length > 1) {
		    genesetview.flanking = genesetview.flanking.concat(newlst.slice(1, newlst.length));
		}
	    }
        }
	/***  upon moving to left, need to re-compute new move.styleLeft  
	      but actually do this for all cases??
	 ***/
	move.styleLeft = 0;
	for(var i=0; i<dspBoundary.vstartr; i++) {
	    move.styleLeft += regionLst[i][5] + regionSpacing.width;
	}
	move.styleLeft += dspBoundary.vstarts*(entire.atbplevel?entire.bpwidth:1)+1; 
	move.styleLeft = 0-move.styleLeft;
    }
    computeEntireLength();
        
    /* compute summary size (size of summary points, # bp each pixel spans) 
       it's okay to compute for all cases, but at basepair level, it's useless
     */
    for(var i=0; i<regionLst.length; i++) {
        if(regionLst[i][7] == undefined)
            regionLst[i][7] = (regionLst[i][4]-regionLst[i][3])/regionLst[i][5];
    }

    if(move.direction == null) {
        /* CGI tells if at basepair level... only when not moving!

	   *** Should this be the only place to determine 
	             whether is at basepair level?

	 */
        entire.atbplevel = ('atbplevel' in data);
        if(entire.atbplevel) {
	    // decide plot width for basepairs (integer number of pixels, <= entire.MAXbpwidth)
	    for(i=1; i<entire.MAXbpwidth; i++) {
	        if(entire.length*i >= hmSpan*3)
		    break;
	    }
	    entire.bpwidth = i;
	    /* atbplevel special update:
	          regionLst[i][5] to be region plotting width
		  entire.spnum to be plotting width of everything...
             */
	    entire.spnum = 0;
	    for(i=0; i<regionLst.length; i++) {
	        regionLst[i][5] = entire.bpwidth * (regionLst[i][4]-regionLst[i][3]);
		entire.spnum += regionLst[i][5];
            }
	    entire.spnum += regionLst.length-1;
	}
        // compute move.styleLeft for not moving...
        if(!('viewStart' in data)) fatalError("jsonMakeRegionLst: viewStart missing when not moving");
        computeMovableLeft(data['viewStart'][0], data['viewStart'][1]);
        updatePixelSpanLength();
    }
    updateDspBoundary();
    updateDsp();
}
function jsonXY(data) {
    /* called by:
       - fresh start
       - restore status

       NOT called by "move"
       htest won't be processed here
     */
    jsonMakeRegionLst(data);

    jsonTrackAddnew(data);

    // clear existing decor canvas
    for(var gf in decorCanvasHash) { removeDecorCanvas(gf);}

    // restore stack decor rendering param in case of restoring session
    if("decorRenderingParams" in data) {
        /* ASSume all decors to be restored are included in this hash, no matter what type it is
	   todo this is duplicative with jsonDecor where it also calls makeNewDecorCanvas
	 */
	var decp = data.decorRenderingParams;
	for(var gf in decp) {
	    // make new entry in decorCanvasHash, painfully
	    var dat;
	    for(var i=0; i<data.decorData.length; i++) {
	        if(data.decorData[i][0] == gf) {
		    dat =  data.decorData[i];
		    break;
		}
	    }
	    makeNewDecorCanvas(gf, dat[5], dat[4], dat[1], dat[3], 0, dat[2]);
	    for(var k in decp[gf]) {decorCanvasHash[gf][k] = decp[gf][k];}
	}
    }
    // restore qtc of decors in case of restoring session
    if('qtc' in data) {
        for(var gf in decorCanvasHash) {
	    qtc_paramCopy(data.qtc[gf], decorCanvasHash[gf].qtc);
	}
    }


    /* recover all custom track information
       tkname : [ ft, label, url, servermd, custmd ]
     */
    if('customTrackAttr' in data) {
	// custom bigwig info
	var v = data.customTrackAttr.bigwig;
	for(var name in v) {
	    // recover hmtk.custom entry, it might be already there if it is displayed
	    if(!(name in hmtk.custom))
	        hmtk.custom[name] = { label:v[name][1], url:v[name][2] };
	    hmtk.custom[name].servermd = v[name][3];
	    hmtk.custom[name].custmd = v[name][4];
	    var obj = findTrackByName(name);
	    if(obj != null) {
	        obj.attrhash = v[name][3];
		obj.custmd = v[name][4];
	        obj.attrlst = [];
	        obj.attrcoloridxlst = [];
	    }
	    // fixme confusing patch
	    registerCustomtrack(name, v[name][1], v[name][2], 3);
	    hmtk.tolabel[name] = v[name][1]; // ?
	    findTrackByName(name).label = v[name][1];
	}
	/* custom bigbed/bam info
	   fixme: previous fillup of decorInfo is incomplete
	 */
	v = data.customTrackAttr.bigbedbam;
	for(name in v) {
	    if(!(name in decorInfo)) {
                decorInfo[name] = {fileType:v[name][0], label:v[name][1], url:v[name][2], grp:-1, hasStruct:0, mode:'hide'};
	    }
	    // fixme confusing patch
	    registerCustomtrack(name, v[name][1], v[name][2], v[name][0]);
	    decorInfo[name].custmd = v[name][4];
	}
    }

    makeTrackAttrAll();
    mcmSortTrack(sortTrackIdx);

    /* in case of restoring session, need to restore .qtc before rendering tracks */
    if('qtc' in data) {
	for(var i=0; i<tkLst.length; i++) {
	    qtc_paramCopy(data.qtc.hmtk[tkLst[i].name], tkLst[i].qtc);
	}
    }
    trackHeightChanged(true); // drawHmCanvas() called here

    // ideogram related
    if('ideogram' in data) {
        ideogram.band = data['ideogram'];
    }
    drawIdeogramCanvas();

    mayUpdateBorder(data);


    jsonDecor(data);
    if('corrData' in data) jsonCorr(data);

    document.body.style.cursor = "auto";
}
function jsonX(data) {
    /* hmcanvas moves are dealt here
       specially, need to tell if data merging will happen in case of move
       steps are messy, must be in strict order
     */

    mayUpdateBorder(data);

    if(move.direction != null) {
        /* check if region at new/old juncture are same
	   beware: atbplevel, region data passed from CGI have # of bp as [5]
	           need to multiply by entire.bpwidth
	 */
	if(entire.atbplevel) {
	    for(var i=0; i<data['regionLst'].length; i++)
	        data['regionLst'][i][5] *= entire.bpwidth;
	}
        move.merge = false;
	if(juxtaposition.type==3 || juxtaposition.type==4) {
	    // applies both to itemlist and pathway
	    if(move.direction == 'l') {
                var n = data['regionLst'][data['regionLst'].length-1]; // new
	        var o = regionLst[0]; // old
	        if(n[6] == o[6]) {
		    move.merge = true;
		    move.offsetShift = n[5];
		}
	    } else {
                var n = data['regionLst'][0]; // new
	        var o = regionLst[regionLst.length-1]; // old
	        if(n[6] == o[6]) {
		    move.merge = true;
		    move.offsetShift = o[5]
		}
	    }
	} else if(juxtaposition.type==0 || juxtaposition.type==1 || juxtaposition.type==2) {
	    if(move.direction == 'l') {
                var n = data['regionLst'][data['regionLst'].length-1]; // new
	        var o = regionLst[0]; // old
		// only look at chr name and region bstart!
		if(n[0]==o[0] && n[1]==o[1]) {
		    move.merge = true;
		    // set move.offsetShift for shifting old bed items
		    move.offsetShift = n[5];
		}
	    } else {
                var n = data['regionLst'][0]; // new
	        var o = regionLst[regionLst.length-1]; // old
		// only look at chr name and region bstop!
		if(n[0]==o[0] && n[2]==o[2]) {
		    move.merge = true;
		    // set move.offsetShift for shifting new bed items
		    move.offsetShift = o[5];
		}
	    }
	} else {
	    fatalError("jsonX: wrong juxtaposition.type");
	}
    }
    jsonMakeRegionLst(data);

    /*** track data ***/
    if(!('tkData' in data)) fatalError("jsonX: tkData missing");
    var v = data['tkData'];
    for(var i=0; i<v.length; i++) {
        var tk = findTrackByName(v[i].name);
        if(tk == null) fatalError("jsonX: track not found by name: "+v[i].name);
        if(move.direction == null) {
            tk.data = v[i].data;
	} else if(move.direction == 'l') {
	    var newlst = v[i].data;
	    if(move.merge) {
	        var lastr = newlst[newlst.length-1];
	        tk.data[0] = lastr.concat(tk.data[0]);
		newlst.pop();
	    }
	    tk.data = newlst.concat(tk.data);
	} else {
	    var newlst = v[i].data;
	    if(move.merge) {
		tk.data[tk.data.length-1] = tk.data[tk.data.length-1].concat(newlst[0]);
		newlst.shift();
	    }
	    tk.data = tk.data.concat(newlst);
	}
    }
    drawHmCanvas();

    /*** ideogram 
         should not receive data under itemlist or atbplevel
	 but always plot...
     ***/
    if((juxtaposition.type!=3 && juxtaposition.type!=4 && juxtaposition.type!=5) && !entire.atbplevel && ('ideogram' in data)) {
        if(move.direction == null) {
            ideogram.band = data['ideogram'];
        } else {
            var v = data['ideogram'];
	    /* if 1st region in regionLst don't have cytoband data
	       TODO not quite reliable handling of cytoband-not-available cases
	     */
            if(move.direction == 'l') {
	        if(move.merge) {
	            var lastr = v[v.length-1]; // last region of new data
		    if(lastr.length != 0) {
		        var lastband = lastr[lastr.length-1]; // last band of new data
		        var firstband = ideogram.band[0][0]; // first band of old data
		        if(firstband[3] == lastband[3]) { // bands have same id
		            firstband[1] += lastband[1]; // plot width
		            lastr.pop();
		        }
		        ideogram.band[0] = lastr.concat(ideogram.band[0]);
		    }
		    v.pop();
	        }
	        ideogram.band = v.concat(ideogram.band);
            } else {
	        if(move.merge) {
		    if(v[0].length != 0) {
	                var lastr = ideogram.band[ideogram.band.length-1]; // last region of old data
		        var lastband = lastr[lastr.length-1]; // last band of old data
		        var firstband = v[0][0]; // first band of new data
		        if(firstband[3] == lastband[3]) { // bands have same name
		            lastband[1] += firstband[1]; // plot width
		            v[0].shift();
		        }
		        ideogram.band[ideogram.band.length-1] = ideogram.band[ideogram.band.length-1].concat(v[0]);
		    }
		    v.shift();
		}
	        ideogram.band = ideogram.band.concat(v);
	    }
        }
    }
    drawIdeogramCanvas();

    jsonDecor(data);

    if(correlation.inuse) {
        jsonCorr(data);
    }
    if(htest.inuse) {
        if(!('htestData' in data)) fatalError("jsonX: htestData missing");
	drawHtestCanvas(data['htestData']);
    }
    if(move.direction != null) {
        viewbox.addEventListener("mousedown", viewboxMD, false);
        move.direction = null;
    }
    if(move.processing) move.processing = false;

    if(pwc.inuse)
        pwc_compute();
    
    document.body.style.cursor = "auto";
}

function ajaxSaveUrlpiece(url, callback) {
    if(urloffset >= url.length) {
        // entire URL has been saved, run it with callback
	if(gflag.savingstatus) // tell cgi to do decoding
	    ajax("reviveURL=on&decodeURL=on&dbName="+dbInfo.name, callback);
	else
	    ajax("reviveURL=on&dbName="+dbInfo.name, callback);
        return;
    }
    var xmlhttp;
    if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
    else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    xmlhttp.onreadystatechange = function() {
        if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	    urloffset += urllenlimit;
	    ajaxSaveUrlpiece(url, callback);
	}
    }
    xmlhttp.open("POST", "/cgi-bin/subtleKnife?offset="+urloffset+"&saveURLpiece="+escape(url.substr(urloffset, urllenlimit))+"&session="+sessionId+"&dbName="+dbInfo.name, true);
    xmlhttp.send();
}
function ajax(queryUrl, callback) {
    /* in case of too long url, need to send it in small pieces one at a time
       to get rid of "Request Entity Too Large" error on server

       in case of saving status, don't run ajaxSaveUrlpiece(), 
       as the already-escaped url will be escaped again,
       and there's no good way to unescape on server-side

       won't process abort directive from returned json packet

       tell from the head of queryUrl if it is saving status
     */
    if(queryUrl.length > urllenlimit) {
        urloffset = 0;
	ajaxSaveUrlpiece(queryUrl, callback);
	return;
    }

    var xmlhttp;
    if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
    else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

    xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	    try {var data = eval('('+xmlhttp.responseText+')');}
	    catch(err) {
	        // TODO: better error handling here
	        print2console(err+" (sorry... please restart by refreshing page)", 3);
		return;
	    }
	    callback(data);
	}
    }
    xmlhttp.open("GET", "/cgi-bin/subtleKnife?"+queryUrl+"&session="+sessionId+'&statusId='+statusId+'&hmspan='+hmSpan, true);
    xmlhttp.send();
}
function ajax2(queryUrl, callback) {
    // only take responseText, won't parse as json
    var xmlhttp;
    if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
    else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	    callback(xmlhttp.responseText);
	}
    }
    xmlhttp.open("GET", "/cgi-bin/subtleKnife?"+queryUrl, true);
    xmlhttp.send();
}
function ajaxX(param) {
    // only X change

    //var d = new Date();
    //var time1 = d.getTime();

    document.body.style.cursor = "wait";
    ajax(param+"&dbName="+dbInfo.name, function(data){

        //var d2 = new Date();
	//var time2 = d2.getTime();

	/* must handle the case of adding new scaffold sequence
	   possible in jumping to relocate
	   ASSume only one scaffold is added at the end of list
	   so need to update right border
	 */
	if('newscaffold' in data) {
	    chrLen[data.newscaffold[0]] = data.newscaffold[1];
	    border.rname = data.newscaffold[0];
	    border.rpos = data.newscaffold[1];
	    // 1 means insert to control panel holder
	    scaffold_cptable_insert(border.rname, 'transparent', 1);
	}

	jsonX(data);
        unveil(viewbox);

	// to allow jumping using minichrcanvas
	gflag.minichrjumping = false;

	//var d3 = new Date();
	//var time3 = d3.getTime();
	//alert("time2-time1: "+(time2-time1)+" time3-time2: "+(time3-time2));
	print2console("done", 1);
    });
}
function ajaxX_defaultRegion() {
    juxtaposition.type = 0;
    juxtaposition.note = "genome";
    juxtaposition.what = "genome";

    setDisplaywhichgf();

    enableJumping();
    cloak(viewbox);
    ajaxX("jump=on&jumppos2="+dbInfo.defaultPosition+"&gftype=genome"+hmtkChoice()+decorParams()+htestParams()+corrParam());
}







/*******************************
       juxtaposition
 *******************************/
function juxtaposeHideOptions() {
    /* e.g. if geneset view is on, bigbed jux and contig will be "not in service"
       juxtaposition.type must be set to appropriate value before calling this

       will also say something...
     */
    if(juxtaposition.type == 0)
        return;
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        // gene set view
        var butt = "<button type=button onclick=turnoffGenesetview()>turn off gene set view</button>";
        document.getElementById("genesetsaysno").style.display = "none";
        document.getElementById("genesetsaysyes").style.display = "block";
	var d = document.getElementById("juxtaposenotinservice");
	d.style.display = "block";
	d.innerHTML = "Genomic juxtaposition function is unavailable, because Gene Set View is on<br><br>"+butt;
	document.getElementById("juxtaposeinservice").style.display = "none";
	var d = document.getElementById('scaffoldnotinservice');
	d.style.display = 'block';
	d.innerHTML = 'You cannot configure scaffold sequence, because Gene Set View is on<br><br>'+butt;
	document.getElementById("scaffoldinservice").style.display = "none";

    } else if(juxtaposition.type==1 || juxtaposition.type==2) {
        /* juxtaposition */
        var butt = "<button type=button onclick=turnoffJuxtapose()>turn off genomic juxtaposition</button>";
        document.getElementById("juxtaposenotinuse").style.display = "none";
        document.getElementById("juxtaposeinuse").style.display = "block";
	d = document.getElementById("genesetnotinservice");
	d.style.display = "block";
	d.innerHTML = "Gene set view function is unavailable, because genomic juxtaposition is on<br><br>"+butt;
	document.getElementById("genesetinservice").style.display = "none";
	var d = document.getElementById('scaffoldnotinservice');
	d.style.display = 'block';
	d.innerHTML = 'You cannot configure scaffold sequence, because genomic juxtaposition is on<br><br>'+butt;
	document.getElementById("scaffoldinservice").style.display = "none";
    } else {
        fatalError("juxtaposeHideOptions: wrong juxtaposition.type value");
    }
}


/*******************************
       GSV gene set view (aka itemlist)
       using custom gene set
       or kegg pathway
 *******************************/
function gsv_manualrearrange() {
    // lead user to that panel
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    document.getElementById('geneset2tab_addremove').dispatchEvent(e);
    var d = document.getElementById('decoriteminfo');
    d.style.display = 'none';
    document.getElementById('decoriteminfosays').innerHTML = 'click on item in this table to rearrange';
    document.getElementById('decoriteminfosaysajax').innerHTML = '';
    var hp = genesetview.lstholder.parentNode;
    var pos = absolutePosition(hp);
    d.style.left = pos[0]+150; d.style.top = pos[1]+hp.clientHeight;
    indicator.style.left = pos[0]; indicator.style.top = pos[1];
    indicator.style.width = hp.clientWidth;
    indicator.style.height = hp.clientHeight;
    setTimeout("document.getElementById('decoriteminfo').style.display='block';indicator.style.display='block'", 200);
    setTimeout("document.getElementById('decoriteminfo').style.display='none';indicator.style.display='none'", 2000);
}
function gsv_itemlist_tdclick(event) {
    // called by clicking on td of gsv items in lstholder
    // highlight for moving
    var lst = genesetview.lstholder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++)
        lst[i].style.fontWeight = 'normal';
    var tr = event.target.parentNode;
    tr.style.fontWeight = 'bold';
    tr.marked2 = true;
    var pos = absolutePosition(tr);
    vrearrange_invoke(6, pos[0]+100, pos[1]+25-genesetview.lstholder.parentNode.scrollTop);
    vrearrangeUtil.gsvtr = tr; // lazy...
}
function copyEntireItemlistRegion() {
    /* variable args:
         in case of restoring session and itemlist collation,
	 CGI will return entire item list as DSP might be partial,
	 that will be the argument
         else, no arg will be provided, genesetview.lst will be made from regionLst
	 assuming that that is complete

       called upon itemlist has been SUBMITTED or UPDATED
       assumed that the newly established regionLst contains entire set of items
       save them into genesetview.lst
       will draw ideogram.minihash.itemlist and ideogram.minirulerhash.itemlist
     */
    if(arguments[0] != undefined) {
        genesetview.lst = arguments[0];
    } else {
        genesetview.lst = [];
        for(var i=0; i<regionLst.length; i++) {
            var r = regionLst[i];
            genesetview.lst.push([r[6], r[0], r[1], r[2]]);
	}
    }
    var canvas = ideogram.minihash.itemlist;
    var ctx = canvas.getContext('2d');
    var ctx2 = ideogram.minirulerhash.itemlist.getContext('2d');
    ctx.clearRect(0,0,canvas.width, canvas.height);
    ctx2.clearRect(0,0,ideogram.minirulerhash.itemlist.width,ideogram.minirulerhash.itemlist.height);
    /* beware: don't use entire.length to compute scaling factor
       as in case of restoring session, dsp might be partial of entire list
       so need to compute entire length from genesetview.lst
     */
    var allLen = 0;
    for(var i=0; i<genesetview.lst.length; i++) {
        var it = genesetview.lst[i];
        allLen += it[3] - it[2];
    }
    var sf = canvas.width / allLen;
    // the minichrcanvas only needs to be drawn once
    genesetview.lstsf = sf;
    var filla = true;
    var xoffset = 0;
    for(i=0; i<genesetview.lst.length; i++) {
        var r = genesetview.lst[i];
	var lenbp = r[3]-r[2];
        var w = lenbp * sf;
	r.push(w);
	if(filla) {
	    ctx.fillStyle = genesetview.minichr_filla;
	    filla = false;
	} else {
	    ctx.fillStyle = genesetview.minichr_fillb;
	    filla = true;
	}
	ctx.fillRect(xoffset, 0, w, ideogram.minicanvasheight);
	var ww = ctx.measureText(r[0]).width;
	if(ww < w) {
	    ctx.fillStyle = genesetview.minichr_text;
	    ctx.fillText(r[0], xoffset+(w-ww)/2, 10);
	}

	ctx2.fillRect(xoffset, 0, 1, 10);
	var word;
	if(lenbp < 1000)
	    word = lenbp.toString();
	else if(lenbp < 1000000)
	    word = (lenbp/1000).toFixed(1)+'K';
	else if(lenbp < 1000000000)
	    word = (lenbp/1000000).toFixed(1)+'M';
	else
	    word = (lenbp/1000000000).toFixed(1)+'G';
	ww = ctx2.measureText(word).width;
	if(ww < w)
	    ctx2.fillText(word, xoffset+(w-ww)/2, 10);

	xoffset += w;
    }
    document.getElementById("displaywhichchr").innerHTML = "";

    // if in use, re-draw small wiggle for ideogram
    var lst = [];
    for(var i=0; i<genesetview.lst.length; i++) {
	var tt = genesetview.lst[i];
	lst.push(tt[1]); lst.push(tt[2]); lst.push(tt[3]); lst.push(Math.ceil(tt[4]));
    }
    var coordparam = '&coordlst='+lst.join(',');
    ideogram.wiggle1.paramstr = coordparam;
    ideogram.wiggle2.paramstr = coordparam;
    if(ideogram.wiggle1.name!=null || ideogram.wiggle2.name!=null) {
	if(ideogram.wiggle1.name != null) {
	    ajax_plotideogramwiggle(1);
	}
	if(ideogram.wiggle2.name != null) {
	    ajax_plotideogramwiggle(2);
	}
    }
}
function submitCustomgeneset() {
    /* called by pushing button, for submiting new gene list
       also handles the case for parsing url parameter when initiating browser
     */
    var t = document.getElementById('genelisttextarea').value;
    if(t.length == 0) {
        print2console("no gene list found in text area", 2);
	return;
    }
    if(ensureNonezerolengthregion(1)) {
        print2console("custom region selector defined zero length", 2);
	return;
    }

    cloak(viewbox);
    print2console("juxtaposing custom gene set...", 0);
    document.getElementById('custgenesetbutt').disabled = true;
    document.getElementById('custgenesetbutt').innerHTML = 'Running...';
    ajax("new=on&itemlist="+t.split('\n').join(',')+gss_param(1)+'&gss_says='+document.getElementById('custgsi_gss_says').innerHTML+hmtkChoice()+decorParams()+corrParam()+htestParams()+"&dbName="+dbInfo.name, function(data){
        if('abort' in data) {
            print2console(data.abort, 2);
            unveil(viewbox);
	    document.getElementById('custgenesetbutt').disabled = false;
	    document.getElementById('custgenesetbutt').innerHTML = 'SUBMIT';
            return;
        }
	juxtaposition.type = 3;
	juxtaposition.note = "gene set";
	juxtaposition.what = "geneset";
        setDisplaywhichgf();
        jsonGenesetview(data);
	unveil(viewbox);
        print2console(data['alert'], 1);
	if(gflag.urlparam.willcontinue)
	    urlparam_handleTriggers();
	document.getElementById('custgenesetbutt').disabled = false;
	document.getElementById('custgenesetbutt').innerHTML = 'SUBMIT';
    });
}
function submitCustomgeneset_withremove() {
    /* call this to update for:
       1. user might marked some items for removal
       2. rearranging items
     */
    var oldlst = [];
    for(var i=0; i<genesetview.lst.length; i++)
        oldlst.push(genesetview.lst[i][0]);
    var newlst = [];
    var trlst = genesetview.lstholder.firstChild.childNodes;
    for(var i=0; i<trlst.length; i++) {
        if(!trlst[i].marked)
	    newlst.push(trlst[i].itemname);
    }
    if(stringLstIsIdentical(oldlst, newlst)) {
        print2console("nothing changed, won't update", 2);
	return;
    }
    if(newlst.length == 0) {
	turnoffGenesetview();
	return;
    }
    document.getElementById('genelisttextarea').value = newlst.join('\n');
    submitCustomgeneset();
}
function submitCustomgeneset_withnew() {
    // TODO only examine new data sets
    // adding new genes to existing gene set
    var v = document.getElementById("addgenetextarea").value;
    if(v.length == 0) {
        print2console("no new gene supplied", 2);
	return;
    }
    var existing = [];
    var trlst = genesetview.lstholder.firstChild.childNodes;
    for(var i=0; i<trlst.length; i++)
	existing.push(trlst[i].itemname);
    document.getElementById('genelisttextarea').value = existing.join('\n')+'\n'+v;
    document.getElementById("addgenetextarea").value = "";
    submitCustomgeneset();
}
function updateGenelist4collate() {
    /* called by pushing button "update" in geneset editing panel
       also process geneset sorting
     */
    if(ensureNonezerolengthregion(3)) {
        print2console("custom region selector spans 0 bp", 2);
	return;
    }
    var sortby = getValue_by_radioName("genesetsortby");
    var tkselectparam = "";
    if(sortby=="tkmeanAsc" || sortby=="tkmeanDesc") {
        var name = document.getElementById('genesetsort_tkname').innerHTML;
	if(name == 'NONE') {
	    print2console('You haven\'t selected a track for sorting', 2);
	    return;
	}
	if(document.getElementById('genesetsort_tkiscustom').innerHTML == '1') {
	    tkselectparam = "&tkiscustom=on&tk="+document.getElementById('genesetsort_tkurl').innerHTML;
	} else {
            tkselectparam = "&tk="+name;
	}
    }
    print2console("updating gene set...", 0);
    cloak(viewbox);
    ajax("itemlist=on&update=on&gss_says="+document.getElementById('gsedit_gss_says').innerHTML+gss_param(3)+((sortby=="no")?"":"&sortby="+sortby)+tkselectparam+hmtkChoice()+decorParams()+corrParam()+htestParams()+"&dbName="+dbInfo.name, function(data){
        jsonGenesetview(data);
	unveil(viewbox);
	print2console("done", 1);
    });
}
function jsonGenesetview(data) {
    /* must set juxtaposition.type to correct value prior to calling this
       must be called by gene set view on custom geneset and kegg
     */

    // disable jump
    disableJumping();

    // update border
    mustUpdateBorder(data);

    jsonX(data);

    if(juxtaposition.type==3 || juxtaposition.type==4) {
        collategenesGotoholder();
	if('gssparam' in data) {
	    update_gssedit(data.gssparam);
	}
    }

    // copy and re-draw minichrcanvas with chains of boxes
    copyEntireItemlistRegion();
    minichrcanvas_setindicator();
}
function update_gssedit(dat) {
    document.getElementById('gsedit_gss_says').innerHTML = dat.gss_says;
    document.getElementById('gsedit_gss_opt').innerHTML = dat.gss_opt;
    document.getElementById('gsedit_gss_origin').innerHTML = dat.gss_origin;
    document.getElementById('gsedit_gss_up').innerHTML = dat.gss_up;
    document.getElementById('gsedit_gss_down').innerHTML = dat.gss_down;
    document.getElementById('gsedit_gss_says_ghost').innerHTML = dat.gss_says;
    document.getElementById('gsedit_gss_opt_ghost').innerHTML = dat.gss_opt;
    document.getElementById('gsedit_gss_origin_ghost').innerHTML = dat.gss_origin;
    document.getElementById('gsedit_gss_up_ghost').innerHTML = dat.gss_up;
    document.getElementById('gsedit_gss_down_ghost').innerHTML = dat.gss_down;
}
function collategenesGotoholder() {
    /* called by:
       - submitting itemlist
       - updating itemlist
       - restoring status
     */
    ajax("getitemlistgenedef=on&dbName="+dbInfo.name,function(data){
        if(!("lst" in data)) fatalError("collategenesGotoholder: lst missing");
	var lst = data['lst'];
	// eles in this array: [name, def, genetype]
	stripChild(genesetview.lstholder.firstChild, 0); // stripping the table.tbody
        for(var i=0; i<lst.length; i++) {
	    // content in a row: button, symbol, refseq name, desc, link
            var tr = genesetview.lstholder.insertRow(-1);
	    tr.style.backgroundColor = "white";
	    tr.itemname = lst[i][0]; // important
	    tr.marked = false; // for removal
	    tr.marked2 = false; // for rearranging
	    // td 1: button
	    var td = tr.insertCell(0);
	    td.innerHTML = "<button type=button class=s onclick=toggle22(event) title='mark for removal'>&#10005;</button>";
	    // td 2: name
	    td = tr.insertCell(-1);
	    td.innerHTML = lst[i][0];
	    td.style.cursor = 'pointer';
	    td.addEventListener('click', gsv_itemlist_tdclick, false);
	    // td 3: desc
	    td = tr.insertCell(-1);
	    td.innerHTML = lst[i][1]==undefined ? 'no desc' : lst[i][1];
	    td.style.fontSize = "12px";
	    td.style.color = '#858585';
	    td.style.cursor = 'pointer';
	    td.addEventListener('click', gsv_itemlist_tdclick, false);
	    // td 4: link
	    td = tr.insertCell(-1);
	    if(lst[i][2]!=undefined)
	        td.innerHTML = "<a href="+decorInfo[lst[i][2]].queryUrl+lst[i][0]+" target=_blank>&#8599;</a>";
        }
        var d = document.getElementById("genesetoperationdiv");
	d.style.display = "block";
	document.getElementById("genesetinservice").appendChild(d);
        //document.getElementById("genesetentrywrapper").style.display = "none";
	// reset these
	//document.getElementById("genesetsort_tkselectdiv").style.display = "none";

        juxtaposeHideOptions();
    });
}
function genesetsortbyChangeoption() {
    // called by changing option on genesetsortby <select>
    // will toggle display of track selection <select>
    var v = getValue_by_radioName("genesetsortby");
    document.getElementById("genesetsort_tkselectdiv").style.display = (v=="tkmeanAsc"||v=="tkmeanDesc") ? 'block' : 'none';
}
function disableJumping() {
    // juxtaposition.type must be set to appropriate value elsewhere
    document.getElementById("jump2chrbutt").disabled = true;
    document.getElementById("jumppos").disabled = true;
    document.getElementById("jumpgene").disabled = true;
    document.getElementById("jumpbutton").disabled = true;
    document.getElementById("jumpresetbutton").disabled = true;
}
function enableJumping() {
    document.getElementById("jump2chrbutt").disabled = false;
    document.getElementById("jumppos").disabled = false;
    document.getElementById("jumpgene").disabled = false;
    document.getElementById("jumpbutton").disabled = false;
    document.getElementById("jumpresetbutton").disabled = false;
}
function turnoffGenesetview() {
    //document.getElementById("genesetentrywrapper").style.display = "block";
    document.getElementById("genesetoperationdiv").style.display = "none";
    document.getElementById("genesetsaysno").style.display = "block";
    document.getElementById("genesetsaysyes").style.display = "none";
    document.getElementById("juxtaposenotinservice").style.display = "none";
    document.getElementById("juxtaposeinservice").style.display = "block";
    document.getElementById("scaffoldnotinservice").style.display = "none";
    document.getElementById("scaffoldinservice").style.display = "block";
    document.getElementById("geneplotcanvasdiv").style.display = "none";
    document.getElementById("geneplotimage").style.display = "none";
    document.getElementById("googlechartdiv").style.display = "none";
    document.getElementById("googleimagechartdiv").style.display = "none";

    // if gene plot is on for gene set, need to turn it off
    d = document.getElementById("geneplotpanel");
    if(d.style.display == "block") {
        if(geneplot.for == 0) {
	    d.style.display = "none";
	}
    }

    ajaxX_defaultRegion();
    ajax2('removeGenesetrecord=on&dbName='+dbInfo.name+'&session='+sessionId+'&statusId='+statusId,function(data){});
}




/*******************************
      CUSTOM track
 ******************************/
function newCustomTrack_isInvalid() {
    /* first fetch url and name of custom track into global variables, 
       then call the validation routine
     */
    var url = gflag.customtmp.url;
    if(url.length <= 0) {
        print2console("no URL given for custom track", 3);
	return true;
    }
    if(url.length <= 8) {
        print2console("URL looks invalid", 3);
	return true;
    }
    if(url.substr(0,4).toLowerCase() != 'http') {
        print2console("shouldn't URL start with 'http'?", 3);
	return true;
    }
    var label = gflag.customtmp.label;
    if(label.length == 0) {
        print2console("no track name entered", 3);
	return true;
    }
    if(label.indexOf(',') != -1) {
        print2console("no comma allowed for track name", 2);
	return true;
    }
    if(label.indexOf('|') != -1) {
        print2console("no vertical line allowed for track name", 2);
	return true;
    }
    return false;
}
function customtrackRemoved(filetype) {
    // call upon removing a custom track
    var s = document.getElementById('custtrackhowmany');
    if(parseInt(s.innerHTML) >= 1)
        s.innerHTML = parseInt(s.innerHTML)-1;
    s = document.getElementById('cust'+filetype+'howmany');
    if(parseInt(s.innerHTML) >= 1)
        s.innerHTML = parseInt(s.innerHTML)-1;

    // in tkselect, might need to hide group tabs, only for bigbed or bam
    if(filetype == 1) {
        tkselect.decor.grptab_bigbed.style.display = tkselect.decor.tkholder_bigbed.firstChild.childNodes.length==0 ? 'none' : 'block';
    } else if(filetype == 5) {
        tkselect.decor.grptab_custbam.style.display = tkselect.decor.tkholder_custbam.firstChild.childNodes.length==0 ? 'none' : 'block';
    }

    custmd_makegrid();
}
function removeCustombigbed_pushDel(event) {
    /* called by clicking delete button in cust track registry table
       will permanently remove this custom track
       hide the track if it is still on, remove entry in registry table

       if doing collation on this file, cancel collation
       but NOTICE: as ajax will be called in turnoffJuxtapose,
       can only do it after clean up trails of bigbed file,
       or else it will be drawn again...
      */
    var name = event.target.getAttribute('tkname');
    if(!(name in decorInfo)) fatalError('removeCustombigbed_pushDel: track not in decorInfo');
    if(decorInfo[name].fileType != 1) fatalError('removeCustombigbed_pushDel: filetype is not 1');
    var need2do = (juxtaposition.what == decorInfo[name].url);

    // if been displayed, remove it
    decoruserlist_remove(name);
    if(name in decorCanvasHash) { removeDecorCanvas(name);}
    // remove tentacles
    document.getElementById("custHolder1").firstChild.removeChild(decorInfo[name].registrytr);
    tkselect.decor.tkholder_bigbed.firstChild.removeChild(decorInfo[name].tksregistrytr);
    delete decorInfo[name];

    // correlation
    if(correlation.inuse && (correlation.targetname==name)) {
        turnoffCorrelation();
    }

    if(need2do) { turnoffJuxtapose();}
    customtrackRemoved(1);
}
function removeCustombam_pushDel(event) {
    // similar as removeCustombigbed_pushDel()
    var name = event.target.getAttribute("tkname");
    decoruserlist_remove(name);
    if(name in decorCanvasHash) {removeDecorCanvas(name);}
    document.getElementById("custHolder5").firstChild.removeChild(decorInfo[name].registrytr);
    tkselect.decor.tkholder_custbam.firstChild.removeChild(decorInfo[name].tksregistrytr);
    if(correlation.inuse && (correlation.targetname==name)) { turnoffCorrelation(); }
    delete decorInfo[name];
    customtrackRemoved(5);
}
function custmd_showeditpanel() {
    /* show edit panel for custom track metadata annotation, all track type!

       variable argument:
       if single argument, is event, called by pressing button
       if two arguments, first is track name (string), second is track file type
     */
    var tkname; var ft;
    if(arguments.length == 1) {
        tkname = event.target.getAttribute('tkname');
	ft = parseInt(event.target.getAttribute('filetype'));
    } else {
        tkname = arguments[0];
	ft = arguments[1];
    }
    mdselect.custeditholder.style.display = 'block';
    mdselect.custeditholder.tkname = tkname;
    mdselect.custeditholder.filetype = ft;
    var obj = ft==3 ? hmtk.custom[tkname] : decorInfo[tkname];
    if(obj == undefined)
        fatalError("custmd_showeditpanel: track object not found");
    document.getElementById('custmd_editwhich').innerHTML = obj.label;
    var count = 0;
    if('servermd' in obj) {
        for(var attr in obj.servermd) {count++;}
    }
    if('custmd' in obj) {
        for(var attr in obj.custmd) {count++;}
    }
    if(count == 0) {
        document.getElementById('custbwmd_editsaysno').style.display = 'block';
	mdselect.custedittable.style.display = 'none';
	stripChild(mdselect.custedittable.firstChild, 1);
	return;
    }
    document.getElementById('custbwmd_editsaysno').style.display = 'none';
    mdselect.custedittable.style.display = 'table';
    stripChild(mdselect.custedittable.firstChild, 1);
    // server metadata
    if('servermd' in obj) {
	for(var attr in obj.servermd) {
	    custmd_tableinsert(mdselect.custedittable, attr, false, mdvc2p[attr], custmd_edit_removeTerm);
	}
    }
    // custom metadata
    if('custmd' in obj) {
	for(var name in obj.custmd) {
	    custmd_tableinsert(mdselect.custedittable, obj.custmd[name], true, name, custmd_edit_removeTerm);
	}
    }
}
function customtrack_showbuttclick(event) {
    /* called by clicking on show/hide button
       will show/hide the track, and toggle itself

       but beware the button might come from two places:
       - custom track manage list in control panel
       - custom track selection list in ftb
     */
    var name = event.target.getAttribute('tkname');
    var ft = parseInt(event.target.getAttribute('filetype'));
    if(ft == 3) { // bigwig
        var tkidx = getTkidxByname(name);
        if(tkidx != -1) {
	    removeBigwigTrack(tkidx);
	    trackHeightChanged(false);
	    event.target.innerHTML = 'show';
	    hmtk.custom[name].showbutt.innerHTML = 'show';
	    return;
	}
	if(!(name in hmtk.custom)) fatalError('customtrack_showbuttclick: custom bigwig track not found');
	// so similar as submitNewcustombigwig()
	gflag.customtmp.name = name;
	gflag.customtmp.label = hmtk.custom[name].label;
	gflag.customtmp.url = hmtk.custom[name].url;
	gflag.customtmp.mode = 'show';
	gflag.customtmp.servermd = hmtk.custom[name].servermd;
	gflag.customtmp.custmd = hmtk.custom[name].custmd;
	cloak(viewbox);
	document.body.style.cursor = 'wait';
	ajax(displayedRegionParamPrecise()+"&addcustombigwig=on&url="+gflag.customtmp.url+'&dbName='+dbInfo.name,function(data){
	    if(!('newcustomdata' in data)) {
		print2console("Error fetching data for the bigWig file", 3);
		unveil(viewbox);
		return;
	    }
	    jsonAddOneCustombigwig(data.newcustomdata);

	    makeTrackAttrAll();
	    mcmSortTrack(sortTrackIdx);
	    drawTrackAttrCanvas_onetrack(findTrackByName(gflag.customtmp.name));
	    stuffTrackCanvas2holder();

	    document.body.style.cursor = 'auto';
	    unveil(viewbox);
	    hmtk.custom[gflag.customtmp.name].showbutt.innerHTML = 'hide';
	});
	event.target.innerHTML = 'hide';
    } else if(ft==1 || ft==5) { // bigbed or bam
        if(name in decorCanvasHash) {
	    decorInfo[name].mode = "hide";
	    toggleDecor(name);
	    event.target.innerHTML = 'show';
	    decorInfo[name].showbutt.innerHTML = 'show';
	    return;
	}
	if(!(name in decorInfo)) fatalError('customtrack_showbuttclick: custom bigbed/bam not found in decorInfo');
	decoruserlist_insert(name); // just insert, no matter what
	decorInfo[name].mode = ft==1 ? 'thin' : 'density';
	toggleDecor(name);
	event.target.innerHTML = 'hide';
	decorInfo[name].showbutt.innerHTML = 'hide';
    }
}
function registerCustomtrack(name, label, url, fileType) {
    if(fileType!=1 && fileType!=3 && fileType!=5)
        fatalError("registerCustomtrack: filetype not 1/3/5");
    var holder = document.getElementById('custHolder'+fileType);
    if(holder == null) fatalError("registerCustomtrack: custHolder not found");
    var tr = holder.insertRow(-1);
    // 1. label
    var td = tr.insertCell(0);
    td.innerHTML = label;
    // 2. url
    td = tr.insertCell(-1);
    td.style.color = '#858585';
    //var urltext = url.length>=55 ? url.substr(0,25)+'....'+url.substr(url.length-25) : url;
    var urltext = url.length>=40 ? url.substr(0,35)+'....' : url;
    td.innerHTML = urltext;

    // 3. utility buttons, one td for each button
    // show button
    var sbutt = document.createElement('button');
    sbutt.innerHTML = 'show';
    sbutt.className = 's';
    sbutt.setAttribute('tkname', name);
    sbutt.setAttribute('filetype', fileType);
    sbutt.addEventListener('click', customtrack_showbuttclick, false);
    tr.insertCell(-1).appendChild(sbutt);

    // metdata editing button
    var b = document.createElement('button');
    b.innerHTML = '&#9998;metadata';
    b.className = 's';
    b.style.whiteSpace = 'nowrap';
    b.setAttribute('tkname', name);
    b.setAttribute('filetype', fileType);
    b.addEventListener('click', custmd_showeditpanel, false);
    tr.insertCell(-1).appendChild(b);
    // delete button
    b = document.createElement('button');
    b.innerHTML = 'delete';
    b.className = 's';
    b.setAttribute("tkname", name);
    if(fileType == 3)
        b.addEventListener("click", removeCustombigwig_pushDel, false);
    else if(fileType == 1)
        b.addEventListener("click", removeCustombigbed_pushDel, false);
    else
        b.addEventListener("click", removeCustombam_pushDel, false);
    tr.insertCell(-1).appendChild(b);


    // increment count
    var s = document.getElementById('custtrackhowmany');
    s.innerHTML = parseInt(s.innerHTML)+1;
    s = document.getElementById('cust'+fileType+'howmany');
    var num = parseInt(s.innerHTML) +1;
    s.innerHTML = parseInt(s.innerHTML)+1;
    var pa = holder.parentNode;
    if(num > 10) {
        // damn it has to be done in this stupid way
        pa.style.height = 200;
	pa.style.overflowY = 'scroll';
    } else {
        pa.style.height = 'auto';
	pa.style.overflowY = 'auto';
    }

    if(fileType == 3) { /* custom bigWig */
	if(!(name in hmtk.custom)) // is the shitty case for restoring status
	    hmtk.custom[name] = {label:label, url:url};
	hmtk.custom[name].registrytr = tr;
	sbutt.innerHTML = getTkidxByname(name)==-1 ? 'show' : 'hide';
	hmtk.custom[name].showbutt = sbutt;
    } else { // bigbed or bam
	if(!(name in decorInfo))
	    fatalError("registerCustomtrack: track "+name+" not found in decorInfo");
        // attach the registry stuff
	decorInfo[name].registrytr = tr;
	sbutt.innerHTML = decorInfo[name].mode=='hide' ? 'show' : 'hide';
	decorInfo[name].showbutt = sbutt;
	/* add entry to track selection panel */
	if(fileType == 1) { // bigbed
	    tkselect.decor.grptab_bigbed.style.display = 'block';
	    tr = tkselect.decor.tkholder_bigbed.insertRow(-1);
	    decorInfo[name].tksregistrytr = tr;
	    td = tr.insertCell(0);
	    td.innerHTML = label;
	    td.className = 'tkentry';
	    td.setAttribute('tkname', name);
	    td.setAttribute('name', 'decortkentry');
	    td.style.backgroundColor = 'transparent';
	    td.addEventListener('click', decortkentry_click, false);
	    decorInfo[name].tksentry = td;
	} else if(fileType == 5) { // bam
	    tkselect.decor.grptab_custbam.style.display = 'block';
	    tr = tkselect.decor.tkholder_custbam.insertRow(-1);
	    decorInfo[name].tksregistrytr = tr;
	    td = tr.insertCell(0);
	    td.innerHTML = label;
	    td.className = 'tkentry';
	    td.setAttribute('tkname', name);
	    td.setAttribute('name', 'decortkentry');
	    td.style.backgroundColor = 'transparent';
	    td.addEventListener('click', decortkentry_click, false);
	    decorInfo[name].tksentry = td;
	}
    }
}
function jsonAddOneCustombigwig(data) {
    var nn = gflag.customtmp.name;
    hmtk.tolabel[nn] = gflag.customtmp.label; // ??
    // too much exposed details
    var tk = {
        name:nn,
        data:data,
        label:gflag.customtmp.label,
	attrhash:gflag.customtmp.servermd,
	custmd:gflag.customtmp.custmd,
	url:gflag.customtmp.url,
	attrlst:[],  attrcoloridxlst:[],
	hmC:document.createElement('canvas'),
	isCustom:true, qtc:{}
	};
    qtc_paramCopy(defaultQtcStyle.ft3, tk.qtc);
    tkLst.push(tk);

    // ??
    if(!(nn in hmtk.custom) || !('registrytr' in hmtk.custom[nn]))
        registerCustomtrack(nn, gflag.customtmp.label, gflag.customtmp.url, 3);

    hmtk.custom[nn].servermd = gflag.customtmp.servermd;
    hmtk.custom[nn].custmd = gflag.customtmp.custmd;

    tkNameLst.push(nn);

    // if it is annotated by custom metadata, need to re-make attribute vertical name canvas
    var custannotated = false;
    for(var ttt in gflag.customtmp.custmd) custannotated = true;
    if(custannotated)
	initiateMdcOnshowCanvas();

/*
    makeTrackAttrAll();
    mcmSortTrack(sortTrackIdx);
    drawTrackAttrCanvas();
    stuffTrackCanvas2holder();
    */

    drawHmCanvas_onetrack(tk);
    if(correlation.inuse) 
	computeCorr_onetrack(tk);

    updateDsp();
    mdcholder_place();
}
function jsonAddOneCustombigbed(data) {
    /* always called for adding custom bigbed:
       manual / datahub / urlparam
     */
    decorInfo[gflag.customtmp.name] = {
        'fileType':1,
	'url':gflag.customtmp.url,
	'grp':-1, 'hasStruct':0,
	'custmd':gflag.customtmp.custmd,
	label:gflag.customtmp.label, 'mode':gflag.customtmp.mode};
    if(gflag.customtmp.mode != 'hide') {
	makeNewDecorCanvas(gflag.customtmp.name, data[0], 
		gflag.customtmp.mode, 1, gflag.customtmp.url, 0,
		gflag.customtmp.label);
	drawDecorCanvas(gflag.customtmp.name);
	decorCanvasHash[gflag.customtmp.name].canvas.style.left = move.styleLeft;
	decorCanvasHash[gflag.customtmp.name].totalitemnumber = data['totalitemnumber'];
    }
    registerCustomtrack(gflag.customtmp.name, gflag.customtmp.label, gflag.customtmp.url, 1);
    decoruserlist_insert(gflag.customtmp.name);
}
function jsonAddOneCustombam(data) {
    decorInfo[gflag.customtmp.name] = {
        'fileType':5,
	'url':gflag.customtmp.url,
	'grp':-1, 'hasStruct':0,
	'custmd':gflag.customtmp.custmd,
	label:gflag.customtmp.label, 'mode':gflag.customtmp.mode};
    if(gflag.customtmp.mode != 'hide') {
	makeNewDecorCanvas(gflag.customtmp.name, data,
		gflag.customtmp.mode, 5, gflag.customtmp.url, 0,
		gflag.customtmp.label);
	drawDecorCanvas(gflag.customtmp.name);
	decorCanvasHash[gflag.customtmp.name].canvas.style.left = move.styleLeft;
    }
    registerCustomtrack(gflag.customtmp.name, gflag.customtmp.label, gflag.customtmp.url, 5);
    decoruserlist_insert(gflag.customtmp.name);
}
function newcustomtrackname() {
    var n = Math.random().toString();
    while((n in hmtk.tolabel) || (n in decorInfo))
        n = Math.random().toString();
    return n;
}
function submitNewcustombigwig() {
    // called only by pushing button...
    gflag.customtmp.name = newcustomtrackname();
    gflag.customtmp.label = document.getElementById('newcustombigwigtkname').value;
    gflag.customtmp.url = document.getElementById('newcustombigwigfileurl').value;
    gflag.customtmp.mode = 'show';
    if(newCustomTrack_isInvalid())
        return;
    // all metadata annotation
    var lst = custmdtable_getTermlist(mdselect.custpriortable3);
    // annotation using server metadata, global variable
    gflag.customtmp.servermd = {}; 
    for(var i=0; i<lst[0].length; i++) {
        gflag.customtmp.servermd[lst[0][i]] = 1;
    }
    // annotation using custom metadata, global variable
    gflag.customtmp.custmd = {}; 
    for(i=0; i<lst[1].length; i+=2) {
        // i is attr, i+1 is term name
	gflag.customtmp.custmd[lst[1][i+1]] = lst[1][i];
    }
    cloak(viewbox);
    // don't escape url
    print2console("adding custom bigWig track...", 0);
    document.body.style.cursor = 'wait';
    ajax(displayedRegionParamPrecise()+"&addcustombigwig=on&url="+gflag.customtmp.url+'&dbName='+dbInfo.name,function(data){
	if(!('newcustomdata' in data)) {
	    print2console("Error fetching data for the bigWig file", 3);
            unveil(viewbox);
	    return;
	}
	jsonAddOneCustombigwig(data.newcustomdata);
        stripChild(mdselect.custpriortable3.firstChild, 1);

	makeTrackAttrAll();
	mcmSortTrack(sortTrackIdx);
	drawTrackAttrCanvas();
	stuffTrackCanvas2holder();

        document.body.style.cursor = 'auto';
        unveil(viewbox);
	print2console("custom bigWig track added", 1);
    });
}
function submitNewcustombigbed() {
    gflag.customtmp.name = newcustomtrackname();
    gflag.customtmp.label = document.getElementById('newcustombigbedtkname').value;
    gflag.customtmp.url = document.getElementById('newcustombigbedfileurl').value;
    gflag.customtmp.mode = getSelectValueById('newcustombigbedmode');
    if(newCustomTrack_isInvalid())
        return;
    var lst = custmdtable_getTermlist(mdselect.custpriortable1);
    // annotation using custom md
    gflag.customtmp.servermd = {}; 
    gflag.customtmp.custmd = {}; 
    for(i=0; i<lst[1].length; i+=2) {
        // i is attr, i+1 is term name
	gflag.customtmp.custmd[lst[1][i+1]] = lst[1][i];
    }
    cloak(viewbox);
    print2console("adding custom bigBed track...", 0);
    document.body.style.cursor = 'wait';
    ajax(displayedRegionParamPrecise()+"&addcustombigbed=on&url="+gflag.customtmp.url+"&mode="+gflag.customtmp.mode+'&dbName='+dbInfo.name,function(data){
	if(!('newcustomdata' in data)) {
	    print2console("Error fetching data for the bigBed file", 3);
            unveil(viewbox);
	    return;
	}
	jsonAddOneCustombigbed(data.newcustomdata);
        stripChild(mdselect.custpriortable1.firstChild, 1);

        unveil(viewbox);
        print2console("custom bigBed track added", 1);
        document.body.style.cursor = 'auto';
    });
}
function submitNewcustombam() {
    gflag.customtmp.name = newcustomtrackname();
    gflag.customtmp.label = document.getElementById('newcustombamtkname').value;
    gflag.customtmp.url = document.getElementById('newcustombamfileurl').value;
    gflag.customtmp.mode = getSelectValueById('newcustombammode');
    if(newCustomTrack_isInvalid())
        return;
    var lst = custmdtable_getTermlist(mdselect.custpriortable5);
    // annotation using custom md
    gflag.customtmp.servermd = {}; 
    gflag.customtmp.custmd = {}; 
    for(i=0; i<lst[1].length; i+=2) {
        // i is attr, i+1 is term name
	gflag.customtmp.custmd[lst[1][i+1]] = lst[1][i];
    }
    cloak(viewbox);
    print2console("adding custom BAM track...", 0);
    document.body.style.cursor = 'wait';
    ajax(displayedRegionParamPrecise()+'&decor5=a,b,'+gflag.customtmp.url+','+gflag.customtmp.mode,function(data){
	if(data.decorData==undefined || data.decorData.length==0) {
	    print2console("Error fetching data for the BAM file", 3);
            unveil(viewbox);
	    return;
	}
	jsonAddOneCustombam(data.decorData[0][5]);
        stripChild(mdselect.custpriortable5.firstChild, 1);

        unveil(viewbox);
        print2console("custom BAM track added", 1);
        document.body.style.cursor = 'auto';
    });
}




/*******************************
      JSON + trigger name
 ******************************/
function jsonTrackAddnew(data) {
    /* process both server and custom tracks, add them to tkLst
       * add new server tracks
       * restore saved state
       ** add one new custom track is not done here
       deal with:
           tkData, custom
     */
    if('tkData' in data) {
        // hmtk data
        var v = data.tkData;
	for(var i=0; i<v.length; i++) {
	    // add label
	    var tkname = v[i].name;
	    var tk = findTrackByName(tkname);
	    if(tk != null) fatalError("track "+tkname+" already exists in jsonTrackAddnew");
	    if(v[i].isCustom) {
	        v[i]['label'] = v[i]['name']; // it would be later corrected, shoot!
	        // need to make partial record of custom 
	    } else {
	        v[i]['label'] = hmtk.tolabel[tkname];
	    }
	    v[i].qtc = {};
	    qtc_paramCopy(defaultQtcStyle.heatmap, v[i].qtc);
	    tkLst.push(v[i]);
	    tkNameLst.push(tkname);
	}
	if('serverbigwigAnno' in data) {
	    // server track attributes
	    v = data['serverbigwigAnno'];
	    for(var name in v) {
	        var tk = findTrackByName(name);
		if(tk == null) fatalError("track "+name+" not found for adding attributes in jsonTrackAddnew");
		tk.attrhash = {};
		for(i=0; i<v[name].length; i++)
		    tk.attrhash[v[name][i]] = 1;
		tk.attrlst = [];
		tk.attrcoloridxlst = [];
	    }
	}
    }
    generateTrackselectionLayout();
    updateDsp();
}
function mergeStackData4moving(gf, newdata) {
    /* newdata is list of newly coming items from server-json
       they will be added to decorCanvasHash[gf].data,
       and items with same id will be merged in old/new holders.
       see "trigger dependency.dia" for description on item array
     */
    var od = decorCanvasHash[gf].data; // old data
    if(move.direction == 'l') {
        // moving left, need to shift plotting coord of old data by leftnewlen
        for(var i=0; i<od.length; i++) 
	    od[i][0] += leftnewlen; // box start
    } else {
        // moving right, shift new data coord by leftoldlen
        for(var i=0; i<newdata.length; i++)
	    newdata[i][0] += leftoldlen;
    }
    // with new data, merge items already exists in old
    var lk = decorCanvasHash[gf].lookup;
    for(var i=0; i<newdata.length; i++) {
        var jack = newdata[i];
        if(jack[2] in lk) {
            var jill = lk[jack[2]];
            if(move.direction == 'l') {
	        // jack placed before jill, modify box start and width
		jill[0] = jack[0];
		jill[1] += jack[1];
	    } else {
	        // jack appended to jill, only modify box width
		jill[1] += jack[1];
	    }
	} else {
	    od.push(jack);
	}
    }
}


/*** left-clicking on decor track pops up tooltip 
 ***/
function decorCanvasLeftclickHide(event) {
    event.preventDefault();
    document.getElementById("decoriteminfo").style.display = "none";
    document.body.removeEventListener("mouseup", decorCanvasLeftclickHide, false);
}
function decorCanvasLeftclickGetInfo(decorname, item, regionIdx) {
    /* called by decorCanvasLeftclick
       retieves info with respect of decor type

       args:
         decorname, must be in decorCanvasHash
	 item: the item array describing an item
       possibly ajax query to fetch additional info depending on decor type
       fill to decor info tooltip

       should be expandable to accommdate new decor tracks
     */
    var sayplain = document.getElementById("decoriteminfosays");
    var sayajax = document.getElementById("decoriteminfosaysajax");
    sayajax.innerHTML = "";
    var text = "";
    if(!(decorname in decorCanvasHash)) {
        sayplain.innerHTML = "decor track name erro";
        return;
    }
    var ft = decorInfo[decorname].fileType;
    if(ft == 0) {
        // server bigbed
	if(decorIsGene(decorname)) {
	    text += (item[15]==undefined?item[3]:("<span style='font-size:14px;font-weight:bold;'>"+item[15]+"</span>&nbsp;&nbsp;"+"internal name: "+item[3]))+"<br>";
	} else if(item[3] != undefined) {
	    text += "<b>"+item[3]+"</b><br>";
	}
	if(item[4] != undefined) {
	    text += "strand: "+(item[4]=='>' ? "forward" : "reverse")+"<br>";
	}
	text += regionLst[regionIdx][0]+":"+item[8]+"-"+item[9];
        if(decorIsGene(decorname)){
	    // need to use parent if current decor is child
	    var genetype = decorname;
	    if("parent" in decorInfo[decorname])
	        genetype = decorInfo[decorname].parent;
	    // gene related, fetch desc
	    var param;
	    ajax('getgenedesc=on&genetype='+genetype+'&itemid='+item[2]+'&dbName='+dbInfo.name, function(data){
	        var d = document.getElementById("decoriteminfosaysajax");
                d.innerHTML = data.desc+"<br><span class=clb3 onmousedown='window.open(\""+decorInfo[data.genetype].queryUrl+data.internalname+"\")'>More info</span>";
		if(data.desc.length > 50)
		    d.style.width = 300;
		else
		    d.style.width = 'auto';
	    });
	} else if(decorIsRepeat(decorname)) {
	    ajax2('getrepeatdesc=on&dbName='+dbInfo.name+'&chr='+regionLst[regionIdx][0]+'&start='+item[8]+'&stop='+item[9]+(item[3]!=undefined?'&repName='+item[3]:''), function(data) {
	        document.getElementById("decoriteminfosaysajax").innerHTML = data;
	    });
	}
    } else if(ft == 1) {
        // custom bigbed
	if(item[3] != undefined)
	    text += item[3]+"<br>";
	if(item[4] != undefined)
	    text += "strand: "+(item[4]=='>' ? "forward" : "reverse")+"<br>";
	text += regionLst[regionIdx][0]+":"+item[8]+"-"+item[9];
    } else if(ft==4 || ft==5) {
        // server/custom BAM
	if(item[2] != undefined)
	    text = "read name: "+item[2] + "<br>";
	var ispaired = false;
	if(item[12]) {
	    if(item[14] == undefined) {
	        text += "(paired-end, but mate not found)<br>";
	    } else {
	        text += "(paired-end)<br>";
		ispaired = true;
	    }
	} else {
	    text += "(single-end)<br>";
	}
	if(item[2] != undefined) {
	    sayajax.innerHTML = "<br>loading data...<br>";
	    // only request more info if read has id (so be able to identify it)
	    var param = ft==4 ? '&fname='+decorname : '&url='+decorInfo[decorname].url;
	    ajax2("getbamreadinfo="+item[2]+"&filetype="+ft+param+"&chr="+regionLst[regionIdx][0]+"&position="+regionLst[regionIdx][0]+":"+item[8]+"-"+(item[9]+1)+(ispaired?"&ispaired=on":""), function(data){
	        sayajax.innerHTML = data;
	    });
	}
    } else {
        text = "decor track file type not supported";
    }
    sayplain.innerHTML = text;
}
function decorCanvasLeftclick(event) {
    /* called by left click on decor track items (full/thin)
     */
    var decorname = event.target.decorname;
    if(!(decorname in decorCanvasHash))
        return;
    var mode = decorInfo[decorname].mode;
    if(mode!="full" && mode!="thin")
        return;
    // figure out the x/y on decor canvas
    // need sum of heights from all upper decor tracks, including htest and pairwise
    var lst = document.getElementById("tgt_decorCanvasHeader").childNodes;
    var updecorheight = 0;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].decorname != decorname)
	    updecorheight += parseInt(lst[i].height)+2; // +2 patch offset
	else
	    break;
    }
    if(pwc.inuse)
        updecorheight += pwc.canvas.height;
    if(htest.inuse)
        updecorheight += parseInt(htest.holder.style.height);
    var mX = event.clientX - iiX - move.styleLeft + document.body.scrollLeft;
    var mY = event.clientY - iiY - sumTrackHeight() - parseInt(ideogram.viewbox.style.height) + document.body.scrollTop - updecorheight -7; // -7 patch offset
    // compute stack id of mouse click (there is 1px spacing between stacks)
    var stkh = mode=="full" ? fullStackHeight+1 : thinStackHeight+1;
    var clickstack = parseInt(mY / stkh);
    for(var i=0; i<decorCanvasHash[decorname].data.length; i++) {
	for(var j=0; j<decorCanvasHash[decorname].data[i].length; j++) {
	    var item = decorCanvasHash[decorname].data[i][j];
	    if(item[5] == undefined)
	        continue;
	    if(item[5] != clickstack)
	        continue;
	    if(item[6]<=mX && item[6]+item[7]>=mX) {
	        // item matched, place tooltip over it
		var d = document.getElementById("decoriteminfo");
		d.style.display = "block";
		d.style.left = event.clientX+document.body.scrollLeft-9;
		d.style.top = event.clientY+document.body.scrollTop-3;
		decorCanvasLeftclickGetInfo(decorname, item, i);
		document.body.addEventListener("mouseup", decorCanvasLeftclickHide, false);
		return;
	    }
	}
    }
}


/*** similar as decor item info system, click on metadata color block also generates tooltip
     still uses decor item tooltip
 ***/
function mdcanvasLeftclick(event) {
    // left click on metadata canvas, present more info on the metadata term in decoriteminfo tooltip
    if(mdnotooltip) {
        mdnotooltip = false;
	return;
    }
    var xi = Math.floor((event.clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
    /* don't need to figure out tkLst index, 
       as event.target is canvas, 
       and .attr holds metadata terms
     */

    if(mdcategoryOnshow[xi] in custmdhash) {
	// wow, custom...
	return;
    }

    var attrIdx = event.target.attr[xi]; // the index of md term under focus
    if(attrIdx == undefined)
        return;
    if(!(attrIdx in mdvidx2attr))
        return;
    if(!(attrIdx in mdvc2p)) // this is actually error
        return;

    mdterm_showtooltip(attrIdx, event.clientX, event.clientY);
}
function mdterm_showtooltip(attridx, clientx, clienty) {
    // pop out tooltip to show desc for a leaf term!!!
    var d = document.getElementById("decoriteminfo");
    d.style.display = "block";
    d.style.left = clientx+document.body.scrollLeft-9;
    d.style.top = clienty+document.body.scrollTop-3;
    d.attridx = attridx;

    // server, must look into mdvidx2attr for its string value
    document.getElementById("decoriteminfosays").innerHTML = "";
    document.getElementById("decoriteminfosaysajax").innerHTML = "loading...";
    document.body.addEventListener("mouseup", decorCanvasLeftclickHide, false);
    ajax2('getmdtermdesc='+attridx+'&dbName='+dbInfo.name, function(data) {
	var attridx = document.getElementById("decoriteminfo").attridx;
        document.getElementById("decoriteminfosaysajax").innerHTML = ((data=="NODATA") ? mdvidx2attr[attridx] : data) + "<br>parent: "+mdvc2p[attridx];
    });
}



function makeNewDecorCanvas(gf, data, mode, fileType, url, skipped, customlabel) {
    /* make a new entry in decorCanvasHash
       args:
           gf: gf name for server tracks, internal name for custom track
	   data: [[region1], [region2], ...]
	   mode: show/density/thin/full
	   fileType: see doc
	   url: string
	   skipped: reserved for future use todo
	   customlabel: not null for custom tracks, the label
       also handles server bam track, which don't have <select>
     */
    var c = document.createElement('canvas'); // decor canvas
    c.height = ordinaryTrackHeight;
    c.style.position = 'absolute';
    c.className = "decorCanvas";
    c.decorname = gf;
    c.addEventListener("click", decorCanvasLeftclick, false);
    var vb = document.createElement('div'); // viewbox
    vb.style.width = hmSpan;
    vb.style.height = ordinaryTrackHeight;
    vb.style.overflow = 'hidden';
    vb.style.position = 'relative';
    vb.style.marginTop = '2px';
    vb.style.marginBottom = '2px';
    vb.appendChild(c);
    document.getElementById('tgt_decorCanvas').appendChild(vb);
    var hc = document.createElement('canvas'); // header canvas
    hc.style.display = 'block';
    hc.width = leftColumnWidth;
    hc.height = ordinaryTrackHeight;
    hc.style.marginTop = '2px';
    hc.style.marginBottom = '2px';
    hc.decorname = gf;
    document.getElementById('tgt_decorCanvasHeader').appendChild(hc);
    // also with default config features
    decorCanvasHash[gf] = {
                'canvas':c, 'viewbox':vb, 
		'data':data, 
		'header':hc, 'skipped':0,
		'qtc':{},
		'textcolor':document.getElementById('stc_textcolor').style.backgroundColor,
		'fontsize':getSelectValueById("stc_fontsize"),
		'fontfamily':getSelectValueById("stc_fontfamily"),
		'fontbold':document.getElementById('stc_fontbold').checked,
		'bedcolor':document.getElementById('stc_bedcolor').style.backgroundColor,
		'forwardcolor':document.getElementById("stc_forwardcolor").style.backgroundColor,
		'reversecolor':document.getElementById("stc_reversecolor").style.backgroundColor,
		'mismatchcolor':document.getElementById("stc_mismatchcolor").style.backgroundColor
		};
    qtc_paramCopy(defaultQtcStyle["ft"+fileType], decorCanvasHash[gf].qtc);

    if(fileType == 4) {
        /* register server bam track 
	   somewhat confusing here
	   todo where is server bam label???
	 */
	if(!(gf in decorInfo))
            decorInfo[gf] = {fileType:4, grp:-1, hasStruct:0, label:customlabel, mode:mode};
    } else if(fileType==1 || fileType==5) {
        /* register custom bigbed and bam track in decorInfo */
        // this is the case when this track has been turned hidden
	if(gf in decorInfo) {
	    // todo need to do this in case of restoring status
	    decorInfo[gf].label = customlabel;
	    return;
	}
        if(url == undefined)
	    fatalError("makeNewDecorCanvas: custom bigbed but no url");
        decorInfo[gf] = {fileType:fileType, url:url, grp:-1, hasStruct:0, label:customlabel, mode:mode};
    }
}




/*******************************
     household TKack operations
 ******************************/
function makeTrackCheckboxHtml(tkname) {
    // make a checkbox for a track, with the label, return html
    return "<input type=checkbox id="+tkname+" onchange=trackcheckboxOnchange(event)> <label for="+tkname+">"+hmtk.tolabel[tkname]+"</label>";
}
function track2addCancel() {
    stripChild(document.getElementById("track2addtable"), 0);
    document.getElementById("track2addwrapper").style.display = "none";
    trackselectionCancel();
}
function trackcheckboxOnchange(event) {
    track2addAddRemoverow(event.target.id, event.target.checked);
}
function track2addAddRemoverow(tkn, addremove) {
    // tkn: track name
    // addremove: boolean, true for adding a row into track2addtable, false for remove row

    // called by clicking checkbox for selecting tracks in floating toolbox
    // will add/remove entry in track2addtable
    var table = document.getElementById("track2addtable");
    var tkn2 = "t2a_"+tkn;
    if(addremove) {
        // add row, but first go over rows to see if this track has already been added
	var notfound = true;
	for(var i=0; i<table.childNodes.length; i++) {
	    if(table.childNodes[i].id == tkn2) {
	        notfound = false;
		break;
	    }
	}
	if(notfound) {
	var tr = document.createElement("tr");
	tr.id = tkn2;
	var td = document.createElement("td");
	td.style.fontSize = "12px";
	td.innerHTML = hmtk.tolabel[tkn];
	tr.appendChild(td);
	td = document.createElement("td");
	td.style.fontSize = "12px";
	td.innerHTML = '<span style="cursor:pointer;padding-left:5px;padding-right:5px;" onclick="getOnetrackdetails(\''+tkn+'\')">&#9432;</span>';
	tr.appendChild(td);
	table.appendChild(tr);
	}
    } else {
        // remove row
	var c = document.getElementById(tkn2);
	if(c != null)
	    table.removeChild(c);
    }
    var w = document.getElementById("track2addwrapper");
    var n = table.childNodes.length;
    w.style.display = (n > 0) ? "block" : "none";
    w = document.getElementById("track2addtablescrollholder");
    if(n >= 8) {
        w.style.height = "135px";
	w.style.overflowY = "scroll";
    } else {
        w.style.height = "auto";
	w.style.overflowY = "auto";
    }
}
function updateAfterRemovetrack() {
    trackHeightChanged(false);
    generateTrackselectionLayout();
}
function trackInDisplay(what) {
    // arg is track name, see if it is in tkLst
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].name == what)
	    return true;
    }
    return false;
}
function highlighttrack(what, which) {
    /* put indicator over single hmtk
       args:
            what: variable argument, could be track name or tkLst array index
	    which: which indicator to use (1 or 3)
     */
    var tdi;
    if(typeof(what) == "string")
        tdi = getTkidxByname(what);
    else
        tdi = what;
    if(tdi == -1 || tdi >= tkLst.length) return;
    var h = 0;
    for(var i=0; i<tdi; i++)
        h += tkLst[i].qtc.height;
    if(which == 3) {
        //indicator.style.display = 'none';
	placeIndicator3(iiX,
	                iiY+h,
                        hmSpan+tkAttrColumnWidth*mdcategoryOnshow.length,
                        tkLst[tdi].qtc.height);
    } else {
        indicator.style.display = 'block';
        indicator.style.left = iiX;
        indicator.style.top = iiY + h;
        indicator.style.width = hmSpan + tkAttrColumnWidth*mdcategoryOnshow.length -2;
        indicator.style.height = tkLst[tdi].qtc.height - 2;
    }
}
function removeTktentacles(tk) {
    /* for heatmap track, 
       argument is track object (element in tkLst)
       don't remove custom track registry <tr>
     */
    tracklabelholder.removeChild(tk.labeldiv);
    // custom track holder
    //if(tk.isCustom) document.getElementById("custHolder3").firstChild.removeChild(tk.registrytr);
    // heatmap canvas
    viewbox.removeChild(tk.hmC);
    // metadata canvas
    tkAttrHolder.removeChild(tk.atC);
    // correlation canvas
    if(correlation.inuse) {
        corrHolder.removeChild(tk.coC);
        // in case the corr choice is on a removed track..
        if(correlation.targetname == tk.name) {
    	    turnoffCorrelation();
	}
    }
    // track selection panel
    tkselect.hmholder.firstChild.removeChild(tk.sptr);
    // htest
    // <div> in htest group holder
    var d = document.getElementById(tk.name+"inhtestgrp");
    if(d != null) {
        if(d.parentNode != null)
	    d.parentNode.removeChild(d);
        if(htest.inuse)
	    turnoffHtest();
    }
    // pairwise compare
    // <div> in pairwise comp group holder
    d = document.getElementById(tk.name+'inpwcgrp');
    if(d != null) {
        d.parentNode.removeChild(d);
	if(pwc.inuse)
	    turnoffPairwisecomp();
    }
}
function removeBigwigTrack(i) {
    /* remove ONE bigwig track by its index in tkLst
       handles both server or custom bigwig
       but don't do any update
       all bigwig removal will finally call this:
       - remove one from menu
       - remove a group from menu
       - remove a custom bigwig by clicking icon in custHolder
       - remove by clicking icon in track selection table in toolbox
       - clicking "remove all" in track selection table in toolbox

       for custom bigwig, won't remove its <tr> in registry

       htest and pwc might be turned off, in tentacle removal
     */
    if(i<0 || i>=tkLst.length) // give a warning?
        return;
    //var wasCustom = tkLst[i].isCustom;
    removeTktentacles(tkLst[i]);
    tkLst.splice(i,1);
    tkNameLst.splice(i,1);
    updateDsp();
}
function removeCustombigwig_pushDel(event) {
    /* should only be called by pushing delete button in custom track registry
       will remove everything of this track
     */
    var tkname = event.target.getAttribute("tkname");
    if(!(tkname in hmtk.custom)) fatalError('removeCustombigwig_pushDel: track not found in hmtk.custom');
    var tkid = getTkidxByname(tkname);
    if(tkid != -1) {
	removeBigwigTrack(tkid);
	updateAfterRemovetrack();
    }

    document.getElementById('custHolder3').firstChild.removeChild(hmtk.custom[tkname].registrytr);
    delete hmtk.custom[tkname];
    customtrackRemoved(3);
}
function removeBigwigTrack_iconchange(event) {
    /* tracks on display will have a cross icon in track selection panel,
       clicking them will remove this track from display,
       and change the cross icon into a checkbox in case user regrets what he's done
       event.target is the icon, sits in an identifiable <div>
     */
    var d = event.target.parentNode;
    var td = d.parentNode; // <td>
    var tkn = d.title;
    td.innerHTML = makeTrackCheckboxHtml(tkn);
    removeBigwigTrack(getTkidxByname(tkn));
    updateAfterRemovetrack();
}
function removeAlltracks() {
    // called by clicking "Remove all" button
    var l = tkLst.length;
    for(i=0; i<l; i++)
       removeBigwigTrack(0);
    stuffTrackCanvas2holder();
    generateTrackselectionLayout();
    if(htest.inuse) turnoffHtest();
    updateDsp();
    trackHeightChanged(false);
}
function removeAllserverbigwig() {
    var l = tkLst.length;
    var j = 0;
    for(i=0; i<l; i++) {
       if(tkLst[j].isCustom)
           j++;
       else
           removeBigwigTrack(j);
    }
    stuffTrackCanvas2holder();
    generateTrackselectionLayout();
    if(htest.inuse) turnoffHtest();
    updateDsp();
    trackHeightChanged(false);
}
function cgiChangeTrack() {
    /* only invoked by *adding* server bigwig tracks

       a list of track names to be chosen by user is in tkselectionlst,
       each track corresponds to one <checkbox> in floating box
       go over tkLst, if it is in tkselectionlst and is unchecked, it will be removed, 
       then add those that are checked and not displayed
     */
    var table = document.getElementById("track2addtable");
    if(table.childNodes.length == 0)
        return;
    var newlyAdd = [];
    for(i=0; i<table.childNodes.length; i++)
        newlyAdd.push(table.childNodes[i].id.split("t2a_")[1]);
    trackselectionCancel();
    track2addCancel();
    ajaxAddnewserverbigwig(newlyAdd);
}
function hmtk_mightAddOne(which) {
    // for adding one server hmtk
    var tk = findTrackByName(which);
    if(tk != null) {
        print2console("The track is already on display", 2);
	return;
    }
    ajaxAddnewserverbigwig([which]);
}
function ajaxAddnewserverbigwig(lst) {
    // argument is list of server bigwig names to be added
    // only fetch data for newly added tracks
    if(lst.length == 0) return;
    cloak(viewbox);
    ajax(displayedRegionParamPrecise()+'&addserverbigwig=on&hmtk2='+lst.join(",")+'&dbName='+dbInfo.name, function(data){
        jsonTrackAddnew(data);

        makeTrackAttrAll();
        mcmSortTrack(sortTrackIdx);

	for(var i=0; i<data.tkData.length; i++) {
	    var tk = findTrackByName(data.tkData[i]['name']);
	    if(tk==null) 
	        fatalError("ajaxAddnewserverbigwig: track "+data.tkData[i]['name']+" not found");
	    qtc_paramCopy(defaultQtcStyle.heatmap, tk.qtc);
	    drawOnehmtk(tk);
	}

	trackHeightChanged(false);
        unveil(viewbox);

	if(gflag.urlparam.willcontinue)
	    urlparam_handleTriggers();

	runCorrelation();
    });
}
function toggleDecor(tkname) {
    /* turn on a decor by simulating change of <select>
       mode has to be already set in decorInfo
       <select>.selectedIndex will have no use
     */
    if(!(tkname in decorInfo))
        fatalError('turnonDecor: '+tkname+' not found in decorInfo');
    var obj = decorInfo[tkname];
    changeSelectByValue(obj.selectdom, obj.mode);
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("change", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    obj.selectdom.dispatchEvent(e);
}
function ajaxAddOneServerbam(event) {
    /* called by clicking button
       add one bam track given its file name
       TODO instead of using thin as default, allow user to choose mode
     */
    if(entire.length >= 1000000) {
        print2console('For security purpose, please zoom in to narrower region to display read alignment data', 2);
	return;
    }
    var fname = event.target.getAttribute('tkname');
    if(fname in decorInfo) {
        if(decorInfo[fname].mode == 'hide') {
	    decorInfo[fname].mode = 'density';
	    toggleDecor(fname);
	    return;
	}
        print2console('This track is already in display', 2);
	return;
    }
    ajax(displayedRegionParamPrecise()+'&addserverbam='+fname+',thin',function(data){
        if(!('serverbamdata' in data))
	    fatalError('ajaxAddOneServerbam: serverbamdata missing');
	jsonAddoneserverbam(data.serverbamdata[0]);

        unveil(viewbox);
        print2console("read alignment track added", 1);
        document.body.style.cursor = 'auto';
    });
}
function jsonAddoneserverbam(data) {
    // data is an array [name, label, mode, [data] ]
    var name = data[0];
    var label = data[1];
    makeNewDecorCanvas(name, data[3], data[2], 4, null, 0, label);
    drawDecorCanvas(name);
    decorCanvasHash[name].canvas.style.left = move.styleLeft;
    decoruserlist_insert(name);
    // register this track
    tkselect.decor.grptab_nativebam.style.display = 'block';
    var tr = tkselect.decor.tkholder_nativebam.insertRow(-1);
    decorInfo[name].tksregistrytr = tr;
    var td = tr.insertCell(0);
    // TODO add information link for user to obtain information about this track
    td.innerHTML = label;
    td.className = 'tkentry';
    td.setAttribute('tkname', name);
    td.setAttribute('name', 'decortkentry');
    td.style.backgroundColor = 'transparent';
    td.addEventListener('click', decortkentry_click, false);
    decorInfo[name].tksentry = td;
}





/********************
   HTEST related functions
 ********************/
function pvcutoff_selectchange() {
    // the <select> in qtc panel, works for normal/bev htest
    if(qtc.which == 9) {
        // normal htest
	htest.qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	drawHtestCanvas();
    } else if(qtc.which == 8) {
        // bev htest
	bev.data[bev.ongoing].qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
	bev_plot(bev.ongoing);
    } else {
        fatalError('pvcutoff_selectchange: unknown qtc.which '+qtc.which);
    }
}
function drawHtestHeadercanvas() {
    htest.header.width = leftColumnWidth;
    htest.header.height = htest.canvas.height;
    htest.header.ctx = htest.header.getContext('2d');
    var ctx = htest.header.ctx;
    ctx.fillStyle = 'black';
    ctx.font = 'bold 8pt Sans-serif';
    ctx.fillText('log10 P value', 1, 20);
    ctx.fillText('cutoff: '+getSelectValueById('pvcutoff'), 1, 36);
    drawVerticalAxis(htest.qtc,htest.header, 0, htest.minlogpv, true, 'black');
}
function drawHtestCanvas() {
    /* call this when pvalue is available

       variable argument:
         if got one argument, it is pvalues passed from CGI
         else plot htest.pvalue

       pvalue cutoff is always read from pvcutoff <select>
     */
    if(!htest.inuse) {return;}
    if(arguments[0] != undefined) {
        if(move.direction == null) {
            htest.pvalue = arguments[0];
        } else if(move.direction == 'l') {
	    var nd = arguments[0];
	    if(move.merge) {
		htest.pvalue[0] = nd[nd.length-1].concat(htest.pvalue[0]);
		nd.pop();
	    }
            htest.pvalue = nd.concat(htest.pvalue);
        } else {
	    var nd = arguments[0];
	    if(move.merge) {
	        var lastr = htest.pvalue[htest.pvalue.length-1];
		htest.pvalue[htest.pvalue.length-1] = lastr.concat(nd[0]);
		nd.shift();
	    }
            htest.pvalue = htest.pvalue.concat(nd);
	}
    }

    /* header will have 4 ticks: 0.0005 0.005 0.05 1
       so zero pvalue will be replaced by to 0.0005
     */
    htest.canvas.width = entire.spnum;
    htest.canvas.height = htest.qtc.height+densitydecorpaddingtop*2;
    htest.holder.style.height = htest.canvas.height;
    htest.header.height = htest.canvas.height;
    htest.canvas.style.left = move.styleLeft;
    var ctx = htest.canvas.ctx;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var logpv = qtrack_logtransform(htest.pvalue, htest.qtc);
    var thv = qtrack_getthreshold(logpv, htest.qtc);
    htest.minlogpv = thv[1];
    drawHtestHeadercanvas();
    qtrack_plotwiggle(logpv, ctx, htest.qtc, 0, thv[1], unitwidth);

    // draw cutoff line
    var lcv = Math.log(htest.qtc.pvcutoff) * Math.LOG10E;
    if(lcv <= htest.minlogpv) { return; }
    ctx.fillStyle = htest.qtc.pvccolor;
    ctx.fillRect(0,densitydecorpaddingtop+htest.qtc.height*lcv/htest.minlogpv,htest.canvas.width,1);
}
function turnoffHtest() {
    htest.holder.style.display = 'none';
    htest.header.style.display = 'none';
    htest.inuse = false;
    document.getElementById("htestsaysno").style.display = "block";
    document.getElementById("htestsaysyes").style.display = "none";
}
function htest_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOn(grpnumber) {
    document.getElementById('htestgroupdiv_'+grpnumber).firstChild.firstChild.style.display = "none";
}
function htest_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "block";
}
function pwc_grpbuttOff(grpnumber) {
    document.getElementById('pairwisecompgroup'+grpnumber).firstChild.firstChild.style.display = "none";
}
function addhmtkgroupholder(grpnumber,height,type) {
    /* make hmtk group holder for htest and pwc
       return list of two dom objects: wrapper to be inserted in place, holder to add ID
       arg is number of group
     */
    var holderid;
    if(type == 'htest') {
        holderid = 'htestgroupdiv_'+grpnumber;
    } else if(type == 'pwc') {
        holderid = 'pairwisecompgroup'+grpnumber;
    } else {
        fatalError('addhmtkgroupholder: unknown type');
    }
    var color = colorCentral.longlst[grpnumber];
    color = lightencolor(colorstr2int(color),0.4);
    var table = document.createElement("table");
    table.cellSpacing = 0;
    table.style.border = "solid 1px "+color;
    table.style.marginBottom = "10px";
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);
    td.style.backgroundColor = color;
    td.align = 'center';
    td.innerHTML = 'GROUP '+grpnumber;
    td = tr.insertCell(-1);
    td.align='right';
    td.innerHTML = '<button class=s holderid='+holderid+' onclick=hmtkgrp_clear(event)>&#10005; clear</button> <button class=s ttype='+type+' grp='+grpnumber+' holderid='+holderid+' onmousedown=tkspanel_close() onclick=hmtkgrp_invoketksp(event)>add &#187;</button>';
    // track holder
    tr = table.insertRow(-1);
    td = tr.insertCell(0);
    td.style.width = 360;
    td.style.height= height;
    td.vAlign = "top";
    td.colSpan = 2;
    td.id = holderid;
    return table;
}
function addhtestgroup() {
    // can be called by pushing add group button
    if(htest.inuse) turnoffHtest();
    htest.grpnum++;
    document.getElementById("htestgroupholder").appendChild(addhmtkgroupholder(htest.grpnum,100,'htest'));
    document.getElementById("htestremovegrpbutton").disabled = (htest.grpnum > 2) ? false : true;
}
function addpwcgroups() {
    /* just called once during page load up */
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(1,105, 'pwc'));
    document.getElementById("pwcgroupholder").appendChild(addhmtkgroupholder(2,105,'pwc'));
}
function removehtestgroup() {
    if(htest.inuse) turnoffHtest();
    htest.grpnum--;
    var h = document.getElementById("htestgroupholder");
    h.removeChild(h.lastChild);
    document.getElementById("htestremovegrpbutton").disabled = (htest.grpnum > 2) ? false : true;
    // remove last option of <select> 
    for(var i=0; i<tkLst.length; i++) {
        var s = document.getElementById(tkLst[i].name+"htestgrpselect");
	s.removeChild(s.lastChild);
    }
}
function htestgroupclearcontent() {
    // called by pushing button, will clear all groups
    if(htest.inuse) turnoffHtest();
    for(var i=1; i<=htest.grpnum; i++) {
        stripChild(document.getElementById("htestgroupdiv_"+i), 0);
    }
}
function menuHtesttkassigngrp(event) {
    // called on clicking grp box on context menu
    // decide if to change single/multiple track
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	htest_assigngrp(tkLst[menu.iY].name, event.target.grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    htest_assigngrp(tkLst[menu.trackIdxLst[i]].name, event.target.grpid);
	}
    }
    if(htest.inuse) turnoffHtest();
}
function menuPairwisecomptkassigngrp(grpid) {
    // similar as htest counterpart, argument is group id 1/2
    if(menu.context == 1) {
        // single track
        if(menu.iY >= tkLst.length) 
	    fatalError("menuHtesttkassigngrp: wrong tkLst index");
	pwc_assigngrp(tkLst[menu.iY].name, grpid);
    } else if(menu.context == 2) {
        // multiple tracks
	for(var i=0; i<menu.trackIdxLst.length; i++) {
	    if(menu.trackIdxLst[i] >= tkLst.length)
	        fatalError("menuHtesttkassigngrp: wrong tkLst index");
	    pwc_assigngrp(tkLst[menu.trackIdxLst[i]].name, grpid);
	}
    }
    if(pwc.inuse)
        turnoffPairwisecomp();
}
function htest_assigngrp(tkname, grp) {
    /* assign a track to a htest group
       1. track name
       2. group number, 0 means this track does not belong to any group
     */
    //if(htest.inuse) turnoffHtest();
    // remove this track from its old group, if any
    var d = document.getElementById(tkname+"inhtestgrp");
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to that group
    d = document.createElement("div");
    d.id = tkname+"inhtestgrp";
    d.setAttribute('tkname', tkname);
    // in case track is custom
    var tkobj = findTrackByName(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"htest_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj==null ? hmtk.tolabel[tkname] : tkobj.label);
    //d.addEventListener("mouseover", generictrackdiv_mouseover, false);
    //d.addEventListener("mouseout", generictrackdiv_mouseoout, false);
    document.getElementById("htestgroupdiv_"+grp).appendChild(d);
}
function htestParams() {
    if(htest.inuse) {
        var lst = [];
	for(var i=1; i<=htest.grpnum; i++) {
	    lst.push("&htestgrp"+i+"="+htest["gtn"+i].join(","));
	}
        var v = getSelectValueById("htestc"); // correction
        return "&htest=on&htestgrpnum="+htest.grpnum+lst.join("")+(v=="no" ? "" : "&htestc="+v);
    }
    return "";
}
function cgiHtest() {
    /* called upon pushing "run test" button
       or restoring session?
       verify at least two htest groups are there with children
     */
    var good = 0;
    for(var i=1; i<=htest.grpnum; i++) {
        if(document.getElementById("htestgroupdiv_"+i).childNodes.length > 0)
	    good++;
    }
    if(good < 2) {
        print2console("make at least 2 track groups", 2);
	turnoffHtest();
	return;
    }
    for(i=1; i<=htest.grpnum; i++) {
        htest["gtn"+i] = [];
	var lst = document.getElementById("htestgroupdiv_"+i).childNodes;
	for(var j=0; j<lst.length; j++) {
	    htest["gtn"+i].push(lst[j].getAttribute('tkname'));
	}
    }
    ajaxHtest();
}
function ajaxHtest() {
    htest.holder.style.display = 'block';
    htest.header.style.display = 'block';
    htest.inuse = true; // need to set to true before calling htestParams()
    document.getElementById("htestsaysno").style.display = "none";
    document.getElementById("htestsaysyes").style.display = "block";
    cloak(viewbox);
    print2console("running hypothesis test...", 0);
    ajax(displayedRegionParamPrecise()+hmtkChoice_htest()+htestParams(), function(data) {
	drawHtestCanvas(data['htestData']);
	unveil(viewbox);
	print2console("done", 0, false);
    });
}
function addHtestgrp2menu() {
    // add group options to context menu
    var holder = document.getElementById("menuHtestgrpholder");
    stripChild(holder, 0);
    for(var i=1; i<=htest.grpnum; i++) {
        var d = document.createElement("div");
	d.grpid = i;
	d.className = "groupselector";
	d.style.display = "inline-block";
	d.style.backgroundColor = colorCentral.longlst[i];
	d.style.marginLeft = 5;
	d.innerHTML = '&nbsp;'+i+'&nbsp;';
	d.addEventListener("click", menuHtesttkassigngrp, false)
	holder.appendChild(d);
    }
}





function setDisplaywhichgf() {
    /* display brief info on top of heatmap panel
       also on collation on/off indicator
       juxtaposition.type has to be set to proper value before calling this
     */
    //var sp = document.getElementById("displaywhichgf");
    var sp2 = document.getElementById("juxtaposewhat");
    if(juxtaposition.type == 0) {
	//sp.innerHTML = juxtaposition.note;
    } else if(juxtaposition.type==1 || juxtaposition.type==2 || juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
	//sp.innerHTML = 
	sp2.innerHTML = juxtaposition.note;
    } else {
	fatalError("setDisplaywhichgf: unknown juxtaposition.type");
    }
}

function cgiJuxtapose(event) {
    /* this is supposedly only called by hand-selection on radio buttons
       deals with server/custom bigbed
       use event.target.className to tell
       
       TODO use standard filetype number?
     */

    /* following are removed because they will cause trouble
       when changing between custom bigbed files 
    if(juxtaposition.type != 0)
        fatalError("cgiJuxtapose: wrong juxtaposition.type value");
     */

    var c = event.target.className;
    if(c!="server" && c!="custom")
        fatalError("cgiJuxtapose: wrong event.target.className");

    if(c == "server") {
        juxtaposition.type = 1;
	juxtaposition.note = event.target.alt;
	juxtaposition.what = event.target.value;
    } else {
        juxtaposition.type = 2;
	juxtaposition.note = "custom bigBed track";
	juxtaposition.what = event.target.value;
    }
    setDisplaywhichgf();
    juxtaposeHideOptions();

    cloak(viewbox);
    print2console("juxtaposing "+juxtaposition.note+"...", 0);
    ajaxX(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&changeGF=on");
}
function turnoffJuxtapose() {
    var jt = juxtaposition.type;
    if(jt == 0) {
        return;
    } else if(jt==1 || jt==2) {
	document.getElementById("juxtaposenotinuse").style.display = "block";
	document.getElementById("juxtaposeinuse").style.display = "none";
	document.getElementById("scaffoldnotinservice").style.display = "none";
	document.getElementById("scaffoldinservice").style.display = "block";
	document.getElementById("genesetnotinservice").style.display = "none";
	document.getElementById("genesetinservice").style.display = "block";
	juxtaposition.note = 'genome';
	juxtaposition.type = 0;
	juxtaposition.what = 'genome';
        ajaxX(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&changeGF=on");
    } else if(jt==3 || jt==4) {
        turnoffGenesetview();
    } else {
        fatalError('turnoffJuxtapose: unknown juxtaposition.type '+jt);
    }
}


function cgiZoomout(howmuch) {
    /* must be called by "zoom out" button, so if already meets borders, disable zoom out button
       argument: 0.5 for zoom out by 1.5 fold
       don't try to toggle entire.atbplevel here
     */
    cloak(viewbox);
    print2console("zooming out...", 0);
    ajax(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&zoom="+howmuch, function(data){
        jsonX(data);
	unveil(viewbox);
        print2console("done", 1);
    });
}
function cgiJumpchr(seq) {
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        print2console('Not jumping because in gene set view mode', 2);
	return;
    }
    cloak(viewbox);
    print2console("displaying entire "+seq+"...",0);
    ajaxX("jump=on&jumpchr="+seq+"&gftype="+juxtaposition.what+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&dbName="+dbInfo.name);
}
function cgiJump2coord(coord) {
    cloak(viewbox);
    print2console("jumping to coordinate...", 0);
    ajaxX(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&jump=on&jumppos="+coord);
}
function cgiJump2region() {
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        print2console('Not jumping because in gene set view mode', 2);
	return;
    }
    var param = document.getElementById('jumppos').value;
    if(param.length!=0 && param!="enter coordinate") {
        var str = param.replace(/,/g, ''); // remove comma
	str = str.replace(/\t/g, ' '); // replace tab with space
        cgiJump2coord(str);
        return;
    }
    param = document.getElementById('jumpgene').value;
    if(param.length!=0 && param!='enter gene name') {
        cloak(viewbox);
	print2console("jumping to one gene...", 0);
        ajaxX(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&jump=on&jumpgene="+param);
	return;
    }
    print2console("neither gene nor coordinate given", 2);
}
function cgiGetData() {
    /* get data underlining genome heatmap
       called by pushing button, one of those misc function
       what if there's no track on?
     */
    document.getElementById("getdatawriteshere").innerHTML = "working...";
    ajax(displayedRegionParamPrecise()+hmtkChoice()+"&sptotalnum="+hmSpan+"&getdata=on",function(data){
        document.getElementById("getdatawriteshere").innerHTML = "right click on link and save: <a style='text-decoration:underline' href=t/"+sessionId+".txt target=_blank>tabular</a> <a style='text-decoration:underline' href=t/"+sessionId+".wig target=_blank>wiggle</a>";
    });
}
function cgiGetSeq() {
    // called by pushing button, one of those misc function
    var yellat = document.getElementById("getseqwriteshere");
    yellat.innerHTML = "working...";
    var v = document.getElementById("getseqcoord").value;
    if(v == "enter coordinate") {
        // fetch seq for currently displayed region
	var el = entire.atbplevel ? hmSpan/entire.bpwidth : hmSpan*entire.summarySize;
	if(el > 1000000) {
	    yellat.innerHTML = "length of currently displayed region exceeds 1 mega bp, try zoom in to a shorter range";
	    return;
	}
	// make region coords over dsp
	var lst = [];
	for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	    var r = regionLst[i];
	    // TODO following yields wrong coord when at finest level
	    var start = i==dspBoundary.vstartr ? getPointCoord(i, dspBoundary.vstarts) : r[3];
	    var stop = i==dspBoundary.vstopr ? getPointCoord(i, dspBoundary.vstops) : r[4];
	    lst.push((juxtaposition.type==5?r[6]:r[0])+':'+start+':'+stop);
	}
	v = lst.join(':');
    }
    ajax2("getChromseqtemp=on&regionlst="+v+"&dbName="+dbInfo.name+'&session='+sessionId, function(data){
        document.getElementById("getseqwriteshere").innerHTML = "<a style='text-decoration:underline' href=t/"+sessionId+"."+data+".fa target=_blank>right click on link and save</a>";
	document.getElementById("getseqcoord").value = "enter coordinate";
    });
}
function cgiDrawDecorSelect(event) {
    /* called by toggling <select> for each server decor, 
       event.id is decor track name
     */
    var decorname = event.target.tkname;
    if(!(decorname in decorInfo))
        fatalError("cgiDrawDecorSelect: unregistered decor name");
    decorInfo[decorname].mode = event.target.options[event.target.selectedIndex].value;
    cgiDrawDecor(decorname);
}
function cgiDrawDecor(gf) {
    /* argument: decor track name (or called gf)
       directly called by:
       - by context menu, both for server/custom bigBed tracks

       if the track is on display, all its information should be in decorCanvasHash
       else, it is ASSumed to be a server track and called by toggling <select>
     */
    if(!(gf in decorInfo))
        fatalError("cgiDrawDecor: unknown decor track name");
    var mode = decorInfo[gf].mode;
    if(mode == 'hide') {
        if(gf in decorCanvasHash) 
	    removeDecorCanvas(gf);
	return;
    }
    var param;
    switch(decorInfo[gf].fileType) {
	case 0:
	    param = 'decor0='+gf+','+mode;
	    break;
	case 1:
	    param = 'decor1='+gf+','+decorInfo[gf].label+','+decorInfo[gf].url+','+mode;
	    break;
	case 8:
	    param = 'decor8='+gf+','+mode;
	    break;
	case 4:
	    param = 'decor4='+gf+','+mode;
	    break;
	case 5:
	    param = 'decor5='+gf+','+decorInfo[gf].label+','+decorInfo[gf].url+','+mode;
	    break;
	default:
	    fatalError("cgiDrawDecor: unknown decor file type");
    }
    cloak(viewbox);
    document.body.style.cursor = 'wait';
    ajax(displayedRegionParamPrecise()+"&"+param, function(data){
        jsonDecor(data);
	unveil(viewbox);
        document.body.style.cursor = 'auto';
    });
}

/* pan and zoom */
function cgiButtonZoomin(howmuch) {
    /* called by clicking on buttons in floating toolbox
       hmSpan divided by howmuch to get region to zoom into
     */
    var sp = parseInt((hmSpan - hmSpan/howmuch)/2);
    if(sp >= hmSpan/2)
        return;
    cgiZoomin(sp, hmSpan-sp);
}
function cgiZoomin(x1, x2) {
    /* for dragging on ideogram and zoom in
       x1/x2 are start,stop of selected horizontal position on ideogram
       (relative to iiX)
       imgAreaSelect trigger is a historic relic,
       but is preserved to be used in case where relocating to positions of (chr1, start1, chr2, start2)
       but not only chr1:start-stop
     */
    if(atfinestlevel())
        return;
    if(x1 >= x2) // do nothing at such irregularity
        return;

    // seek dsp boundary by user selection
    var tmp = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, x1);
    dspBoundary.vstartr = tmp[0];
    dspBoundary.vstarts = tmp[1];
    tmp = regionLstSPseekleft(dspBoundary.vstopr, dspBoundary.vstops, hmSpan-x2);
    dspBoundary.vstopr = tmp[0];
    dspBoundary.vstops = tmp[1];

    /* following tries to detect whether intended zoom in will reach finest level
       and prevent it from going beyond:
       1. compute seq length of going-to region
       2. if this len < hmSpan/entire.MAXbpwidth,
          shift start/stop coord of going-to region so to increase its length
     */
    var ar = dspBoundary.vstartr;
    var br = dspBoundary.vstopr;
    var vstartcoord = entire.atbplevel ? (regionLst[ar][3]+dspBoundary.vstarts) : getPointCoord(ar, dspBoundary.vstarts);
    var vstopcoord = entire.atbplevel ? (regionLst[br][3]+dspBoundary.vstops) : getPointCoord(br, dspBoundary.vstops);
    var L = 0; // length of going-to region
    for(var i=ar; i<=br; i++) {
        var start = i==ar ? vstartcoord : regionLst[i][3];
	var stop = i==br ? vstopcoord : regionLst[i][4];
	L += stop-start;
    }
    var minlen = hmSpan/entire.MAXbpwidth;
    if(L < minlen) {
        // after zoom in, at finest level
	var addit = Math.ceil((minlen-L)/2);
	var leftadd = addit;
	var rightadd = minlen - L - addit;
	if(vstartcoord-leftadd >= regionLst[ar][1]) {
	    if(vstopcoord+rightadd <= regionLst[br][2]) {
	        vstartcoord -= leftadd;
		vstopcoord += rightadd;
	    } else {
		vstartcoord -= leftadd + rightadd-(regionLst[br][2]-vstopcoord);
	        vstopcoord = regionLst[br][2];
	    }
	} else {
	    vstopcoord += rightadd + leftadd-(vstartcoord-regionLst[ar][1]);
	    vstartcoord = regionLst[ar][1];
	}
    }

    cloak(viewbox);
    print2console("zooming in...", 0);
    ajax(displayedRegionParam(vstartcoord, vstopcoord)+hmtkChoice()+decorParams()+htestParams()+corrParam()+'&imgAreaSelect=on', function(data){
        jsonX(data);
	unveil(viewbox);
	print2console("done", 1);
    });
}
function cgiPanning(direction, howmuch) {
    /* for clicking on << >> on ftb, hope this works in touch-screen device!
       args:
          direction: 'l' or 'r'
	  howmuch: 0~1
     */

    if(howmuch <= 0) howmuch = 0.01;
    if(howmuch >= 1) howmuch = 0.99;
    // seek dsp boundary by user selection
    var seeksp = parseInt(hmSpan*howmuch);
    if(direction == "l") {
        if(-move.styleLeft < seeksp)
	    seeksp = -move.styleLeft;
        var tmp = regionLstSPseekleft(dspBoundary.vstartr, dspBoundary.vstarts, seeksp);
        dspBoundary.vstartr = tmp[0];
        dspBoundary.vstarts = tmp[1];
        tmp = regionLstSPseekleft(dspBoundary.vstopr, dspBoundary.vstops, seeksp);
        dspBoundary.vstopr = tmp[0];
        dspBoundary.vstops = tmp[1];
    } else {
        if(entire.spnum - hmSpan + move.styleLeft < seeksp)
	    seeksp = entire.spnum - hmSpan + move.styleLeft;
        var tmp = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, seeksp);
        dspBoundary.vstartr = tmp[0];
        dspBoundary.vstarts = tmp[1];
        tmp = regionLstSPseekright(dspBoundary.vstopr, dspBoundary.vstops, seeksp);
        dspBoundary.vstopr = tmp[0];
        dspBoundary.vstops = tmp[1];
    }

    cloak(viewbox);
    print2console("panning...", 0);
    ajax(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&imgAreaSelect=on", function(data){
        jsonX(data);
	unveil(viewbox);
	print2console("done", 1);
    });
}



/**********************************
   CORRelation function has 4 layers 

   cgiCorrelation -- called by user clicking radio buttons
   jsonCorr
   computeCorr
   drawCorr
 *********************************/
function drawCorrscalecanvas() {
    // re-draw correlation scale canvas
    // usually width will change, but height won't be changed
    var c = document.getElementById('corrscalecanvas');
    c.width = leftColumnWidth;
    c.height = 27;
    var sp = 5; // spacing
    var w = leftColumnWidth - sp*2;
    ctx = c.getContext('2d');
    ctx.font = "10pt Sans-serif";
    ctx.fillStyle = "black";
    var x = 0;
    ctx.fillRect(x+sp,24,w,1); // horizontal backbone
    ctx.fillText("-1", x+1,15);
    ctx.fillRect(x+sp,19,1,5); // tick
    x = w/2+sp;
    ctx.fillText("0", x-2,15);
    ctx.fillRect(x,19,1,5); // tick
    x = sp+w;
    ctx.fillText("1", x-4,15);
    ctx.fillRect(x-1,19,1,5); // tick
}
function jsCorrelation(data) {
    /* only do stuff on client side
       argument is numerical data to compute correlation against,
       like tkLst[i].data or decorCanvasHash[gf].data
     */
    correlation.rawdata = data;
    computeCorr();
    for(var i=0; i<tkLst.length; i++)
        corrHolder.appendChild(tkLst[i].coC);
}
function hmtkRadioClickCorrelation(event) {
    /* calling correlation by clicking on radio button
       ** only for hm tracks **
     */
    var dn = event.target.value;
    var ft = parseInt(event.target.getAttribute('filetype'));
    correlation.targetft = ft;
    correlation.targetname = dn;
    correlation.where = 0;
    correlation.inuse = true;
    runCorrelation();
}

function runCorrelation() {
    /* used to initiate correlation
       - menu option selection
       - checking radio buttons
       - restore session

       if decor is not displayed or not in show/density mode, run ajax and compute data!!

       but not to be called when moving
     */
    if(!correlation.inuse)
        return;
    var tft = correlation.targetft;
    var tname = correlation.targetname;
    if(tft==2 || tft==3) {
	// hm bigwig
	var tk = findTrackByName(tname);
	if(tk == null) {
	    fatalError("runCorrelation: heatmap track not found");
	}
	jsCorrelation(tk.data);
	corrStageOpen(findTrackByName(tname).label);
    } else if(tft == 8) {
	// ASSume decor bigwig can only be 8
	// just see if bigwig is displayed, no need to check mode...
	if(tname in decorCanvasHash) {
	    jsCorrelation(decorCanvasHash[tname].data);
	} else {
	    ajax(displayedRegionParamPrecise()+"&decor8="+tname+",show", function(data){
		jsCorrelation(data["decorData"][0][4]);
	    });
	}
	corrStageOpen(decorInfo[tname].label);
    } else if(tft==0 || tft==1) {
        /* decor bigbed density
	 */
	if(tname in decorCanvasHash && decorInfo[tname].mode=="density") {
	    // this decor is been displayed in density mode
	    jsCorrelation(decorCanvasHash[tname].data);
	} else {
	    // not in correct mood, ajax kicks in
	    var param;
	    if(tft == 0)
	        param = displayedRegionParamPrecise()+"&decor0="+tname+",density";
	    else
	        param = displayedRegionParamPrecise()+"&decor1="+tname+","+escape(decorInfo[tname].url)+",density";
	    ajax(param, function(data){
		jsCorrelation(data["decorData"][0][4]);
	    });
	}
	corrStageOpen(decorInfo[tname].label);
    } else if(tft==4 || tft==5) {
        if(!(tname in decorCanvasHash)) {
	    print2console("BAM track not in display", 2);
	    correlation.inuse = false;
	    return;
	}
	jsCorrelation(decorCanvasHash[tname].data);
	corrStageOpen(decorInfo[tname].label);
    } else {
        fatalError("runCorrelation: unknown target type");
	return;
    }
}
function corrStageOpen(saywhat) {
    // set up stage and print out some words. opposite is turnoffCorrelation()
    document.getElementById('corrwhich').innerHTML = saywhat;
    document.getElementById('corrscalecanvas').style.display = 'block';
    document.getElementById('corrnotinuse').style.display = 'none';
    document.getElementById('corrinuse').style.display = 'block';
}
function jsonCorr(data) {
    // argument is wholesome json object retrieved by ajax
    if(!correlation.inuse)
        return;
    var tft = correlation.targetft;
    var tname = correlation.targetname;
    if(tft==2 || tft==3) {
        // hm bigwig
	var tk = findTrackByName(tname);
	if(tk == null) {
	    print2console("jsonCorr: heatmap track not found", 2);
	    correlation.inuse = false;
	    return;
	}
	jsCorrelation(tk.data);
    } else if(tft == 8) {
	// ASSume decor bigwig can only be 8
	if(tname in decorCanvasHash) {
	    // is been displayed
	    jsCorrelation(decorCanvasHash[tname].data);
	} else {
	    if(!("corrData" in data))
		fatalError("jsonCorr: corrData missing");
	    moveMergeNumericaldata(data["corrData"], correlation.rawdata);
	    jsCorrelation(correlation.rawdata);
	}
    } else if(tft==0 || tft==1) {
        // bigbed
	if(tname in decorCanvasHash && decorInfo[tname].mode=="density") {
	    // this decor is been displayed in density mode
	    jsCorrelation(decorCanvasHash[tname].data);
	} else {
	    if(!("corrData" in data))
		fatalError("jsonCorr: corrData missing");
	    moveMergeNumericaldata(data["corrData"], correlation.rawdata);
	    jsCorrelation(correlation.rawdata);
	}
    } else if(tft==4 || tft==5) {
        // bam, same treatment as bigbed
	if(tname in decorCanvasHash && decorInfo[tname].mode=="density") {
	    // this decor is been displayed in density mode
	    jsCorrelation(decorCanvasHash[tname].data);
	} else {
	    if(!("corrData" in data))
		fatalError("jsonCorr: corrData missing");
	    moveMergeNumericaldata(data["corrData"], correlation.rawdata);
	    jsCorrelation(correlation.rawdata);
	}
    } else {
	fatalError("jsonCorr: unknown target type");
    }
}
function initiateCorrCanvasCtx(ctx) {
    // add color gradient for correlation coefficient plot
    var lingrad = ctx.createLinearGradient(0,0,leftColumnWidth,0);
    var tq = correlation.qtc;
    lingrad.addColorStop(0,'rgb('+tq.nr+','+tq.ng+','+tq.nb+')');
    lingrad.addColorStop(0.5,lightencolor([tq.nr,tq.ng,tq.nb],0.7));
    lingrad.addColorStop(0.5,lightencolor([tq.pr,tq.pg,tq.pb],0.7));
    lingrad.addColorStop(1,'rgb('+tq.pr+','+tq.pg+','+tq.pb+')');
    ctx.fillStyle = lingrad;
}
function viewingRegionData2array(data) {
    /* "data" is 2d array for numerical data on regions: [[v1,v2,v3,...], [], ...]
       for data between viewed regions, compress into to one array, 
       doesn't include spacing between regions

       - track score
       - decor density
       - corrData.raw
     */
    var tmp = [];
    for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	var start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
	var stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++)
	    tmp.push(data[i][j]);
    }
    return tmp;
}
function spearmanRankCorr(v1, v2) {
    // works for arrays of any length
    var rho = 0;
    var L = v1.length;
    for(var i=0; i<L; i++)
        rho += (v1[i]-v2[i]) * (v1[i]-v2[i]);
    rho = 1 - 6*rho/(L*(L*L-1));
    return rho;
}
function computeCorr_onetrack(tk) {
    // compute correlation for one track
    var tmp = viewingRegionData2array(tk.data);
    var rk = correlation.rankeddata;
    if(tmp.length != rk.length) 
        fatalError('Track '+tk.name+' has different vector length to compute correlation: '+tmp.length+' '+rk.length);
    var tkrank = array2rank(tmp);
    tk.corr = spearmanRankCorr(tkrank, rk);
    //if(Math.abs(rho) > 1) alert(tk.label+' '+rho);
    drawCorr_onetrack(tk);
}
function computeCorr() {
    // gf density data is in corrData, might be dsp+wings
    // for each track, compute its correlation with corrData
    // store result in tk.corr
    var tmp = viewingRegionData2array(correlation.rawdata);
    correlation.rankeddata = array2rank(tmp);
    for(i=0; i<tkLst.length; i++) 
        computeCorr_onetrack(tkLst[i]);
}
function array2rank(data) {
    // fractional ranking (1, 2.5, 2.5, 4)
    var valueCount = {};
    // key: value, val: # of items having this value
    var sortdata = []; // the "keys" of valueCount...
    for(var i=0; i<data.length; i++) {
        if(data[i] in valueCount) {
	    valueCount[data[i]]++;
	} else {
	    valueCount[data[i]] = 1;
	    sortdata.push(data[i]);
	}
    }
    sortdata.sort(numSort);
    var cumulativeRank = 1;
    var value2rank = {}; // key: value, val: rank
    for(i=0; i<sortdata.length; i++) {
        if(valueCount[sortdata[i]] == 1) {
	    value2rank[sortdata[i]] = cumulativeRank++;
	} else {
	    var xx = 0;
	    for(var j=0; j<valueCount[sortdata[i]]; j++)
	        xx += cumulativeRank+j;
            value2rank[sortdata[i]] = xx/valueCount[sortdata[i]];
	    cumulativeRank += valueCount[sortdata[i]];
	}
    }
    var rank = [];
    for(i=0; i<data.length; i++)
        rank.push(value2rank[data[i]]);
    return rank;
}
function drawCorr() {
    for(var i=0; i<tkLst.length; i++) drawCorr_onetrack(tkLst[i]);
}
function drawCorr_onetrack(tk) {
    // argument is element in tkLst
    tk.coC.ctx.clearRect(0,0,leftColumnWidth,tk.qtc.height);
    var spacing = 5;
    var middle = leftColumnWidth/2;
    var w = (middle-spacing)*tk.corr;
    if(tk.corr > 0) {
	tk.coC.ctx.fillRect(middle, 0, w, tk.qtc.height);
    } else if(tk.corr < 0) {
	tk.coC.ctx.fillRect(middle+w, 0, -w, tk.qtc.height);
    }
}
function turnoffCorrelation() {
    correlation.inuse = false;
    stripChild(corrHolder, 0);
    document.getElementById('corrscalecanvas').style.display = 'none';
    document.getElementById('corrnotinuse').style.display = 'block';
    document.getElementById('corrinuse').style.display = 'none';
}
function generictrackdiv_mouseover(event) {
    // not used!
    // div calls this function to highlight corresponding track in heatmap
    // div must have attribute "tk" which is track name, and must have at most one child
    var obj = event.target;
    while(obj.tk == undefined) {
        obj = obj.parentNode;
	if(obj == null) return;
    }
    obj.style.backgroundColor = "white";
    for(var i=0; i<tkLst.length; i++) {
        if(obj.tk == tkLst[i].name) {
	    highlighttrack(i, 1);
	    break;
	}
    }
}
function generictrackdiv_mouseoout(event) {
    indicator.style.display = "none";
    var obj = event.target;
    while(obj.tk == undefined) {
        obj = obj.parentNode;
	if(obj == null) return;
    }
    obj.style.backgroundColor = "transparent";
}



/***********************
   DRAWing functions 
 ***********************/
function makecanvas_verticalstring(plottext, bgFill) {
    /* make canvas with string plotted vertically
       args:
       - plottext: a string
       - bgFill: boolean whether to fill background (#fff9d2)
     */
    var c = document.createElement("canvas");
    var ctx = c.getContext('2d');
    ctx.font = "10pt Sans-serif";
    var w = ctx.measureText(plottext).width;
    c.width = tkAttrColumnWidth-2;
    var truncate = false;
    if(w+10 > 200) {
        c.height = 200;
	truncate = true;
    } else {
        c.height = w+10;
    }
    if(bgFill) {
        ctx.fillStyle = "#fff9d2";
	ctx.fillRect(0,0,c.width,c.height);
    }
    ctx.font = "10pt Sans-serif";
    ctx.fillStyle = "black";
    ctx.rotate(Math.PI*1.5);
    ctx.fillText(plottext, -c.height+2, 12);
    if(truncate) {
        ctx.clearRect(-14,0,14,12);
        ctx.font = "bold 11pt Georgia";
        ctx.fillText('...', -14, 12);
    }
    return c;
}
function sortNumber(a,b) {
    return a-b;
}
function qtrack_logtransform(data,qtconfig) {
    // only works on regional data, like tkLst[x].data, not bev data
    var nd = [];
    for(var i=0; i<=dspBoundary.rwr; i++) {
        nd.push([]);
    }
    for(i=0; i<dspBoundary.lws; i++) {
        nd[dspBoundary.lwr].push(0);
    }
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++) {
	    if(qtconfig.logtype == 1) {
	        nd[i][j] = Math.log(data[i][j]) * Math.LOG2E;
	    } else if(qtconfig.logtype==2) {
	        nd[i][j] = Math.log(data[i][j]);
	    } else {
	        nd[i][j] = Math.log(data[i][j]) * Math.LOG10E;
	    }
	}
    }
    return nd;
}
function drawOnehmtk(obj) {
    // draw canvases for one hmtk
    drawHmCanvas_onetrack(obj);
    drawTrackAttrCanvas_onetrack(obj);
    obj.coC.height = obj.qtc.height;
    initiateCorrCanvasCtx(obj.coC.ctx);
    if(correlation.inuse)
	drawCorr_onetrack(obj);
}
function drawHmCanvas_onetrack(tk) {
    /* argument: tkLst element
       dspBoundary must be made
       only draw canvas of two wings and viewed region
       todo custom baseline color
     */
    tk.hmC.width = entire.spnum;
    tk.hmC.height = tk.qtc.height;
    tk.hmC.style.left = move.styleLeft;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    var ctx = tk.hmC.getContext("2d");
    ctx.fillStyle = "white";
    ctx.fillRect(0,0,tk.hmC.width, tk.hmC.height);
    if(tk.qtc.uselog) {
        var logdata = qtrack_logtransform(tk.data, tk.qtc);
	var thv = qtrack_getthreshold(logdata, tk.qtc);
	if(tk.qtc.height >= 20)
	    qtrack_plotwiggle(logdata, ctx, tk.qtc, thv[0], thv[1], unitwidth);
	else
	    qtrack_plotheatmap(logdata, ctx, tk.qtc, thv[0], thv[1], unitwidth);
    } else {
	var thv = qtrack_getthreshold(tk.data, tk.qtc);
	if(tk.qtc.height >= 20)
	    qtrack_plotwiggle(tk.data, ctx, tk.qtc, thv[0], thv[1], unitwidth);
	else
	    qtrack_plotheatmap(tk.data, ctx, tk.qtc, thv[0], thv[1], unitwidth);
    }
}
function drawHmCanvas() {
    print2console("drawing genome heatmap...", 0);
    for(var i=0; i<tkLst.length; i++) 
        drawHmCanvas_onetrack(tkLst[i]);
    print2console(" done", 0, false);
}
function sumTrackHeight() {
    /* variable argument
       if no argument, will return sum of height for all tracks
       else, the argument should be index of a track,
       and sum of height for tracks before this one will be given
     */
    var stop;
    if(arguments[0] == undefined)
        stop = tkLst.length;
    else
        stop = arguments[0];
    var h = 0;
    for(var i=0; i<stop; i++)
        h += tkLst[i].qtc.height;
    return h;
}
function qtcpanel_close() {
    // close quantitative track config panel in ftb
    if(document.getElementById("ftb_qtCfgdiv").style.display == "none") return;
    document.getElementById("ftb_qtCfgdiv").style.display = "none";
    indicator3.style.display = "none";
    // task type-specific cleanup
    if(qtc.which == 8) {
        // configuring bev vector
	if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    for(var vn in bev.data) {
	        if(bev.data[vn].onshow) {
	            bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
		}
	    }
	} else {
	    bev.data[bev.ongoing].tr.childNodes[3].style.backgroundColor = "transparent";
	}
    }
}
function tkhs_onchange() {
    // works for all types of quantitative tracks, not just hmtk
    qtc.height = parseInt(getSelectValueById("qtc_tkh"));
    qtc.changed = 'height';
    qtc_update();
    if(qtc.which==1 || qtc.which==2) {
	if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    var c = absolutePosition(viewbox);
	    placeIndicator3(c[0], c[1], viewbox.clientWidth, viewbox.clientHeight);
	} else {
	    if(menu.context == 1)
		highlighttrack(menu.iY, 3);
	    else
		placeIndicator3_menuTklst();
	}
    }
}
function trackHeightChanged(redraw) {
    /* call this whenever track height is changed, any one of them

       argument is boolean, if true, will redraw corr, hm, mcm canvases
       the argument is used to cope with cases when only hmtk got removed
       and no actual hight change happen for remaining tracks
     */
    var th = sumTrackHeight();
    viewbox.style.height = th;

    if(redraw) {
	drawHmCanvas();
	drawTrackAttrCanvas();
	for(i=0; i<tkLst.length; i++) {
	    var tk = tkLst[i];
	    tk.coC.height = tk.qtc.height;
	    initiateCorrCanvasCtx(tk.coC.ctx);
	    tk.labeldiv.style.height = tk.qtc.height;
	}
    }


    // set corrCanvasholder height so that it will show track label when corr is off
    var d = document.getElementById("corrCanvasholder");
    d.style.width = leftColumnWidth;
    d.style.height = th;

    if(redraw) {
	if(correlation.inuse) 
	    drawCorr();
    }

    scalebar.beam.style.height = th;

    mdcholder_place();
}

/* IDEO  both regular ideogram and small one */
function minichrcanvasMD(event) {
    if(event.button != 0) return; // only process left click
    if(gflag.minichrjumping) {
        // don't jump if already doing the same thing
        return;
    }
    event.preventDefault();
    // look for absolute position of minichr canvas holder div, to place indicator
    var pos = absolutePosition(minichrcanvasdiv);
    indicator.style.display = "block";
    indicator.style.left = event.clientX + document.body.scrollLeft;
    indicator.style.top = pos[1];
    indicator.style.width = 1;
    indicator.style.height = ideogram.minicanvasheight+5;
    indicator.x = event.clientX + document.body.scrollLeft;
    indicator.xcurb = pos[0]; // curb of movement on x positions
    document.body.addEventListener("mousemove", minichrcanvasM, false);
    document.body.addEventListener("mouseup", minichrcanvasMU, false);
}
function minichrcanvasM(event) {
    var currx = event.clientX + document.body.scrollLeft;
    if(currx > indicator.x) {
        if(currx < indicator.xcurb+ideogram.minicanvaswidth) {
            indicator.style.width = currx - indicator.x;
	}
    } else {
        if(currx >= indicator.xcurb) {
            indicator.style.width = indicator.x - currx;
	    indicator.style.left = currx;
	}
    }
}
function minichrcanvasMU(event) {
    document.body.removeEventListener("mousemove", minichrcanvasM, false);
    document.body.removeEventListener("mouseup", minichrcanvasMU, false);
    //minichrcanvasdiv.firstChild.removeEventListener("mousedown", minichrcanvasMD, false);
    indicator.style.display = "none";
    var x = parseInt(indicator.style.left)-indicator.xcurb; // relative to minichr canvas div
    var w = parseInt(indicator.style.width);
    var jt = juxtaposition.type;
    if(jt==3 || jt==4) {
        // gene set view
        var t1 = itemlistSeekRight(x);
        var t2 = itemlistSeekRight(x+w);
	// note: imgAreaSelect is used...
	cloak(viewbox);
	var samestring = "itemlist=on&imgAreaSelect=on&statusId="+statusId+
	      "&dbName="+dbInfo.name+
	      "&startChr="+t1[0]+"&startCoord="+t1[1]+
	      "&stopChr="+t2[0]+"&stopCoord="+t2[1]+
	      hmtkChoice()+decorParams()+corrParam()+htestParams()+
	      (entire.atbplevel?'&atbplevel=on':'');
	if(jt==3) {
            ajaxX(samestring+gss_param(1));
	} else if(jt==4) {
            ajaxX(samestring+gss_param(2));
	} else {
	    fatalError("minichrcanvasMU: unknown juxtaposition.type value");
	}
    } else if(regionLst[dspBoundary.vstartr][0] == regionLst[dspBoundary.vstopr][0]) {
        // looking at same chr
	var chr = regionLst[dspBoundary.vstartr][0];
	var chrL = chrLen[chr];
	var start = parseInt(x * chrL / ideogram.minicanvaswidth);
	var stop = start + parseInt(w * chrL / ideogram.minicanvaswidth);
	if(stop > chrL) stop = chrL;
	cgiJump2coord(chr+':'+start+'-'+stop);
    } else {
        // across multiple chrs
        var startbp = parseInt(x / ideogram.cross.sf);
	var stopbp = startbp + parseInt(w / ideogram.cross.sf);
	var startchr=null, startcoord;
	var tmp = 0;
	for(var i=0; i<ideogram.cross.lenlst.length; i++) {
	    if(startbp < tmp+ideogram.cross.lenlst[i]) {
	        startchr = ideogram.cross.namelst[i];
		startcoord = startbp - tmp;
		break;
	    }
	    tmp += ideogram.cross.lenlst[i];
	}
	if(startchr == null) { print2console('error with startchr', 2); return; }
	var stopchr=null, stopcoord;
	tmp = 0;
	for(i=0; i<ideogram.cross.lenlst.length; i++) {
	    if(stopbp < tmp+ideogram.cross.lenlst[i]) {
	        stopchr = ideogram.cross.namelst[i];
		stopcoord = stopbp - tmp;
		break;
	    }
	    tmp += ideogram.cross.lenlst[i];
	}
	if(stopchr == null) { print2console('error with stopchr', 2); return; }
	cloak(viewbox);
	ajaxX('imgAreaSelect=on&dbName='+dbInfo.name+'&gftype='+juxtaposition.what+'&startChr='+startchr+'&startCoord='+startcoord+'&stopChr='+stopchr+'&stopCoord='+stopcoord+hmtkChoice()+decorParams()+htestParams()+corrParam());
    }
    // disable cursor pressing using a dumb method
    gflag.minichrjumping = true;
    // it will be toggled off in ajaxX
}
function drawIdeogramCanvas() {
    /* at itemlist or atbplevel, will all call this function to draw "ideogram"
       but at those cases no idegogram is never drawn...

       TODO receive band coordinate from cgi, but not plotting width,
            in order to remove dependency on the regionspacing
            during genome or collation mode, compute band plotting width and
	    call actuallyDrawIdeogramCanvas to draw it
     */
    document.getElementById("basepairlegend").style.display = "none";
    drawRuler();

    if(entire.atbplevel) {
        /*** not drawing any cytobands ***
             query and display chromosomal sequence
	 */
	var lst = [];
	// querying seq for all regions, instead of those within wings
	for(var i=0; i<regionLst.length; i++) {
	    lst.push(regionLst[i][0]);
	    lst.push(regionLst[i][3]);
	    lst.push(regionLst[i][4]);
	}
	ajax("getChromseq=on&regionlst="+lst.join(',')+"&dbName="+dbInfo.name, function(data) {
	    if(!('lst' in data)) fatalError("drawIdeogramCanvas: lst missing");
	    var seqlst = data['lst'];
	    if(seqlst.length != regionLst.length) 
	        fatalError("drawIdeogramCanvas: unmatched seqlst length");
	    //alert('got '+seqlst[0].length);
	    /* bases will be indicated by color stripe
	       if enough width is available, draw bases
	     */
            ideogram.canvas.width = entire.spnum;
            ideogram.canvas.height = ideoHeight + cbarHeight;  // the numbers are global variable
            ideogram.canvas.style.left = move.styleLeft;
            ideogram.viewbox.style.height = ideogram.canvas.height;
	    var ctx = ideogram.canvas.ctx;
            var xoffset = dspBoundary.lwidx;
	    for(var i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	        var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
		var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (regionLst[i][4]-regionLst[i][3]);
	        var s = seqlst[i].toLowerCase();
	        for(var j=start; j<stop; j++) {
		    ctx.fillStyle = ntbcolor[s.charAt(j)];
		    ctx.fillRect(xoffset, 0, entire.bpwidth, ideoHeight);
		    xoffset += entire.bpwidth;
		}
		xoffset += regionSpacing.width;
	    }
	    if(entire.bpwidth >= entire.MAXbpwidth) {
	        // add ATCG
                ctx.font = "bold 10pt Sans-serif";
		xoffset = dspBoundary.lwidx;
	        for(var i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	            var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
		    var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (regionLst[i][4]-regionLst[i][3]);
	            var s = seqlst[i].toUpperCase();
		    ctx.fillStyle = 'white';
	            for(var j=start; j<stop; j++) {
		        ctx.fillText(s.charAt(j), xoffset, 12);
		        xoffset += entire.bpwidth;
		    }
		    ctx.fillStyle = 'black';
		    ctx.fillRect(xoffset, 0, 1, ideoHeight);
		    xoffset += regionSpacing.width;
	        }
	    }
            document.getElementById("basepairlegend").style.display = "block";
	});
	minichrcanvas_setindicator();
        return;
    }

    if(juxtaposition.type==3 || juxtaposition.type==4) {
        /*** not drawing any cytobands ***
	     drawing stack of boxes to indicate items
	     stack and plot

	     must draw all items, but not only those within DSP
	 */
	var ctx = ideogram.canvas.ctx;
        ctx.font = "8pt Sans-serif";
	/* temporary data structure for region stacking:
	   0 box start
	   1 name width
	   2 stack idx
	   3 name start
	 */
	var regionStack = []; // same length as regionLst
	var stack = [0];
	var xoffset = 0;
	for(var i=0; i<regionLst.length; i++) {
	    var nw = ctx.measureText(regionLst[i][6]).width;
	    var stackstart = xoffset;
	    var namestart = 0;
	    var L = regionLst[i][5];
	    if(nw < L) {
	        // name in box
		namestart = xoffset+(L-nw)/2;
	    } else {
	        // enough space on left?
		if(nw < xoffset) {
	            stackstart = xoffset-nw;
		    namestart = stackstart;
		} else {
		    // name take entire left space
		    stackstart = 0;
		    namestart = 0;
		}
	    }
	    var idx = 0;
	    // here
	    while(stack[idx]!=0 && stack[idx]+regionSpacing.width>stackstart) {
	        idx++;
		if(idx == stack.length) {
		    stack.push(0);
		    break;
		}
	    }
	    // determine stack stop
	    if(namestart+nw > xoffset+L)
	        stack[idx] = namestart + nw;
	    else
	        stack[idx] = xoffset + L;
	    regionStack.push([xoffset, nw, idx, namestart]);
	    // here
	    xoffset += L+regionSpacing.width;
	}
	var stackHeight = fullStackHeight+3;
	ideogram.canvas.width = entire.spnum;
	ideogram.canvas.height = (stackHeight+1) * stack.length;
	ideogram.canvas.style.left = move.styleLeft;
	ideogram.viewbox.style.height = ideogram.canvas.height;
        ctx.font = "8pt Sans-serif";

	for(i=0; i<regionStack.length; i++) {
	    var r = regionStack[i];
	    var r2 = regionLst[i];
	    var y = (stackHeight+1)*r[2];
	    // check if to paint flank
	    var scf = null; // scaling factor
	    var fcoord = genesetview.flanking[i];
	    if(fcoord[0] != -1) {
	        // has 5' flank
		scf = r2[5]/(r2[4]-r2[3]);
		ctx.fillStyle = genesetview.ideogram_fill5;
		ctx.fillRect(r[0]+0.5+(fcoord[0]-r2[3])*scf, y+0.5, (fcoord[1]-fcoord[0])*scf, stackHeight);
	    }
	    if(fcoord[2] != -1) {
	        // has 3' flank
		if(scf == null) scf = r2[5]/(r2[4]-r2[3]);
		ctx.fillStyle = genesetview.ideogram_fill3;
		ctx.fillRect(r[0]+0.5+(fcoord[2]-r2[3])*scf, y+0.5, (fcoord[3]-fcoord[2])*scf, stackHeight);
	    }
	    ctx.strokeStyle = genesetview.ideogram_stroke;
	    ctx.strokeRect(r[0]+0.5, y+0.5, r2[5]-1, stackHeight);
	    ctx.fillStyle = genesetview.ideogram_stroke;
	    ctx.fillText(r2[6], r[3], y+10);
	}
        minichrcanvas_setindicator();
        return;
    }

    if(juxtaposition.type == 0) {
        actuallyDrawIdeogramCanvas(ideogram.band, regionLst);
	return;
    }


    /* collating using server/custom bigbed, need to merge bands of same chr
       so bands of each chr can be plotted together just like genome mode
       they are all together and in separate regions
     */

    // step 1: hash the bands, figure out plotting width for each chr
    var chr2band = {}; // key: chr, val: list of bands
    var chrlst = []; // chr names in order
    var chrdata = []; // mocking regionLst, [0] chr name, [5] total plot size
    for(var i=0; i<regionLst.length; i++) {
        var chr = regionLst[i][0];
        if(!(chr in chr2band)) {
	    chr2band[chr] = [];
	    chrlst.push(chr);
	    chrdata.push([chr, ,,,, 0]);
	}
	// append current region length to chr width
	for(var j=0; j<chrdata.length; j++) {
	    if(chrdata[j][0] == chr) {
	        chrdata[j][5] += regionLst[i][5]+regionSpacing.width;
		break;
	    }
	}
	if(!(chr in ideogram.cytoband))
	    continue;
        for(var j=0; j<ideogram.band[i].length; j++) {
	    var band = ideogram.band[i][j];
	    // make copy of this band
	    var bc = [];
	    bc[0] = band[0];
	    if(j==0 && i!=0)
		bc[1] = band[1]+regionSpacing.width; // add spacing
	    else
		bc[1] = band[1];
	    bc[2] = band[2];
	    bc[3] = band[3];
	    chr2band[chr].push(bc);
	}
    }
    // step 2: merge same bands in each region
    var banddata = []; // list of bands in each chr
    for(i=0; i<chrlst.length; i++) {
        var chr = chrlst[i];
	if(!(chr in ideogram.cytoband)) {
	    banddata.push([]);
	    continue;
	}
        var bandlist = [chr2band[chr][0]];
	for(j=1; j<chr2band[chr].length; j++) {
	    var band = chr2band[chr][j];
	    if(band[3] == bandlist[bandlist.length-1][3])
	        bandlist[bandlist.length-1][1] += band[1];
	    else
	        bandlist.push(band);
	}
	banddata.push(bandlist);
    }
    actuallyDrawIdeogramCanvas(banddata, chrdata);
}
function actuallyDrawIdeogramCanvas(banddata, regiondata) {
    /* always called by drawIdeogramCanvas()
       will only works for genome or bigBed collation modes

       "banddata": array of arrays, each array is bands in one region
       "regiondata": array of arrays, each array describes one region,
                     [i][0] must be chromosome name,
		     [i][5] must be summary size,
		     (follows regionLst schema)

       if displaying genome, banddata is ideogram.band, regiondata is regionLst
       else if collating using bigbed files, the two will be re-synthesized

       ideogram canvas contains two rows: 
       1. cyto band, showing band color and name
       2. chromosome name
       * if colorIdx is minus, means it is centromere
       * in case of collating for itemlist, gene names will be plotted into ideogram,
         ideogram.chr will be null,
         and second row chromosome name will not be plotted

       when in collation but not in itemlist/pathway mode, merge bands with same chr and name

       TODO
       more intelligent placing of item/chr name in viewed regions
       draw within DSP
       
       FIXME 
       sum of band width in an region sometimes will be greater
       than region summary size.
       So use cumulative band width to curb band plotting,
       to make seemingly correct ideogram plots
     */
    // for collation using itemlist or pathay, will not print chromosome name
    ideogram.canvas.width = entire.spnum;
    ideogram.canvas.height = ideoHeight + cbarHeight;  // the numbers are global variable
    ideogram.canvas.style.left = move.styleLeft;
    ideogram.viewbox.style.height = ideogram.canvas.height;

    var ctx = ideogram.canvas.ctx;
    ctx.fillStyle = 'black';
    ctx.fillRect(0, 0, entire.spnum, ideoHeight);
    var xoffset = 0; // offset in canvas
    ctx.font = "bold 8pt Sans-serif";
    for(var i=0; i<banddata.length; i++) {
        if(!(regiondata[i][0] in ideogram.cytoband)) {
	    // this chr don't have cytoband, draw hollow box
	    var rw = regiondata[i][5]; // region width
	    ctx.fillStyle = "#919191";
	    ctx.fillRect(xoffset, 0, rw, ideoHeight);
	    ctx.clearRect(xoffset+1, 1, rw-2, ideoHeight-2);
	    ctx.fillStyle = "#919191";
	    var word = "no karyotype data";
	    var ww = ctx.measureText(word).width;
	    if(ww < rw)
	        ctx.fillText(word, xoffset+(rw-ww)/2, 10)
	    xoffset += rw+regionSpacing.width;
	    continue;
	}
        var rw = regiondata[i][5]; // region width
        var bandOffset = 0; // offset of bands relative to region start
	// for each band
        var previousIsCentromere = null;
	for(var j=0; j<banddata[i].length; j++) {
	    if(bandOffset >= rw) break; // stop plotting for this region...
            var band = banddata[i][j];
	    var plotwidth = ((band[1]+bandOffset)>rw) ? (rw-bandOffset) : band[1];
	    if(plotwidth == 0) {break;}
	    var stringWidth = ctx.measureText(band[0]).width;
	    if(band[2] < 0) { // centromere
	        // plot centromere band
		ctx.clearRect(xoffset+bandOffset, 0, plotwidth, ideoHeight);
	        ctx.fillStyle = centromereColor;
	        ctx.fillRect(xoffset+bandOffset, 2,  plotwidth, ideoHeight-4);
	        if(stringWidth < plotwidth) {
	            ctx.fillStyle = 'white';
	            ctx.fillText(band[0], xoffset+bandOffset+(plotwidth-stringWidth)/2, 10);
	        }
	        // add vertical border if previous item is a band
	        if(previousIsCentromere == false) {
	            ctx.fillStyle = 'black';
		    ctx.fillRect(xoffset+bandOffset-1, 0, 1, ideoHeight);
	        }
	        previousIsCentromere = true;
	    } else { // common band
	        ctx.fillStyle = 'rgb('+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+')';
	        ctx.fillRect(xoffset+bandOffset, 1,  plotwidth, ideoHeight-2);
	        if(stringWidth < plotwidth) {
	            ctx.fillStyle = 'rgb('+cytoWordColor[band[2]]+','+cytoWordColor[band[2]]+','+cytoWordColor[band[2]]+')';
	            ctx.fillText(band[0], xoffset+bandOffset+(plotwidth-stringWidth)/2, 10);
	        }
	        // add vertical border if previous item is centromere
	        if(previousIsCentromere == true) {
	            ctx.fillStyle = 'black';
		    ctx.fillRect(xoffset+bandOffset, 0, 1, ideoHeight);
	        }
	        previousIsCentromere = false;
	    }
	    bandOffset += plotwidth;
	}
        // vertical region borders
        ctx.fillStyle = 'black';
	ctx.fillRect(xoffset, 0, 1, ideoHeight);
	ctx.fillRect(xoffset+rw-1, 0, 1, ideoHeight);
	// spacing after this region
        ctx.fillStyle = 'white';
	ctx.fillRect(xoffset+rw, 0, 1, ideoHeight);
	xoffset += rw;
	xoffset += regionSpacing.width;
    }

        // plot chr name on second row, merging same chr names for adjacent regions
	ctx.fillStyle = "black";
        //ctx.font = "bold 8pt Sans-serif";
	// chr of first region
	var previouschrname = regiondata[0][0];
	var previouschrstart = 0;
        xoffset = regiondata[0][5];
	//var w = ctx.measureText(previouschrname).width;
	var y = ideoHeight + 2;
	//if(w < regionLst[0][5])
	//    ctx.fillText(previouschrname, (regionLst[0][5]-w)/2, y+7);
	for(i=1; i<regiondata.length; i++) {
	    if(previouschrname != regiondata[i][0]) {
	        // plot previous chr name
		var w = ctx.measureText(previouschrname).width;
		if(w < xoffset-previouschrstart)
	            ctx.fillText(previouschrname, previouschrstart+(xoffset-previouschrstart-w)/2, y+7);
	        ctx.fillRect(xoffset+1, ideoHeight+2, 1, ideoHeight+cbarHeight-2);
		previouschrname = regiondata[i][0];
		previouschrstart = xoffset;
	    }
            xoffset += regiondata[i][5] +regionSpacing.width;
	}
	// last chr
        ctx.fillRect(xoffset-1, ideoHeight+2, 1, ideoHeight+cbarHeight-2);
	var w = ctx.measureText(previouschrname).width;
	if(w < xoffset-previouschrstart) {
            ctx.fillText(previouschrname, previouschrstart+(xoffset-previouschrstart-w)/2, y+7);
	    }
        minichrcanvas_setindicator();
}
function drawIdeogramRuler(which, width) {
    /* only draws the ruler to be placed beneath mini ideogram
       todo expand it to render generic horizontal ruler
     */
    var canvas = document.createElement('canvas');
    var sf = width / scaffold.len[which];
    canvas.width = width;
    canvas.height = 15;
    canvas.style.marginTop = 3;
    var ctx = canvas.getContext('2d');
    //ctx.fillStyle = colorCentral.foreground;
    ctx.fillStyle = lightencolor(colorstr2int(colorCentral.foreground), 0.5);
    var ulst = ['','0','00','K','0K','00K','M','0M','00M'];
    var k = -1;
    for(var i=ulst.length-1; i>=0; i--) {
        if(Math.pow(10,i)*2 < scaffold.len[which]) {
	    k = i;
	    break;
	}
    }
    if(k == -1) {
        print2console('cannot draw ideogram ruler', 2);
        return canvas;
    }
    var ulen = Math.pow(10,k); // unit length
    var unum = parseInt(scaffold.len[which] / ulen);
    var uplot = ulen * sf;
    ctx.fillRect(0,0,uplot*unum,1);
    ctx.fillRect(0,0,1,5);
    ctx.fillText(0,0,15);
    var x = 0;
    for(i=1; i<=unum; i++) {
        ctx.fillRect(x+uplot/4,0,1,2);
        ctx.fillRect(x+uplot/2,0,1,2);
        ctx.fillRect(x+uplot*3/4,0,1,2);
	ctx.fillRect(x+uplot, 0, 1, 5);
	var w = i.toString()+ulst[k];
	var ww = ctx.measureText(w).width;
	x += uplot;
	ctx.fillText(w, i==unum ? x-ww+1 : x-ww/2,15);
    }
    
    return canvas;
}
function drawChromIdeogram(which, width, height) {
    /* args:
       - which: chromosome name
       - width: canvas width
       - height: canvas height
       optional arg 4th:
         if canvas object is provided, will draw on it, else will create new and return
       note that "chr" might not have cytoband data (chrM, contigs, ...)
       in this case, draw empty block
     */
    // scaling factor from sequence length to plot length
    var sf = width/scaffold.len[which]; 
    var canvas;
    if(arguments[3] == undefined)
        canvas = document.createElement("canvas");
    else
        canvas = arguments[3];
    canvas.width = width;
    canvas.height = height;;
    canvas.style.marginTop = 3;
    var ctx = canvas.getContext("2d");
    ctx.fillStyle = '#6b6b6b';
    ctx.fillRect(0,0,width,height);

    if(!(which in ideogram.cytoband)) {
        // no karyotype data
        ctx.fillStyle = "white";
	ctx.fillRect(1,1,width-2,height-2);
        ctx.font = "8pt Sans-serif";
        ctx.fillStyle = "#919191";
	var word = "no karyotype data";
	var w = ctx.measureText(word).width;
	if(w < width)
	    ctx.fillText(word, (width-w)/2, 10);
        return canvas;
    }
    var centromerexoffset = 2;
    // plot each cytoband
    var x = 0;
    var previousIsCentromere = false;
    for(var i=0; i<ideogram.cytoband[which].length; i++) {
        var band = ideogram.cytoband[which][i];
        var w = (band[1]-band[0])*sf;
        if(band[2] < 0) {
	    // centromere
	    ctx.clearRect(x,0,w+1,height);
            ctx.fillStyle = centromereColor;
            ctx.fillRect(x, centromerexoffset, w, height-centromerexoffset*2);
	    if(!previousIsCentromere) {
		// vertical boundary line at left of centromere
	        ctx.fillStyle = '#6b6b6b';
		ctx.fillRect(x,0,1,height);
		previousIsCentromere = true;
	    }
	} else {
	    // not centromere...
            ctx.fillStyle = 'rgb('+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+','+cytoBandColor[band[2]]+')';
            ctx.fillRect(x, 1, w, height-2);
	    if(previousIsCentromere) {
	        // vertical boundary line
	        ctx.fillStyle = '#6b6b6b';
		ctx.fillRect(x,0,1,height);
		previousIsCentromere = false;
            }
	}
	x += w;
    }
    // left/right vertical border of entire chr
    ctx.fillStyle = '#6b6b6b';
    ctx.fillRect(0,0,1,height);
    ctx.fillRect(width-1,0,1,height);
    if(arguments[3] == undefined)
        return canvas;
}
function onetimedeal_drawChromIdeogramAll() {
    /* fillin ideogram.minihash, one time deal...
       key: chr name, val: <canvas> object

       also make empty canvas, for gsv and cross chromosome cases
       fixme: creating and drawing ideogram for all scaffold sequences might be time consuming
     */
    var canvasheight = ideogram.minicanvasheight;
    var canvaswidth = ideogram.minicanvaswidth;
    for(var chr in scaffold.len) {
	ideogram.minihash[chr] = drawChromIdeogram(chr, canvaswidth, canvasheight);
	ideogram.minihash[chr].addEventListener("mousedown", minichrcanvasMD, false);
	ideogram.minirulerhash[chr] = drawIdeogramRuler(chr, canvaswidth, ideogram.minirulerheight);
    }

    // canvas for gsv and cross-chr cases (will be drawn on the fly)
    var canvas = document.createElement("canvas");
    canvas.height = canvasheight;
    canvas.width = canvaswidth;
    canvas.style.marginTop = 3;
    canvas.addEventListener("mousedown", minichrcanvasMD, false);
    ideogram.minihash.itemlist = canvas;
    canvas = document.createElement('canvas');
    canvas.width = canvaswidth;
    canvas.height = ideogram.minirulerheight;
    canvas.getContext('2d').fillStyle = lightencolor(colorstr2int(colorCentral.foreground),0.5);
    ideogram.minirulerhash.itemlist = canvas;
}
function minichrcanvas_setindicator() {
    /* deals with multiple situations
       * dsp within single chr
       * dsp spans multiple chrs
       * gene set view
       each has its own exit

       most of time, minichrindicator gliding over minichrcanvas
       might need to draw new small wiggle associated with ideogram

       ** the ideogram.wiggle.paramstr must be made no matter if drawing wiggle or not
     */
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        // won't re-draw small wiggle
        if(genesetview.lst.length == 0)
	    return;
        ideogram.previous = []; // reset for safe
        stripChild(minichrcanvasdiv, 0);
	minichrcanvasdiv.appendChild(ideogram.minihash.itemlist);
        minichrcanvasdiv.appendChild(minichrindicator);
        stripChild(minichrrulerdiv, 0);
	minichrrulerdiv.appendChild(ideogram.minirulerhash.itemlist);
	var bp = 0; // # bp before dsp vstart
	var lookname = regionLst[dspBoundary.vstartr][6];
	for(var i=0; i<genesetview.lst.length; i++) {
	    var r = genesetview.lst[i];
	    if(r[0] == lookname) {
	        if(entire.atbplevel)
	            bp += dspBoundary.vstarts;
		else
		    bp += getPointCoord(dspBoundary.vstartr, dspBoundary.vstarts) - r[2];
		break;
	    }
	    bp += r[3]-r[2];
	}
	minichrindicator.style.left = bp * genesetview.lstsf;
	bp = 0;
	for(i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
	    var r = regionLst[i];
	    var start, stop;
	    if(entire.atbplevel) {
	        start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts : 0;
		stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops : r[4]-r[3];
	    } else {
	        start = (i==dspBoundary.vstartr) ? getPointCoord(i, dspBoundary.vstarts) : r[3];
		stop = (i==dspBoundary.vstopr) ? getPointCoord(i, dspBoundary.vstops) : r[4];
	    }
	    bp += stop - start;
	}
	minichrindicator.style.width = bp * genesetview.lstsf;
        return;
    }

    var dosmallwiggle = ideogram.wiggle1.name!=null || ideogram.wiggle2.name!=null;

    if(regionLst[dspBoundary.vstartr][0] != regionLst[dspBoundary.vstopr][0]) {
	/* dsp spans multiple chrs
	   draw all chrs spaned by dsp, place indicator above them
	 */
	//document.getElementById("displaywhichchr").innerHTML = 'Displayed region spans '+regionLst[dspBoundary.vstartr][0]+' and '+regionLst[dspBoundary.vstopr][0];
	document.getElementById("displaywhichchr").innerHTML = 'multiple ...';
	//document.getElementById("link2ucsc").innerHTML = "";

	ideogram.cross.namelst = [regionLst[dspBoundary.vstartr][0]];
	// never put in chr name for each single region...
	for(var i=dspBoundary.vstartr+1; i<=dspBoundary.vstopr; i++) {
	    if(regionLst[i][0] != ideogram.cross.namelst[ideogram.cross.namelst.length-1])
	        ideogram.cross.namelst.push(regionLst[i][0]);
	}

	if(!stringLstIsIdentical(ideogram.cross.namelst, ideogram.previous)) {

	    var totalL = 0;
	    ideogram.cross.lenlst = [];
	    for(i=0; i<ideogram.cross.namelst.length; i++) {
		totalL += scaffold.len[ideogram.cross.namelst[i]];
		ideogram.cross.lenlst.push(scaffold.len[ideogram.cross.namelst[i]]);
	    }

	    ideogram.cross.sf = ideogram.minicanvaswidth / totalL;
	    var ctx = ideogram.minihash.itemlist.getContext('2d');
	    ctx.clearRect(0,0,ideogram.minicanvaswidth, ideogram.minicanvasheight);
	    ctx.fillStyle = colorCentral.foreground;
	    ctx.strokeStyle = colorCentral.foreground;
	    var ctx2 = ideogram.minirulerhash.itemlist.getContext('2d');
	    ctx2.clearRect(0,0,ideogram.minirulerhash.itemlist.width,ideogram.minirulerhash.itemlist.height);
	    var xoffset = 0;
	    for(i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
		var chrname = regionLst[i][0];
		var lenbp = scaffold.len[chrname];
		var w = ideogram.cross.sf * lenbp;
		ctx.strokeRect(xoffset, 0, w, ideogram.minicanvasheight);
		var ww = ctx.measureText(chrname).width;
		if(ww < w)
		    ctx.fillText(chrname, xoffset+w/2-ww/2, 10);

		ctx2.fillRect(xoffset, 0, 1, 10);
		var word;
		if(lenbp < 1000)
		    word = lenbp.toString();
		else if(lenbp < 1000000)
		    word = (lenbp/1000).toFixed(1)+'K';
		else if(lenbp < 1000000000)
		    word = (lenbp/1000000).toFixed(1)+'M';
		else
		    word = (lenbp/1000000000).toFixed(1)+'G';
		ww = ctx2.measureText(word).width;
		if(ww < w)
		    ctx2.fillText(word, xoffset+(w-ww)/2, 10);

		xoffset += w;
	    }
	}

	stripChild(minichrcanvasdiv, 0);
	minichrcanvasdiv.appendChild(ideogram.minihash.itemlist);
	minichrcanvasdiv.appendChild(minichrindicator);
	stripChild(minichrrulerdiv, 0);
	minichrrulerdiv.appendChild(ideogram.minirulerhash.itemlist);

	// place indicator
	var tmp = getDspStat();
	minichrindicator.style.left = tmp[1] * ideogram.cross.sf;
	minichrindicator.style.width = ideogram.cross.sf * (entire.atbplevel ? hmSpan/entire.bpwidth : hmSpan*entire.summarySize);

	var lst = [];
	for(var i=0; i<ideogram.cross.namelst.length; i++) {
	    lst.push(ideogram.cross.namelst[i]);
	    lst.push(Math.ceil(ideogram.cross.lenlst[i]*ideogram.cross.sf));
	    ideogram.previous.push(ideogram.cross.namelst[i]);
	}
	var scaffoldparam = '&scaffold='+lst.join(',');
	ideogram.wiggle1.paramstr = scaffoldparam;
	ideogram.wiggle2.paramstr = scaffoldparam;
	if(dosmallwiggle) {
	    if(!stringLstIsIdentical(ideogram.previous, ideogram.cross.namelst)) {
		if(ideogram.wiggle1.name != null)
		    ajax_plotideogramwiggle(1);
		if(ideogram.wiggle2.name != null)
		    ajax_plotideogramwiggle(2);
	    }
	}
	ideogram.previous = [];
	for(var i=0; i<ideogram.cross.namelst.length; i++)
	    ideogram.previous.push(ideogram.cross.namelst[i]);
	return;
    }

    // dsp within single chr
    var chr = regionLst[dspBoundary.vstartr][0];
    stripChild(minichrcanvasdiv, 0);
    minichrcanvasdiv.appendChild(ideogram.minihash[chr]);
    document.getElementById('displaywhichchr').innerHTML = chr;
    var startc, stopc;
    if(entire.atbplevel) {
        startc = dspBoundary.vstarts + regionLst[dspBoundary.vstartr][3];
	stopc = dspBoundary.vstops + regionLst[dspBoundary.vstopr][3];
    } else {
        startc = getPointCoord(dspBoundary.vstartr, dspBoundary.vstarts);
	stopc = getPointCoord(dspBoundary.vstopr, dspBoundary.vstops);
    }
    //document.getElementById('link2ucsc').innerHTML = "<a target=_blank href="+dbInfo.mirrorlinkurl+chr+":"+startc+"-"+stopc+">UCSC genome browser mirror</a>";
    var sf = ideogram.minicanvaswidth/chrLen[chr]; 
    minichrcanvasdiv.appendChild(minichrindicator);
    minichrindicator.style.left = startc*sf;
    minichrindicator.style.width = (stopc-startc)*sf;
    stripChild(minichrrulerdiv, 0);
    minichrrulerdiv.appendChild(ideogram.minirulerhash[chr]);
    
    /* see if need to redraw wiggles surrounding ideogram
     */
    var scaffoldparam = '&scaffold='+chr+','+ideogram.minicanvaswidth;
    ideogram.wiggle1.paramstr = scaffoldparam; // param saved for laziness...
    ideogram.wiggle2.paramstr = scaffoldparam;
    if(dosmallwiggle) {
	if(ideogram.previous.length != 1 || ideogram.previous[0]!=chr) {
	    if(ideogram.wiggle1.name != null)
		ajax_plotideogramwiggle(1);
	    if(ideogram.wiggle2.name != null)
		ajax_plotideogramwiggle(2);
	    ideogram.previous = [chr];
	}
    }
}

function ajax_plotideogramwiggle(which) {
    /* calls ajax and retrieve data for small wiggle curve
       over/below small ideogram

       which: 1/2, to refer to the wiggle on top/bottom of ideogram
     */
    var param = '&which='+which+'&fname='+
         (which==1 ? ideogram.wiggle1.name : ideogram.wiggle2.name)+
	 '&ft='+
	 (which==1 ? ideogram.wiggle1.filetype : ideogram.wiggle2.filetype)+
	 '&url='+
	 (which==1 ? ideogram.wiggle1.url : ideogram.wiggle2.url) +
	 (which==1 ? ideogram.wiggle1.paramstr : ideogram.wiggle2.paramstr);

    ajax('ideogramwiggle=on&dbName='+dbInfo.name+param,function(data){
        if(!('data' in data))
	    fatalError('ajax_plotideogramwiggle: data missing');
	if(data.which == 1)
	    ideogram.wiggle1.data = data.data;
	else
	    ideogram.wiggle2.data = data.data;
	draw_ideogramWiggle(data.which);
    });
}
function draw_ideogramWiggle_nothing() {
    ideogram.wiggle1.hcanvas.style.display = 'none';
    var c = ideogram.wiggle1.canvas;
    c.style.display = 'block';
    c.width = ideogram.minicanvaswidth;
    c.height = 20;
    var ctx = c.getContext('2d');
    ctx.fillStyle = '#88A389';
    var t = 'CLICK TO ADD A WIGGLE TRACK';
    ctx.fillText(t, (ideogram.minicanvaswidth-ctx.measureText(t).width)/2, 15);
}
function draw_ideogramWiggle(which) {
    /* actually draw ideogram small wiggle
       call this when requested new data,
       or changed rendering style
       has intolerable amount of redundancy with qtc rendering code
     */
    if(which == 1) {
	ideogram.wiggle1.hcanvas.style.display = 'block';
	ideogram.wiggle1.canvas.style.display = 'block';
    } else {
	ideogram.wiggle2.hcanvas.style.display = 'block';
	ideogram.wiggle2.canvas.style.display = 'block';
    }

    var qtc = which==1 ? ideogram.wiggle1.qtc : ideogram.wiggle2.qtc;
    var data = which==1 ? ideogram.wiggle1.data : ideogram.wiggle2.data;

    if(qtc.height < 20)
        qtc.height = 20;

    /* figure out threshold for a quantitative track for plotting
       replicative of qtrack_getthreshold */
    var scalemax=0, scalemin=0;
    if(qtc.thtype == 1) {
	scalemax = qtc.thmax;
	scalemin = qtc.thmin;
    } else {
	if(qtc.thtype == 2) { // use percentile
	    var plst = []; var nlst = [];
	    for(var i=0; i<data.length; i++) {
		for(var j=0; j<data[i].length; j++) {
		    var v = data[i][j];
		    if(isNaN(v) || v==Infinity || v==-Infinity) {
		    } else if(v > 0) {
			plst.push(v);
		    } else if(v < 0) {
			nlst.push(v);
		    }
		}
	    }
	    if(plst.length > 0) {
		plst.sort(numSort);
		var n = parseInt(plst.length*qtc.thpercentile/100);
		if(n >= plst.length)
		    n = plst.length - 1;
		scalemax = plst[n];
	    } else {
		scalemax = 0;
	    }
	    if(nlst.length > 0) {
		nlst.sort(numSort);
		var n = parseInt(nlst.length * (100-qtc.thpercentile)/100);
		if(n < 0) n = 0;
		scalemin = nlst[n];
	    } else {
		scalemin = 0;
	    }
	} else if(qtc.thtype == 0){
	    // auto scale
	    for(var i=0; i<data.length; i++) {
		for(var j=0; j<data[i].length; j++) {
		    var v = data[i][j];
		    if(isNaN(v) || v==Infinity || v==-Infinity) {
		    } else if(v > 0) {
			if(v > scalemax) scalemax = v;
		    } else {
			if(v < scalemin) scalemin = v;
		    }
		}
	    }
	} else {
	    fatalError("draw_ideogramWiggle: unknown threshold type");
	}
    }

    if(which == 1) {
        ideogram.wiggle1.scalemax = scalemax;
        ideogram.wiggle1.scalemin = scalemin;
    } else {
        ideogram.wiggle2.scalemax = scalemax;
        ideogram.wiggle2.scalemin = scalemin;
    }

    draw_ideogramWiggleHeader(which);

    /* rendering color
       if there's only 1 region in obj.data, use only first four colors:
          ppc: positive value within threshold
	  ppch: position value beyond threshold
	  pnc: negative value within threshold
	  pnch: negative value beyond threshold
       else another set of colors will be used
     */
    var ppc,ppch,pnc,pnch,ppc2,ppch2,pnc2,pnch2;
    if(data.length == 1) {
        ppc = 'rgb('+qtc.pr+','+qtc.pg+','+qtc.pb+')';
        pnc = 'rgb('+qtc.nr+','+qtc.ng+','+qtc.nb+')';
	ppch = qtc.pth;
	pnch = qtc.nth;
    } else {
        ppc = darkencolor([qtc.pr,qtc.pg,qtc.pb],0.1);
        ppc2 = lightencolor([qtc.pr,qtc.pg,qtc.pb],0.1);
        pnc = darkencolor([qtc.nr,qtc.ng,qtc.nb],0.1);
        pnc2 = lightencolor([qtc.nr,qtc.ng,qtc.nb],0.1);
	ppch = darkencolor(colorstr2int(qtc.pth), 0.1);
	pnch = darkencolor(colorstr2int(qtc.nth), 0.1);
	ppch2 = lightencolor(colorstr2int(qtc.pth), 0.1);
	pnch2 = lightencolor(colorstr2int(qtc.nth), 0.1);
    }
    var canvas = which==1 ? ideogram.wiggle1.canvas : ideogram.wiggle2.canvas;
    canvas.height = qtc.height + 2*densitydecorpaddingtop;
    canvas.width = ideogram.minicanvaswidth;
    var ctx = canvas.getContext('2d');
    // first figure out baseline/0 position
    var baseliney;
    if(which==1) {
        if(scalemax > 0) {
	    if(scalemin > 0)
	        baseliney = canvas.height - densitydecorpaddingtop;
	    else
	        baseliney = (scalemax/(scalemax-scalemin)) * qtc.height + densitydecorpaddingtop;
	} else {
	    if(scalemin > 0)
	        fatalError('draw_ideogramWiggle: scalemin > scalemax');
	    baseliney = densitydecorpaddingtop;
	}
    } else {
        if(scalemax > 0) {
	    if(scalemin > 0)
	        baseliney = densitydecorpaddingtop;
	    else
	        baseliney = ((-scalemin)/(scalemax-scalemin)) * qtc.height + densitydecorpaddingtop;
	} else {
	    if(scalemin > 0)
	        fatalError('draw_ideogramWiggle: scalemin > scalemax');
	    baseliney = canvas.height - densitydecorpaddingtop;
	}
    }
    var alter = true;
    // the xx and x offset is workaround for imprecise coord when doing gsv or ideogram.cross
    var xx = 0; // global offset
    for(var i=0; i<data.length; i++) {
        var c1,c2,c3,c4;
	if(alter) {
	    c1=ppc;c2=ppch;c3=pnc;c4=pnch;
	} else {
	    c1=ppc2;c2=ppch2;c3=pnc2;c4=pnch2;
	}
	alter = !alter;
	var x = parseInt(xx); // local offset
        for(var j=0; j<data[i].length; j++) {
	    var v = data[i][j];
	    if(which == 1) { // point up
		if(v >= 0) {
		    if(v >= scalemax) {
		        ctx.fillStyle = qtc.thtype==0 ? c1 : c2;
			ctx.fillRect(x, densitydecorpaddingtop, 1, baseliney-densitydecorpaddingtop);
		    } else {
		        ctx.fillStyle = c1;
			var h = (baseliney-densitydecorpaddingtop) * v / scalemax;
			ctx.fillRect(x, baseliney-h, 1, h);
		    }
		} else {
		    if(v <= scalemin) {
		        ctx.fillStyle = qtc.thtype==0 ? c3 : c4;
			ctx.fillRect(x, baseliney, 1, canvas.height-baseliney-densitydecorpaddingtop);
		    } else {
		        ctx.fillStyle = c3;
			var h = (canvas.height-baseliney-densitydecorpaddingtop) * v / scalemin;
			ctx.fillRect(x, baseliney, 1, (canvas.height-baseliney-densitydecorpaddingtop)*v/scalemin);
		    }
		}
	    } else { // point down
	        if(v >= 0) {
		    if(v >= scalemax) {
		        ctx.fillStyle = qtc.thtype==0 ? c1 : c2;
			ctx.fillRect(x, baseliney, 1, canvas.height-baseliney-densitydecorpaddingtop);
		    } else {
		        ctx.fillStyle = c1;
			ctx.fillRect(x, baseliney, 1, (canvas.height-densitydecorpaddingtop-baseliney) * v / scalemax);
		    }
		} else {
		    if(v <= scalemin) {
		        ctx.fillStyle = qtc.thtype==0 ? c3 : c4;
			ctx.fillRect(x, densitydecorpaddingtop, 1, canvas.height-baseliney-densitydecorpaddingtop);
		    } else {
		        ctx.fillStyle = c3;
			var h = (baseliney-densitydecorpaddingtop)*v/scalemin;
			ctx.fillRect(x, baseliney-h, 1, h); }
		}
	    }
	    x++;
	}
	if(juxtaposition.type==3 || juxtaposition.type==4)
	    xx += genesetview.lst[i][4];
	else
	    xx += ideogram.cross.sf*ideogram.cross.lenlst[i];
    }
    findPos();
    scalebar.beam.style.top = iiY; // iiY could have been changed
}
function draw_ideogramWiggleHeader(which) {
    // only draw header (scale) for small wiggle of ideogram
    var obj = which==1 ? ideogram.wiggle1 : ideogram.wiggle2;
    obj.hcanvas.width = leftColumnWidth;
    obj.hcanvas.height = obj.qtc.height + 2*densitydecorpaddingtop;
    var fcolor = lightencolor([obj.qtc.pr,obj.qtc.pg,obj.qtc.pb], 0.2);
    // draw label first
    var ctx = obj.hcanvas.getContext('2d');
    ctx.fillStyle = fcolor;
    // scale will take this much width
    var w = 15+Math.max(ctx.measureText(neatstr(obj.scalemax)).width, ctx.measureText(neatstr(obj.scalemin)).width);
    var w2 = ctx.measureText(obj.label).width;
    if(w2 <= leftColumnWidth-w) {
        ctx.fillText(obj.label, leftColumnWidth-w-w2, obj.hcanvas.height/2+5);
    } else {
        ctx.fillText(obj.label, 0, obj.hcanvas.height/2+5);
	// then clear space for drawing vertical scale
	ctx.clearRect(leftColumnWidth-w-10, 0, w+10, obj.hcanvas.height);
    }
    drawVerticalAxis(obj.qtc, obj.hcanvas, obj.scalemax, obj.scalemin, which==1, fcolor);
}
function ideogramwigglemenu_close() {
    ideogram.wigglemenu.style.display = 'none';
    document.body.removeEventListener('mousedown', ideogramwigglemenu_close, false);
}
function ideogramwiggle_menuremove() {
    if(ideogram.wigglemenu.which==1) {
	ideogram.wiggle1.name = null;
	ideogram.wiggle1.filetype = -1;
	ideogram.wiggle1.url = null;
	if(ideogram.wiggle2.name == null) {
	    // nothing there
	    ideogram.wiggle1.hcanvas.style.display = 'none';
	    draw_ideogramWiggle_nothing();
	} else {
	    // move wiggle2 up
	    ideogram.wiggle1.name = ideogram.wiggle2.name;
	    ideogram.wiggle1.filetype = ideogram.wiggle2.filetype;
	    ideogram.wiggle1.url = ideogram.wiggle2.url;
	    ideogram.wiggle1.qtc = ideogram.wiggle2.qtc;
	    ideogram.wiggle1.scalemax = ideogram.wiggle2.scalemax;
	    ideogram.wiggle1.scalemin = ideogram.wiggle2.scalemin;
	    ideogram.wiggle1.data = ideogram.wiggle2.data;
	    draw_ideogramWiggle(1);
	    ideogram.wiggle2.name = null;
	    ideogram.wiggle2.filetype = -1;
	    ideogram.wiggle2.url = null;
	    ideogram.wiggle2.hcanvas.style.display = 'none';
	    ideogram.wiggle2.canvas.style.display = 'none';
	}
    } else {
	ideogram.wiggle2.name = null;
	ideogram.wiggle2.filetype = -1;
	ideogram.wiggle2.url = null;
	ideogram.wiggle2.hcanvas.style.display = 'none';
	ideogram.wiggle2.canvas.style.display = 'none';
    }
    findPos();
    scalebar.beam.style.top = iiY; // iiY could have been changed
    ideogramwigglemenu_close();
}
function ideogramwiggle_menuflip() {
    var t = ideogram.wiggle1.name;
    ideogram.wiggle1.name = ideogram.wiggle2.name; ideogram.wiggle2.name = t;
    t = ideogram.wiggle1.filetype;
    ideogram.wiggle1.filetype=ideogram.wiggle2.filetype; ideogram.wiggle2.filetype= t;
    t = ideogram.wiggle1.url;
    ideogram.wiggle1.url=ideogram.wiggle2.url; ideogram.wiggle2.url= t;
    t = ideogram.wiggle1.label;
    ideogram.wiggle1.label=ideogram.wiggle2.label; ideogram.wiggle2.label= t;
    t = ideogram.wiggle1.qtc;
    ideogram.wiggle1.qtc=ideogram.wiggle2.qtc; ideogram.wiggle2.qtc= t;
    t = ideogram.wiggle1.scalemax;
    ideogram.wiggle1.scalemax=ideogram.wiggle2.scalemax; ideogram.wiggle2.scalemax= t;
    t = ideogram.wiggle1.scalemin;
    ideogram.wiggle1.scalemin=ideogram.wiggle2.scalemin; ideogram.wiggle2.scalemin= t;
    t = ideogram.wiggle1.data;
    ideogram.wiggle1.data=ideogram.wiggle2.data; ideogram.wiggle2.data= t;
    draw_ideogramWiggle(1);
    draw_ideogramWiggle(2);
    ideogramwigglemenu_close();
}
function ideogramwiggle_menuinfo() {
    getOnetrackdetails(ideogram.wigglemenu.which==1 ? ideogram.wiggle1.name : ideogram.wiggle2.name);
    ideogramwigglemenu_close();
}
function ideogram_wiggle1_click(event) {
    if(ideogram.wiggle1.name == null) {
        // nothing there yet
	invoketkssm(5, event.clientX-100, event.clientY);
	tkselect.smallmenu.firstChild.addEventListener('mousedown', ideogramwiggle1_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].addEventListener('mousedown', ideogramwiggle1_gf_invoketksp, false);
	return;
    }
    ideogram.wigglemenu.style.display = 'block';
    ideogram.wigglemenu.style.left = event.clientX+document.body.scrollLeft;
    ideogram.wigglemenu.style.top = event.clientY+document.body.scrollTop;
    ideogram.wigglemenu.which = 1;
    document.getElementById('ideogramwigglemenu1').style.display = ideogram.wiggle2.name==null ? 'block' : 'none';
    document.getElementById('ideogramwigglemenu2').style.display = 'block';
    document.getElementById('ideogramwigglemenu3').style.display = 'block';
    document.getElementById('ideogramwigglemenu4').style.display = ideogram.wiggle2.name==null ? 'none' : 'block';
    document.body.addEventListener('mousedown', ideogramwigglemenu_close, false);
}
function ideogram_wiggle2_click(event) {
    ideogram.wigglemenu.style.display = 'block';
    ideogram.wigglemenu.style.left = event.clientX+document.body.scrollLeft;
    ideogram.wigglemenu.style.top = event.clientY+document.body.scrollTop;
    ideogram.wigglemenu.which = 2;
    document.getElementById('ideogramwigglemenu1').style.display = 'none';
    document.getElementById('ideogramwigglemenu2').style.display = 'block';
    document.getElementById('ideogramwigglemenu3').style.display = 'block';
    document.getElementById('ideogramwigglemenu4').style.display = 'block';
    document.body.addEventListener('mousedown', ideogramwigglemenu_close, false);
}
function ideogramwiggle_menuadd(event) {
    // always choosing one for wiggle2
    var opt = event.target;
    if(opt.className != 'menuactivechoice')
       opt = event.target.parentNode;
    var pos = absolutePosition(opt);
    invoketkssm(6, pos[0]+opt.clientWidth, pos[1]);
    tkselect.smallmenu.firstChild.addEventListener('mousedown', ideogramwiggle2_hm_invoketksp, false);
    tkselect.smallmenu.childNodes[1].addEventListener('mousedown', ideogramwiggle2_gf_invoketksp, false);
}
function ideogramwiggle_menureplace(event) {
    var opt = event.target;
    if(opt.className != 'menuactivechoice')
       opt = event.target.parentNode;
    var pos = absolutePosition(opt);
    if(ideogram.wigglemenu.which == 1) {
	invoketkssm(5, pos[0]+opt.clientWidth, pos[1]);
	tkselect.smallmenu.firstChild.addEventListener('mousedown', ideogramwiggle1_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].addEventListener('mousedown', ideogramwiggle1_gf_invoketksp, false);
    } else {
	invoketkssm(6, pos[0]+opt.clientWidth, pos[1]);
	tkselect.smallmenu.firstChild.addEventListener('mousedown', ideogramwiggle2_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].addEventListener('mousedown', ideogramwiggle2_gf_invoketksp, false);
    }
}
function ideogramwiggle1_hm_invoketksp(event) {
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(13,
        event.clientX-120+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
}
function ideogramwiggle1_gf_invoketksp(event) {
    tkspanel_gfbleach();
    tkspanel_invoke(14,
        event.clientX-120+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 0);
}
function ideogramwiggle2_hm_invoketksp(event) {
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(15,
        event.clientX-120+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
}
function ideogramwiggle2_gf_invoketksp(event) {
    tkspanel_gfbleach();
    tkspanel_invoke(16,
        event.clientX-120+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 0);
}
function ideogramwiggle_config() {
    qtcpanel_setdisplay(ideogram.wigglemenu.which==1 ? ideogram.wiggle1.qtc : ideogram.wiggle2.qtc,
	true, // pc
	true, // nc
	true, // scale
	false, // log
	false, // pvcut
	true, // height
	false, // alltk
	"small wiggle plot",
	ideogram.wigglemenu.which==1 ? 10 : 11,
	'positive value', 'negative value');
    ideogramwigglemenu_close();
}



/*** BEV 
     first is the config functions
 ***/
function bev_changecmargintop() {
    var mt = parseInt(getSelectValueById("bev_cmargintop"));
    for(var vn in bev.data) {
        for(var cn in bev.scfd.hash) {
	    bev.data[vn].canvas[cn].style.marginTop = mt;
	}
    }
}
function bev_hlvectors(vn) {
    // highlight participating vectors for one pwc log ratio track or htest pvalue track
    var obj = bev.data[vn];
    if(obj.filetype == 6) {
        var c = lightencolor([obj.qtc.pr, obj.qtc.pg, obj.qtc.pb], 0.8);
	for(var i=0; i<obj.gtn1.length; i++) {
	    bev.data[obj.gtn1[i]].tr.style.backgroundColor = c;
	}
	obj.tr.childNodes[1].childNodes[1].style.backgroundColor = c;
        c = lightencolor([obj.qtc.nr, obj.qtc.ng, obj.qtc.nb], 0.8);
	for(i=0; i<obj.gtn2.length; i++) {
	    bev.data[obj.gtn2[i]].tr.style.backgroundColor = c;
	}
	obj.tr.childNodes[1].childNodes[2].style.backgroundColor = c;
    } else if(obj.filetype == 7) {
        for(var i=1; i<=obj.htestgrpnum; i++) {
	    var gn = 'gtn'+i;
            var c = lightencolor(colorstr2int(colorCentral.longlst[i]), 0.8);
	    for(var j=0; j<obj[gn].length; j++) {
	        bev.data[obj[gn][j]].tr.style.backgroundColor = c;
	    }
	    obj.tr.childNodes[1].childNodes[i].style.backgroundColor = c;
	}
    } else {
        fatalError('bev_hlvectors: unknown vector type '+obj.filetype);
    }
}
function bev_togglevectordisplay(arg) {
    /* called by changing the checkbox in front of each vector in registry table
       variable argument, could be vector name, or event triggered by clicking checkbox
     */
    var show; var td; var wrenchtd; var vectorname;
    var obj;
    if(typeof(arg) == "string") {
        vectorname = arg;
	obj = bev.data[arg];
	show = obj.onshow;
	document.getElementById("bevcheckbox_"+arg).checked = show;
	td = obj.tr.firstChild;
	wrenchtd = obj.tr.childNodes[3];
    } else {
        // argument is event object
	show = arg.target.checked;
	td = arg.target.parentNode;
	wrenchtd = td.nextSibling.nextSibling.nextSibling;
	vectorname = arg.target.parentNode.parentNode.vectorname;
	obj = bev.data[vectorname];
        obj.onshow = show;
    }
    if(show) { // turn on
        wrenchtd.firstChild.style.display = "block";
	var cparent;
	for(var cn in bev.scfd.hash) {
	    cparent = obj.canvas[cn].parentNode;
	    break;
	}
	if(cparent == null) {
	    for(var cn in bev.scfd.hash) {
	        bev.genomeCanvasTd[cn].appendChild(obj.canvas[cn]);
	    }
	}
    } else { // hide
	wrenchtd.firstChild.style.display = "none";
	wrenchtd.style.backgroundColor = "transparent";
	var cparent;
	for(var cn in bev.scfd.hash) {
	    cparent = obj.canvas[cn].parentNode;
	    break;
	}
	if(cparent != null) {
	    for(var cn in bev.scfd.hash) {
	        if(obj.canvas[cn].parentNode != null)
		    bev.genomeCanvasTd[cn].removeChild(obj.canvas[cn]);
	    }
	}
    }
    if(obj.filetype == 6) {
        // this is pwc log ratio vector
	if(show) {
	    bev_hlvectors(vectorname);
	} else {
	    for(var i=0; i<obj.gtn1.length; i++) {
	        bev.data[obj.gtn1[i]].tr.style.backgroundColor = "transparent";
	    }
	    for(i=0; i<obj.gtn2.length; i++) {
	        bev.data[obj.gtn2[i]].tr.style.backgroundColor = "transparent";
	    }
	}
    } else if(obj.filetype == 7) {
        // this is htest pvalue
        if(show) {
	    bev_hlvectors(vectorname);
	} else {
	    for(var i=1; i<=obj.htestgrpnum; i++) {
	        var gn = 'gtn'+i;
		for(var j=0; j<obj[gn].length; j++) {
		    bev.data[obj[gn][j]].tr.style.backgroundColor = 'transparent';
		}
	    }
	}
    }
}
function bev_changemaxwidth() {
    /* called by changing max width <select>, will make bev.scfd.plotlen
       pitfall -- 
     */
    // compute plot width for scaffold sequences
    bev.scfd.plotlen = {};
    var maxlength = parseInt(getSelectValueById("bev_maxwidth"));
    var maxbplen = 0;
    for(var chr in bev.scfd.hash) {
        if(bev.scfd.hash[chr] > maxbplen)
	    maxbplen = bev.scfd.hash[chr];
    }
    var sf = maxlength / maxbplen;
    for(var chr in bev.scfd.hash) {
        bev.scfd.plotlen[chr] = Math.ceil(bev.scfd.hash[chr]*sf);
    }

    var lst = [];
    for(var vn in bev.data) {
        var obj = bev.data[vn];
        if(obj.filetype==6 || obj.filetype==7) {
	    // pwc
	    if(obj.onshow) {
	        /* uncheck the checkbox, remove bgcolor of participating tracks remove canvas */
		var e = document.createEvent("MouseEvents");
		e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
		obj.tr.firstChild.firstChild.dispatchEvent(e);
	    }
	    document.getElementById('bev_dataregistry').firstChild.removeChild(obj.tr);
	    if(obj.filetype==6) {
	        print2console("Please re-run pairwise comparison.", 2);
	    } else {
	        print2console("Please re-run hypothesis test.", 2);
	    }
	    delete bev.data[vn];
	    bev.runtype = 1;
	} else {
            lst.push(vn);
	}
    }
    ajaxBirdsEyeView(lst);
    bev_plotIdeogram();
}
function bev_logtransform(vn) {
    /* duplicated code from qtrack_logtransform()
       append log data to bev object
     */
    var obj = bev.data[vn];
    obj.logdata = {};
    var logtype = obj.qtc.logtype;
    for(var cn in bev.scfd.hash) {
        var nd2 = [];
	var data = obj.data[cn];
	for(var i=0; i<data.length; i++) {
	    if(logtype == 1) {
	        nd2[i] = Math.log(data[i]) * Math.LOG2E;
	    } else if(logtype==2) {
	        nd2[i] = Math.log(data[i]);
	    } else {
	        nd2[i] = Math.log(data[i]) * Math.LOG10E;
	    }
	}
	obj.logdata[cn] = nd2;
    }
}
function bev_computeThreshold(vectorname) {
    /* duplicated code from qtrack_getthreshold()
       but somewhat neater...
     */
    var pth; // positive threshold value
    var nth; // negative
    var obj = bev.data[vectorname];
    var data = obj.qtc.uselog ? obj.logdata : obj.data;
    if(obj.qtc.thtype == 1) {
        pth = obj.qtc.thmax;
        nth = obj.qtc.thmin;
    } else if(obj.qtc.thtype == 0) {
        pth=0; nth=0;
	for(var cn in bev.scfd.hash) {
	    for(var i=0; i<data[cn].length; i++) {
	        var v = data[cn][i];
		if(isNaN(v) || v==Infinity || v==-Infinity) {
		} else if(v > 0) {
		    if(v > pth) pth = v;
	        } else {
		    if(v < nth) nth = v;
		}
	    }
	}
    } else if(obj.qtc.thtype == 2){
        var plst = []; var nlst = [];
	for(var cn in bev.scfd.hash) {
	    for(var i=0; i<data[cn].length; i++) {
	        var v = data[cn][i];
		if(isNaN(v) || v==Infinity || v==-Infinity) {
		} else if(v > 0)
		    plst.push(v);
		else if(v < 0)
		    nlst.push(v);
	    }
	}
	if(plst.length == 0) {
	    pth = 0;
	} else {
	    plst.sort(numSort);
	    var n = parseInt(plst.length*obj.qtc.thpercentile/100);
	    if(n >= plst.length)
	        n = plst.length - 1;
	    pth = plst[n];
	}
	if(nlst.length == 0) {
	    nth = 0;
	} else {
	    nlst.sort(numSort);
	    var n = parseInt(nlst.length * (100-obj.qtc.thpercentile)/100);
	    if(n < 0) n = 0;
	    nth = nlst[n];
	}
    }
    obj.max = pth;
    obj.min = nth;
}
function bev_plot(vectorname) {
    /* duplicated code from qtrack_plotwiggle()
     */
    var obj = bev.data[vectorname];
    var nthvalue=obj.min; var pthvalue=obj.max;
    var ploth = obj.qtc.height;
    var baselinev = 0; // baseline value (always 0...)
    var baseliney = 0; // baseline y position
    var usebaseline = false;
    if(baselinev>=nthvalue && baselinev<=pthvalue) {
        usebaseline = true;
    }
    if(usebaseline) {
	if(nthvalue == 0) {
	    baseliney = ploth;
	} else if(pthvalue == 0) {
	    baseliney = 0;
	} else {
	    baseliney = (pthvalue/(pthvalue-nthvalue))*ploth;
	}
    }
    var pcolor = "rgb("+obj.qtc.pr+","+obj.qtc.pg+","+obj.qtc.pb+")";
    var ncolor = "rgb("+obj.qtc.nr+","+obj.qtc.ng+","+obj.qtc.nb+")";
    var usethreshold = (obj.qtc.thtype != 0);
    for(var cn in bev.scfd.hash) {
        // append track name at the end of canvas
        var ctx = obj.canvas[cn].getContext('2d');
        obj.canvas[cn].width = obj.data[cn].length + 3 + ctx.measureText(obj.printname).width;
	obj.canvas[cn].height = obj.qtc.height;
	var data = obj.qtc.uselog ? obj.logdata[cn] : obj.data[cn];
	for(var i=0; i<data.length; i++) {
	    var v = data[i];
	    var barh;
	    if(isNaN(v)) {
	        // do nothing
	    } else if(v == Infinity) {
	        ctx.fillStyle = "#B5B5B5";
		if(usebaseline) {
		    ctx.fillRect(i, 0, 1, baseliney);
		} else {
		    ctx.fillRect(i, 0, 1, ploth);
		}
	    } else if(v == -Infinity) {
	        ctx.fillStyle = "#B5B5B5";
		if(usebaseline) {
		    ctx.fillRect(i, baseliney, 1, ploth-baseliney);
		} else {
		    ctx.fillRect(i, 0, 1, ploth);
		}
	    } else if(usebaseline) {
	        // valid baseline, between pthvalue and nthvalue
	        if(v > baselinev) {
		    if(usethreshold && v>=pthvalue) {
			barh = baseliney; // ?
			ctx.fillStyle = obj.qtc.pth;
		    } else {
			barh = baseliney*v/pthvalue;
			ctx.fillStyle = pcolor;
		    }
		    ctx.fillRect(i, baseliney-barh, 1, barh);
		} else if(v < baselinev) {
		    if(usethreshold && v<=nthvalue) {
			barh = ploth-baseliney;
			ctx.fillStyle = obj.qtc.nth;
		    } else {
			barh = (ploth-baseliney)*v/nthvalue;
			ctx.fillStyle = ncolor;
		    }
		    ctx.fillRect(i, baseliney, 1, barh);
		}
	    } else {
	        // no valid baseline (pth and nth all >0 or <0)
		if(v > 0 && v > nthvalue) {
		    if(v >= pthvalue) {
		        // full fill
			ctx.fillStyle = obj.qtc.pth;
		        ctx.fillRect(i, 0, 1, ploth);
		    } else {
		        // half fill, bar pointing upward
			barh = ploth*(v-nthvalue)/(pthvalue-nthvalue);
			ctx.fillStyle = pcolor;
		        ctx.fillRect(i, ploth-barh, 1, barh);
		    }
		} else if(v<0 && v<pthvalue) {
		    if(v <= nthvalue) {
		        // full fill
			ctx.fillStyle = obj.qtc.nth;
		        ctx.fillRect(i, 0, 1, ploth);
		    } else {
		        // half fill, bar pointing downward
			barh = ploth*(pthvalue-v)/(pthvalue-nthvalue);
			ctx.fillStyle = ncolor;
		        ctx.fillRect(i, 0, 1, barh);
		    }
		}
	    }
	}
	ctx.fillText(obj.printname, obj.data[cn].length+3, 10);
    }
    if(obj.filetype == 7) {
	// htest, draw cutoff line
	var lcv = Math.log(obj.qtc.pvcutoff) * Math.LOG10E;
	if(lcv > obj.min) {
	    var y = obj.qtc.height * lcv / obj.min;
	    for(cn in bev.scfd.hash) {
	        ctx = obj.canvas[cn].getContext('2d');
		ctx.fillStyle = obj.qtc.pvccolor;
	        ctx.fillRect(0,y,obj.canvas[cn].width,1);
	    }
	}
    }
}
function bev_updatevector(which) {
    // recompute threshold, then render
    var obj = bev.data[which];
    if(obj.qtc.uselog) {
        bev_logtransform(which);
    }
    bev_computeThreshold(which);
    obj.tr.childNodes[2].innerHTML = "max: "+neatstr(obj.max)+" min: "+neatstr(obj.min);
    bev_plot(which);
    bev_togglevectordisplay(which);
}
function birdsEyeView(stuff,runtype) {
    /* argument: a list, each element: [tkname, filetype, label, url, true/false (plot or not)]
       runtype:
           1: conventional, request some vectors and render
	   2: pwc
	   3: htest

       runs on bigwig or bigbed
       according to fileType, it will be made into [tkname].bigWig or [tkname].bigBed
       if is bigbed, will display density
     */
    bev.runtype = runtype;
    var newtk = [];
    for(var i=0; i<stuff.length; i++) {
        if(stuff[i][0] in bev.data) {
            // great this vector has already been computed
	    bev_plot(stuff[i][0]);
	} else {
	    newtk.push(stuff[i]);
	}
    }
    if(newtk.length==0 && (runtype==1 || runtype==2)) {
	if(runtype == 2) {
	    bev_pwc();
	}
	if(document.getElementById("bait18").style.display == "none") { toggle18(); }
	return;
    }
    for(i=0; i<newtk.length; i++) {
        var t = newtk[i];
        bev.data[t[0]] = {qtc:{}, filetype:t[1], 'printname':t[2], url:t[3], onshow:t[4]};
        qtc_paramCopy(defaultQtcStyle.bev, bev.data[t[0]].qtc);
    }
    if(runtype == 3) {
        /* running on htest pvalues, that will be computed on serverside,
	   so server has to know all participating tracks
	 */
	newtk = [];
	for(i=0; i<stuff.length; i++) { newtk.push(stuff[i][0]); }
	// make empty pvalue vector
	var id = 0;
	var vn;
	while(true) {
	    vn = "htest"+id;
	    if(vn in bev.data) {
		id++;
	    } else {
		break;
	    }
	}
	bev.ongoing = vn;
	bev.data[vn] = { qtc:{}, printname:'hypothesis test P-values', onshow:true, filetype:7,htestgrpnum:htest.grpnum};
	qtc_paramCopy(htest.qtc, bev.data[vn].qtc);
	for(i=1; i<=htest.grpnum; i++) {
	    var gn = 'gtn'+i;
	    bev.data[vn][gn] = [];
	    for(var j=0; j<htest[gn].length; j++) {bev.data[vn][gn].push(htest[gn][j]);}
	}
    } else {
        var tmp = [];
	for(i=0; i<newtk.length; i++) {tmp.push(newtk[i][0]);}
	newtk = tmp;
    }
    ajaxBirdsEyeView(newtk);
}
function ajaxBirdsEyeView(tknamelst) {
    /* make bird's eye view
       parameter is a list of bigwig/bigbed names, and they all have to be already in bev.data
       ASSume decor bigwig can only be 8
     */
    var ft0=[], ft1=[], ft2=[], ft3=[], ft8=[];
    for(var i=0; i<tknamelst.length; i++) {
        var vn = tknamelst[i];
        var obj = bev.data[vn];
	switch(obj.filetype) {
	case 0: ft0.push(vn);break;
	case 1: ft1.push(obj.url);ft1.push(vn);break;
	case 2: ft2.push(vn);break;
	case 3: ft3.push(obj.url);ft3.push(vn);break;
	case 8: ft8.push(vn);break;
	}
    }
    if(ft0.length+ft1.length+ft2.length+ft3.length+ft8.length == 0) { return; }
    var param = [];
    if(ft0.length > 0) param.push("ft0="+ft0.join(","));
    if(ft1.length > 0) param.push("ft1="+ft1.join(","));
    if(ft2.length > 0) param.push("ft2="+ft2.join(","));
    if(ft3.length > 0) param.push("ft3="+ft3.join(","));
    if(ft8.length > 0) param.push("ft8="+ft8.join(","));
    var tmp = [];
    for(var cn in bev.scfd.plotlen) { 
        tmp.push(cn); 
	tmp.push(bev.scfd.plotlen[cn]);
	tmp.push(scaffold.len[cn]);
    }
    param.push('plotwidth='+tmp.join(','));
    param.push("runtype="+bev.runtype);
    param.push("maxlength="+parseInt(getSelectValueById("bev_maxwidth")));
    param.push("dbName="+dbInfo.name);
    param.push("birdseyeview=on");
    if(bev.runtype == 2) {
        // ??
    } else if(bev.runtype == 3) {
        // lots of additional params for htest
	param.push(htestParams());
	param.push('htestvn='+bev.ongoing); // htest vector name, will be spitted back in ajax
    }

    document.body.style.cursor = 'wait';
    print2console("making bird's eye view...", 0);
    ajax(param.join('&'), function(data) {
        for(var vn in data) {
	    // deposit all vectors
	    var obj = bev.data[vn];
	    obj.data = data[vn];
	    if(obj.canvas == undefined) {
	        bev_fillVector(vn);
            }
	    bev_updatevector(vn);
	}
	if(bev.runtype == 2) {
	    bev_pwc();
	} else if(bev.runtype == 3) {
	    // find htest pvalue vector and toggle it on
	    for(vn in data) {
	        if(bev.data[vn].onshow == true) {bev_togglevectordisplay(vn);}
	    }
	}

	if(document.getElementById("bait18").style.display == "none") { toggle18(); }
	document.getElementById('hook17b').style.display = 'none';
	document.getElementById('hook17').style.display = 'block';
        document.body.style.cursor = 'auto';
    });
}
function bev_pwc() {
    /* compute log ratio, duplicated code from pwc_compute()

       !! always make a new pwc track name
       so it would brake when changing chr plot width as canvas of old vector will still be there
     */
    var logratio = {};
    for(var cn in bev.scfd.hash) {
	logratio[cn] = [];
	for(i=0; i<bev.data[pwc.gtn1[0]].data[cn].length; i++) {
	    var g1v= [];
	    var g2v= [];
	    for(var j=0; j<pwc.gtn1.length; j++) {
		g1v.push(bev.data[pwc.gtn1[j]].data[cn][i]);
	    }
	    for(var j=0; j<pwc.gtn2.length; j++) {
		g2v.push(bev.data[pwc.gtn2[j]].data[cn][i]);
	    }
	    logratio[cn].push(Math.log(arrayMean(g1v)/arrayMean(g2v)) * Math.LOG2E);
	}
    }
    // find a name for this log ratio vector
    var id = 0;
    var vn;
    while(true) {
	vn = "pwc"+id;
	if(vn in bev.data) {
	    id++;
	} else {
	    break;
	}
    }
    bev.data[vn] = { qtc:{}, printname:'pairwise comparison log ratio', 
		     onshow:true, data:logratio, filetype:6};
    qtc_paramCopy(pwc.qtc, bev.data[vn].qtc);
    bev.data[vn].gtn1 = [];
    for(i=0; i<pwc.gtn1.length; i++) { bev.data[vn].gtn1.push(pwc.gtn1[i]); }
    bev.data[vn].gtn2 = [];
    for(i=0; i<pwc.gtn2.length; i++) { bev.data[vn].gtn2.push(pwc.gtn2[i]); }
    bev_fillVector(vn);
    bev_updatevector(vn);
    bev_togglevectordisplay(vn);
}
function bev_fillVector(vn) {
    /* arg is vector name
       the vector should be just created and must lack .tr and .canvas
       will make them here
     */
    var obj = bev.data[vn];
    if(obj.tr!=undefined) {
        fatalError("bev_fillVector: vector "+vn+" already got .tr");
    }
    if(obj.canvas!=undefined) {
        fatalError("bev_fillVector: vector "+vn+" already got .canvas");
    }
    var table = document.getElementById("bev_dataregistry");
    var tr = table.insertRow(-1);
    tr.vectorname = vn;
    //tr.filetype = fileType;
    obj.tr = tr;
    var td = tr.insertCell(0);
    td.innerHTML = "<input type=checkbox id=\"bevcheckbox_"+vn+"\" onchange=bev_togglevectordisplay(event) title='show/hide vector'>";
    td = tr.insertCell(-1);
    td.innerHTML = "<label for=\"bevcheckbox_"+vn+"\" style='margin-right:10px;'>"+obj.printname+"</label>";
    if(obj.filetype == 6) {
        // color blob as group indicator
        td.innerHTML += '<span style="font-size:10px;">&nbsp;group 1&nbsp;</span><span style="font-size:10px;">&nbsp;group 2&nbsp;</span>';
    } else if(obj.filetype == 7) {
        for(var i=1; i<=obj.htestgrpnum; i++) {
	    td.innerHTML += '<span style="font-size:10px;">&nbsp;group '+i+'&nbsp;</span>';
	}
    }
    td = tr.insertCell(-1);
    td.style.color = "#b5b5b5";
    td = tr.insertCell(-1);
    td.className = "bevwrench";
    td.style.backgroundColor = "transparent";
    td.innerHTML = "<img src=images/wrench.png width=20 style='cursor:pointer;display:"+(obj.onshow?"block":"none")+";' onclick='bev_vectorwrench_click(event, false);'>";
    td = tr.insertCell(-1);
    var willaddclick = obj.filetype!=6 && obj.filetype!=7;
    if(willaddclick) {
        td.innerHTML = "<span style='cursor:pointer;color:blue;' onclick=\"getOnetrackdetails('"+vn+"')\">&#9432;</span>";
    }
    bev_initiateVectorcanvas(vn);
}
function bev_initiateVectorcanvas(vn) {
    var obj = bev.data[vn];
    obj.canvas = {};
    var pt = parseInt(getSelectValueById("bev_cmargintop"));
    //var willaddclick = obj.filetype!=6 && obj.filetype!=7;
    for(var chr in bev.scfd.hash) {
	var c = document.createElement("canvas");
	c.style.display = "block";
	c.style.marginTop = pt;
	c.title = vn;
	c.addEventListener("click", bevcanvasmenu_open, false);
	obj.canvas[chr] = c;
    }
}
function bevcanvasmenu_open(event) {
    // called by clicking on bev canvas
    bev.menu.style.display = 'block';
    bev.menu.style.left = event.clientX + document.body.scrollLeft;
    bev.menu.style.top = event.clientY + document.body.scrollTop;
    document.body.addEventListener('mousedown', bevcanvasmenu_close, false);
    bev.ongoing = event.target.title;
}
function bevcanvasmenu_close() {
    bev.menu.style.display = 'none';
    document.body.removeEventListener('mousedown', bevcanvasmenu_close, false);
}
function bevcanvasmenu_remove() {
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    bev.data[bev.ongoing].tr.firstChild.firstChild.dispatchEvent(e);
    bevcanvasmenu_close();
}
function bev_config() {
    // bring up qtc panel for vector bev.ongoing
    var obj = bev.data[bev.ongoing];
    if(obj.filetype == 6) {
        // pwc
	qtcpanel_setdisplay(obj.qtc,
	    true, // pc
	    true, // nc
	    true, // scale
	    false, // log
            false, // pvcut
	    true, // tkh
	    false, // alltk
	    "log ratio track", 8, 'grp1 > grp2', 'grp1 < grp2');
    } else if(obj.filetype == 7) {
        // htest
	qtcpanel_setdisplay(obj.qtc,
	    false, // pc
	    true, // nc
	    false, // scale
	    false, // log
            true, // pvcut
	    true, // tkh
	    false, // alltk
	    "P-value track", 8, '', 'P-value bar color');
    } else {
	qtcpanel_setdisplay(obj.qtc,
	    true, // pc
	    true, // nc
	    true, // scale
	    true, // log
            false, // pvcut
	    true, // tkh
	    true, // alltk
	    "BirdsEyeView track", 8, 'positive value', 'negative value');
    }
    obj.tr.childNodes[3].style.backgroundColor = Lpurple;
}
function bev_vectorwrench_click(event) {
    /* clicking on a wrench icon for a vector
     */
    var td = event.target.parentNode;
    if(td.style.backgroundColor == "transparent") {
        for(var vn in bev.data) {
	    bev.data[vn].tr.childNodes[3].style.backgroundColor = "transparent";
	}
        td.style.backgroundColor = Lpurple;
        bev.ongoing = td.parentNode.vectorname;
	bev_config();
    } else {
        td.style.backgroundColor = "transparent";
	qtcpanel_close();
    }

}
function bev_plotIdeogram() {
    // called at initiation or change of chr plot width or ideogram height...
    var height = parseInt(getSelectValueById("bev_ideogramheight"));
    for(var i=0; i<bev.scfd.order.length; i++) {
        var chr = bev.scfd.order[i];
	drawChromIdeogram(chr, bev.scfd.plotlen[chr], height, document.getElementById("bevideogram_"+chr));
    }
}
// relocate using ideogram
function bev_ideogramMD(event) {
    if(event.button != 0) return; // only process left click
    event.preventDefault();
    bev.pressedChr = event.target.title;
    var d = document.getElementById("indicator2veil");
    d.style.backgroundColor = "blue";
    d.style.opacity = 0.1;

    // sum of vector canvas height
    var height = 0;
    for(var vn in bev.data) {
        if(bev.data[vn].onshow)
	    height += bev.data[vn].qtc.height+parseInt(bev.data[vn].canvas[bev.pressedChr].style.marginTop);
    }
    if(height == 0) {
        bev.pressedChr = undefined;
	return;
    }

    // mouse down
    document.body.addEventListener("mousemove", bev_ideogramM, false);
    document.body.addEventListener("mouseup", bev_ideogramMU, false);
    indicator2.style.display = "block";
    indicator2.leftarrow.style.display = "block";
    indicator2.rightarrow.style.display = "block";
    indicator2.style.height = height + parseInt(getSelectValueById("bev_ideogramheight"))+3; // 3 is ideogram marginTop
    indicator2.leftarrow.style.top = height/2-indicator2.leftarrow.height/2;
    indicator2.rightarrow.style.top = indicator2.leftarrow.style.top;
    indicator2.style.width = 0;
    indicator2.xstart = event.clientX+document.body.scrollLeft;
    var tmp = absolutePosition(event.target);
    indicator2.chrcanvasx = tmp[0];
    indicator2.xlimit = tmp[0] + event.target.width;
    indicator2.style.top = tmp[1] - height - document.getElementById("bev_chrgraphtable").parentNode.scrollTop-3;
    indicator2.style.left = indicator2.xstart;
}
function bev_ideogramM(event) {
    // mouse move, only process horizontal move
    var currx = event.clientX + document.body.scrollLeft;
    var xstart = indicator2.xstart;
    if(currx > xstart) {
        if(currx < indicator2.xlimit) {
            indicator2.style.width = currx - xstart;
	}
    } else {
        if(currx >= indicator2.chrcanvasx) {
            indicator2.style.width = xstart - currx;
	    indicator2.style.left = currx;
	}
    }
}
function bev_ideogramMU(event) {
    // mouse up
    indicator2.style.display = "none";
    indicator2.leftarrow.style.display = "none";
    indicator2.rightarrow.style.display = "none";
    document.body.removeEventListener("mousemove", bev_ideogramM, false);
    document.body.removeEventListener("mouseup", bev_ideogramMU, false);
    if(!(bev.pressedChr in chrLen)) {
        print2console('Cannot jump to this location: this scaffold sequence is not displayed in heatmap.',2);
	return;
    }

    var currx = event.clientX + document.body.scrollLeft;
    var x1, x2;
    var xstart = indicator2.xstart;
    var chrcanvasx = indicator2.chrcanvasx;
    if(currx > xstart) {
        x1 = xstart - chrcanvasx;
	x2 = currx - chrcanvasx;
    } else {
	x1 = (currx <= chrcanvasx) ? 0 : currx-chrcanvasx;
        x2 = xstart - chrcanvasx;
    }
    toggle18();
    // figure out chr plot length from ideogram canvas width
    var chrplotlen = bev.scfd.plotlen[bev.pressedChr];
    cgiJump2coord(bev.pressedChr+' '
        +parseInt(scaffold.len[bev.pressedChr]*x1/chrplotlen)+' '
        +parseInt(scaffold.len[bev.pressedChr]*x2/chrplotlen));
}
function bev_config_showSmallmenu(event) {
    var pos = absolutePosition(event.target);
    var m = document.getElementById('genomebevSmallmenu');
    m.style.display = 'block';
    m.style.left = pos[0];
    m.style.top = pos[1]+event.target.clientHeight+4;
    document.body.addEventListener('mouseup', bev_config_hideSmallmenu, false);
}
function bev_config_hideSmallmenu() {
    document.getElementById('genomebevSmallmenu').style.display = 'none';
    document.body.removeEventListener('mouseup', bev_config_hideSmallmenu, false);
}
function genomebev_initiateViewtable() {
    // initiate view table for genome bev
    bev.genomeCanvasTd = {};
    var table = document.getElementById("bev_chrgraphtable");
    stripChild(table.firstChild, 0);
    for(var i=0; i<bev.scfd.order.length; i++) {
        var cn = bev.scfd.order[i];
	var tr = table.insertRow(-1);
	var td = tr.insertCell(0);
	td.style.textAlign = "right";
	td.vAlign = "middle";
	td.rowSpan = 2;
	td.style.color = "#969696";
	td.innerHTML = "<span style='font-weight:bold;'>"+cn+"</span><br><span style='font-size:10px;'>"+scaffold.len[cn]+" bp</span>";
	td = tr.insertCell(-1);
	bev.genomeCanvasTd[cn] = td;
	tr = table.insertRow(-1);
	td = tr.insertCell(0);
	c = document.createElement("canvas");
	c.id = "bevideogram_"+cn;
	c.height = 30;
	c.title = cn; // for drag and zoom in
	c.addEventListener("mousedown", bev_ideogramMD, false);
	td.appendChild(c);
    }
    bev_changemaxwidth();
}




function drawRuler() {
    /* ruler and scale bar above genome heatmap
       1. scale bar
       2. ruler (only for genome mode?)
     */

    scalebarSlider_fill();

    rulercanvas.style.display = 'block';
    rulercanvas.width = entire.spnum;
    rulercanvas.style.left = move.styleLeft;
    ctx = rulercanvas.ctx;
    ctx.fillStyle = colorCentral.foreground;
    ctx.font = "8pt Sans-serif";

    if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
        // only draw hollow boxes in one row
	var x = 0;
	ctx.strokeStyle = '#858585';
	for(var i=0; i<regionLst.length; i++) {
	    ctx.strokeRect(x+0.5, 0, regionLst[i][5]-1, rulercanvas.height);
	    x += regionLst[i][5]+regionSpacing.width;
	}
        return;
    }

    var previousplotstop = 0;
    //var xoffset = dspBoundary.lwidx;
    var xoffset = dspBoundary.lwrlpx;
    if(entire.atbplevel) {
        for(var i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	    var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	    var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : regionLst[i][5];
	    for(var j=start; j<stop; j++) {
	        var coord = j+regionLst[i][3];
	        var w = ctx.measureText(coord).width;
		var bpos = xoffset+j*entire.bpwidth; // bar plot pos
		if(w <= bpos-previousplotstop-40) {
		    ctx.fillText(coord, bpos-10-w, 10);
		    ctx.fillRect(bpos, 2, 1, 8);
		    previousplotstop = bpos;
		}
	    }
	    xoffset += regionLst[i][5] + regionSpacing.width;
	}
    } else {
        for(var i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
	    var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	    var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : regionLst[i][5];
	    for(var j=start; j<stop; j++) {
	        var coord = getPointCoord(i,j);
	        var w = ctx.measureText(coord).width;
		var bpos = xoffset + j;
	        if(w <= bpos-previousplotstop-40) {
	            ctx.fillText(coord, bpos-10-w, 10);
		    ctx.fillRect(bpos, 2, 1, 8);
		    previousplotstop = bpos;
		    j+=80;
	        }
	    }
	    // TODO must use regionLst[i][5] but instead of 
            xoffset += regionLst[i][5] + regionSpacing.width;
        }
    }
}


/*********************

    METAdata related

 *********************/
function mdvGetallparent(what, lst) {
    if(what in mdvc2p) {
        lst.push(mdvc2p[what]);
	mdvGetallparent(mdvc2p[what], lst);
    }
}
function mdvGetallchild(what, lst) {
    if(what in mdvp2c) {
        for(var i=0; i<mdvp2c[what].length; i++) {
	    var c = mdvp2c[what][i];
	    lst.push(c);
	    mdvGetallchild(c, lst);
	}
    }
}
function initiateMdcOnshowCanvas() {
    /* called when:
       - page first loaded
       - restore status
       - submit bigwig track with custom metadata

       write metadata categories vertically, check metadata voc tree checkboxes, only do once
     */
    stripChild(mdcholder.holder, 0);
    if(mdcategoryOnshow.length == 0) return;
    mdcholder.style.width = tkAttrColumnWidth * mdcategoryOnshow.length;
    for(var i=0; i<mdcategoryOnshow.length; i++) {
        var c = makecanvas_verticalstring((mdcategoryOnshow[i] in mdvidx2attr) ? mdvidx2attr[mdcategoryOnshow[i]] : mdcategoryOnshow[i], false);
        c.className = 'tkattrnamevcanvas'; // for tooltip
	c.id = i; // for track sorting
	var td = mdcholder.holder.insertCell(-1);
	td.vAlign = mdcholder.attop ? 'bottom' : 'top';
	td.appendChild(c);
    }

    var lst = document.getElementsByName("mdcheckbox");
    for(i=0; i<lst.length; i++) {
	if(thinginlist(lst[i].getAttribute('termidx'), mdcategoryOnshow))
	    lst[i].checked = true;
	else
	    lst[i].checked = false;
    }
}
function metadatahelpclick() { openManual("e"); }
function mdcolormap_add(term) {
    /* add term to metadata color map
       but won't be responsible for checking the checkbox in vocabulary tree
     */
    mdcategoryOnshow.push(term);
    var c = makecanvas_verticalstring((term in mdvidx2attr) ? mdvidx2attr[term] : term, false);
    c.className = 'tkattrnamevcanvas'; // for tooltip
    c.id = mdcategoryOnshow.length-1;
    var td = mdcholder.holder.insertCell(-1);
    td.vAlign = mdcholder.attop ? 'bottom' : ' top';
    td.appendChild(c);
    makeTrackAttrAll();
    drawTrackAttrCanvas();
    mdcholder.style.width = tkAttrColumnWidth * mdcategoryOnshow.length;
    mdcholder_place();
}
function mdcolormap_remove(term) {
    /* called upon checking the checkbox in metadata selector panel
       remove term to color map
     */
    var i = getArrIdx(term, mdcategoryOnshow);
    if(i == -1) return;
    var c = mdcholder.holder.childNodes[i];
    mdcholder.holder.removeChild(c);
    mdcategoryOnshow.splice(i,1);
    // need to change canvas.id for each category
    for(var j=0; j<mdcategoryOnshow.length; j++)
	mdcholder.holder.childNodes[j].id = j;
    for(j=0; j<tkLst.length; j++) {
	tkLst[j].attrlst.splice(i,1);
	tkLst[j].attrcoloridxlst.splice(i,1);
    }
    drawTrackAttrCanvas();
    mdcholder.style.width = tkAttrColumnWidth * mdcategoryOnshow.length;
    mdcholder_place();
}
function mdcholder_place() {
    // to place mdcholder either on top or bottom of mcm
    var lst = mdcholder.holder.childNodes;
    if(mdcholder.attop) {
        document.getElementById('mdcholder_upholder').appendChild(mdcholder);
	for(var i=0; i<lst.length; i++)
	    lst[i].vAlign = 'bottom';
    } else {
        document.getElementById('mdcholder_downholder').appendChild(mdcholder);
	for(var i=0; i<lst.length; i++)
	    lst[i].vAlign = 'top';
    }
}
function custmd_tableinsert(table, term, iscustom, parentterm, removecallback) {
    /* insert a row to table showing metadata annotation for custom bigwig file
       args:
         table: <table> dom object
	 term: leaf term index, or attribute name of custom term
	 iscustom: boolean
	 parentterm: name of term
     */
    var tr = table.insertRow(-1);
    tr.setAttribute('termidx', term);
    tr.setAttribute('termparent', parentterm);
    if(iscustom) {
        tr.setAttribute('custom', 1);
    }
    // attribute name
    var td = tr.insertCell(0);
    td.style.backgroundColor = 'white';
    if(iscustom) {
        td.innerHTML = term+' <span style="color:#858585;">of '+parentterm+'</span>';
	td.colSpan = 2;
    } else {
        td.innerHTML = mdvidx2attr[term];
    }
    // info icon
    if(!iscustom) {
	td = tr.insertCell(-1);
	td.style.backgroundColor = 'white';
	td.align = 'center';
	td.innerHTML = '<a termidx="'+term+'" style="cursor:pointer;" onclick=mdterm_requesttooltip(event)>&#9432;</a>';
    }
    // removal icon
    td = tr.insertCell(-1);
    td.style.backgroundColor = 'white';
    td.style.cursor = 'pointer';
    td.align = 'center';
    td.innerHTML = '&#10005;';
    td.addEventListener('click', removecallback, false);
}
function mdCheckboxchange(event) {
    /* on changing a checkbox in metadata selector panel
       event fired on the checkbox
     */
    var term = event.target.getAttribute('termidx');
    switch(mdselect.which) {
    case 1: // show in colormap
        if(event.target.checked) {
	    mdcolormap_add(term);
	} else {
	    mdcolormap_remove(term);
	}
	break;
    case 2: // custom bigwig prior to submission
        if(event.target.checked) {
	    /* to insert <tr> in table to be used in annotation
	       term must be leaf, and could be server or custom
	       need to imprint both term and parent info on the <tr>
	     */
	    // different treatment for server/custom terms...
	    var iscustom = (event.target.getAttribute('custom') != null);
	    var parentterm = event.target.getAttribute('termparent');
	    custmd_tableinsert(mdselect.custpriortable3, term, iscustom, parentterm, custmd_prior_removeTerm);
	} else {
	    custmd_prior_removeTerm(term, mdselect.custpriortable3);
	}
	break;
    case 4: // custom bigbed prior to submission
        if(event.target.checked) {
	    /* to insert <tr> in table to be used in annotation
	       term must be leaf, and will only be custom
	       need to imprint both term and parent info on the <tr>
	     */
	    // different treatment for server/custom terms...
	    var parentterm = event.target.getAttribute('termparent');
	    custmd_tableinsert(mdselect.custpriortable1, term, true, parentterm, custmd_prior_removeTerm);
	} else {
	    custmd_prior_removeTerm(term, mdselect.custpriortable1);
	}
	break;
    case 5: // custom bam prior to submission
        if(event.target.checked) {
	    /* to insert <tr> in table to be used in annotation
	       term must be leaf, and will only be custom
	       need to imprint both term and parent info on the <tr>
	     */
	    // different treatment for server/custom terms...
	    var parentterm = event.target.getAttribute('termparent');
	    custmd_tableinsert(mdselect.custpriortable5, term, true, parentterm, custmd_prior_removeTerm);
	} else {
	    custmd_prior_removeTerm(term, mdselect.custpriortable5);
	}
	break;
    case 3: // editing custom track anno after submission!
        if(event.target.checked) {
	    var tkobj = mdselect.custeditholder.filetype==3 ? hmtk.custom[mdselect.custeditholder.tkname] : decorInfo[mdselect.custeditholder.tkname];
	    var iscustom = (event.target.getAttribute('custom') != null);
	    var parentterm = event.target.getAttribute('termparent');
	    /* to insert <tr> in table to be used in annotation
	       term must be leaf, and could be server or custom
	       need to imprint both term and parent info on the <tr>
	     */
	    document.getElementById('custbwmd_editsaysno').style.display = 'none';
	    mdselect.custedittable.style.display = 'table';
	    custmd_tableinsert(mdselect.custedittable, term, iscustom, parentterm, custmd_edit_removeTerm);
	    // actually add annotation
	    if(iscustom) {
		tkobj.custmd[parentterm] = term;
	    } else {
	        tkobj.servermd[term] = 1;
            }
	    if(mdselect.custeditholder.filetype == 3) {
	        tkobj = findTrackByName(mdselect.custeditholder.tkname);
		if(tkobj != null) {
		    if(iscustom) {
			tkobj.custmd[parentterm] = term;
		    } else {
			tkobj.attrhash[term] = 1;
		    }
		    // make sure that this track is displayed at all
		    makeTrackAttrAll(); // to make all is so lazy...
		    drawTrackAttrCanvas_onetrack(tkobj);
		}
	    }
	} else {
	    custmd_edit_removeTerm(term);
	}
	break;
    default:
        fatalError('mdCheckboxchange: unknown mdselect.which');
    }
}
function makeMetatreeRecursive(which, lst) {
    /* for metadata control panel

       each entry corresponds to <li>
       leaf nodes are not expandable
       non-leaf nodes can be clicked to show/hide its children
     */
    var checked = thinginlist(which, mdcategoryOnshow) ? "checked" : "";
    //var notrootthing = thinginlist(which, mdvroot) ? "" : "|--";
    if(which in mdvp2c) {
        // not leaf
	lst.push('<li><span class=clb onclick=mdshowhide(event)><span style="color:#00289E;">&#8862;</span> '+which+'</span> <input type=checkbox name=mdcheckbox '+checked+' termidx="'+which+'" onchange=mdCheckboxchange(event)></li><ul id="'+which+'treeul" style="display:none;">');
	for(var i=0; i<mdvp2c[which].length; i++)
	    makeMetatreeRecursive(mdvp2c[which][i], lst);
	lst.push('</ul>');
    } else {
        // is leaf
	lst.push('<li>'+mdvidx2attr[which]+' <a termidx="'+which+'" onclick=mdterm_requesttooltip(event)>&#9432;</a> <input type=checkbox name=mdcheckbox termparent="'+mdvc2p[which]+'" '+checked+' termidx="'+which+'" onchange=mdCheckboxchange(event)></li>');
    }
}
function mdterm_requesttooltip(event) {
    // by clicking (i) for a leaf metadata term, pop up tooltip
    mdterm_showtooltip(event.target.getAttribute('termidx'), event.clientX, event.clientY);
}
function mds_close() {
    mdselect.main.style.display = 'none';
}
function mdcolormap_invokemds(event) {
    // select terms to be displayed in metadata colormap
    // toggle server md checkbox display, custom checkboxes will be done in invokemds()
    var lst = document.getElementsByName('mdcheckbox');
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('custom') == null) {
	    lst[i].style.display = 'inline';
	    if(thinginlist(lst[i].getAttribute('termidx'), mdcategoryOnshow)) {
		lst[i].checked = true;
	    } else {
		lst[i].checked = false;
	    }
	}
    }
    var pos = absolutePosition(event.target);
    mdselect.main.style.display = 'block';
    invokemds(1,
    pos[0]+event.target.clientWidth-mdselect.main.clientWidth,
    pos[1]+event.target.clientHeight,
    true);
}
function custprior3_invokemds(event) {
    // annotate custom bigwig track prior to submission
    // will hide checkboxes for none-leaf terms, and check those leaves already selected for annotation
    var lst = document.getElementsByName('mdcheckbox');
    var slst = custmdtable_getTermlist(mdselect.custpriortable3);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].getAttribute('termparent') == null) {
	    // non leaf term, hide
	    lst[i].style.display = 'none';
	} else {
	    // is leaf!
	    var attr = lst[i].getAttribute('termidx');
	    lst[i].style.display = 'inline';
	    if(lst[i].getAttribute('custom') == null) {
		lst[i].checked = thinginlist(attr, slst[0]);
	    } else {
	        var pa = lst[i].getAttribute('termparent');
		if(thinginlist(attr, slst[1]) && thinginlist(pa, slst[1])) {
		    lst[i].checked = true;
		} else {
		    lst[i].checked = false;
		}
	    }
	}
    }
    invokemds(2,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	true);
}
function custprior1_invokemds(event) {
    // annotate custom bigbed track prior to submission
    // will hide checkboxes for none-leaf terms, and check those leaves already selected for annotation
    var lst = document.getElementsByName('mdcheckbox');
    var slst = custmdtable_getTermlist(mdselect.custpriortable1);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].getAttribute('termparent') == null) {
	    // non leaf term, hide
	    lst[i].style.display = 'none';
	} else {
	    // is leaf!
	    var attr = lst[i].getAttribute('termidx');
	    lst[i].style.display = 'inline';
	    if(lst[i].getAttribute('custom') == null) {
		lst[i].checked = thinginlist(attr, slst[0]);
	    } else {
	        var pa = lst[i].getAttribute('termparent');
		if(thinginlist(attr, slst[1]) && thinginlist(pa, slst[1])) {
		    lst[i].checked = true;
		} else {
		    lst[i].checked = false;
		}
	    }
	}
    }
    invokemds(4,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	false);
}
function custprior5_invokemds(event) {
    // annotate custom bigbed track prior to submission
    // will hide checkboxes for none-leaf terms, and check those leaves already selected for annotation
    var lst = document.getElementsByName('mdcheckbox');
    var slst = custmdtable_getTermlist(mdselect.custpriortable5);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].getAttribute('termparent') == null) {
	    // non leaf term, hide
	    lst[i].style.display = 'none';
	} else {
	    // is leaf!
	    var attr = lst[i].getAttribute('termidx');
	    lst[i].style.display = 'inline';
	    if(lst[i].getAttribute('custom') == null) {
		lst[i].checked = thinginlist(attr, slst[0]);
	    } else {
	        var pa = lst[i].getAttribute('termparent');
		if(thinginlist(attr, slst[1]) && thinginlist(pa, slst[1])) {
		    lst[i].checked = true;
		} else {
		    lst[i].checked = false;
		}
	    }
	}
    }
    invokemds(5,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	false);
}
function custmdedit_invokemds(event) {
    /* custom track metadata editing */
    // will hide checkboxes for none-leaf terms, and check those leaves already selected for annotation
    var lst = document.getElementsByName('mdcheckbox');
    var slst = custmdtable_getTermlist(mdselect.custedittable);
    for(var i=0; i<lst.length; i++) {
	if(lst[i].getAttribute('termparent') == null) {
	    // not a leaf term
	    lst[i].style.display = 'none';
	} else {
	    // is leaf!
	    var attr = lst[i].getAttribute('termidx');
	    lst[i].style.display = 'inline';
	    if(lst[i].getAttribute('custom') == null) {
	        lst[i].checked = thinginlist(attr, slst[0]);
	    } else {
	        var pa = lst[i].getAttribute('termparent');
		if(thinginlist(attr, slst[1]) && thinginlist(pa, slst[1])) {
		    lst[i].checked = true;
		} else {
		    lst[i].checked = false;
		}
	    }
	}
    }
    var ft = mdselect.custeditholder.filetype;
    invokemds(3,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	ft==3);
}
function invokemds(which, x, y, showservermd) {
    document.body.addEventListener('mousedown', mds_close, false);
    mdselect.which = which;
    mdselect.main.style.display = 'block';
    mdselect.main.style.left = x;
    mdselect.main.style.top = y;
    document.getElementById('mds_servermdholder').style.display = showservermd ? 'block' : 'none';
    custmd_checkbox_togglevisibility();
}
function menuCustbwmdedit() {
    // only for custom bigwig
    custmd_showeditpanel(tkNameLst[menu.iY], 3);
}
function custmdtable_getTermlist(table) {
    /* argument: <table> dom object

       retrieve terms from table
       each <tr> is one term (leaf nodes only!)
       have attributes "termidx" and "termparent"
       custom terms will have "custom" attribute

       returns:
       [ [server term idx, idx2, ...], [cust term attr, cust term name, attr2, name2, ...] ]
     */
    var lst = table.firstChild.childNodes;
    var slst = []; // server term idx
    var clst = []; // custom term (name, attr)
    for(var i=1; i<lst.length; i++) {
        if(lst[i].getAttribute('custom') == null) {
	    slst.push(lst[i].getAttribute('termidx'));
	} else {
	    clst.push(lst[i].getAttribute('termidx'));
	    clst.push(lst[i].getAttribute('termparent'));
	}
    }
    return [slst, clst];
}
function custmd_prior_removeTerm() {
    /* prior to custom track submission,
       remove a term from the list
       variable argument:
          if only one argument, called by clicking <td>X</td>
	  if two arguments, 1 - term idx, 2 - holder
     */
    if(arguments.length == 1) {
	arguments[0].target.parentNode.parentNode.removeChild(arguments[0].target.parentNode);
    } else if (arguments.length == 2) {
        var lst = arguments[1].firstChild.childNodes;
        for(var i=0; i<lst.length; i++) {
	    if(arguments[0] == lst[i].getAttribute('termidx')) {
	        arguments[1].firstChild.removeChild(lst[i]);
		break;
	    }
	}
    } else {
        fatalError('custmd_prior_removeTerm: unknown arguments');
    }
}
function custmd_edit_removeTerm() {
    /* doing what custmd_prior_removeTerm does but with extra work
       here has to actually remove attribute and redraw track attribute canvas...
       variable argument:
        - event, called by clicking on <td>X</td> in the shitty table
	- string, md term
       important: 
        - obtain track filetype and name from attributes on mdselect.custeditholder
	- term and term parent are attributes of tr of the clicked <td>
     */
    var termiscustom;
    var term;
    var termparent;
    if(typeof(arg) == 'string') {
        var lst = mdselect.custedittable.firstChild.childNodes;
        for(var i=0; i<lst.length; i++) {
	    if(arg == lst[i].getAttribute('termidx')) {
	        term = lst[i].getAttribute('termidx');
		termparent = lst[i].getAttribute('termparent');
		termiscustom = lst[i].getAttribute('custom')==null;
	        mdselect.custedittable.firstChild.removeChild(lst[i]);
		break;
	    }
	}
    } else {
        // it is event on the <td> object
	var trobj = event.target.parentNode;
	term = trobj.getAttribute('termidx');
	termparent = trobj.getAttribute('termparent');
	termiscustom = trobj.getAttribute('custom')==null;
	mdselect.custedittable.firstChild.removeChild(trobj);
    }
    // toggle display of wordy
    if(mdselect.custedittable.firstChild.childNodes.length > 1) {
        mdselect.custedittable.style.display = 'table';
	document.getElementById('custbwmd_editsaysno').style.display = 'none';
    } else {
        mdselect.custedittable.style.display = 'none';
	document.getElementById('custbwmd_editsaysno').style.display = 'block';
    }
    // remove the attribute from track anno
    var ft = mdselect.custeditholder.filetype;
    var tkname = mdselect.custeditholder.tkname;
    var tkobj = ft==3 ? hmtk.custom[tkname] : decorInfo[tkname];
    if(iscustom) {
	delete tkobj.custmd[termparent];
    } else {
	delete tkobj.servermd[term];
    }
    if(ft == 3) {
        tkobj = findTrackByName(tkname);
	if(tkobj != null) {
	    // the track might not be shown!!
	    makeTrackAttrAll();
	    drawTrackAttrCanvas_onetrack(tkobj);
	}
    }
}
function makeMetadataSelectorPanel() {
    /* only call once
       make metadata selector panel...
     */
    var words = ['<ul>'];
    for(var i=0; i<mdvroot.length; i++) {
        makeMetatreeRecursive(mdvroot[i], words);
    }
    words.push('</ul>');
    document.getElementById('mds_servermdholder').innerHTML = words.join("");
}


/*** custom metadata entry system!!
 ***/
function custmd_example() {
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("change", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    var s = document.getElementById('newcustmdattrvnum');
    s.selectedIndex = 1;
    s.dispatchEvent(e);
    document.getElementById('newcustmdattrname').value = 'my friends';
    document.getElementById('newcustmdnewvalue_1').value = 'Sanborn';
    document.getElementById('newcustmdnewvalue_2').value = 'Eldridge';
    document.getElementById('newcustmdnewvalue_3').value = 'James';
    submitCustommdterm();
}
function newcustmd_setattrvalue() {
    /* called by changing <select>
       see how many values are chosen for new attribute, and make that number of inputs
     */
    var n = parseInt(getSelectValueById("newcustmdattrvnum"));
    var holder = document.getElementById("newcustmd_attrvalueentryholder");
    stripChild(holder, 0);
    for(var i=1; i<=n; i++) {
        var d = document.createElement("div");
	d.style.margin = "4px";
	d.style.display = "inline-block";
	d.innerHTML = "attr. "+i+"<br><input type=text id=newcustmdnewvalue_"+i+" size=3>";
	holder.appendChild(d);
    }
}
function resetCustommdterm() {
    document.getElementById('newcustmdattrname').value = '';
    document.getElementById('newcustmdattrvnum').selectedIndex = 1;
    newcustmd_setattrvalue();
}
function submitCustommdterm() {
    /* called by clicking "add new attr" button
       beware restoring status won't invoke this!!
     */
    // input: attr name
    var name = document.getElementById("newcustmdattrname").value;
    if(name == "") {
        print2console("please specify term name", 2);
	return;
    }
    if(name.indexOf(',') != -1) {
        print2console("comma not allowed in term name", 2);
	return;
    }
    if(name.indexOf('|') != -1) {
        print2console("vertical bar not allowed in term name", 2);
	return;
    }
    if(name in custmdhash) {
        print2console('Term name already in use', 2);
	return;
    }
    var nlst = [];
    var un = parseInt(getSelectValueById("newcustmdattrvnum"));
    for(var i=1; i<=un; i++) {
        var t = document.getElementById("newcustmdnewvalue_"+i).value;
        if(t == "") continue;
        if(t.indexOf(',') != -1) {
            print2console("comma not allowed in attribute value", 2);
	    return;
	}
        if(t.indexOf('|') != -1) {
            print2console("vertical bar not allowed in attribute value", 2);
	    return;
	}
	if(thinginlist(t, nlst)) continue;
	nlst.push(t);
    }
    if(nlst.length == 0) {
        print2console('no valid attributes.', 2);
	return;
    }
    // push this new attribute into custmdhash
    custmdhash[name] = nlst;
    displayCustmdattr(name);
    custmd_checkbox_togglevisibility();
    resetCustommdterm();
    toggle6();
}
function custmdselect_toggle() {
    var s = document.getElementById('custmdselect_row');
    if(s.selectedIndex == -1) {
        // nothing there yet
	return;
    }
    var w = s.options[s.selectedIndex].value;
    s = document.getElementById('custmdselect_col');
    var lst = s.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].value == '|') continue;
	lst[i].disabled = lst[i].value==w;
    }
    if(s.options[s.selectedIndex].value == w)
        s.selectedIndex = 0;
}
function custtkCount_onecustmd(term, attr) {
    /* give two number of cust tracks on a md term
       the term is *custom* metadata
     */
    var nall=0, nuse=0;
    for(var tk in hmtk.custom) {
        var h = hmtk.custom[tk].custmd;
	if(h == undefined) continue;
        if(term in h && h[term]==attr) {
	    nall++;
	    if(findTrackByName(tk) != null)
	        nuse++;
	}
    }
    for(var tk in decorInfo) {
        if(decorInfo[tk].fileType==1 || decorInfo[tk].fileType==5) {
	    var h = decorInfo[tk].custmd;
	    if(h == undefined) continue;
	    if(term in h && h[term]==attr) {
		nall++;
		if(tk in decorCanvasHash)
		    nuse++;
	    }
	}
    }
    return [nall, nuse];
}
function custtkCount_twocustmd(term1, attr1, term2, attr2) {
    /* give two number of cust tracks on two md terms
       the terms are *custom* metadata
     */
    var nall=0, nuse=0;
    for(var tk in hmtk.custom) {
        var h = hmtk.custom[tk].custmd;
	if(h == undefined) continue;
        if(term1 in h && h[term1]==attr1 && term2 in h && h[term2]==attr2) {
	    nall++;
	    if(findTrackByName(tk) != null)
	        nuse++;
	}
    }
    for(var tk in decorInfo) {
        if(decorInfo[tk].fileType==1 || decorInfo[tk].fileType==5) {
	    var h = decorInfo[tk].custmd;
	    if(h == undefined) continue;
	    if(term1 in h && h[term1]==attr1 && term2 in h && h[term2]==attr2) {
		nall++;
		if(tk in decorCanvasHash)
		    nuse++;
	    }
	}
    }
    return [nall, nuse];
}
function custtk_numpair2str(numpair) {
    /* takes input from custtkCount_onecustmd or two
       return print string with link
       but have to wrap it into <div class=tscell></div> with onclick attached to it
     */
    if(numpair[0] == 0)
        return [false, '<span style="color:#ccc;">none</span>'];
    return [true, '<span class=g>'+numpair[0]+'</span>'+(numpair[1]==0 ? '/0' : '/<span class=r>'+numpair[1]+'</span>')];
}
function custmd_makegrid() {
    var s1 = document.getElementById('custmdselect_row');
    if(s1.selectedIndex == -1) {
        //print2console('No custom metadata term yet', 2);
	return;
    }
    var rowname = s1.options[s1.selectedIndex].value;
    var rowattrlst = custmdhash[rowname];
    var s2 = document.getElementById('custmdselect_col');
    var table = document.getElementById('custmdgrid');
    stripChild(table.firstChild, 0);
    if(s2.selectedIndex == 0) {
        // only row
	// first row
	var tr = table.insertRow(0);
	var td = tr.insertCell(0);
	td.className = 'tksgridvoval';
	td.vAlign = "middle";
	td.appendChild(makecanvas_verticalstring(rowname, false));
	td.rowSpan = rowattrlst.length;
	td = tr.insertCell(-1);
	td.align = 'right';
	td.innerHTML = rowattrlst[0];
	var tmp = custtk_numpair2str(custtkCount_onecustmd(rowname,rowattrlst[0]));
	tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[0]+'\')">'+tmp[1]+'</div>' : tmp[1];
	// remaining rows
	for(var i=1; i<rowattrlst.length; i++) {
	    tr = table.insertRow(-1);
	    td = tr.insertCell(0);
	    td.align = 'right';
	    td.innerHTML = rowattrlst[i];
	    tmp = custtk_numpair2str(custtkCount_onecustmd(rowname,rowattrlst[i]));
	    tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[i]+'\')">'+tmp[1]+'</div>' : tmp[1];
	}
    } else {
        // row & column
        var colname = s2.options[s2.selectedIndex].value;
	var colattrlst = custmdhash[colname];
	// first row, horizontal header
	var tr = table.insertRow(0);
	tr.insertCell(0);
	tr.insertCell(-1);
	var td = tr.insertCell(-1);
	td.className = 'tksgridhoval';
	td.innerHTML = colname;
	td.colSpan = colattrlst.length;
	// second row, vertical names
	tr = table.insertRow(-1);
	tr.insertCell(0);
	tr.insertCell(-1);
	for(var i=0; i<colattrlst.length; i++) {
	    td = tr.insertCell(-1);
	    td.vAlign = 'bottom';
	    td.appendChild(makecanvas_verticalstring(colattrlst[i], false));
	}
	// first row of rowattrlst
	tr = table.insertRow(-1);
	td = tr.insertCell(0);
	td.className = 'tksgridvoval';
	td.vAlign = "middle";
	td.appendChild(makecanvas_verticalstring(rowname, false));
	td.rowSpan = rowattrlst.length;
	td = tr.insertCell(-1);
	td.align = 'right';
	td.innerHTML = rowattrlst[0];
	for(i=0; i<colattrlst.length; i++) {
	    var tmp = custtk_numpair2str(custtkCount_twocustmd(rowname,rowattrlst[0],colname,colattrlst[i]));
	    tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[0]+'\',\''+colname+'\',\''+colattrlst[i]+'\')">'+tmp[1]+'</div>' : tmp[1];
	}
	// remaining rows of rowattrlst
	for(i=1; i<rowattrlst.length; i++) {
	    tr = table.insertRow(-1);
	    td = tr.insertCell(0);
	    td.align = 'right';
	    td.innerHTML = rowattrlst[i];
	    for(var j=0; j<colattrlst.length; j++) {
	        var tmp = custtk_numpair2str(custtkCount_twocustmd(rowname,rowattrlst[i],colname,colattrlst[j]));
	        tr.insertCell(-1).innerHTML = tmp[0] ? '<div class=tscell onclick="showcusttkchoice(\''+rowname+'\',\''+rowattrlst[i]+'\',\''+colname+'\',\''+colattrlst[j]+'\')">'+tmp[1]+'</div>' : tmp[1];
	    }
	}
    }
}
function showcusttkchoice() {
    /* called by clicking on tscell in custom track grid
       variable argument
       - if length 2, will be term, attr
       - if length 4, will be two pairs of term/attr
     */
    var tklst = [];
    var t1 = arguments[0];
    var a1 = arguments[1];
    var t2 = arguments[2]; // could be undefined
    var a2 = arguments[3]; // could be undefined
    for(var tk in hmtk.custom) {
        var hash = hmtk.custom[tk].custmd;
	if(t1 in hash && hash[t1]==a1) {
	    if(t2 == undefined) {
	        tklst.push([tk, 3]);
	    } else {
	        if(t2 in hash && hash[t2]==a2)
	            tklst.push([tk, 3]);
	    }
	}
    }
    for(tk in decorInfo) {
        var ft = decorInfo[tk].fileType;
	if(ft==1 || ft==5) {
            var hash = decorInfo[tk].custmd;
	    if(t1 in hash && hash[t1]==a1) {
	        if(t2 == undefined) {
		    tklst.push([tk, ft]);
		} else {
		    if(t2 in hash && hash[t2]==a2)
		        tklst.push([tk, ft]);
		}
	    }
	}
    }
    document.getElementById('custtkselectwrapper').style.display = 'block';
    var table = document.getElementById('custtkselecttable');
    stripChild(table, 0);
    for(var i=0; i<tklst.length; i++) {
        var tn = tklst[i][0];
        var ft = tklst[i][1];
        var tr = table.insertRow(-1);
	tr.insertCell(0).innerHTML = ft==3 ? hmtk.custom[tn].label : decorInfo[tn].label;
	var td = tr.insertCell(-1);
	td.style.color = '#858585';
	td.innerHTML = ft==1 ? 'bigBed' : (ft==3 ? 'bigWig' : 'BAM');
	var shown = false;
	if(ft == 3) {
	    if(getTkidxByname(tn) != -1) shown = true;
	} else {
	    if(tn in decorCanvasHash) shown = true;
	}
	tr.insertCell(-1).innerHTML = '<button class=s tkname='+tn+' filetype='+ft+' onclick=customtrack_showbuttclick(event)>'+(shown?'hide':'show')+'</button>';
    }
    var p = table.parentNode;
    if(table.clientHeight > 200) {
        p.style.height =200;
	p.style.overflowY = 'scroll';
    } else {
        p.style.height = 'auto';
	p.style.overflowY = 'auto';
    }
}
function custtkselect_addall() {
    /* called by pushing "add all" button
       some awkward implementation here
       simulating button pushing on bigbed/bam works
       but won't work for hmtk
       so hmtk is collected and be added in one single ajax call
     */
    var bwtk = [];
    var lst = document.getElementById('custtkselecttable').firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        var butt = lst[i].childNodes[2].firstChild;
	var tn = butt.getAttribute('tkname');
	if(butt.getAttribute('filetype') == '3') { // bigwig
	    if(getTkidxByname(tn) == -1)
	        bwtk.push(butt.getAttribute('tkname'));
	} else {
	    // bigbed/bam
	    if(!(tn in decorCanvasHash)) {
		var e = document.createEvent("MouseEvents");
		e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
		butt.dispatchEvent(e);
	    }
	}
    }
    document.getElementById('custtkselectwrapper').style.display = 'none';
    custmd_makegrid();

    if(bwtk.length == 0) return;

    var lst = [];
    for(i=0; i<bwtk.length; i++) {
	lst.push(bwtk[i]);
	lst.push(hmtk.custom[bwtk[i]].url);
    }
    cloak(viewbox);
    document.body.style.cursor = 'wait';
    ajax(displayedRegionParamPrecise()+"&addmulticustombigwig=on&tklst="+lst.join(','),function(data){
	if(!('bwdata' in data)) fatalError('custtkselect_addall: bwdata missing');
	for(var name in data.bwdata) {
	    gflag.customtmp.name = name;
	    gflag.customtmp.label = hmtk.custom[name].label;
	    gflag.customtmp.url = hmtk.custom[name].url;
	    gflag.customtmp.mode = 'show';
	    gflag.customtmp.servermd = hmtk.custom[name].servermd;
	    gflag.customtmp.custmd = hmtk.custom[name].custmd;
	    jsonAddOneCustombigwig(data.bwdata[name]);
	    hmtk.custom[name].showbutt.innerHTML = 'hide';
	}

	makeTrackAttrAll();
	mcmSortTrack(sortTrackIdx);
	stuffTrackCanvas2holder();
	drawTrackAttrCanvas();

        custmd_makegrid();

	document.body.style.cursor = 'auto';
	unveil(viewbox);
    });
}
function custtkselect_removeall() {
    var lst = document.getElementById('custtkselecttable').firstChild.childNodes;
    var hmtkremoved = false;
    for(var i=0; i<lst.length; i++) {
        var butt = lst[i].childNodes[2].firstChild;
	var tkname = butt.getAttribute('tkname');
	var ft = parseInt(butt.getAttribute('filetype'));
	if(ft == 3) {
	    var j = getTkidxByname(tkname);
	    if(j != -1) {
	        removeBigwigTrack(j);
		hmtkremoved = true;
	    }
	} else if(ft==1 || ft==5) {
	    decorInfo[tkname].mode = 'hide';
	    toggleDecor(tkname);
	}
    }
    if(hmtkremoved) {
	stuffTrackCanvas2holder();
	generateTrackselectionLayout();
	if(htest.inuse) turnoffHtest();
	updateDsp();
	trackHeightChanged(false);
    }
    document.getElementById('custtkselectwrapper').style.display = 'none';
    custmd_makegrid();
}
function displayCustmdattr(termname) {
    /* display one custom metadata attribute in table
       call this when a new term is added
       argument: custom term name
       values for this attribute is in custmdhash

       custom metadata will always be shown
       push it into mdcategoryOnshow
       insert it into the two <select>
     */
    if(!(termname in custmdhash)) fatalError('displayCustmdattr: unknown term name');

    var lst = ['<li><span class=clb onclick=mdshowhide(event)><span style="color:#00289E;">&#8862;</span> '+termname+'</span> <input type=checkbox name=mdcheckbox custom=1 termidx="'+termname+'" onchange=mdCheckboxchange(event)></li><ul id="'+termname+'treeul" style="display:none;">'];
    for(var i=0; i<custmdhash[termname].length; i++) {
        var attr = custmdhash[termname][i];
        lst.push('<li>'+attr+' <input type=checkbox name=mdcheckbox custom=1 termparent="'+termname+'" termidx="'+attr+'" onchange=mdCheckboxchange(event)></li>');
    }
    lst.push('</ul>');
    mdselect.cust.innerHTML += lst.join('');

    /* append this custom md term to the two <select> */
    var opt = document.createElement('option');
    opt.value = termname;
    opt.innerHTML = termname;
    document.getElementById('custmdselect_row').add(opt);
    opt = document.createElement('option');
    opt.value = termname;
    opt.innerHTML = termname;
    document.getElementById('custmdselect_col').add(opt);
    custmdselect_toggle();
}
function custmd_checkbox_togglevisibility() {
    /* well this is a makeup
       in case of choosing terms to be displayed in colormap,
       custom term attributes have to hide their checkbox

       to tell custom term checkbox, use "custom" attribute
     */
    var lst = document.getElementsByName('mdcheckbox');
    var plst = []; // custom term name checkboxes
    var clst = []; // custom term attribute checkboxes
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('custom') != null) {
	    if(lst[i].getAttribute('termparent') != null) {
	        clst.push(i);
	    } else {
	        plst.push(i);
	    }
	}
    }
    switch(mdselect.which) {
    case 1:
        for(var i=0; i<plst.length; i++) { lst[plst[i]].style.display = 'inline'; }
        for(var i=0; i<clst.length; i++) { lst[clst[i]].style.display = 'none'; }
        break;
    case 2:
    case 3:
    case 4:
    case 5:
        for(var i=0; i<plst.length; i++) { lst[plst[i]].style.display = 'none'; }
        for(var i=0; i<clst.length; i++) { lst[clst[i]].style.display = 'inline'; }
        break;
    default:
        fatalError('custmd_checkbox_togglevisibility: unknown mdselect.which value');
    }
}
function recursiveFetchTrackAttr(which, tkidx, mdcidx) {
    /* args:
       - which: an attribute, index for leaf, string for non-leaf
       - tkidx: track idx
       - mdcidx: mdcategoryOnshow array idx
       sets tkLst[tkidx].attrlst[mdcidx] using the attr value in .attrhash.....
     */
    if(which in mdvidx2attr) {
        // leaf
        if(which in tkLst[tkidx].attrhash)
	    tkLst[tkidx].attrlst[mdcidx] = which;
	return;
    } else {
        if(!(which in mdvp2c)) fatalError(which);
        for(var i=0; i<mdvp2c[which].length; i++)
	    recursiveFetchTrackAttr(mdvp2c[which][i], tkidx, mdcidx);
    }
}
function makeTrackAttrAll() {
    /* mdcategoryOnshow and tkLst[i].attrhash must be ready
       make .attrlst and .attrcoloridxlst for each track
     */
    // wipe out existing .attrlst (in case of editing custbw metadata)
    for(var i=0; i<tkLst.length; i++) {
	for(var j=0; j<mdcategoryOnshow.length; j++) {
	    tkLst[i].attrlst[j] = undefined;
	}
    }
    for(i=0; i<mdcategoryOnshow.length; i++) {
        makeTrackAttrOneCategory(i);
    }
}
function makeTrackAttrOneCategory(mdcidx) {
    /* argument is mdcategoryOnshow array index
       make .attrlst[mdcidx] for each track

       different treatment for server/custom metadata!!
     */
    var thism = mdcategoryOnshow[mdcidx];
    if(thism in custmdhash) {
        var attrvalues = {};
        // is custom metadata
	for(var i=0; i<tkLst.length; i++) {
	    // only operate on tracks with .custmd hash
	    if('custmd' in tkLst[i]) {
		if(thism in tkLst[i].custmd) {
		    tkLst[i].attrlst[mdcidx] = tkLst[i].custmd[thism];
		    attrvalues[tkLst[i].attrlst[mdcidx]] = 1;
		}
	    }
	}
	var lst = [];
	for(var v in attrvalues) lst.push(v);
	// make .attrcoloridxlst[mdcidx] for those tracks with custmdhash
	for(i=0; i<tkLst.length; i++) {
	    if(tkLst[i].custmd == undefined) {
		tkLst[i].attrcoloridxlst[mdcidx] = -1;
	    } else {
	        tkLst[i].attrcoloridxlst[mdcidx] = getArrIdx(tkLst[i].attrlst[mdcidx], lst);
	    }
	}
	return;
    }
    var attrvalues = {};
    for(var i=0; i<tkLst.length; i++) {
	recursiveFetchTrackAttr(thism, i, mdcidx);
	var thing = tkLst[i].attrlst[mdcidx];
	if(thing != undefined) attrvalues[thing]=1;
    }
    var lst = [];
    for(var v in attrvalues) lst.push(v);
    // make .attrcoloridxlst[mdcidx] for each track
    for(i=0; i<tkLst.length; i++) {
        if(tkLst[i].attrlst[mdcidx] == undefined)
	    tkLst[i].attrcoloridxlst[mdcidx] = -1;
	else
	    tkLst[i].attrcoloridxlst[mdcidx] = getArrIdx(tkLst[i].attrlst[mdcidx], lst);
    }
}
function drawTrackAttrCanvas_onetrack(tk) {
    // argument is one tkLst element, object!!
    var c = tk.atC;
    if(tk.atC == undefined) 
        fatalError('drawTrackAttrCanvas_onetrack: undefined .atC for track '+tk.name);
    var h = tk.qtc.height;
    c.height = h;
    c.width = mdcategoryOnshow.length * tkAttrColumnWidth;
    var ctx = c.getContext('2d');
    var clen = colorCentral.longlst.length-1;
    for(var j=0; j<mdcategoryOnshow.length; j++) {
        var v = tk.attrcoloridxlst[j];
        if(v == -1) {
	    ctx.fillStyle = GRAY;
	} else {
	    if(v > clen) {
	        var f = parseInt(v/clen);
		ctx.fillStyle = darkencolor(colorstr2int(colorCentral.longlst[v%clen]), f<10?f/10:1);
	    } else {
                ctx.fillStyle = colorCentral.longlst[v];
	    }
	}
	ctx.fillRect(j*tkAttrColumnWidth,0,tkAttrColumnWidth-1,h);
    }
    c.attr = tk.attrlst;
}
function drawTrackAttrCanvas() {
    for(var i=0; i<tkLst.length; i++) 
        drawTrackAttrCanvas_onetrack(tkLst[i]);
}
function moveMdcanvasMD(event){
    // only accepts if mouse left click issued the event
    if(event.button != 0) return;
    tooltiphide();
    document.body.addEventListener("mousemove", moveMdcanvasM, false);
    document.body.addEventListener("mouseup", moveMdcanvasMU, false);
    mdcholder.x = event.clientX - iiiX + document.body.scrollLeft; // previous x
    mdcholder.xi = Math.floor(mdcholder.x/tkAttrColumnWidth);
}
function moveMdcanvasMU(event){
    document.body.removeEventListener("mousemove", moveMdcanvasM, false);
    document.body.removeEventListener("mouseup", moveMdcanvasMU, false);
}
function moveMdcanvasM(event){
    /* somehow removing "click" event handler while moving won't prevent
       track sorting,
       solution here is to add a dumb flag in mdcholder
       so mcmSortTrack will see it and won't do anything

       in firefox, the onmouseover event will be activated for canvas during move,
       so need to toggle off
     */
    mdnotooltip = true; // to prevent pop up of tooltip
    var x = event.clientX-iiiX + document.body.scrollLeft;
    if(x<0 || x>mdcategoryOnshow.length*tkAttrColumnWidth) {
        moveMdcanvasMU(event);
	return;
    }
    var pxi = mdcholder.xi; // previous xi
    if(x > mdcholder.x) {
        if(pxi >= mdcategoryOnshow.length-1) return;
	if(x > (pxi+1)*tkAttrColumnWidth) {
	    swapMdcategory(pxi, pxi+1);
	    drawTrackAttrCanvas();
	    mdcholder.x = x;
	    mdcholder.xi++;
	    mdcholder.moved = true;
	}
    } else {
        if(pxi == 0) return;
	if(x < pxi*tkAttrColumnWidth) {
	    swapMdcategory(pxi, pxi-1);
	    drawTrackAttrCanvas();
	    mdcholder.x = x;
	    mdcholder.xi--;
	    mdcholder.moved = true;
	}
    }
}
function swapMdcategory(i,j){
    // ij are array index for mdcategoryOnshow and tkLst[?].attrlst, tkLst[?].attrcoloridxlst
    // swap track metadata category name canvas in their holder
    var clst = [];
    for(var k=0; k<mdcategoryOnshow.length; k++)
        clst.push(mdcholder.holder.childNodes[k]);
    for(k=0; k<clst.length; k++) {
	if(k == i) {
	    mdcholder.holder.appendChild(clst[j]);
	} else if(k == j) {
	    mdcholder.holder.appendChild(clst[i]);
	} else {
	    mdcholder.holder.appendChild(clst[k]);
	}
    }
    // mdcategoryOnshow it self
    var tmp = mdcategoryOnshow[i];
    mdcategoryOnshow[i] = mdcategoryOnshow[j];
    mdcategoryOnshow[j] = tmp;
    // swap .attrlst and .attrcoloridxlst for each track
    for(k=0; k<tkLst.length; k++) {
        tmp = tkLst[k].attrlst[i];
	tkLst[k].attrlst[i] = tkLst[k].attrlst[j];
	tkLst[k].attrlst[j] = tmp;
        tmp = tkLst[k].attrcoloridxlst[i];
	tkLst[k].attrcoloridxlst[i] = tkLst[k].attrcoloridxlst[j];
	tkLst[k].attrcoloridxlst[j] = tmp;
    }
}
function trackchoice1selectchange(){
    var v = getSelectValueById("trackchoicemdr1");
    var s = document.getElementById("trackchoicemdr2");
    var lst = s.options;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].value == v) {
	    lst[i].disabled = true;
	    if(s.selectedIndex == i)
	        s.selectedIndex = 0;
	} else {
	    lst[i].disabled = false;
	}
    }
    document.getElementById('generatehmtksgridbutt').style.display='block';
}
function initiateTrackControlpanel() {
    // mdvroot must be ready
    var s1 = document.getElementById("trackchoicemdr1");
    var s2 = document.getElementById("trackchoicemdr2");
    var opt = document.createElement("option");
    opt.text = "don't use";
    opt.value = "no";
    s2.add(opt, null);
    for(var i=0; i<mdvroot.length; i++) {
        var opt1 = document.createElement("option");
        var opt2 = document.createElement("option");
        opt1.text = mdvroot[i];
	opt1.value = mdvroot[i];
        opt2.text = mdvroot[i];
	opt2.value = mdvroot[i];
	if(mdvroot[i] == "Sample") {
	    opt1.selected = true;
	    opt2.disabled = true;
	}
	if(mdvroot[i] == "Epigenetic Mark")
	    opt2.selected = true;
	s1.add(opt1, null);
	s2.add(opt2, null);
    }
}
function recursivegettrack(what, tkset) {
    // search for any tracks annotated by an attribute, store in hash, key is track name
    if(what in mdvp2c) {
        // not leaf
        for(var i=0; i<mdvp2c[what].length; i++)
            recursivegettrack(mdvp2c[what][i], tkset);
    } else {
        // is leaf
        for(var tk in hmtk.mdanno) {
	    if(what in hmtk.mdanno[tk])
	        tkset[tk] = 1;
	}
    }
}
function maketrackselectioncell_onecriteria(attr, numall, numinuse) {
    if(numall == 0) {
        return '<span style="color:#ccc;">none</span>';
    } else {
        return '<div class=tscell '+
           ' style="display:inline-block;"'+
	   ' onclick="showtrackchoice(\''+attr+'\')"'+
	   ' title="click to show tracks"'+
	   '><span class=g>'+ numall + '</span>' +
	   ((numinuse==0) ? '/0' : '/<span class=r>'+numinuse+'</span>') +
	   '</div>';
    }
}
function showhide_trackselection_twocriteria_horizontal(event) {
    // largely repetitive with showhide_trackselection_twocriteria_vertical
    var what = event.target.name;
    // look for "what" in tsmdc_rows
    for(var i=0; i<tsmdc_rows.length; i++) {
        if(tsmdc_rows[i][0] == what) break;
    }
    if(tsmdc_rows[i][2] == "images/plus.png") {
        // expand details, insert child terms into array
	tsmdc_rows[i][2] = "images/minus.png";
	for(var j=0; j<mdvp2c[what].length; j++)
	    tsmdc_rows.splice(i+1+j, 0, [mdvp2c[what][j], tsmdc_rows[i][1]+20, "images/plus.png"]);
    } else {
        // hide details, remove child terms from array
	tsmdc_rows[i][2] = "images/plus.png";
	var lst = [];
	mdvGetallchild(what, lst);
	var newlst = [];
	for(var i=0; i<tsmdc_rows.length; i++) {
	    var notinlst = true;
	    for(var j=0; j<lst.length; j++) {
	        if(lst[j] == tsmdc_rows[i][0]) {
		    notinlst = false
		    break;
		}
	    }
	    if(notinlst)
	        newlst.push(tsmdc_rows[i]);
	}
	tsmdc_rows = newlst;
    }
    generateTrackselectionGrid(getSelectValueById("trackchoicemdr1"), getSelectValueById("trackchoicemdr2"));
}
function showhide_trackselection_twocriteria_vertical(event) {
    // largely repetitive with showhide_trackselection_twocriteria_horizontal
    var what = event.target.name;
    // look for "what" in tsmdc_cols
    for(var i=0; i<tsmdc_cols.length; i++) {
        if(tsmdc_cols[i][0] == what) break;
    }
    if(tsmdc_cols[i][2] == "images/plus.png") {
        // expand details, insert child terms into array
	tsmdc_cols[i][2] = "images/minus.png";
	for(var j=0; j<mdvp2c[what].length; j++)
	    tsmdc_cols.splice(i+1+j, 0, [mdvp2c[what][j], tsmdc_cols[i][1]+20, "images/plus.png"]);
    } else {
        // hide details, remove child terms from array
	tsmdc_cols[i][2] = "images/plus.png";
	var lst = [];
	mdvGetallchild(what, lst);
	var newlst = [];
	for(var i=0; i<tsmdc_cols.length; i++) {
	    var notinlst = true;
	    for(var j=0; j<lst.length; j++) {
	        if(lst[j] == tsmdc_cols[i][0]) {
		    notinlst = false
		    break;
		}
	    }
	    if(notinlst)
	        newlst.push(tsmdc_cols[i]);
	}
	tsmdc_cols = newlst;
    }
    generateTrackselectionGrid(getSelectValueById("trackchoicemdr1"), getSelectValueById("trackchoicemdr2"));
}
function tracksetTwonumbers(tkset) {
    // takes in a hash of track names
    // return a list [total number, number displayed now]
    var numall = 0; // # tracks in tkset
    var numinuse = 0; // # tracks in tkset in display
    for(var tk in tkset) {
        numall++;
	if(trackInDisplay(tk)) numinuse++;
    }
    return [numall, numinuse];
}
function trackselectionoption_onecriteria(what) {
    // use when only one criterion is used to determine track selection layout
    // return string for one metadata term, which is one <li>
    var isLeaf = what in mdvidx2attr;
    // count tracks annotated to this term
    var tkset = {};
    recursivegettrack(what, tkset);
    var num = tracksetTwonumbers(tkset);
    if(isLeaf)
        return '<li>'+mdvidx2attr[what]+' '+
	       maketrackselectioncell_onecriteria(what, num[0], num[1]) +'</li>';
    else
        return '<li><span class=clb onclick=toggle32(event) term="'+what+'"'+
	       ' title="click to show/hide details"><span style="color:#00289e;">&#8862;</span> '+what+'</span> '+
	       maketrackselectioncell_onecriteria(what, num[0], num[1]) +'</li>' +
	       '<ul id="'+what+'ul" style="display:none;"></ul>';
}
function tksNumbercellMouseover(attr1, attr2) {
    // attr1 is horizontal, attr2 is vertical, change style of their corresponding <td>
    var t = document.getElementById(attr1+"td");
    t.style.backgroundColor = "white";
    t.style.borderBottomColor = "#009e00";
    t = document.getElementById(attr2+"td");
    t.style.backgroundColor = "white";
    t.style.borderRightColor = "#009e00";
}
function tksNumbercellMouseout(attr1, attr2) {
    // attr1 is horizontal, attr2 is vertical, change style of their corresponding <td>
    var t = document.getElementById(attr1+"td");
    t.style.backgroundColor = "transparent";
    t.style.borderBottomColor = "transparent";
    t = document.getElementById(attr2+"td");
    t.style.backgroundColor = "transparent";
    t.style.borderRightColor = "transparent";
}
function tksverticalmouseover(event) {
    // to prevent multiple calls of mouseover events in <td> by image...
    //if(tksSmallmenu.style.display == "block" && tksSmallmenu.attr==event.target.name)
    //    return;
    var t = document.getElementById(event.target.name+"td");
    t.style.backgroundColor = "white";
    t.style.borderRight = "dashed 1px #009e00";
    tksSmallmenu.style.display = "block";
    var p = absolutePosition(t);
    tksSmallmenu.style.left = p[0];
    tksSmallmenu.style.top = p[1]+t.clientHeight-5;
    tksSmallmenu.attr = event.target.name;
}
function tksverticalmouseout(event) {
    var t = document.getElementById(event.target.name+"td");
    t.style.backgroundColor = "transparent";
    t.style.borderRight = "dashed 1px transparent";
    tksSmallmenu.style.display = "none";
}
function tkshorizontalmouseover(event) {
    if(tksSmallmenu.style.display == "block" && tksSmallmenu.attr==event.target.name)
        return;
    var t = document.getElementById(event.target.name+"td");
    t.style.backgroundColor = "white";
    t.style.borderBottom = "dashed 1px #009e00";
    tksSmallmenu.style.display = "block";
    var p = absolutePosition(t);
    tksSmallmenu.style.left = p[0] + t.clientWidth-5;
    tksSmallmenu.style.top = p[1];
    tksSmallmenu.attr = event.target.name;
}
function tkshorizontalmouseout(event) {
    var t = document.getElementById(event.target.name+"td");
    t.style.backgroundColor = "transparent";
    t.style.borderBottom = "dashed 1px transparent";
    tksSmallmenu.style.display = "none";
}
function tksNonclickablehorizontalmouseover(event) {
    // mouse over leaf term <td> that are not clickable
    var td;
    if(event.target.tagName != "TD")
        td = document.getElementById(event.target.name+"td");
    else
        td = event.target;
    td.style.backgroundColor = "white";
    tksSmallmenu.style.display = "block";
    var p = absolutePosition(td);
    tksSmallmenu.style.left = p[0] + td.clientWidth-5;
    tksSmallmenu.style.top = p[1];
    tksSmallmenu.attr = td.name;
}
function tksNonclickableverticalmouseover(event) {
    // mouse over leaf term <td>
    var td;
    if(event.target.tagName != "TD")
        td = document.getElementById(event.target.name+"td");
    else
        td = event.target;
    td.style.backgroundColor = "white";
    tksSmallmenu.style.display = "block";
    var p = absolutePosition(td);
    tksSmallmenu.style.left = p[0];
    tksSmallmenu.style.top = p[1] + td.clientHeight-5;;
    tksSmallmenu.attr = td.name;
}
function tksNonclickablemouseout(event) {
    // mouse out leaf term <td>
    if(event.target.tagName == "TD")
        event.target.style.backgroundColor = "transparent";
    else
        document.getElementById(event.target.name+"td").style.backgroundColor = "transparent";
    tksSmallmenu.style.display = "none";
}
function selectalltrack_oneattr() {
    // called by clicking tksSmallmenu choice, 
    // to select all tracks annotated by the attribute attached to the menu
    var s = {};
    recursivegettrack(tksSmallmenu.attr, s);
    tksSmallmenu.style.display = "none";
    var newlst = [];
    for(var n in s) {
        if(findTrackByName(n) == null)
	    newlst.push(n);
    }
    ajaxAddnewserverbigwig(newlst);
}
function unselectalltrack_oneattr() {
    var s = {};
    recursivegettrack(tksSmallmenu.attr, s);
    tksSmallmenu.style.display = "none";
    for(var n in s) {
        for(var i=0; i<tkLst.length; i++) {
	    if(tkLst[i].name == n)
	        removeBigwigTrack(i);
        }
    }
    generateTrackselectionLayout();
    stuffTrackCanvas2holder();
}

/* actions on track selection grid row/column headers */
function tksGridHovalClick() {
    /* called by clicking on horizontal oval button spanning over all vertical term names in track selection grid
       will expand/collapse all columns
     */
    var hasExpanded = false;
    for(var i=0; i<tsmdc_cols.length; i++) {
        if(tsmdc_cols[i][1] > 0) {
	    hasExpanded = true;
	    break;
        }
    }
    if(hasExpanded) {
        // collapse those that are not
	var tmp = [];
        for(var i=0; i<tsmdc_cols.length; i++) {
            if(tsmdc_cols[i][1] == 0) {
	        tsmdc_cols[i][2] = "images/plus.png";
	        tmp.push(tsmdc_cols[i]);
	    }
	}
	tsmdc_cols = tmp;
        generateTrackselectionGrid(getSelectValueById("trackchoicemdr1"), getSelectValueById("trackchoicemdr2"));
	return;
    }
    // none has been expanded, expand them all
    var tmp = []; // must make temp array of term names, or else client will explode
    for(var i=0; i<tsmdc_cols.length; i++)
        tmp.push(tsmdc_cols[i][0]);
    for(i=0; i<tmp.length; i++) {
	var e = document.createEvent("MouseEvents");
        e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	document.getElementById(tmp[i]+"td").dispatchEvent(e);
    }
}
function tksGridVovalClick() {
    /* called by clicking vertical oval button over all horizontal terms in track selection grid
       will expand/collapse all rows
     */
    var hasExpanded = false;
    for(var i=0; i<tsmdc_rows.length; i++) {
        if(tsmdc_rows[i][1] > 0) {
	    hasExpanded = true;
	    break;
        }
    }
    if(hasExpanded) {
	var tmp = [];
        for(var i=0; i<tsmdc_rows.length; i++) {
            if(tsmdc_rows[i][1] == 0) {
	        tsmdc_rows[i][2] = "images/plus.png";
	        tmp.push(tsmdc_rows[i]);
	    }
	}
	tsmdc_rows = tmp;
        generateTrackselectionGrid(getSelectValueById("trackchoicemdr1"), getSelectValueById("trackchoicemdr2"));
	return;
    }
    var tmp = [];
    for(var i=0; i<tsmdc_rows.length; i++)
        tmp.push(tsmdc_rows[i][0]);
    for(i=0; i<tmp.length; i++) {
	var e = document.createEvent("MouseEvents");
        e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	document.getElementById(tmp[i]+"td").dispatchEvent(e);
    }
}
function generateTrackselectionGrid(v1, v2) {
    /* for two criteria case
       make grid for track selection, each cell corresponds to metadata categories
       rerun when criteria changed
     */

    // for childrens of v1/v2, recursively make set of tracks
    var attr2tkset = {};
    // key: attr, val: set of track
    for(var i=0; i<tsmdc_rows.length; i++) {
        // skip expanded parent term
	if(tsmdc_rows[i][2] == 'images/minus.png')
	    continue;
        var s = {};
	recursivegettrack(tsmdc_rows[i][0], s);
	attr2tkset[tsmdc_rows[i][0]] = s;
    }
    for(i=0; i<tsmdc_cols.length; i++) {
	if(tsmdc_cols[i][2] == 'images/minus.png')
	    continue;
        var s = {};
	recursivegettrack(tsmdc_cols[i][0], s);
	attr2tkset[tsmdc_cols[i][0]] = s;
    }

    var table = document.getElementById("tkslayout2");
    stripChild(table, 0);

    /** first row **/
    var tr = document.createElement("tr");
    var td = document.createElement("td");
    tr.appendChild(td);
    td = document.createElement("td");
    tr.appendChild(td);
    td = document.createElement("td");
    td.colSpan = tsmdc_cols.length;
    td.innerHTML = v2;
    td.className = 'tksgridhoval';
    td.addEventListener("click", tksGridHovalClick, false);
    td.title = "click to expand/collapse";
    tr.appendChild(td);
    table.appendChild(tr);
    /** second row **/
    tr = document.createElement("tr");
    td = document.createElement("td");
    td.colSpan = 2;
    td.vAlign = "top";
    td.align = "left";
    tr.appendChild(td);
    // one cell for each attribute in tsmdc_cols, vertical canvas
    for(var i=0; i<tsmdc_cols.length; i++) {
        var what = tsmdc_cols[i][0];
        td = document.createElement("td");
	td.style.paddingTop = tsmdc_cols[i][1];
	td.vAlign = "top";
	td.id = what+"td"; // to identify this cell when mouse over on number <div>
	td.name = what; // for "select all" function

        if(what in mdvidx2attr) {
	    // is leaf
	    td.style.paddingTop = tsmdc_cols[i][1] + 17;
	    td.style.borderRight = "dashed 1px transparent";
	    td.addEventListener("mouseover", tksNonclickableverticalmouseover, false);
	    td.addEventListener("mouseout", tksNonclickablemouseout, false);
        } else {
	    // not leaf
	    var img = document.createElement("img");
	    img.src = tsmdc_cols[i][2];
	    img.name = what;
	    img.style.margin = 3;
	    img.style.display = "block";
	    td.appendChild(img);
	    td.className = "clbv";
	    td.addEventListener("mouseover", tksverticalmouseover, false);
	    td.addEventListener("mouseout", tksverticalmouseout, false);
            td.addEventListener("click", showhide_trackselection_twocriteria_vertical, false);
        }
        var c = makecanvas_verticalstring((what in mdvidx2attr) ? mdvidx2attr[what] : what, false);
        c.name = what; // for click event
	td.appendChild(c);
	tr.appendChild(td);
    }
    table.appendChild(tr);
    /** remaining rows, one for each attribute in tsmdc_rows
     **/
    tr = document.createElement("tr");
    td = document.createElement("td");
    td.rowSpan = tsmdc_rows.length;
    td.className = 'tksgridvoval';
    td.vAlign = "middle";
    td.appendChild(makecanvas_verticalstring(v1, false));
    td.addEventListener("click", tksGridVovalClick, false);
    td.title = "click to expand/collapse";
    tr.appendChild(td);
    for(i=0; i<tsmdc_rows.length; i++) {
        // make first cell, the row header
        var what = tsmdc_rows[i][0];
        if(i != 0)
	    tr = document.createElement("tr");
	td = document.createElement("td");
	td.id = what+"td";
	td.style.paddingLeft = tsmdc_rows[i][1];
	td.name = what; // for "select all tracks" function
	if(what in mdvidx2attr) {
	    // is leaf
	    td.style.paddingLeft = tsmdc_rows[i][1] + 17;
	    td.style.borderBottom = "dashed 1px transparent";
	    td.addEventListener("mouseover", tksNonclickablehorizontalmouseover, false);
	    td.addEventListener("mouseout", tksNonclickablemouseout, false);
	} else {
	    // not leaf
	    var img = document.createElement("img");
	    img.src = tsmdc_rows[i][2];
	    img.name = what;
	    img.style.margin = 3;
	    td.appendChild(img);
	    td.className = "clb";
	    td.addEventListener("mouseover", tkshorizontalmouseover, false);
	    td.addEventListener("mouseout", tkshorizontalmouseout, false);
            td.addEventListener("click", showhide_trackselection_twocriteria_horizontal, false);
	}
	var s = document.createElement("span");
	s.innerHTML = (what in mdvidx2attr) ? mdvidx2attr[what] : what;
	s.name = what; // for click event
	td.appendChild(s);
	tr.appendChild(td);
	// make remaining cells, track number selector
	for(var j=0; j<tsmdc_cols.length; j++) {
	    td = document.createElement("td");
	    var what2 = tsmdc_cols[j][0];

	    if(what in attr2tkset && what2 in attr2tkset) {

	    var intersection = {};
	    for(var tk in attr2tkset[what]) {
	        if(tk in attr2tkset[what2])
		    intersection[tk] = 1;
	    }
	    var num = tracksetTwonumbers(intersection);
	    if(num[0] == 0) {
	        td.innerHTML = '<span style="color:#ccc;">none</span>';
	    } else {
	        td.innerHTML = '<div class=tscell'+
                    ' style="display:inline-block;"'+
	            ' onclick="showtrackchoice(\''+what+'\',\''+what2+'\')"'+
	            ' onmouseover="tksNumbercellMouseover(\''+what+'\',\''+what2+'\')"'+
	            ' onmouseout="tksNumbercellMouseout(\''+what+'\',\''+what2+'\')"'+
	            ' title="click to show tracks"'+
	            '><span class=g>'+ num[0] + '</span>' +
	            ((num[1]==0) ? '/0' : '/<span class=r>'+num[1]+'</span>') +
	            '</div>';
            }
	    
	    }
	    tr.appendChild(td);
	}
	table.appendChild(tr);
    }
}
function generateTrackselectionLayout() {
    /* called upon:
       - initiation
       - pushing button generatehmtksgridbutt
     */
    document.getElementById('generatehmtksgridbutt').style.display = 'none';

    var v1 = getSelectValueById("trackchoicemdr1"); // criteria 1
    var v2 = getSelectValueById("trackchoicemdr2"); // criteria 2
    if(v2 == 'no') {
        // only one criterion applies, make a text tree
	document.getElementById("tkslayout2").style.display = "none";
        var holder = document.getElementById("tkslayout1");
	holder.style.display = "block";
	var lst = [];
	for(var i=0; i<mdvp2c[v1].length; i++)
	    lst.push(trackselectionoption_onecriteria(mdvp2c[v1][i]));
	holder.innerHTML = "<ul>"+lst.join('')+"</ul>";
        document.getElementById("trackselectiontablewrapper").style.display = "none";
	return;
    }
    // two criteria
    document.getElementById("tkslayout1").style.display = "none";
    document.getElementById("tkslayout2").style.display = "block";
    tsmdc_rows = [];
    tsmdc_cols = [];
    for(var i=0; i<mdvp2c[v1].length; i++)
        tsmdc_rows.push([mdvp2c[v1][i], 0, 'images/plus.png']);
    for(i=0; i<mdvp2c[v2].length; i++)
        tsmdc_cols.push([mdvp2c[v2][i], 0, 'images/plus.png']);
    generateTrackselectionGrid(v1, v2);

    /* expand table to show one more level
       but it is disabled because it slows down response (the grid is too big)
    for(i=0; i<mdvp2c[v1].length; i++) {
        var t = mdvp2c[v1][i];
	if(t in mdvp2c) {
	    var e = document.createEvent("MouseEvents");
	    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	    document.getElementById(t+"td").dispatchEvent(e);
	}
    }
    for(i=0; i<mdvp2c[v2].length; i++) {
        var t = mdvp2c[v2][i];
	if(t in mdvp2c) {
	    var e = document.createEvent("MouseEvents");
	    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	    document.getElementById(t+"td").dispatchEvent(e);
	}
    }
    */

}
function showtrackchoice() {
    // variable argument, can be 1 or 2 metadata attributes
    // select tracks annotated by them, and stuff them into floating toolbox for user to check out
    if(arguments[0] == undefined) return;
    var tkset1 = {};
    recursivegettrack(arguments[0], tkset1);
    if(arguments[1] != undefined) {
        // second attribute
	var tkset2 = {};
	recursivegettrack(arguments[1], tkset2);
	var intersection = {};
	for(var tk in tkset1) {
	    if(tk in tkset2)
	        intersection[tk] = 1;
	}
	tkset1 = intersection;
    }
    tkselectionlst = []; // global variable...
    for(var tk in tkset1) 
        tkselectionlst.push(tk);
    if(tkselectionlst.length == 0) 
        return;
    // make <tr> for these tracks and put into trackselectiontable
    // todo use .insertCell .insertRow dude!!
    var holder = document.getElementById("trackselectiontable");
    stripChild(holder, 0);
    var w = document.getElementById("trackselectiontablescrollholder");
    if(tkselectionlst.length <= 8) {
        w.style.height = "auto";
	w.style.overflowY = "auto";
    } else {
        w.style.height = "170px";
	w.style.overflowY = "scroll";
    }
    var notrackonshow = true;
    for(var i=0; i<tkselectionlst.length; i++) {
        var tkn = tkselectionlst[i];
        var tr = document.createElement("tr");
	var td = document.createElement("td");
	td.style.fontSize = "12px";
	if(trackInDisplay(tkn)) {
	    notrackonshow = false;
	    td.innerHTML = "<div title="+tkn+" style='display:inline-block;margin-left:3px;margin-right:3px;'><span class=clb onclick=removeBigwigTrack_iconchange(event) title='remove this track from display' style='color:#e60000;font-size:16px;'>&#10005;</span></div> <label for="+tkn+" onmouseover=\"highlighttrack('"+tkn+"', 1);\" onmouseout=\"indicator.style.display='none';\">"+hmtk.tolabel[tkn]+"</label>";
	} else {
	    td.innerHTML = makeTrackCheckboxHtml(tkn);
	}
	tr.appendChild(td);
	td = document.createElement("td");
	td.style.fontSize = "12px";
	/** here track filetype is hardcoded to be 2 for bev 
	    TODO allow for more file types for heatmap tracks
	 **/
	td.innerHTML = "<span style=\"cursor:pointer;padding-left:5px;padding-right:5px;\" onclick=getOnetrackdetails(\""+tkn+"\") title='information'>&#9432;</span>";
	tr.appendChild(td);
	holder.appendChild(tr);
    }
    document.getElementById("trackselectiontablewrapper").style.display = "block";
    document.getElementById("trackselectionRemoveallbutton").disabled = false;
}
function trackselectionSelectall() {
    // <tr><td><checkbox> ...
    var c = document.getElementById("trackselectiontable");
    for(var i=0; i<c.childNodes.length; i++) {
        var what = c.childNodes[i].firstChild.firstChild;
	// what could be checkbox or div
	if(what.tagName == "INPUT") {
	    what.checked = true;
	    track2addAddRemoverow(what.id, true);
	}
    }
}
function trackselectionClear() {
    var c = document.getElementById("trackselectiontable");
    for(var i=0; i<c.childNodes.length; i++) {
        var what = c.childNodes[i].firstChild.firstChild;
	if(what.tagName == "INPUT") {
	    what.checked = false;
	    track2addAddRemoverow(what.id, false);
	}
    }
}
function trackselectionCancel() {
    stripChild(document.getElementById("trackselectiontable"), 0);
    document.getElementById("trackselectiontablewrapper").style.display = "none";
    tkselectionlst = [];
}
function trackselectionRemoveall() {
    /* called by clicking "Remove all" button
       to remove all displayed tracks from track selection panel in floatingtoolbox
     */
    var c = document.getElementById("trackselectiontable");
    for(var i=0; i<c.childNodes.length; i++) {
        var td = c.childNodes[i].firstChild; // <td>
        var what = td.firstChild;
	if(what.tagName == "DIV") {
	    // remove this guy
	    var tkn = what.title;
	    removeBigwigTrack(getTkidxByname(tkn));
	    td.innerHTML = makeTrackCheckboxHtml(tkn);
	}
    }
    updateAfterRemovetrack();
    document.getElementById("trackselectionRemoveallbutton").disabled = true;
}




/**************************
     DECOR related
 **************************/
function decoruserlist_insert(decorname) {
    // try to insert a row in decor user list table
    var table = document.getElementById('decoruserlist');
    var lst = table.firstChild.childNodes;
    var found = false;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('tkname') == decorname) {
	    found = true;
	    break;
	}
    }
    if(found) {return;}
    var tr = table.insertRow(-1);
    tr.setAttribute('tkname', decorname);
    var td = tr.insertCell(0);
    td.innerHTML = decorInfo[decorname].label;
    td = tr.insertCell(-1); 
    td.style.color = '#ccc';
    var ft = decorInfo[decorname].fileType;
    if(ft==1 || ft==5) {
        td.innerHTML = 'custom';
    }
    td = tr.insertCell(-1);
    td.style.color = '#ccc';
    if(ft==0 || ft==1) {
        td.innerHTML = 'bigBed';
    } else if(ft == 8) {
        // ASSume decor bigwig can only be 8
        td.innerHTML = 'bigWig';
    } else if(ft==4 || ft==5) {
        td.innerHTML = 'BAM';
    } else {
        fatalError('decoruserlist_insert: unknown decor filetype '+ft);
    }

    td = tr.insertCell(-1);
    var s = makeSelect4decor(decorname);
    td.appendChild(s);
    decorInfo[decorname].selectdom = s;
    td = tr.insertCell(-1);
    td.innerHTML = '<span style="color:#FF6666;font-weight:bold;cursor:pointer;" onclick="decoruserlist_remove(\''+decorname+'\')">&#10005;</span>';
}
function decoruserlist_remove(decorname) {
    // try to remove an decor entry from registry, need to turn off if it is on
    if(decorInfo[decorname].mode != 'hide') {
        decorInfo[decorname].mode = 'hide';
	removeDecorCanvas(decorname);
    }
    var lst = document.getElementById('decoruserlist').firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('tkname') == decorname) {
	    lst[i].parentNode.removeChild(lst[i]);
	    break;
	}
    }
    /* ?? if it is custom bam, need to remove its record in decorInfo
    if(decorInfo[decorname].fileType == 5)
        delete decorInfo[decorname];
    */
}
function decorselectMover(event) {this.parentNode.parentNode.firstChild.style.backgroundColor="#DECED8";}
function decorselectMout(event) {this.parentNode.parentNode.firstChild.style.backgroundColor="transparent";}
function makeSelect4decor(decorname) {
    // make <select> for decor track by its file type
    if(!(decorname in decorInfo))
        fatalError("makeSelect4decor: unknown decor name "+decorname);
    var s = document.createElement("select");
    s.tkname = decorname;
    s.title = "change display mode";
    s.addEventListener("change", cgiDrawDecorSelect, false);
    s.addEventListener('mouseover', decorselectMover, false);
    s.addEventListener('mouseout', decorselectMout, false);
    var o = document.createElement("option");
    o.value = "hide";
    o.selected = true;
    o.text = 'hide';
    s.add(o);
    var ft = decorInfo[decorname].fileType;
    if(ft==0 || ft==1 || ft==4 || ft==5) {
        // bigbed or bam
	o = document.createElement("option"); 
	o.text = 'thin';
	o.value='thin'; s.add(o);
	o = document.createElement("option"); o.text="full"; o.value="full"; s.add(o);
	o = document.createElement("option"); 
	o.text = 'density';
	o.value='density'; s.add(o);
    } else if(ft == 8) {
        // ASSume bigwig decor can only be 8
	o = document.createElement("option"); o.value = "show"; 
	o.text = 'show';
	s.add(o);
    } else {
        fatalError("wrong file type for decor "+decorname);
    }
    changeSelectByValue(s, decorInfo[decorname].mode);
    return s;
}






function mergeStackdecor(sink, source, fileType) {
    /* if is BAM file:
         merge sink/source reads that have same id (make them a paired end)
       else, if source item also exists in sink (tell by item id), skip
       else, push it into sink

       args:
       - sink: array of bed items of "sink" region
       - source: array of bed items of "source" region

       ** beware **
       if move left, need to shift sink box start using move.offsetShift
       if move right, need to shift source box start using sink region length
     */

    if(move.direction!='l' && move.direction!='r')
        fatalError("mergeStackdecor: move direction error");

    if(move.direction == 'l') {
        // shift sink
        for(var i=0; i<sink.length; i++)
	    sink[i][0] += move.offsetShift;
    } else {
        // shift source
	for(var i=0; i<source.length; i++)
	    source[i][0] += move.offsetShift;
    }

    // make lookup table for items in sink
    var lookup = {}; // key: item id, val: item array
    for(var i=0; i<sink.length; i++)
        lookup[sink[i][2]] = sink[i];

    for(var i=0; i<source.length; i++) {
	if(source[i][2] in lookup) {
	    if(fileType==4 || fileType==5) {
		if(source[i][12]) {
		    // merge source read into sink as its mate
	            var sourceitem = source[i];
		    var sinkitem = lookup[sourceitem[2]];
		    if(sourceitem[13]!=undefined && sourceitem[14]!=undefined)
		        continue; // mate already there, do nothing
	            if(move.direction == 'l') {
		        // moving to left, source should be read1
			sinkitem[14] = [sinkitem[13][0], sinkitem[13][1]];
			sinkitem[13] = [sourceitem[8], sourceitem[9]];
			sinkitem[8] = sourceitem[8];
			sinkitem[9] = sinkitem[14][1]; // necessary?
		    } else {
		        // moving to right, source should be read2
			sinkitem[14] = [sourceitem[8], sourceitem[9]];
			sinkitem[9] = sourceitem[9];
			sinkitem[8] = sinkitem[13][0]; // necessary?
		    }
		    sinkitem[11] = sinkitem[11].concat(sourceitem[11]);
		    sinkitem[12] = true;
		}
	    }
	} else {
	    sink.push(source[i]);
	}
    }
}
function jsonDecor(data) {
    /* if not under move...
       if under move...
     */
    if(!("decorData" in data))
        return;

    var dat = data.decorData;
    for(var i=0; i<dat.length; i++) {
        var lst = dat[i];
	var decorname = lst[0];
	var filetype = lst[1];
	var customlabel = lst[2];
	var url = lst[3];
	var mode = lst[4];
	var decordata = lst[5];

	if(mode=='density' || mode=='show') {

	    if(move.direction == null) {
	        if(decorname in decorCanvasHash)
		    decorCanvasHash[decorname].data = decordata;
		else
	            makeNewDecorCanvas(decorname, decordata, mode, filetype, url, 0, customlabel);
	    } else {
	        if(!(decorname in decorCanvasHash)) 
		    fatalError("jsonDecor: "+decorname+" not in decorCanvasHash");
	        if(move.direction == 'l') {
		    if(move.merge) {
		        var lastr = decordata[decordata.length-1];
		        decorCanvasHash[decorname].data[0] = lastr.concat(decorCanvasHash[decorname].data[0]);
		        decordata.pop();
		    }
	            decorCanvasHash[decorname].data = decordata.concat(decorCanvasHash[decorname].data);
	        } else {
		    if(move.merge) {
		        decorCanvasHash[decorname].data[decorCanvasHash[decorname].data.length-1] = decorCanvasHash[decorname].data[decorCanvasHash[decorname].data.length-1].concat(decordata[0]);
		        decordata.shift();
		    }
 		    decorCanvasHash[decorname].data = decorCanvasHash[decorname].data.concat(decordata);
	        }
	    }
	    decorInfo[decorname].mode = mode;

	    if('qtc' in data) {
	        // restoring session, need to restore decor qtc
		qtc_paramCopy(data.qtc.decor[decorname],decorCanvasHash[decorname].qtc);
	    }

	    drawDensityDecorCanvas(decorname);

        } else if(mode=='thin' || mode=='full') {

	    if(move.direction == null) {
	        if(!(decorname in decorCanvasHash)) {
	            makeNewDecorCanvas(decorname, decordata, mode, filetype, url, 0, customlabel);
		} else {
		    decorCanvasHash[decorname].data = decordata;
		}
	    } else {
	        if(!(decorname in decorCanvasHash)) fatalError("jsonDecor: "+decorname+" not in decorCanvasHash");
	        if(move.direction == 'l') {
		    if(move.merge) {
		        mergeStackdecor(decorCanvasHash[decorname].data[0], decordata[decordata.length-1], filetype);
		        decordata.pop();
		    }
		    decorCanvasHash[decorname].data = decordata.concat(decorCanvasHash[decorname].data);
	        } else {
		    if(move.merge) {
		        mergeStackdecor(decorCanvasHash[decorname].data[decorCanvasHash[decorname].data.length-1], decordata[0], filetype);
		        decordata.shift();
		    }
		    decorCanvasHash[decorname].data = decorCanvasHash[decorname].data.concat(decordata);
	        }
	        decorCanvasHash[decorname].skipped = 0; // TODO
	    }
	    decorInfo[decorname].mode = mode;
	    if('qtc' in data) {
	        // restoring session, need to restore decor qtc
		qtc_paramCopy(data.qtc.decor[decorname],decorCanvasHash[decorname].qtc);
	    }
	    drawStackDecorCanvas(decorname);

        } else {
	    fatalError("jsonDecor: unknown display mode "+decorname+' '+mode);
	}
    }
    for(decorname in decorCanvasHash)
        decorCanvasHash[decorname].canvas.style.left = move.styleLeft;
}
function removeDecorCanvas(gf) {
    if(gf in decorCanvasHash) {
	document.getElementById('tgt_decorCanvas').removeChild(decorCanvasHash[gf].viewbox);
	document.getElementById('tgt_decorCanvasHeader').removeChild(decorCanvasHash[gf].header);
	delete decorCanvasHash[gf];
    }
}
function drawDecorCanvas(gf) {
    var m = decorInfo[gf].mode;
    if(m == 'density')
        drawDensityDecorCanvas(gf);
    else if(m == 'show')
        drawDensityDecorCanvas(gf);
    else if(m=='thin' || m=='full')
        drawStackDecorCanvas(gf);
    else
         fatalError("drawDecorCanvas: illegal mode '"+m+"' for "+gf);
}
function drawDecorHeadercanvas(decorname) {
    /* isolates decor header canvas drawing code from main decor canvas drawing
       for purpose of changing leftColumnWidth

       if in stack mode: 
         only draw decor name
	 but has to set canvas height before calling this
       if in show/density mode:
         will also draw vertical scale
     */
    var mode = decorInfo[decorname].mode;
    var isNumerical = mode=="density" || mode=="show";
    var obj = decorCanvasHash[decorname];

    obj.header.width = leftColumnWidth;
    var ctx = obj.header.getContext('2d'); // for header
    //ctx.clearRect(0, 0, leftColumnWidth, ordinaryTrackHeight);
    ctx.font = "bold 8pt Sans-serif";
    ctx.fillStyle = colorCentral.foreground;
    ctx.fillText(decorInfo[decorname].label, 1, isNumerical ? 20 : 10);

    if(!isNumerical)
        return;
    if(obj.qtc.uselog) {
        if(obj.qtc.logtype == 1) {
	    ctx.fillText("(log2 scale)", 1, 36);
	} else if(obj.qtc.logtype==2) {
	    ctx.fillText("(logE scale)", 1, 36);
	} else {
	    ctx.fillText("(log10 scale)", 1, 36);
	}
    } else {
        ctx.fillText("(linear scale)", 1, 36);
    }
    drawVerticalAxis(obj.qtc,obj.header,obj.maxv,obj.minv, true, 'black');
}
function drawDensityDecorCanvas(gf) {
    /* plot quantitative data, deals with feature density or numerical
       but applies different treatment for the two types:

       if is feature density data:
           all values are expected to be positive
	   user can choose which direction bars point to (up/down)
       if is numerical data:
           allows positive/negative values, point to up/down
	   allows configuring bar color separately

       header canvas must be replotted as max number will be changed
     */
    if(!(gf in decorCanvasHash)) 
        fatalError("drawDensityDecorCanvas: "+gf+' not in decorCanvasHash');
    print2console("drawing "+decorInfo[gf].label+" track...", 0);

    var canvas = decorCanvasHash[gf].canvas;
    var thisqtc = decorCanvasHash[gf].qtc;
    canvas.width = entire.spnum;
    canvas.height = thisqtc.height + densitydecorpaddingtop*2;
    decorCanvasHash[gf].header.height = canvas.height;
    decorCanvasHash[gf].viewbox.style.height = canvas.height;
    canvas.style.left = move.styleLeft;
    var data = decorCanvasHash[gf].data;
    var spacing = 4;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;

    // bigbed density .uselog should always be false
    if(thisqtc.uselog) {
        var logdata = qtrack_logtransform(data, thisqtc);
        var thvalues = qtrack_getthreshold(logdata, thisqtc);
        qtrack_plotwiggle(logdata, canvas.getContext("2d"), thisqtc, thvalues[0], thvalues[1], unitwidth);
    } else {
        var thvalues = qtrack_getthreshold(data, thisqtc);
        qtrack_plotwiggle(data, canvas.getContext("2d"), thisqtc, thvalues[0], thvalues[1], unitwidth);
    }
    decorCanvasHash[gf].maxv = thvalues[0];
    decorCanvasHash[gf].minv = thvalues[1];
    drawDecorHeadercanvas(gf);

    print2console(" done", 0, false);
}

function gfSort(a,b) {
    /* for genomic feature items in decor drawing
       item boxstart/boxwidth could be undefined
     */
    if(a[0] == undefined) {
        if(b[0] == undefined)
	    return 0;
	else
	    return -1;
    }
    if(b[0] == undefined)
        return 1;
    if(a[0] != b[0]) {
        return a[0]-b[0];
    } else if(a[1] != b[1]) {
        return b[1]-a[1];
    }
    return 0;
}
function numSort(a,b) {
    return a-b;
}
function countMaxstackUnderView(data) {
    // cout max stack number for items within viewbox
    var maxStack = 0;
    for(var i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
        var start, stop; // coordinate of current region
	if(entire.atbplevel) {
	    start = (i==dspBoundary.vstartr) ? dspBoundary.vstarts+regionLst[i][3] : regionLst[i][3];
	    stop = (i==dspBoundary.vstopr) ? dspBoundary.vstops+regionLst[i][3] : regionLst[i][4];
	} else {
	    start = (i==dspBoundary.vstartr) ? getPointCoord(i,dspBoundary.vstarts) : regionLst[i][3];
	    stop = (i==dspBoundary.vstopr) ? getPointCoord(i,dspBoundary.vstops) : regionLst[i][4];
	}
        for(var j=0; j<data[i].length; j++) {
	    if(data[i][j][5] == undefined) continue;
            var item = data[i][j];
	    if(Math.max(item[8], start) < Math.min(item[9], stop)) {
	        if(maxStack < item[5]) 
		    maxStack = item[5];
	    }
	}
    }
    return maxStack;
}

function plotBAMmismatch(ctx, item, y, stackh, isThin, miscolor) {
    /* args:
       - ctx: canvas plotting handle
       - item: the item array holding the read(pair)
       - y: y offset
       - stackh: stack height
       - isThin: boolean
       - miscolor: mismatch line/letter color
     */
    if(item[11].length == 0)
        return;
    var sf = item[1] / (item[9]-item[8]); // plot width of each basepair
    // don't plot if read plotting length is shorter than 10px
    if(item[12]) {
        if((item[13][0]-item[8])*sf < 10)
	    return;
    } else {
        if(item[1] < 10)
	    return;
    }
    var plotlineonly = isThin ? true : (sf < 8);
    ctx.fillStyle = miscolor;
    ctx.font = "bold 8pt Sans-serif"
    // plot mismatches, no matter if it is paired or single
    for(var i=0; i<item[11].length; i+=2) {
        var x = (item[11][i]-item[8])*sf+item[0];
	if(plotlineonly)
	    ctx.fillRect(x,y, (sf<1)?1:sf, stackh);
	else
	    ctx.fillText(item[11][i+1], x+1, y+8);
    }
}

function drawStackDecorCanvas(gf) {
    /* steps:
       - compute box start/width for each item using genomic coord of item and region
       - sort items
       - stack items
       - plot those stacked
         - separate treatment for BAM and bigBed files

       superimpose gene structure on genebody
       gene name will always be outside of box
       after stacking is done, run ajax to fetch all gene structure data for
       all genes between left/right wings
       and impose them onto viewbox
       
       about name/strand:
       first try fitting name+strand into box
       else, if enough width on left of box, plot name
       else, don't plot name
     */
    if(!(gf in decorCanvasHash)) 
        fatalError("drawStackDecorCanvas: "+gf+" not in decorCanvasHash");
    if(!(gf in decorInfo)) 
        fatalError("drawStackDecorCanvas: "+gf+" not in decorInfo");
    switch (decorInfo[gf].fileType) {
        case 0:
            print2console("drawing "+decorInfo[gf].label+" track...", 0);
	    break;
	case 1:
            print2console("drawing custom bigBed track...", 0);
	    break;
	case 4:
            print2console("drawing server BAM track...", 0);
	    break;
	case 5:
            print2console("drawing custom BAM track...", 0);
	    break;
	default:
	    fatalError("drawStackDecorCanvas: unknown decor file type");
    }


    // item array index
    var id_boxstart=0, id_boxwidth=1, id_id=2, 
        id_name=3, id_strand=4, id_stackid=5,
        id_stackstart=6, id_stackwidth=7, id_startcoord=8, 
	id_stopcoord=9, id_namewidth=10,
	id_mismatches=11, id_isPaired=12, id_r1coord=13, id_r2coord=14,
	id_name2=15;

    var xoffset = dspBoundary.lwrlpx;

    /*** convert item coord into box start/width 
         only do for items within lws and rws
	 those fit in will have valid id_boxstart/id_boxwidth computed,
	 else they will be left undefined
	 serve as a way to quickly tell if to process this item later
     ***/
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var r = regionLst[i];

	/* curb by coord of current region
	   NO CURB
	var start, stop;
	if(entire.atbplevel) {
            start = (i==dspBoundary.lwr) ? dspBoundary.lws+r[3] : r[3];
	    stop = (i==dspBoundary.rwr) ? dspBoundary.rws+r[3] : r[4];
	} else {
	    start = (i==dspBoundary.lwr) ? getPointCoord(i, dspBoundary.lws) : r[3];
	    stop = (i==dspBoundary.rwr) ? getPointCoord(i, dspBoundary.rws) : r[4];
	}
	*/

        var rstart = r[3];
	var rstop = r[4];
        var data = decorCanvasHash[gf].data[i];
	for(var j=0; j<data.length; j++) {
	    var item = data[j];
	    item[id_stackid] = undefined; // by default
	    /*
	    if(Math.max(item[id_startcoord], start) >= Math.min(item[id_stopcoord], stop)) {
	        // won't deal with this item
		item[id_boxstart] = undefined;
		item[id_boxwidth] = undefined;
		continue;
	    }
	    */
	    // curb by region coord
	    var istart = (item[id_startcoord]<rstart) ? rstart : item[id_startcoord];
	    var istop = (item[id_stopcoord]>rstop) ? rstop : item[id_stopcoord];
	    if(entire.atbplevel) {
	        item[id_boxstart] = xoffset + (istart-rstart)*entire.bpwidth;
		item[id_boxwidth] = (istop - istart) * entire.bpwidth;
	    } else {
	        item[id_boxstart] = xoffset + (istart-rstart)/r[7];
		item[id_boxwidth] = Math.ceil((istop - istart)/r[7]);
	    }
	}
	xoffset += r[5]+regionSpacing.width;
    }

    var canvas = decorCanvasHash[gf].canvas;
    canvas.width = entire.spnum;
    var ctx = canvas.getContext('2d');
    // for measuring name width during stacking
    ctx.font = (decorCanvasHash[gf].fontbold?'bold':'')+' '+decorCanvasHash[gf].fontsize+' '+decorCanvasHash[gf].fontfamily;

    var isThin = (decorInfo[gf].mode == 'thin');
    var superimpose = false; // whether to superimpose gene struct
    /* in case superimpose will be used, store id of those items that are plotted
       after stacking, issue ajax query to get structure data by those id
     */
    var idlst = []; // gene id
    var superimposelookup = {}; // see "data structure.dia"
    if(!isThin && decorInfo[gf].hasStruct)
        superimpose = true;

    /*** stacking
         in thin mode, allow items sit right next to each other in one stack
	 in full mode, there must be 1px spacing between items in same stack
         for each region between left/right wing:
	    for each bed item:
	        define stack start/width by full/thin, if item has name, name width, ...
		try stacking item
		if successfully stacked:
		    set stack id
		    save item id if superimpose
		else:
		    left stack id unspecified
     ***/
    //var stackNumberLimit = isThin ? 400 : 100;

    var stack = [-1000];
    var skippedInClient = 0; // number of items skipped at client side
    var maxstack = 0;
    xoffset = dspBoundary.lwrlpx;
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var data = decorCanvasHash[gf].data[i];
        data.sort(gfSort);
	for(var j=0; j<data.length; j++) {
	    if(data[j][id_boxstart]==undefined || data[j][id_boxwidth]==undefined)
	        continue;
	    var item = data[j];
	    item[id_stackid] = undefined; // by default
	    // make stack start/width for stacking
            var k = 0; // stack id iterator
	    if(isThin) { // thin
	        item[id_stackstart] = item[id_boxstart];
		item[id_stackwidth] = item[id_boxwidth];
	        while(stack[k] > item[id_stackstart]) {
	            k++;
	            //if(k == stackNumberLimit) break;
	            if(k == stack.length) stack.push(-1000);
		}
	    } else { // full
		if(item[id_name]==undefined && item[id_name2]==undefined) { // no name
		    item[id_stackstart] = item[id_boxstart];
		    item[id_stackwidth] = item[id_boxwidth];
	        } else {
		    // increase name width by 1, do same for plotting
		    item[id_namewidth] = ctx.measureText(item[id_name2]==undefined?item[id_name]:item[id_name2]).width+1; 
		    if(superimpose) { // name is outside box
			item[id_stackstart] = item[id_boxstart] - item[id_namewidth];
			item[id_stackwidth] = item[id_boxwidth] + item[id_namewidth];
		    } else {
	   	        if(item[id_namewidth] < item[id_boxwidth]) {
		            item[id_stackstart] = item[id_boxstart];
		            item[id_stackwidth] = item[id_boxwidth];
		        } else {
			    item[id_stackstart] = item[id_boxstart] - item[id_namewidth];
			    item[id_stackwidth] = item[id_boxwidth] + item[id_namewidth];
			}
	            }
		}
	        // need items in same stack to have one pixel spacing,
	        while(stack[k]+1 > item[id_stackstart]) {
	            k++;
	            //if(k == stackNumberLimit) break;
		    // big negative value help process items with 0 or negative box start
	            if(k == stack.length) stack.push(-10000);
		}
	    }
	    /*
	    if(k == stackNumberLimit) {
	        // this item is NOT stacked, set stack index to undefined as a signal
	        skippedInClient++;
		continue;
	    }
	    */
	    // this item is stacked
	    stack[k] = item[id_stackstart]+item[id_stackwidth];
	    item[id_stackid] = k;
	    if(superimpose) {
	        // same item might show up for multiple times
	        idlst.push(item[id_id]);
		var r = regionLst[i];
		var plotpos = [ item[id_strand],
			item[id_stackid],
			i,
			xoffset,
			Math.max(item[id_startcoord], r[3]),
			Math.min(item[id_stopcoord], r[4]),
			item[id_boxstart],
			item[id_boxwidth]
			];
		if(item[id_id] in superimposelookup)
		    superimposelookup[item[id_id]].push(plotpos);
		else
		    superimposelookup[item[id_id]] = [plotpos];
	    }
	    if(maxstack < k) maxstack = k;
	}
	xoffset += regionLst[i][5]+regionSpacing.width;
    }

    var stackHeight = isThin ? thinStackHeight : fullStackHeight;
    canvas.height = (stackHeight+1) * (maxstack+1);
    if(canvas.height < 10) canvas.height = 10;
    // need to set it again as canvas height has been changed
    ctx.font = (decorCanvasHash[gf].fontbold?'bold':'')+' '+decorCanvasHash[gf].fontsize+' '+decorCanvasHash[gf].fontfamily;

    /* now that canvas height is determined,
       add alternating background color for regions 
       to distinguish regions
       only do this if isn't in genome mode
     */
    if(juxtaposition.type != 0) {
        ctx.fillStyle = "#FFF5B8";
        ctx.fillRect(0, 0, canvas.width, canvas.height);
        xoffset = 0;
        ctx.fillStyle = "white";
        for(i=0; i<regionLst.length; i++) {
            if(i % 2)
	        ctx.fillRect(xoffset, 0, regionLst[i][5], canvas.height);
	    xoffset += regionLst[i][5] + regionSpacing.width;
        }
    }


    var isBam = decorInfo[gf].fileType==4 || decorInfo[gf].fileType==5;

    // plot
    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var data = decorCanvasHash[gf].data[i];
	for(var j=0; j<data.length; j++) {
	    if(data[j][id_stackid] == undefined)
	        continue;
	    var item = data[j];

	    var y = item[id_stackid]*(stackHeight+1);

	    if(superimpose) {
	        // only plot name
	        if(item[id_name]!=undefined || item[id_name2]!=undefined) { // with name
		    ctx.fillStyle = decorCanvasHash[gf].textcolor;
		    ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2], item[id_boxstart]-item[id_namewidth], y+8);
		}
		continue;
	    }
	    // plot box
	    if(isBam) {
	        /***********************************
		            BAM plotting
	         ***********************************/
		var fcolor = decorCanvasHash[gf].forwardcolor;
		var rcolor = decorCanvasHash[gf].reversecolor;
		var mcolor = decorCanvasHash[gf].mismatchcolor;
		if(item[id_isPaired]) {
		    // paired end read
		    if(item[id_r2coord] == undefined) {
		        // but mate is missing, plot as single
		        item[id_r1coord] = [item[id_startcoord],item[id_stopcoord]];
	                ctx.fillStyle = item[id_strand]=='>' ? fcolor : rcolor;
	                ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
		        plotBAMmismatch(ctx, item, y, stackHeight, isThin, mcolor);
			continue;
		    }
		    // has mate, compute read length using entire read pair length
		    var rplen = item[id_stopcoord] - item[id_startcoord];
		    // plot width of each read
		    var r1width = item[id_boxwidth]*(item[id_r1coord][1]-item[id_r1coord][0])/rplen;
		    var r2width = item[id_boxwidth]*(item[id_r2coord][1]-item[id_r2coord][0])/rplen;
		    var r1color = item[id_strand]=='>' ? fcolor : rcolor;
		    ctx.fillStyle = r1color;
		    ctx.fillRect( // read 1
		            item[id_boxstart],
		            y,
			    Math.ceil(r1width),
			    stackHeight);
	            ctx.fillStyle = r1color==fcolor ? rcolor : fcolor;
		    ctx.fillRect( // read 2
		            item[id_boxstart]+item[id_boxwidth]-r2width,
		            y,
			    Math.ceil(r2width),
			    stackHeight);
		    // line joining the pair
		    ctx.lineWidth = 1;
		    ctx.strokeStyle = GRAY;
		    ctx.beginPath();
		    var y2 = isThin ? y+.5 : y+4.5;
		    ctx.moveTo(item[id_boxstart]+r1width, y2);
		    ctx.lineTo(item[id_boxstart]+item[id_boxwidth]-r2width, y2);
		    ctx.stroke();
		    //ctx.fillRect(item[id_boxstart]+r1width, y+stackHeight/2, item[id_boxwidth]-r1width-r2width, 1);
		    plotBAMmismatch(ctx, item, y, stackHeight, isThin, mcolor);
		    continue;
		}
		// single read
                ctx.fillStyle = item[id_strand]=='>' ? fcolor : rcolor;
	        ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
		plotBAMmismatch(ctx, item, y, stackHeight, isThin, mcolor);
		item[id_r1coord] = [item[id_startcoord],item[id_stopcoord]];
		continue;
	    }
	    // following deals bigBed plotting
	    ctx.fillStyle = decorCanvasHash[gf].bedcolor;
	    ctx.fillRect(item[id_boxstart], y, item[id_boxwidth], stackHeight);
            // additional plots for full mode
	    if(!isThin) {
	        if(item[id_name2]!=undefined || item[id_name]!=undefined) { // with name
	            if(item[id_namewidth] < item[id_boxwidth]) { // name goes into box
	                ctx.fillStyle = 'white';
			ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2], item[id_boxstart]+(item[id_boxwidth]-item[id_namewidth])/2, y+8);
			if(item[id_strand] != undefined) { // has strand
			    // see if strand can fit in as well
			    var sw = ctx.measureText(item[id_strand]).width;
			    if(sw < (item[id_boxwidth]-item[id_namewidth])/4) {
			        ctx.fillText(item[id_strand], item[id_boxstart], y+8);
			        ctx.fillText(item[id_strand], item[id_boxstart]+item[id_boxwidth]-sw, y+8);
			    }
			}
		    } else { // name won't go into box, see if enough space on left of box
			ctx.fillStyle = decorCanvasHash[gf].textcolor;
			ctx.fillText(item[id_name2]==undefined?item[id_name]:item[id_name2], item[id_boxstart]-item[id_namewidth], y+8);
			if(item[id_strand] != undefined) {
			    var sw = ctx.measureText(item[id_strand]).width;
			    if(sw < item[id_boxwidth]) {
		                ctx.fillStyle = 'white';
				ctx.fillText(item[id_strand], item[id_boxstart]+(item[id_boxwidth]-sw)/2, y+8);
		            }
			}
	            }
		} else { // no name
		    if(item[id_strand] != undefined) { // has strand
		        var sw = ctx.measureText(item[id_strand]).width;
		        if(sw < item[id_boxwidth]) {
		            ctx.fillStyle = 'white';
			    ctx.fillText(item[id_strand], item[id_boxstart]+(item[id_boxwidth]-sw)/2, y+8);
		        }
		    }
		}
	    }
	}
    }

    var maxStack = countMaxstackUnderView(decorCanvasHash[gf].data);
    var h = stackHeight * (maxStack+1) + maxStack;
    decorCanvasHash[gf].viewbox.style.height = (h>10) ? h : 10;
    decorCanvasHash[gf].header.height = parseInt(decorCanvasHash[gf].viewbox.style.height);
    drawDecorHeadercanvas(gf);

    /* print number of skipped items
       TODO mark out region with skipped items on bottom of decor canvas
     */
    if(0) {
        var hctx = decorCanvasHash[gf].header.getContext('2d');
        hctx.font = "8pt Sans-serif";
	hctx.fillStyle = '#668CFF';
	hctx.fillRect(0,18,leftColumnWidth-2,32);
	hctx.fillStyle = 'white';
	hctx.fillText('Not all items shown', 1, 29);
	hctx.fillText((decorCanvasHash[gf].skipped + skippedInClient)+' skipped...', 1, 44);
    }
    decorCanvasHash[gf].skipped = 0;

    if(superimpose && idlst.length > 0) {
        cloak2(decorCanvasHash[gf].viewbox);
	decorCanvasHash[gf].superimposelookup = superimposelookup;
	ajax("getGenestruct="+gf+"&lst="+idlst.join(",")+"&genenum="+parseInt(idlst.length)+"&dbName="+dbInfo.name, function(data){
	    /* return a hash, 
	       key: item id, 
	       val: a long array, genomic coordinate
	            tx start, stop,
	       	    5' utr start, stop,
		    3' utr start, stop,
	            [exon start, exon width, frame (-1/0/1/2)], ...
	       use item id to look for more info on this gene in hash superimposelookup
	       one scaling factor for each region
	     */
	    var gf = data["genetype"];
	    var ctx = decorCanvasHash[gf].canvas.getContext("2d");
	    ctx.fillStyle = decorCanvasHash[gf].bedcolor;
            ctx.font = "bold 6pt Courier New"; // for >< arrows
	    var strandw = ctx.measureText(">").width; // strand char width
	    var sfhash = {}; 
	    // key: region index, val: scaling factor
	    // to avoid repeated computing of scaling factor in one region
	    var id_txstart=0, id_txstop=1, id_5ustart=2, id_5uwidth=3, id_3ustart=4, id_3uwidth=5;
	    var LUdata = decorCanvasHash[gf].superimposelookup;
	    for(var id in data) {
	        if(!(id in LUdata))
		    continue;
		for(var outIterator=0; outIterator<LUdata[id].length; outIterator++) {
		    var arr = LUdata[id][outIterator];
		    var strand = arr[0] // >, <
		    var stackid = arr[1];
		    var regionid = arr[2];
		    var coordplotstart = arr[4]; // start coord of actually plotted region
		    var coordplotstop = arr[5]; // stop of that
		    var boxstart = arr[6]; // plot box start, patch of wrong plotting offset problem in fish chrM moving left
		    var boxwidth = arr[7]; // plot box width
		    var regionstart = regionLst[regionid][3];
		    var regionwidth = regionLst[regionid][5];
		    if(!(regionid in sfhash)) {
			sfhash[regionid] = regionwidth / (regionLst[regionid][4]-regionstart);
		    }
		    var sf = sfhash[regionid];
		    var y = stackid * (fullStackHeight+1);

		    // backbone with strand arrows
		    var startcoord = Math.max(data[id][id_txstart], coordplotstart);
		    var stopcoord = Math.min(data[id][id_txstop], coordplotstop);
		    var w = (stopcoord-startcoord)*sf;
		    // reset width if it exceeds width of current region
		    if(w > boxwidth)
			w = boxwidth;
		    ctx.fillRect(boxstart, y+fullStackHeight/2-.5, w, 1);
		    var cumulativex = 0;
		    while(cumulativex < w-strandw) {
			ctx.fillText(strand, parseInt(cumulativex+boxstart), y+7);
			cumulativex += strandw+1;
		    }

		    // all the exons...
		    for(var i=id_3uwidth+1; i<data[id].length; i++) {
			var tt = data[id][i];

			// only plot for intended region
			if(tt[1]<=coordplotstart || tt[0]>=coordplotstop)
			    continue;
			startcoord = (tt[0]<coordplotstart) ? coordplotstart : tt[0];
			stopcoord = (tt[1]>coordplotstop) ? coordplotstop : tt[1];

			var x = (startcoord-coordplotstart)*sf;
			if(x >= boxwidth) continue;
			var w = (stopcoord-startcoord)*sf;
			if(x+w > boxwidth)
			    w = boxwidth - x;
			// have to make exon width >= 1px or it won't show on Firefox
			if(w < 1)
			    w = 1;
			ctx.fillRect(boxstart+x, y, w, fullStackHeight);
		    }
		    // 5' utr
		    tt = data[id];
		    if(tt[id_5uwidth]>0 && tt[id_5ustart]<coordplotstop && (tt[id_5uwidth]+tt[id_5ustart])>coordplotstart) {
			startcoord = (tt[id_5ustart]<coordplotstart) ? coordplotstart : tt[id_5ustart];
			stopcoord = (tt[id_5ustart]+tt[id_5uwidth] > coordplotstop) ? coordplotstop : tt[id_5ustart]+tt[id_5uwidth];
			var x = (startcoord-coordplotstart)*sf;
			var w = (stopcoord-startcoord)*sf;
			if(x+w > boxwidth)
			    w = boxwidth - x;
			if(w <= 1) w = 1;
			// FIXME: the parseInt on 5' utr start helps remove the extra spurious line at tss
			ctx.clearRect(Math.floor(boxstart+x), y, Math.ceil(w), fullStackHeight);
			ctx.fillRect(boxstart+x, y+2, w, 5);
		    }
		    // 3' utr
		    if(tt[id_3uwidth]>0 && tt[id_3ustart]<coordplotstop && (tt[id_3ustart]+tt[id_3uwidth])>coordplotstart) {
			startcoord = (tt[id_3ustart]<coordplotstart) ? coordplotstart : tt[id_3ustart];
			stopcoord = (tt[id_3ustart]+tt[id_3uwidth] > coordplotstop) ? coordplotstop : tt[id_3ustart]+tt[id_3uwidth];
			var x = (startcoord-coordplotstart)*sf;
			var w = (stopcoord-startcoord)*sf;
			if(x+w > boxwidth)
			    w = boxwidth - x;
			if(w <= 1) w = 1;
			// FIXME patch: x-1
			if(strand == '<')
			    ctx.clearRect(boxstart+x-1, y, Math.ceil(w), fullStackHeight);
			else
			    ctx.clearRect(boxstart+x, y, Math.ceil(w), fullStackHeight);
			ctx.fillRect(boxstart+x, y+2, w, 5);
		    }
	        }
	    }
	    unveil(decorCanvasHash[gf].viewbox);
	});
    }
    print2console(" done", 0, false);
}
function adjustDecorViewboxHeight() {
    // for leisure moving, will not re-draw canvas, just find max stack under view
    // then change viewbox height accordingly
    for(var gf in decorCanvasHash) {
        var maxStack = 0;
	var data = decorCanvasHash[gf].data;
        var drawstart = -move.styleLeft;
        var drawstop = hmSpan-move.styleLeft-1;
        for(var i=0; i<data.length; i++) {
	    if(Math.max(data[i][0], drawstart) < Math.min(data[i][0]+data[i][1], drawstop)) {
	        if(maxStack < j) maxStack = j;
	    }
	}
    }
}





/* TSP track select panel
 */
function registerDecorGroup(name,label) {
    /* inserts group place holder into track selection panel
       argument: name is used by code, label is to read by human, but they could be same
       returns a list of two elements:
         1. div dom of group tab name
	 2. table dom of track holder of this group (identified by name, but not label)
     */
    var d = document.createElement('div');
    d.innerHTML = label;
    d.setAttribute('grpname', name);
    d.className = 'degrpt';
    d.addEventListener('click', decorgrp_click, false);
    tkselect.decor.grpholder.appendChild(d);

    // make panel for decor tracks in this group
    var table = document.createElement('table');
    table.setAttribute('grpname', name);
    tkselect.decor.tkholder.appendChild(table);

    return [d, table];
}
function onetimedeal_registerserverdecor() {
    /* register server decor in track selection panel
       only run at page startup or switching genome
       decorGrouping has to be made before calling this

       at list of decor groups, also add two additional groups
       "custom genomic features", "custom bam", "server bam" but hidden at first
       whenever such tracks are added, the group tab will be turned on

       TODO allow multiple levels of parent/child relationship
     */

    stripChild(tkselect.decor.grpholder, 0);
    stripChild(tkselect.decor.tkholder, 1);

    for(var i=0; i<decorGrouping.length; i++) {
        // add one tab for each decor group

        var grpid = decorGrouping[i][0];
	var table = registerDecorGroup(decorGrouping[i][1], decorGrouping[i][1])[1];

	// iterate over decor tracks, each parent track will occupy one row
	for(var dn in decorInfo) {
	    if(decorInfo[dn].grp != grpid)
	        continue;
	    if("parent" in decorInfo[dn])
	        continue;
	    var parenttr = table.insertRow(-1);
	    var pname = parenttr.insertCell(0);
	    pname.innerHTML = decorInfo[dn].label;
	    pname.className = 'tkentry';
	    pname.style.backgroundColor = 'transparent';
	    pname.addEventListener('click', decortkentry_click, false);
	    pname.setAttribute('tkname', dn);
	    pname.setAttribute('name', 'decortkentry');
	    // add hook to this <td> in decorInfo
	    decorInfo[dn].tksentry = pname;
	    var arrowtd = parenttr.insertCell(-1);
	    var clst = []; // children tracks of this parent, might be empty
	    for(var dn2 in decorInfo) {
	        if("parent" in decorInfo[dn2]) {
		    if(decorInfo[dn2]["parent"] == dn)
		        clst.push(dn2);
		}
	    }
	    if(clst.length > 0) {
	        // this decor has child
		var s = document.createElement("div");
		s.innerHTML = " &darr; ";
		s.className = "shortcutbut";
		s.style.fontSize = "16px";
		s.style.fontWeight = "bold";
		s.addEventListener("click", toggle20, false);
		arrowtd.appendChild(s);
		var ctr = table.insertRow(-1);
		ctr.style.display = "none";
		var ctd = ctr.insertCell(0);
		ctd.colSpan = 2;
		ctd.align = 'right';
		ctd.style.paddingLeft = '15px';
		for(var j=0; j<clst.length; j++) {
		    var childentry = document.createElement('div');
		    childentry.setAttribute('tkname', clst[j]);
		    childentry.innerHTML = decorInfo[clst[j]].label;
		    childentry.className = 'tkentry';
	            childentry.style.backgroundColor = 'transparent';
	            childentry.addEventListener('click', decortkentry_click, false);
	    	    childentry.setAttribute('name', 'decortkentry');
	            decorInfo[clst[j]].tksentry = childentry;
		    ctd.appendChild(childentry);
		}
	    }
	}
    }

    // add reserved groups
    var lst = registerDecorGroup('custbigbed', 'Genomic features <span style="font-size:12px;color:white;background-color:#A8B3D0;">custom</span>');
    lst[0].style.display = 'none';
    tkselect.decor.grptab_bigbed = lst[0];
    tkselect.decor.tkholder_bigbed = lst[1];
    lst = registerDecorGroup('custbam', 'Read alignments <span style="font-size:12px;color:white;background-color:#A8B3D0;">custom</span>');
    lst[0].style.display = 'none';
    tkselect.decor.grptab_custbam = lst[0];
    tkselect.decor.tkholder_custbam = lst[1];
    lst = registerDecorGroup('nativebam', 'Read alignments <span style="font-size:12px;color:white;background-color:#A8B3D0;">&nbsp;native&nbsp;</span>');
    lst[0].style.display = 'none';
    tkselect.decor.grptab_nativebam = lst[0];
    tkselect.decor.tkholder_nativebam = lst[1];

    // simulate clicking on first group
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    tkselect.decor.grpholder.firstChild.dispatchEvent(e);
}
function dbody_tkspanel_close() {
    tkspanel_close();
    document.body.removeEventListener('mousedown', dbody_tkspanel_close, false);
}
function tkspanel_close() {
    document.getElementById('tkspanel').style.display = 'none';
}
function hmtkgrp_clear(event) {
    /* clear a heatmap track group holder
       called by pushing button associated with a group holder
       event.target should be a button
       works for htest and pwc, and to be expanded
       attribute 'holderid' gives id of holder
     */
    stripChild(document.getElementById(event.target.getAttribute('holderid')),0);
}
function tkspanel_hmbleach() {
    // highlight off all hm track entries in tkspanel
    var lst = tkselect.hmholder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        lst[i].firstChild.style.backgroundColor = 'transparent';
    }
}
function tkspanel_gfbleach() {
    // highlight off all gf track entries in tkspanel
    var lst = document.getElementsByName('decortkentry');
    for(var i=0; i<lst.length; i++) {
        lst[i].style.backgroundColor = 'transparent';
    }
}
function tkspanel_gftoggle(tkname) {
    // toggle highlight for a decor track, use hook to the td element
    var entrytd = decorInfo[tkname].tksentry;
    if(entrytd.style.backgroundColor == 'transparent') {
	entrytd.style.backgroundColor = '#CCCCFF';
    } else {
	entrytd.style.backgroundColor = 'transparent';
    }
}
function tkspanel_hmtoggle(tkname) {
    // toggle highlight for a hmtk todo use hook
    var lst = tkselect.hmholder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('tkname') == tkname) {
            if(lst[i].firstChild.style.backgroundColor=='transparent') {
	        lst[i].firstChild.style.backgroundColor = '#CCCCFF';
	    } else {
	        lst[i].firstChild.style.backgroundColor = 'transparent';
	    }
	    return;
	}
    }
}
function decor_invoketksp(event) {
    /* called by pushing button for adding decor tracks for display
     */
    tkspanel_gfbleach();
    tkspanel_invoke(5,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 0);
    // highlight decors already in collection
    var lst = document.getElementById('decoruserlist').firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
    	tkspanel_gftoggle(lst[i].getAttribute('tkname'));
    }
}
function hmtkgrp_invoketksp(event) {
    /* called by pushing button, works for htest/pwc, to be expanded
       invoke tkspanel for pwc/htest track group assignment
     */
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    var type = event.target.getAttribute('ttype');
    var which;
    if(type == 'pwc') {
        which = 1;
    } else if(type == 'htest') {
        which = 2;
    } else {
        fatalError('hmtkgrp_invoketksp: unknown ttype '+type);
    }
    tkselect.grp = parseInt(event.target.getAttribute('grp'));
    tkspanel_hmbleach();
    tkspanel_invoke(which,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
    var lst = document.getElementById(event.target.getAttribute('holderid')).childNodes;
    for(var i=0; i<lst.length; i++) {
        tkspanel_hmtoggle(lst[i].getAttribute('tkname'));
    }
}
function corrhm_invoketksp(event) {
    /* called by pushing button, to select hm track for correlation
     */
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(3,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
    if(correlation.inuse && correlation.where==0) {
        tkspanel_hmtoggle(correlation.targetname);
    }
}
function corrgf_invoketksp(event) {
    /* called by pushing button, to select a decor track for correlation */
    tkspanel_gfbleach();
    tkspanel_invoke(4,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 0);
    if(correlation.inuse && correlation.where==1) {
        tkspanel_gftoggle(correlation.targetname);
    }
}
function juxtapose_invoketksp(event) {
    /* called by pushing button, to select a decor track for juxtaposition */
    tkspanel_gfbleach();
    tkspanel_invoke(6,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 1);
}
function genesetsort_hm_invoketksp(event) {
    /* to select a heatmap track for sorting gene set */
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(7,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
}
function genesetsort_gf_invoketksp(event) {
    /* to select a quantitative decor for sorting gene set */
    tkspanel_gfbleach();
    tkspanel_invoke(12,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 2);
}
function geneplot_hm_invoketksp(event) {
    /* to select a heatmap track for geneplot */
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(9,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        true,false);
}
function geneplot_gf_invoketksp(event) {
    /* to select a quantitative decor for geneplot */
    tkspanel_gfbleach();
    tkspanel_invoke(8,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
        false,true, 2);
}
function genomebev_hm_invoketksp(event) {
    /* select a hmtk to run in genome bev */
    if(tkLst.length == 0) {
        print2console('Cannot invoke heatmap track selection panel: no track in display', 2);
	return;
    }
    tkspanel_hmbleach();
    tkspanel_invoke(10,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	true, false);
    for(var tk in bev.data) {
        var obj = bev.data[tk];
	if(obj.filetype==2 || obj.filetype==3) {
            tkspanel_hmtoggle(tk);
	}
    }
}
function genomebev_gf_invoketksp(event) {
    /* select a decor to run in genome bev */
    tkspanel_gfbleach();
    tkspanel_invoke(11,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop,
	false, true, 0);
    for(var tk in bev.data) {
        var obj = bev.data[tk];
	if(obj.filetype==0 || obj.filetype==1 || obj.filetype==8) {
            tkspanel_gftoggle(tk);
	}
    }
}
function tkspanel_invoke(which,x,y,hm,decor, decortoggleindicator) {
    /* invoke tkspanel, args:
       which: 1/2/3... event type indicator
       x,y: coordinate to place the panel
       hm: true/false, whether to show hm track list
       decor: true/false, whether to show decor track list
       decortoggleindicator: only works for decor
            0 - activate all
	    1 - activate positional
	    2 - activate quantitative
     */
    setTimeout("document.body.addEventListener('mousedown', dbody_tkspanel_close, false)", 100);
    tkselect.main.style.display = 'block';
    tkselect.which = which;
    tkselect.main.style.left = x;
    tkselect.main.style.top= y;
    tkselect.hmdiv.style.display = hm ? 'block' : 'none';
    tkselect.decor.main.style.display = decor ? 'block' : 'none';

    if(decor) {
        // see if some decor tracks is to be inactivated
	if(decortoggleindicator == undefined) {
	    fatalError('tkspanel_invoke: decortoggleindicator is undefined when it should not be');
	}
	switch(decortoggleindicator) {
	case 0:
	    // activate all
	    for(var gf in decorInfo) {
	        if(!('tksentry' in decorInfo[gf])) continue; // tolerate server bam
	        decorInfo[gf].tksentry.className = 'tkentry';
	    }
	    break;
	case 1:
	    // only activate positional decors
	    for(var gf in decorInfo) {
	        if(!('tksentry' in decorInfo[gf])) continue; // tolerate server bam
	        if(decorInfo[gf].fileType==0 || decorInfo[gf].fileType==1) {
	            decorInfo[gf].tksentry.className = 'tkentry';
		} else {
	            decorInfo[gf].tksentry.className = 'tkentry_inactive';
		}
	    }
	    break;
	case 2:
	    // only activate quantitative decors
	    for(var gf in decorInfo) {
	        if(!('tksentry' in decorInfo[gf])) continue; // tolerate server bam
	        if(decorInfo[gf].fileType==8) {
	            decorInfo[gf].tksentry.className = 'tkentry';
		} else {
	            decorInfo[gf].tksentry.className = 'tkentry_inactive';
		}
	    }
	    break;
	default:
	    fatalError('tkspanel_invoke: unknown decortoggleindicator value');
	}
    }
}
function decorgrp_click(event) {
    /* clicking decor group tab in tkspanel
       event.target is <div> that tab, will switch decor child panels
     */
    // turn off all grp tabs, all children panels
    var lst = tkselect.decor.grpholder.childNodes;
    for(var i=0; i<lst.length; i++) { lst[i].className = 'degrpt';}
    lst = tkselect.decor.tkholder.childNodes;
    for(i=1; i<lst.length; i++) { lst[i].style.display = 'none'; }
    // turn on the one clicked
    event.target.className = 'degrpt2';
    var grp = event.target.getAttribute('grpname');
    for(i=0; i<lst.length; i++) {
        if(lst[i].getAttribute('grpname') == grp) {
	    lst[i].style.display = 'block';
	    break;
	}
    }
}
function decortkentry_click(event) {
    /* clicking on a decor track entry in tkspanel
     */
    var add = false;
    if(event.target.style.backgroundColor == 'transparent') {
        event.target.style.backgroundColor = '#CCCCFF';
	add = true;
    } else {
        event.target.style.backgroundColor = 'transparent';
    }
    var tkname = event.target.getAttribute('tkname');
    var ft = decorInfo[tkname].fileType;
    switch(tkselect.which) {
    case 4: // corr
	correlation.targetname = tkname;
	correlation.targetft = ft;
	correlation.where = 1; // from decor...
	correlation.inuse = true;
	runCorrelation();
	tkspanel_close();
        break;
    case 5: // add decor to registry
        if(add) {
	    decoruserlist_insert(tkname);
	} else {
	    decoruserlist_remove(tkname);
	}
	break;
    case 6: // run juxtaposition
	if(ft==2||ft==3) {
	    print2console('Don\'t select quantitative track', 2);
	} else if(ft==4 || ft==5) {
	    print2console('Don\'t select BAM track', 2);
	} else if(ft==0 || ft==1) {
	    // fake a menu call
	    menu.decorname = tkname;
	    menuDecorJuxtapose();
	}
	tkspanel_close();
	break;
    case 8: // geneplot, only quantitative track allowed
        if(ft != 8) {
	    print2console('Must select quantitative track for GenePlot', 2);
	} else {
	    // ASSume bigwig decor filetype can only be 8
	    document.getElementById('geneplot_tklabel').innerHTML = decorInfo[tkname].label;
	    document.getElementById('geneplot_tkname').innerHTML = tkname;
	    document.getElementById('geneplot_tkiscustom').innerHTML = 0;
	}
	tkspanel_close();
	break;
    case 11: // genome bev, all decors welcome
        // hitchhike menu bev call...
	if(add) {
	    menu.context = 3;
	    menu.decorname = tkname;
	    document.body.style.cursor = 'wait';
	    menuBirdeyeview();
	}
	tkspanel_close();
	break;
    case 12: // gene set sort
        if(ft != 8) {
	    print2console('Must select quantitative track for GenePlot', 2);
	} else {
	    // ASSume bigwig decor can only be 2
	    document.getElementById('genesetsort_tkname').innerHTML = tkname;
	    document.getElementById('genesetsort_tklabel').innerHTML = decorInfo[tkname].label;
	    document.getElementById('genesetsort_tkiscustom').innerHTML = 0;
	}
	tkspanel_close();
        break;
    case 14: // ideogram wiggle 1
        if(ft==4 || ft==5) {
	    print2console('Sorry but BAM track isn\'t allowed for this function', 2);
	} else {
	    ideogram.wiggle1.name = tkname;
	    ideogram.wiggle1.filetype = ft;
	    ideogram.wiggle1.url = ft==1 ? decorInfo[tkname].url : null;
	    ideogram.wiggle1.label = decorInfo[tkname].label;
	    ajax_plotideogramwiggle(1);
	}
	tkspanel_close();
        return;
    case 16: // ideogram wiggle 2
        if(ft==4 || ft==5) {
	    print2console('Sorry but BAM track isn\'t allowed for this function', 2);
	} else {
	    ideogram.wiggle2.name = tkname;
	    ideogram.wiggle2.filetype = ft;
	    ideogram.wiggle2.url = ft==1 ? decorInfo[tkname].url : null;
	    ideogram.wiggle2.label = decorInfo[tkname].label;
	    ajax_plotideogramwiggle(2);
	}
	tkspanel_close();
        return;
    default:
        fatalError('decortkentry_click: unknown tkselect.which');
    }
}
function hmtkentry_click(event) {
    /* clicking on hmtk entries in tkspanel
       event.target is <td>
     */
    var add = false;
    if(event.target.style.backgroundColor == 'transparent') {
        event.target.style.backgroundColor = '#CCCCFF';
	add = true;
    } else {
        event.target.style.backgroundColor = 'transparent';
    }
    // tkselect.which specific operations
    var tkname = event.target.parentNode.getAttribute('tkname');
    switch(tkselect.which) {
    case 1: // pwc
        if(add) {
	    pwc_assigngrp(tkname, tkselect.grp);
	} else {
	    var d = document.getElementById(tkname+'inpwcgrp');
	    d.parentNode.removeChild(d);
	}
	break;
    case 2: // htest
        if(add) {
	    htest_assigngrp(tkname, tkselect.grp);
	} else {
	    var d = document.getElementById(tkname+'inhtestgrp');
	    d.parentNode.removeChild(d);
	}
        break;
    case 3: // hm corr
	correlation.targetname = tkname;
	correlation.targetft = findTrackByName(tkname).isCustom ? 3 : 2;
	correlation.where = 0; // from heatmap...
	correlation.inuse = true;
	runCorrelation();
	tkspanel_close();
	break;
    case 7: // gene set sort
        var obj = findTrackByName(tkname);
        document.getElementById('genesetsort_tkname').innerHTML = tkname;
        document.getElementById('genesetsort_tklabel').innerHTML = obj.label;
        document.getElementById('genesetsort_tkiscustom').innerHTML = obj.isCustom ? 1 : 0;
        document.getElementById('genesetsort_tkurl').innerHTML = obj.isCustom ? obj.url : '';
	tkspanel_close();
        break;
    case 9: // gene plot
        var obj = findTrackByName(tkname);
        document.getElementById('geneplot_tklabel').innerHTML = obj.label;
        document.getElementById('geneplot_tkname').innerHTML = tkname;
        document.getElementById('geneplot_tkiscustom').innerHTML = obj.isCustom ? 1 : 0;
        document.getElementById('geneplot_tkurl').innerHTML = obj.isCustom ? obj.url : '';
	tkspanel_close();
        break;
    case 10: // genome bev
        // hitchhike using hm menu...
	if(add) {
	    menu.context = 1;
	    menu.iY = -1;
	    for(var i=0; i<tkNameLst.length; i++) {
		if(tkNameLst[i] == tkname) {
		    menu.iY = i;
		    break;
		}
	    }
	    if(menu.iY == -1) {
		fatalError('hmtkentry_click: status 10, unknown track name');
	    }
	    document.body.style.cursor = 'wait';
	    menuBirdeyeview();
	}
	tkspanel_close();
        break;
    case 13: // ideogram wiggle1
	ideogram.wiggle1.name = tkname;
	var obj = findTrackByName(tkname);
	ideogram.wiggle1.filetype = obj.isCustom ? 3 : 2;
	ideogram.wiggle1.url = obj.isCustom ? obj.url : null;
	ideogram.wiggle1.label = obj.label;
	ajax_plotideogramwiggle(1);
        tkspanel_close();
	break;
    case 15: // ideogram wiggle2
	ideogram.wiggle2.name = tkname;
	var obj = findTrackByName(tkname);
	ideogram.wiggle2.filetype = obj.isCustom ? 3 : 2;
	ideogram.wiggle2.url = obj.isCustom ? obj.url : null;
	ideogram.wiggle2.label = obj.label;
	ajax_plotideogramwiggle(2);
        tkspanel_close();
	break;
    default:
        fatalError('hmtkentry_click: unknown tkselect.which');
    }
}
function tkselectsmallmenuclose() {
    tkselect.smallmenu.style.display = 'none';
    document.body.removeEventListener('mouseup', tkselectsmallmenuclose, false);
    switch(tkselect.smallmenu.which) {
    case 1:
        tkselect.smallmenu.firstChild.removeEventListener('mousedown', genomebev_hm_invoketksp, false);
        tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', genomebev_gf_invoketksp, false);
	return;
    case 2:
	tkselect.smallmenu.firstChild.removeEventListener('mousedown', geneplot_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', geneplot_gf_invoketksp, false);
	return;
    case 3:
	tkselect.smallmenu.firstChild.removeEventListener('mousedown', corrhm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', corrgf_invoketksp, false);
	return;
    case 4:
	tkselect.smallmenu.firstChild.removeEventListener('mousedown', genesetsort_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', genesetsort_gf_invoketksp, false);
	return;
    case 5:
	tkselect.smallmenu.firstChild.removeEventListener('mousedown', ideogramwiggle1_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', ideogramwiggle1_gf_invoketksp, false);
	return;
    case 6:
	tkselect.smallmenu.firstChild.removeEventListener('mousedown', ideogramwiggle2_hm_invoketksp, false);
	tkselect.smallmenu.childNodes[1].removeEventListener('mousedown', ideogramwiggle2_gf_invoketksp, false);
	return;
    default:
        fatalError('tkselectsmallmenuclose: unknown tkselect.smallmenu.which value');
    }
}
function invoketkssm(which,x,y) {
    // invoke track selection small menu
    tkselect.smallmenu.style.display = 'block';
    tkselect.smallmenu.style.left = x;
    tkselect.smallmenu.style.top = y;
    document.body.addEventListener('mouseup', tkselectsmallmenuclose, false);
    tkselect.smallmenu.which = which;
}
function genomebev_invoketkssm(event) {
    // add track for genome bev
    var pos = absolutePosition(event.target);
    invoketkssm(1, pos[0], pos[1]+event.target.clientHeight+4);
    tkselect.smallmenu.firstChild.addEventListener('mousedown', genomebev_hm_invoketksp, false);
    tkselect.smallmenu.childNodes[1].addEventListener('mousedown', genomebev_gf_invoketksp, false);
}
function geneplot_invoketkssm(event) {
    // select a track for gene plot
    var pos = absolutePosition(event.target);
    invoketkssm(2, pos[0], pos[1]+event.target.clientHeight+4);
    tkselect.smallmenu.firstChild.addEventListener('mousedown', geneplot_hm_invoketksp, false);
    tkselect.smallmenu.childNodes[1].addEventListener('mousedown', geneplot_gf_invoketksp, false);
}
function corr_invoketkssm(event) {
    // select one for corr
    var pos = absolutePosition(event.target);
    invoketkssm(3, pos[0], pos[1]+event.target.clientHeight+4);
    tkselect.smallmenu.firstChild.addEventListener('mousedown', corrhm_invoketksp, false);
    tkselect.smallmenu.childNodes[1].addEventListener('mousedown', corrgf_invoketksp, false);
}
function genesetsort_invoketkssm(event) {
    // select one for gene set sort
    var pos = absolutePosition(event.target);
    invoketkssm(4, pos[0], pos[1]+event.target.clientHeight+4);
    tkselect.smallmenu.firstChild.addEventListener('mousedown', genesetsort_hm_invoketksp, false);
    tkselect.smallmenu.childNodes[1].addEventListener('mousedown', genesetsort_gf_invoketksp, false);
}






function stuffTrackCanvas2holder() {
    /* put dom objects associated with tracks in holder by order defined by tkNameLst
       for purpose of re-ordering tracks
       
       dom objects include:
       heatmap canvas
       heatmap viewbox height
       move single track canvas height
       track metadata canvas
       track correlation canvas
       inter-track correlation radio <div>
       htest track <div> for deciding which group that damned track belongs to
     */
    viewbox.style.height = sumTrackHeight();
    if(tkLst.length == 0) {
        //moveTrackCanvas.height = 0;
	return;
    }
    stripChild(viewbox, 0);
    stripChild(tkAttrHolder, 0);
    if(correlation.inuse)
        stripChild(corrHolder, 0);
    stripChild(tracklabelholder, 0);
    for(i=0; i<tkNameLst.length; i++) {
        var tk = findTrackByName(tkNameLst[i]);
	if(tk == null) 
	    fatalError("stuffTrackCanvas2holder: "+tkNameLst[i]+" not found in tkLst");
	if(tk.hmC == undefined) {
	    var c = document.createElement('canvas');
	    tk.hmC = c;
	}
	tk.hmC.className = "hmCanvas"; // for tooltip
	tk.hmC.style.position = 'relative';
	tk.hmC.style.display = 'block';
	tk.hmC.style.left = move.styleLeft;
	viewbox.appendChild(tk.hmC);
	if(tk.atC == undefined) {
	    // track metadata canvas
	    var c = document.createElement('canvas');
	    c.className = "tkattrCanvas"; // for tooltip
	    c.style.display = "block";
	    c.addEventListener("mousedown", moveMdcanvasMD, false);
	    c.addEventListener("click", mdcanvasLeftclick, false);
	    tk.atC = c;
	}
	tkAttrHolder.appendChild(tk.atC);
	if(tk.coC == undefined) {
	    var c = document.createElement('canvas');
	    c.className = 'corrCanvas'; // for tooltip
  	    c.style.display = 'block';
	    c.width = leftColumnWidth;
	    c.height = tk.qtc.height;
	    c.ctx = c.getContext('2d');
	    initiateCorrCanvasCtx(c.ctx);
	    tk.coC = c;
	}
	if(correlation.inuse) 
	    corrHolder.appendChild(tk.coC);
	// entry in track selection panel
	if(tk.sptr == undefined) {
	    var tr = tkselect.hmholder.insertRow(-1);
	    tr.setAttribute('tkname', tk.name);
	    var td = tr.insertCell(0);
	    td.className = 'tkentry';
	    td.style.backgroundColor = 'transparent';
	    td.addEventListener('click', hmtkentry_click, false);
	    td.innerHTML = hmtk.tolabel[tkNameLst[i]];
	    td = tr.insertCell(-1);
	    td.innerHTML = '<div class=iconholder style="color:#858585;cursor:pointer;" onclick="getOnetrackdetails(\''+tk.name+'\')">&#9432;</div>';
	    tk.sptr = tr;
	}
	// heatmap track label that are hidden by default
	if(tk.labeldiv == undefined) {
	    var d = document.createElement("div");
            if(tk.isCustom) {
	        d.style.fontSize = "9px";
	        d.style.overflow = "hidden";
	        d.style.whiteSpace = "nowrap";
	    } else {
	        // only server tracks are clickable for details
	        d.className = "clb2";
		d.tkname = tkNameLst[i];
	        d.addEventListener("click", getOnetrackdetails, false);
	    }
	    d.style.height = tk.qtc.height;
	    d.innerHTML = tk.label;
	    tk.labeldiv = d;
	}
	tracklabelholder.appendChild(tk.labeldiv);
    }
    document.getElementById("corrCanvasholder").style.height = sumTrackHeight();
}

function corrSort(a,b) {
    // sort on tkLst
    return b.corr-a.corr;
}
function mcmSortTrack() {
    /* sort track by metadata annotation, variable argument:
       * array index of mdcategoryOnshow
       * event object fired by clicking on mdcholder
     */
    if(mdcholder.moved) {
        // ??
        mdcholder.moved = false;
	return;
    }
    if(tkLst.length == 0) {
	document.getElementById('hmtkorderRevertButton').style.display = 'none';
	return;
    }
    if(arguments[0] == undefined) {
        fatalError("mcmSortTrack: no arguments");
    }

    // hide qtc config panel in case it is still open
    qtcpanel_close();

    if(typeof(arguments[0]) == 'number')
        sortTrackIdx = arguments[0];
    else {
        /* event object
	   need to allow revert to old hmtk order
	 */
	sortTrackIdx = Math.floor((arguments[0].clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
	// save previous hmtk order
	mdcholder.previousorder = [];
	for(var i=0; i<tkNameLst.length; i++)
	    mdcholder.previousorder.push(tkNameLst[i]);
	// show revert button
	document.getElementById('hmtkorderRevertButton').style.display = 'block';
    }
    var values = {}; // key: values of that attribute type
    for(var i=0; i<tkLst.length; i++) {
        if(tkLst[i].attrlst[sortTrackIdx] != undefined)
            values[tkLst[i].attrlst[sortTrackIdx]] = 1;
    }
    var newLst = [];
    var valuelst = []; // hold values in a list and sort, so that value order is stable
    for(var name in values)
        valuelst.push(name);
    valuelst.sort();
    for(var j=0; j<valuelst.length; j++) {
        for(i=0; i<tkLst.length; i++) {
	    if(tkLst[i].attrlst[sortTrackIdx] == valuelst[j])
	        newLst.push(tkLst[i]);
	}
    }
    for(i=0; i<tkLst.length; i++) {
        if(tkLst[i].attrlst[sortTrackIdx]==undefined)
	    newLst.push(tkLst[i]);
    }
    tkLst = newLst;
    tkNameLst = [];
    for(i=0; i<tkLst.length; i++) 
        tkNameLst.push(tkLst[i].name);
    stuffTrackCanvas2holder();
}
function hmtkorderRevert() {
    // precaution here: must take care of added/removed tracks before reverting
    var tp = mdcholder.previousorder;
    var newlst = []; // new sequence
    // from tp select existing tracks, skip removed ones
    for(var i=0; i<tp.length; i++) {
        if(thinginlist(tp[i], tkNameLst))
	    newlst.push(tp[i]);
    }
    // from tkNameLst add newly added ones
    for(i=0; i<tkNameLst.length; i++) {
        if(!thinginlist(tkNameLst[i], tp))
	    newlst.push(tkNameLst[i]);
    }
    tkNameLst = newlst;
    stuffTrackCanvas2holder();
    document.getElementById('hmtkorderRevertButton').style.display = 'none';
    print2console("heatmap track order reverted", 0);
}




/***********************
      SESSion
 ***********************/

function saveStateParams() {
    /* for controls that's only used on client side,
       and never passed to CGI in normal conditions except saving sessions

       TODO: store track grouping for htest
     */

    // server bigwig track names
    lst = [];
    for(i=0; i<tkLst.length; i++) {
        var tk = tkLst[i];
        if(!tk.isCustom) {
            lst.push(tk.name);
	}
    }
    var servertrackparam = '';
    if(lst.length > 0)
        servertrackparam = "&serverTrack="+escape(lst.join(','));

    // custom bigwig tracks
    lst = [];
    for(i=0; i<tkLst.length; i++) {
        var tk = tkLst[i];
        if(tk.isCustom)
            lst.push(tk.name+','+tk.label+','+tk.url);
    }
    var customtrackparam = '';
    if(lst.length > 0)
        customtrackparam = "&customTrack="+escape(lst.join(','));

    // custom track information (name:[ft, label, url, servermd, custmd])
    var wlst = []; // custom bigwig annotation
    for(var tn in hmtk.custom) {
        var obj = hmtk.custom[tn];
	var lst2 = []; // annotation using server metadata
	for(var attr in obj.servermd)
	    lst2.push(attr+":1");
	var lst3 = []; // annotation using custom metadata
	for(attr in obj.custmd)
	    lst3.push('\\"'+attr+'\\":\\"'+obj.custmd[attr]+'\\"');
	wlst.push('\\"'+tn+'\\":[3,\\"'+obj.label+'\\",\\"'+obj.url+'\\",{'+lst2.join(',')+'},{'+lst3.join(',')+'}]');
    }
    var dlst = []; // custom bigbed/bam info, same format as bigwig
    for(var dn in decorInfo) {
        // for ft 1/5, they should only have custom md anno
	var obj = decorInfo[dn];
        if(obj.fileType==1 || obj.fileType==5) {
	    var lst2 = [];
	    for(var attr in obj.custmd)
	        lst2.push('\\"'+attr+'\\":\\"'+obj.custmd[attr]+'\\"');
	    dlst.push('\\"'+dn+'\\":['+obj.fileType+',\\"'+obj.label+'\\",\\"'+obj.url+'\\",,{'+lst2.join(',')+'}]');
	}
    }
    var customtrackattrparam = '&customTrackAttr='+escape('\\"bigwig\\":{'+wlst.join(',')+'},\\"bigbedbam\\":{'+dlst.join(',')+'}');

    // dsp, gf
    var dspstring = "&dspStat="+getDspStat().join(',');

    // custom metadata
    lst = [];
    for(attr in custmdhash) {
        lst2 = [];
	for(i=0; i<custmdhash[attr].length; i++)
	    lst2.push("\\\""+custmdhash[attr][i]+"\\\"");
        lst.push("\\\""+attr+"\\\":["+lst2.join(",")+"]");
    }
    var custmdstring = escape(lst.join(","));

    // correlation
    var corrStat = "";
    if(correlation.inuse) {
        var tft = correlation.targetft;
	var where = correlation.where;
        corrStat = "&corrStat="+tft+","+where+","+correlation.targetname;
    }

    // mdcategoryOnshow
    lst = [];
    for(i=0; i<mdcategoryOnshow.length; i++) {
        lst.push("\\\""+mdcategoryOnshow[i]+"\\\"");
    }
    var mdconshow = escape(lst.join(",")); // must be quoted as some name have &

    // pairwise comparison
    lst=[]; lst2=[];
    var pwcstring = '';
    if(pwc.inuse) {
        for(i=0; i<pwc.gtn1.length; i++) {
	    lst.push('\\"'+pwc.gtn1[i]+'\\"');
	}
        for(i=0; i<pwc.gtn2.length; i++) {
	    lst2.push('\\"'+pwc.gtn2[i]+'\\"');
	}
	pwcstring = '&pairwisecomp=[['+escape(lst.join(','))+'],['+escape(lst2.join(','))+']]';
    }

    // qtc (but no bevs...)
    lst = [];
    lst.push(escape('\\"htest\\":'+qtc2json(htest.qtc))+',');
    lst.push(escape('\\"pwc\\":'+qtc2json(pwc.qtc))+',');
    lst.push(escape('\\"correlation\\":'+qtc2json(correlation.qtc))+',');
    lst.push(escape('\\"hmtk\\":{'));
    for(i=0; i<tkLst.length; i++) {
        lst.push(escape('\\"'+tkLst[i].name+'\\":'+qtc2json(tkLst[i].qtc))+',');
    }
    lst.push('},');
    lst.push(escape('\\"decor\\":{'));
    for(var gf in decorCanvasHash) {
        lst.push(escape('\\"'+gf+'\\":'+qtc2json(decorCanvasHash[gf].qtc))+',');
    }
    lst.push('}');
    var qtcstring = '&qtc={'+lst.join('')+'}';

    // gssparam
    var gssparamstring = '';
    if(juxtaposition.type==3 || juxtaposition.type==4) {
        gssparamstring = escape('&gssparam={\\"gss_says\\":\\"'+document.getElementById('gsedit_gss_says_ghost').innerHTML+'\\",'+
	    '\\"gss_opt\\":\\"'+document.getElementById('gsedit_gss_opt_ghost').innerHTML+'\\",'+
	    '\\"gss_origin\\":\\"'+document.getElementById('gsedit_gss_origin_ghost').innerHTML+'\\",'+
	    '\\"gss_up\\":\\"'+document.getElementById('gsedit_gss_up_ghost').innerHTML+'\\",'+
	    '\\"gss_down\\":\\"'+document.getElementById('gsedit_gss_down_ghost').innerHTML+'\\"}');
    }

    // sticky notes...
    var snstring = "";
    lst=[]; lst2=document.getElementsByClassName("stickynote");
    if(lst2.length > 0) {
        for(i=0; i<lst2.length; i++) {
	    var thissn = lst2[i];
	    var value = thissn.firstChild.value;
	    if(value != "") {
	        value = value.replace(/\|/g, "-verBar-");
	        value = value.replace(/\n/g, "-newline-");
	        lst.push(parseInt(thissn.style.left)+"|"+parseInt(thissn.style.top)+"|"+escape(value));
	    }
	}
	if(lst.length > 0)
	    snstring = "&stickynote="+lst.join("|");
    }

    //return "&clientCtrl="+ escape("\\\"S\\\":{"+sparam.join(',')+"},"+ "\\\"R\\\":{"+rparam.join(',')+"}")+
    return "&juxType="+juxtaposition.type+
	   "&juxWhat="+juxtaposition.what+
	   "&juxNote="+juxtaposition.note+
	   servertrackparam+
	   customtrackparam+
	   customtrackattrparam+
	   dspstring+
	   decorParams()+
	   "&decorRenderingParams="+escape(decorRenderingParams())+
	   corrStat+ 
	   (custmdstring == "" ? "" : "&custmd="+custmdstring)+
	   (mdconshow=="" ? "" : "&mdconshow="+mdconshow)+
	   "&dataset="+datasetLst.join(",")+
	   pwcstring+
	   qtcstring+
	   gssparamstring+
	   snstring;
}
function saveStatus() {
    /* put status into db
       upon successful, will return new status id
     */
    var note = document.getElementById('statusNote').value;
    if(note != '')
        note = '&statusNote='+escape(note);
    if(note.length > 200)
        note = note.substr(0,200);
    gflag.savingstatus = true;
    print2console("saving status...", 0);
    ajax('saveStatus=on'+note+saveStateParams()+"&dbName="+dbInfo.name,function(data){
        gflag.savingstatus = false;
        if(!('statusTicket' in data)) fatalError("jsonkey statusTicket missing");
	statusId = data['statusTicket'][0];
	addRow4newStatus(document.getElementById('statusHolder'), statusId,data['statusTicket'][1]);
	document.getElementById('statusNote').value = '';
	print2console(" done", 1, false)
    });
}
function retrieveSession() {
    /* current session ID will be replaced by the previous session
       so need to update runtime tables...
       handles urlparam and normal case
     */
    var param;
    if(gflag.urlparam.usingsession) {
        param = 'pastSession='+gflag.urlparam.hash.session+'&dbName='+gflag.urlparam.dbname;
    } else {
	var s = document.getElementById('oldSessionId').value;
	if(s.length == 0) {
	    print2console("Please enter session ID", 2);
	    return;
	}
	param = 'updateRuntimetable=on&pastSession='+s+'&juxType='+juxtaposition.type+'&dbName='+dbInfo.name;
    }
    print2console("retrieving status...", 0);
    ajax(param, function(data){
        if('abort' in data) {
	    if(gflag.urlparam.usingsession)
	        oneshotDialog(1, data.abort);
	    else
	        print2console(data.abort, 2);
	    return;
	}
        if(!('statusLst' in data)) fatalError("jsonkey statusLst missing");
	var v = data.statusLst;
	if(gflag.urlparam.usingsession) {
	    var holder = document.getElementById('oneshotbelly');
	    stripChild(holder, 0);
	    sessionId = v[0];
	    for(var i=1; i<v.length; i++)
		addRow4newStatus(holder,v[i][0],v[i][1],v[i][2],v[i][3],v[i][4]);
	    oneshotDialog(2, null);
	} else {
	    var holder = document.getElementById('statusHolder');
	    stripChild(holder, 0);
	    document.getElementById('oldSessionId').value = '';
	    sessionId = v[0];
	    document.getElementById('sessionId').innerHTML = sessionId;
	    for(var i=1; i<v.length; i++)
		addRow4newStatus(holder, v[i][0],v[i][1],v[i][2],v[i][3],v[i][4]);
	}
	print2console((data['statusLst'].length-1)+" retrieved", 0, false);
    });
}
function deleteStatus(stid) {
    var holder = document.getElementById('statusHolder');
    holder.firstChild.removeChild(document.getElementById('stid'+stid));

    ajax("deleteStatus="+stid+"&dbName="+dbInfo.name, function(data){return;});
}
function cleanuphtmlholder() {
    // do this before restoring status or changing genome
    stripChild(pwc.grp1, 0);
    stripChild(pwc.grp2, 0);
    pwc.gtn1 = [];
    pwc.gtn2 = [];

    // metadata color map
    mdcategoryOnshow = [];
    stripChild(mdcholder.holder, 0);
    tkselect.main.style.display = 'none';
    stripChild(document.getElementById('decoruserlist').firstChild, 0);

    // custom metadata
    stripChild(mdselect.cust, 0);
    stripChild(document.getElementById('custmdselect_row'), 0);
    stripChild(document.getElementById('custmdselect_col'), 1);

    // custom track
    hmtk.custom = {};
    document.getElementById('custtrackhowmany').innerHTML = 0;
    document.getElementById('cust3howmany').innerHTML = 0;
    document.getElementById('cust1howmany').innerHTML = 0;
    document.getElementById('cust5howmany').innerHTML = 0;
    stripChild(document.getElementById('custHolder1').firstChild, 0);
    stripChild(document.getElementById('custHolder3').firstChild, 0);
    stripChild(document.getElementById('custHolder5').firstChild, 0);

    // bev cleanup
    var lst = document.getElementById("bev_dataregistry").firstChild.childNodes;
    for(var i=0; i<lst.length; i++) { delete bev.data[lst[i].vectorname];}
    stripChild(document.getElementById("bev_dataregistry").firstChild, 0);
    for(var cn in bev.genomeCanvasTd) {
        stripChild(bev.genomeCanvasTd[cn], 0);
    }
    
    // misc
    stripChild(tracklabelholder, 0);
    document.getElementById('hmtkorderRevertButton').style.display = 'none';
    document.getElementById('simpleinfoWrapper').style.display = 'none';
    document.getElementById('hmtkdetailwrapper').style.display = 'none';
    ideogram.previous = [];
    qtcpanel_close();
}
function restoreStatus(stid) {
    /* SESS first do some clean up
       chrInfo needs to be restored
     */

    if(gflag.urlparam.usingsession) {
        // restore a status given by url parameter on page start up
	gflag.urlparam.restore2stid = stid;
	readygo(gflag.urlparam.dbname, false);
    } else {
        // restore status during normal browsing, need to clean up html holders
	statusId = stid; // this is important!
	ajaxRestorestatus();
    }
}
function ajaxRestorestatus() {
    // called by button-click session or urlparam
    cleanuphtmlholder();
    cloak(viewbox);
    print2console("restoring past browsing status...", 0);
    ajax('restoreStatus=on&dbName='+dbInfo.name, function(data){

        // follow strict order...
	json_scaffoldRuntimeInfo(data);
	// don't need to copy scaffold info to bev?

	var voidcustomtrack;
	if('voidcustomtrack' in data) {
	    voidcustomtrack = data['voidcustomtrack'];
	    alert(voidcustomtrack);
	}

	// dataset
	if(!("dataset" in data)) fatalError("restoreStatus: dataset missing");
	datasetLst = data["dataset"];
	jsonParseTkMetadata(data);
	jsonParseTkDetail(data);
	toggleOffAllDatasets();
	for(var i=0; i<datasetLst.length; i++) {
	    toggleOnDataset(datasetLst[i]);
	}

	stripChild(tkAttrHolder, 0);
	stripChild(viewbox, 0);
	turnoffCorrelation();

	if('custmd' in data) {
	    custmdhash = data['custmd'];
	    for(var attr in custmdhash) {
	        displayCustmdattr(attr);
	    }
	}

	if('mdconshow' in data)
	    mdcategoryOnshow = data['mdconshow'];
	initiateMdcOnshowCanvas();

	if(!("juxtaposition" in data)) fatalError("restoreStatus: juxtaposition missing");
        juxtaposition = data["juxtaposition"];
	juxtaposeHideOptions();

	/* qtrack config */
	if(!('qtc' in data)) fatalError('restoreStatus: qtc missing');
	qtc_paramCopy(data.qtc.htest, htest.qtc);
	qtc_paramCopy(data.qtc.pwc, pwc.qtc);
	qtc_paramCopy(data.qtc.correlation, correlation.qtc);


	tkLst = [];
	jsonXY(data);


        for(var gf in decorCanvasHash) {
	    decoruserlist_insert(gf);
	}

	setDisplaywhichgf();
        
	// pairwise comparison
	pwc.inuse = false;
	if('pairwisecomp' in data) {
	    pwc.gtn1 = data['pairwisecomp'][0];
	    pwc.gtn2 = data['pairwisecomp'][1];
	    for(i=0; i<pwc.gtn1.length; i++) {
	        pwc_assigngrp(pwc.gtn1[i], 1);
	    }
	    for(i=0; i<pwc.gtn2.length; i++) {
	        pwc_assigngrp(pwc.gtn2[i], 2);
	    }
	    pwc.inuse = true;
	    pwc_run();
	}


	/*
        if(!('clientCtrl' in data)) fatalError("restoreStatus: clientCtrl missing");
	var v = data['clientCtrl'];
	// SELECT
        for(var sid in v['S']) {
	    if(sid.length > 0) {
		var c = document.getElementById(sid);
		if(c == null) fatalError("<select> not found by id: "+sid);
		c.selectedIndex = v['S'][sid];
	    }
	}
        // RADIO
        for(var rname in v['R']) {
            var lst = document.getElementsByName(rname);
            for(var i=0; i<lst.length; i++)
                if(lst[i].value == v['R'][rname]) lst[i].checked = true;
        }
	*/



        /* though ideogram has been drawn in jsonXY()
	   but the "gftype" radio choice could be wrong at that time,
	   so if data collation is happening, must redrawn it...
	 */
	if(juxtaposition.type==3 || juxtaposition.type==4 || juxtaposition.type==5) {
            if(!('entireItemlist' in data))
		fatalError('restoreStatus: entireItemlist missing');
	    copyEntireItemlistRegion(data['entireItemlist']);
	    if(juxtaposition.type == 5) {
	        // extra work for contigs: put them into contig.Dtable
		for(i=0; i<data['entireItemlist'].length; i++) {
		    var cn = data['entireItemlist'][i][0];
		    var cid = -1;
		    for(j=0; j<contig.lst.length; j++) {
		        if(contig.lst[j][0] == cn) {
			    cid = j;
			    break;
			}
		    }
		    if(cid == -1)
		        fatalError("restoreStatus: unknown contig "+cn);
		    addContig2displaydiv(cid);
		}
	    }
	}
	drawIdeogramCanvas();

	if("correlation" in data) {
	    correlation.inuse = true;
	    correlation.targetft = data["correlation"][0];
	    correlation.where = data["correlation"][1];
	    correlation.targetname = data["correlation"][2];
	    runCorrelation();
	}

	if(htest.inuse) ajaxHtest();

	if(juxtaposition.type==3 || juxtaposition.type==4) {
	    collategenesGotoholder();
	    if('gssparam' in data) {
	        update_gssedit(data.gssparam);
	    }
	}

	// sticky notes...
	if("stickynote" in data) {
	    for(i=0; i<data["stickynote"].length; i++) {
	        var sndata = data["stickynote"][i];
	        var note = makestickynote();
		note.style.left = sndata[0];
		note.style.top = sndata[1];
		var tmpstring = sndata[2].replace(/-verBar-/g, "|");
		tmpstring = tmpstring.replace(/-newline-/g, "\n");
		note.firstChild.value = tmpstring;
	    }
	}

	unveil(viewbox);
	print2console("status restored", 1);
    });
}

function addRow4newStatus() {
    /* add a row in statusHolder for a status
       called by:
          saving a new status under session (where information will be gathered from objects)
	  retrieving statuses using a session ID, where all arguments will be supplied

       variable arguments:
       0. holder (table dom object)
       1. status id
       2. note
       3. dsp string (optional)
       4. array of file number (optional)
       5. jux note (optional)

       if arguments 3,4,5 are missing, implies that it is saving current state
     */

    var holder = arguments[0];

    var tr = holder.insertRow(-1);
    tr.id = "stid"+arguments[1]; // global id, for delete status
    // (1) note, also show status id in small font
    var td = tr.insertCell(0);
    td.align = 'right';
    td.innerHTML = '<span class=clb style="color:#00c;" onclick="restoreStatus('+arguments[1]+')">"'+arguments[2]+'"</span><br><span style="color:#858585;font-size:10px;">id: '+arguments[1]+'</span>';
    // (2) jux on what
    tr.insertCell(-1).innerHTML = 'viewing '+(arguments[5]==undefined ? juxtaposition.note : arguments[5]);
    // (3) dsp
    var ss;
    if(arguments[3] != undefined) {
        ss = arguments[3];
    } else {
        var tmp = getDspStat();
        if(tmp[0] == tmp[2])
            ss = tmp[0]+' from '+tmp[1]+' to '+tmp[3];
        else
            ss = 'from '+tmp[0]+'('+tmp[1]+') to '+tmp[2]+'('+tmp[3]+')';
    }
    td = tr.insertCell(-1);
    td.innerHTML = ss;
    td.style.color = '#858585';
    // (4) # of tracks
    var lst = [];
    if(arguments[4] != undefined) {
        lst = arguments[4];
    } else {
        lst = [0,0,0,0,0,0];
	for(var dn in decorCanvasHash) {
	    if(decorInfo[dn].fileType==1)
	        lst[1]++;
	    else if(decorInfo[dn].fileType==5)
	        lst[5]++;
	}
	for(var i=0; i<tkLst.length; i++) {
	    if(tkLst[i].isCustom)
	        lst[3]++;
	    else
	        lst[2]++;
	}
    }
    var lst2 = [];
    if(lst[2] > 0) lst2[0] = lst[2]+' heatmap tracks';
    if(lst[3]>0) lst2.push(lst[3]+' custom heatmap tracks');
    if(lst[1]>0) lst2.push(lst[1]+' custom genomic feature tracks');
    if(lst[5]>0) lst2.push(lst[5]+' custom BAM tracks');
    tr.insertCell(-1).innerHTML = lst2.join('<br>');

    // (5) removal icon
    if(!gflag.urlparam.usingsession) {
        tr.insertCell(-1).innerHTML = "<span style='color:#C20013;cursor:pointer;' onclick=deleteStatus("+arguments[1]+") title='delete status from database'>&#10005;</span>";
        document.getElementById('sessionsaysyes').style.display = 'block';
    }
}



/*********************
    tooltip
    it is supposed that it's working for the tooltip over genome heatmap
 *********************/
function tooltipshowup(event) {
    // bring tooltip up, move it to where event happens, and don't update
    tooltipshow();
    tooltipmove(event);
}
function tooltipshow() {
    pica.style.display = 'block';
}

function tooltiphide() {
    pica.style.display = 'none';
    indicator.style.display = 'none';
    /* when mouse over heatmap, and if track label is shown, one track label will be highlighted
       by changing its class name
       need to change the class name back when mouse out genome heatmap
     */
    if(viewbox.tknameshow) {
	for(var i=0; i<tkNameLst.length; i++)
	    tracklabelholder.childNodes[i].className = 'clb2';
    }
}
function tooltipmove(event) {
    var x = event.clientX + document.body.scrollLeft;
    var y = event.clientY + document.body.scrollTop;
    var iX = x - iiX - move.styleLeft;
    var iY = getTrackIdxByMousepos(event.clientY);
    pica.style.top = y + 10;
    pica.style.left = x + 10;
    var ta = event.target;
    if(ta.className === 'hmCanvas') {
	iX = x - iiX+1;
	var tmp = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, iX);
	if(tmp[1] < 0) {
	    picasays.innerHTML = '';
	} else {
	    var r = regionLst[tmp[0]];
	    if(entire.atbplevel)
	        picasays.innerHTML = 'score: '+tkLst[iY].data[tmp[0]][tmp[1]]+'<br>track: '+tkLst[iY].label+'<br>'+r[0]+' '+(r[3]+tmp[1]);
	    else
	        picasays.innerHTML = 'score: '+tkLst[iY].data[tmp[0]][tmp[1]]+'<br>track: '+tkLst[iY].label+'<br>'+r[0]+' '+parseInt(r[3]+tmp[1]*r[7]);
	}
	// highlight metadata canvas
	if(mdcategoryOnshow.length > 0) {
	    indicator.style.display = 'block';
	    indicator.style.left = iiiX;
	    indicator.style.top = iiY + sumTrackHeight(iY);
	    indicator.style.width = tkAttrColumnWidth * mdcategoryOnshow.length-2;
	    indicator.style.height = tkLst[iY].qtc.height-2;
	}
	// highlight track name if name is shown
	if(viewbox.tknameshow) {
	    // don't fire mouseover events that won't work
	    for(var i=0; i<tkNameLst.length; i++)
	        tracklabelholder.childNodes[i].className = 'clb2';
	    tracklabelholder.childNodes[iY].className = 'clb4';
	}
    } else if(ta.className === 'tkattrCanvas') {
        var x = Math.floor((event.clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
	// decide if this metadata attribute is "server" or "custom"!!!
	if(mdcategoryOnshow[x] in custmdhash) {
	    // wow, custom...
            picasays.innerHTML = (ta.attr[x]==undefined) ? "" : ta.attr[x];
	} else {
	    // server, must look into mdvidx2attr for its string value
            picasays.innerHTML = (ta.attr[x]==undefined) ? "" : mdvidx2attr[ta.attr[x]];
	}
	// highlight hmcanvas
	indicator.style.display = 'block';
	indicator.style.left = iiX;
	indicator.style.top = iiY + sumTrackHeight(iY);
	indicator.style.width = hmSpan-2;
	indicator.style.height = tkLst[iY].qtc.height-2;
    } else if(ta.className === 'trackGroup') {
        picasays.innerHTML = ta.alt;
    } else if(ta.className === 'moveTrack') {
        picasays.innerHTML = tkLst[iY].label+"<br><span style='color:white'>drag to move</span>";
	highlighttrack(iY, 1);
    } else if(ta.className === 'corrCanvas') {
        var n = new Number(tkLst[iY].corr);
        picasays.innerHTML = tkLst[iY].label+"<br>spearman's rho: "+n.toFixed(3);
	highlighttrack(iY, 1);
    } else if(ta.className === 'htestCanvas') {
	iX = x - iiX+1;
	var tmp = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, iX);
	if(tmp[1] < 0) {
	    picasays.innerHTML = '';
	} else {
	    var r = regionLst[tmp[0]];
	    picasays.innerHTML = r[0]+' '+(parseInt(r[3]+tmp[1]*r[7]))+'<br>P value: '+htest.pvalue[tmp[0]][tmp[1]];
	}
    } else if(ta.className === 'pairwisecompCanvas') {
	iX = x - iiX+1;
	var tmp = regionLstSPseekright(dspBoundary.vstartr, dspBoundary.vstarts, iX);
	if(tmp[1] < 0) {
	    picasays.innerHTML = '';
	} else {
	    var r = regionLst[tmp[0]];
	    picasays.innerHTML = r[0]+' '+(parseInt(r[3]+tmp[1]*r[7]))+'<br>log2 ratio: '+pwc.logratio[tmp[0]][tmp[1]].toFixed(2);
	}
    } else if(ta.className === 'tkattrnamevcanvas') {
        picasays.innerHTML = mdcategoryOnshow[event.target.id]+"<br><span style='color:white'>click to sort tracks</span>";
    } else if(ta.className == 'geneplotcanvas') {
        // only works for mode s4, heatmap
	if(y-geneplot.canvasY >= geneplot.genelst.length*geneplot.canvasrheight)
	    return;
	var dpidx = parseInt((x-geneplot.canvasX)/geneplot.canvaspwidth);  // data point idx
	var geneid = geneplot.genelst[parseInt((y-geneplot.canvasY)/geneplot.canvasrheight)];
	var genename = geneplot.safe2real[geneid];
	if(genename == undefined)
	    return;
	picasays.innerHTML = genename+"<br>data point value: "+geneplot.data[geneid][dpidx+1];
    } else if(ta.className == "jumpposinput") {
        picasays.innerHTML = "e.g. chr1:1397760-1808384<br>use space/tab/dash/colon to separate fields<br>use 'chrX' but not 'chrx' or 'ChrX'";
    } else if(ta.className == "jumpgeneinput") {
        picasays.innerHTML = "e.g. CDK11B, IL1RAPL1<br>case insensititve";
    }
}
function showhelpitem(id, x, y) {
    var img = document.getElementById(id);
    img.style.display = 'inline';
    img.style.position = 'absolute';
    img.style.left = x;
    img.style.top = y;
}
function helpmsg() {
    if(helpmsgshowing) {
        helpmsghide();
	helpmsgshowing = false;
	return;
    }
    helpmsgshowing = true;
    showhelpitem('hmcanvasHelp', iiX+hmSpan/2-130, iiY-108);
    showhelpitem('corrHelp', 0, iiY-120);
    showhelpitem('tkattrsortHelp', iiiX-58, iiY-200);
    showhelpitem('tkgrpmoveHelp', iiiX-230, iiY-125);
    showhelpitem('ideogramHelp', iiX+hmSpan/2-100, iiY+sumTrackHeight()+1);
    showhelpitem('tkmoveHelp', iiiX+tkAttrColumnWidth*mdcategoryOnshow.length-125, iiY+sumTrackHeight()-100);
    showhelpitem('decorHelp', iiiX-hmSpan, iiY+sumTrackHeight()+50);
    document.getElementById("helpmsgbutton").className = "shortcutbutMD";
}
function helpmsghide() {
    var lst = document.getElementsByName("help");
    for(var i=0; i<lst.length; i++) {
        lst[i].style.display = 'none';
    }
    document.getElementById("helpmsgbutton").className = "shortcutbut";
	helpmsgshowing = false;
}


function swapTrack(i,j) {
    // track j will be put at place i
    // not actually swap position i with j
    if(i == j) return;
    var tn = tkNameLst.splice(j,1)[0];
    var tk = tkLst.splice(j,1)[0];
    tkNameLst.splice(i,0,tn);
    tkLst.splice(i,0,tk);
}



/******************************
    track group moving, 
    by dragging on metadata color block
 *****************************/
function sameAttrIdxCheckup(xi, yi) {
    /* yi is tkLst index, xi is mdcategoryOnshow index
       like 2d grid of color bar
       check for tkLst index for same attribute to 'up'
     */
    var j = yi;
    var at = tkLst[yi].attrlst[xi];
    while(j>0) {
        if(tkLst[j-1].attrlst[xi] == at)
	    j--;
	else
	    break;
    }
    return j;
}
function sameAttrIdxCheckdown(xi, yi) {
    var j = yi;
    var at = tkLst[yi].attrlst[xi];
    while(j<tkLst.length-1) {
        if(tkLst[j+1].attrlst[xi] == at)
	    j++;
	else
	    break;
    }
    return j;
}
function movetkgrpSetborders(xi, yi) {
    /* |----|======|----|
       a    b      c    d
       abcd are array index of tkLst, a nears 0, d nears ++
       between b and c are moving part

       TODO a,d are obsolete, because now tkgrp are moved by steps of single tracks
     */
    if(tkLst[yi].attrlst[xi] == undefined) throw("movetkgrpSetborders landed on null attribute: "+xi+" "+yi);
    tkAttrHolder.b = sameAttrIdxCheckup(xi, yi);
    tkAttrHolder.c = sameAttrIdxCheckdown(xi, yi);
    if(tkAttrHolder.b == 0)
        tkAttrHolder.a = 0;
    else {
        if(tkLst[tkAttrHolder.b-1].attrlst[xi] == undefined)
	    tkAttrHolder.a = tkAttrHolder.b-1;
	else
            tkAttrHolder.a = sameAttrIdxCheckup(xi, tkAttrHolder.b-1);
    }
    if(tkAttrHolder.c == tkLst.length-1)
        tkAttrHolder.d = tkLst.length-1;
    else {
        if(tkLst[tkAttrHolder.c+1].attrlst[xi] == undefined)
	    tkAttrHolder.d = tkAttrHolder.c+1;
	else
            tkAttrHolder.d = sameAttrIdxCheckdown(xi, tkAttrHolder.c+1);
    }
}

function movetkgrpMD(event) {
    if(event.button != 0) return;
    event.preventDefault();
    var xidx = Math.floor((event.clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
    tkAttrHolder.idx = xidx;
    tkAttrHolder.y = event.clientY - iiY + document.body.scrollTop;
    var yidx = getTrackIdxByMousepos(event.clientY);
    // not moving null regions
    if(tkLst[yidx].attrlst[xidx] == null) return;
    movetkgrpSetborders(xidx, yidx);
    tooltiphide();
    tkAttrHolder.removeEventListener("mousemove", tooltipmove, false);
    document.body.addEventListener("mousemove", movetkgrpM, false);
    document.body.addEventListener("mouseup", movetkgrpMU, false);
}
function movetkgrpMU(event) {
    tooltipshow();
    document.body.removeEventListener("mousemove", movetkgrpM, false);
    document.body.removeEventListener("mouseup", movetkgrpMU, false);
    tkAttrHolder.addEventListener("mousemove", tooltipmove, false);
}
function movetkgrpM(event) {
    var y = event.clientY - iiY + document.body.scrollTop;
    var L = tkLst.length;
    if(y > tkAttrHolder.y) {
        // move down
        if(tkAttrHolder.c >= L-1) return;
	if(y-tkAttrHolder.y >= tkLst[tkAttrHolder.c+1].qtc.height) {
	    swapTrack(tkAttrHolder.b,tkAttrHolder.c+1);
	    stuffTrackCanvas2holder();
	    movetkgrpSetborders(tkAttrHolder.idx, tkAttrHolder.c+1);
	    tkAttrHolder.y = y;
	}
    } else {
        // move up
        if(tkAttrHolder.b <= 0) return;
	if(tkAttrHolder.y-y >= tkLst[tkAttrHolder.b-1].qtc.height) {
	    swapTrack(tkAttrHolder.c,tkAttrHolder.b-1);
	    stuffTrackCanvas2holder();
	    movetkgrpSetborders(tkAttrHolder.idx, tkAttrHolder.b-1);
	    tkAttrHolder.y = y;
	}
    }
}


/***************************
    context MENU

    menu.context - tells the context, 1. single track in heatmap
                                      2. group of tracks in metadata area
				      3. decor track canvas
				      4. htest pvalue canvas
    menu.iY - tkLst index of single track
    menu.trackIdxLst - list of tkLst index of selected tracks
 ***************************/
function contextMenu(event) {
    /* context-specific menu by right click
       tell which component is under focus by class name
     */
    var ec = event.target.className;
    if(ec==undefined || ec=="") 
        return true;

    // first, shut off stuff that's been open by menu
    qtcpanel_close();
    stcpanel_hide();
    vrearrange_close();

    // shut off all wrappers and solos, then turn on whenever needed
    menu.singletkwrapper.style.display = 'none';
    menu.htestwrapper.style.display = "none";
    menu.pairwisecompwrapper.style.display = "none";
    menu.corrwrapper.style.display = "none";
    menu.decorwrapper.style.display = "none";
    menu.mcmwrapper.style.display = "none";
    menu.c15.style.display = 'none';
    menu.c9.style.display = 'none';
    menu.c21.style.display = 'none';
    menu.c20.style.display = 'none';
    menu.style.width = 180; // default width

    if(ec == "hmCanvas") {
        // clicked on heatmap, dealing with one track, menu.iY is tkLst index
        menu.context = 1;
        menu.iY = getTrackIdxByMousepos(event.clientY);
	menu.c1.innerHTML = "this track:";
	menu.singletkwrapper.style.display = 'block';
	menu.c18.style.display = (juxtaposition.type==3 || juxtaposition.type==4) ? "block" : "none";
	//menu.c23.style.display = (tkNameLst[menu.iY] in hmtk.tobam) ? 'block' : 'none';
	// solos
	menu.c15.style.display = document.getElementById("tgt_htest").style.display;
	menu.c21.style.display = document.getElementById("tgt_pairwiseCompare").style.display;
	menu.c20.style.display = "block";
        menu.c9.style.display = 'block';

	addHtestgrp2menu();

	tooltiphide();
	// disable tooltip on viewbox and metadata canvas
        viewbox.removeEventListener("mouseover", tooltipshow, false);
        viewbox.removeEventListener("mouseout", tooltiphide, false);
        viewbox.removeEventListener("mousemove", tooltipmove, false);
        tkAttrHolder.removeEventListener("mouseover", tooltipshow, false);
        tkAttrHolder.removeEventListener("mouseout", tooltiphide, false);
        tkAttrHolder.removeEventListener("mousemove", tooltipmove, false);

	highlighttrack(menu.iY, 3);

	// if is custom track, need to hide "Information" and "link to geo" choices
	menu.c16.style.display = "block";
	//menu.c17.style.display = "block";
	menu.c19.style.display = 'none';
	if(tkLst[menu.iY].isCustom) {
	    menu.c16.className = "menustaticchoice";
	    //menu.c17.className = "menustaticchoice";
	    menu.c19.style.display = 'block';
	} else {
	    menu.c16.className = "menuactivechoice";
	}

    } else if(ec == "tkattrCanvas") {
        /* mcm metadata color map
	   if clicked on gray area, don't pop up menu,
	 */
        menu.context = 2;
	menu.iY = getTrackIdxByMousepos(event.clientY);
        menu.iX = Math.floor((event.clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
	var attrvalue = tkLst[menu.iY].atC.attr[menu.iX];
	if(attrvalue==undefined || attrvalue==null) 
	    return false;
	menu.trackIdxLst = [];
	// count number of tracks to be touched
	var targetAttrValue = tkLst[menu.iY].atC.attr[menu.iX];
	// going up
	for(var i=menu.iY; i>=0; i--) {
	    if(tkLst[i].atC.attr[menu.iX] == targetAttrValue)
	        menu.trackIdxLst.push(i);
	    else 
	        break;
        }
	var firsttrackidx = i+1; // for placing indicator <div>
	// going down
	for(i=menu.iY+1; i<tkLst.length; i++) {
	    if(tkLst[i].atC.attr[menu.iX] == targetAttrValue)
	        menu.trackIdxLst.push(i);
	    else 
	        break;
	}
	menu.style.width = 170;
	menu.c1.innerHTML = (attrvalue in mdvidx2attr ? mdvidx2attr[attrvalue] : attrvalue)+": "+menu.trackIdxLst.length+" track"+((menu.trackIdxLst.length>1)?"s":"");

	//menu.c17.style.display = "none";
        menu.c9.style.display = 'block';
	menu.c15.style.display = document.getElementById("tgt_htest").style.display;
	menu.c21.style.display = document.getElementById("tgt_pairwiseCompare").style.display;
	menu.c20.style.display = "block";
	addHtestgrp2menu();

	tooltiphide();
	// disable tooltip on viewbox and metadata canvas
        viewbox.removeEventListener("mouseover", tooltipshow, false);
        viewbox.removeEventListener("mouseout", tooltiphide, false);
        viewbox.removeEventListener("mousemove", tooltipmove, false);
        tkAttrHolder.removeEventListener("mouseover", tooltipshow, false);
        tkAttrHolder.removeEventListener("mouseout", tooltiphide, false);
        tkAttrHolder.removeEventListener("mousemove", tooltipmove, false);

	// place indicator <div> over this group of tracks
	placeIndicator3_menuTklst();
    } else if(ec == "decorCanvas") {
        // decor track canvas
        menu.context = 3;
	menu.style.width = 170;
	menu.decorname = event.target.decorname; // .decorname of canvas
	var ft = decorInfo[menu.decorname].fileType;
	menu.c22.style.display = "none";
	/*
	if(ft == 1) {
	    // is custom bigbed
	    menu.c22.style.display = "block";
	} else {
	    menu.c22.style.display = "none";
	}
	*/
        menu.c1.innerHTML = decorInfo[menu.decorname].label;
	menu.decorwrapper.style.display = "block";
	var mode = decorInfo[menu.decorname].mode;
	if(mode == "show") {
	    menu.c6.style.display = "none";
	    menu.c7.style.display = "none";
	    menu.c8.style.display = "none";
	    menu.c20.style.display = "block";
	} else {
	    if(mode == "thin") {
	        menu.c6.style.display = "none";
	    } else {
	        menu.c6.style.display = "block";
	    }
	    if(mode == "full") {
	        menu.c7.style.display = "none";
	    } else {
	        menu.c7.style.display = "block";
	    }
	    if(mode == "density") {
	        menu.c8.style.display = "none";
	        menu.c20.style.display = (ft==4||ft==5) ? 'none' : 'block';
	    } else {
	        menu.c8.style.display = "block";
	    }
	}
	// show rearrange option if more than one decor track is shown
	menu.c9.style.display = document.getElementById('tgt_decorCanvasHeader').childNodes.length>1 ? 'block' : 'none';

	var fileType = decorInfo[menu.decorname].fileType;

        menu.c12.style.display = "none";
        menu.c2.style.display = "none";
	if(gflag.allowjuxtaposition && (fileType==0 || fileType==1)) {
	    if(juxtaposition.type == 0) {
	        if(mode=="thin" || mode=="full") {
		    menu.c12.style.display = "block";
		}
	    } else {
	        menu.c2.style.display = "block";
	    }
	}
	if(mode=='density' || mode=='show')
	    menu.c14.style.display = "block";
	else
	    menu.c14.style.display = "none";
	placeIndicator3_menuDecor();
    } else if(ec == "htestCanvas") {
        // htest pvalue canvas
	menu.context = 4; // context needed for this case?
	menu.c1.innerHTML = "Htest P-values:";
	menu.c20.style.display = "block";
	menu.htestwrapper.style.display = "block";
	//changeSelectByValue("pvcutoff_menu", getSelectValueById("pvcutoff"));
    } else if(ec == "pairwisecompCanvas") {
        // pairwise
        menu.context = 5;
	menu.c1.innerHTML = "Pairwise comparison";
	menu.c20.style.display = "block";
	menu.pairwisecompwrapper.style.display = "block";
    } else if(ec == "corrCanvas") {
        menu.context = 6;
	menu.corrwrapper.style.display = "block";
	menu.c1.innerHTML = 'correlation';
	/*
    } else if(ec == "bevvcanvas") {
        bird's eye view vector canvas 
        menu.context = 7;
	bev.ongoing = event.target.title;
	menu.c1.innerHTML = bev.data[bev.ongoing].printname;
	*/
    } else if(ec == 'tkattrnamevcanvas') {
        /* clicked on canvas 
	   use iX to tell which term is clicked
	 */
        menu.context = 8;
        menu.iX = Math.floor((event.clientX-iiiX+document.body.scrollLeft)/tkAttrColumnWidth);
	menu.c1.innerHTML = mdcategoryOnshow[menu.iX];
        menu.mcmwrapper.style.display = 'block';
    } else {
        // context menu not activated
	return true;
    }
    menu.style.display = "block";
    var pos = event.clientX + document.body.scrollLeft;
    if(event.clientX+menu.clientWidth > document.body.clientWidth)
        pos -= menu.clientWidth;
    menu.style.left = pos;
    pos = event.clientY + document.body.scrollTop;
    if(event.clientY+menu.clientHeight > document.body.clientHeight)
        pos -= menu.clientHeight;
    menu.style.top = pos;
    document.body.addEventListener("click", menuHide, false);
    return false;
}
function menuHide() {
    menu.style.display = "none";
    document.body.removeEventListener("click", menuHide, false);
    // recover event listner for tooltip on viewbox and metadata canvas
    if(menu.context==1 || menu.context==2) {
        viewbox.addEventListener("mouseover", tooltipshow, false);
        viewbox.addEventListener("mouseout", tooltiphide, false);
        viewbox.addEventListener("mousemove", tooltipmove, false);
        tkAttrHolder.addEventListener("mouseover", tooltipshow, false);
        tkAttrHolder.addEventListener("mouseout", tooltiphide, false);
        tkAttrHolder.addEventListener("mousemove", tooltipmove, false);
	if(document.getElementById('ftb_qtCfgdiv').style.display=='none') {
	    indicator3.style.display = "none";
	}
    }
    if(menu.context == 3) {
        if(document.getElementById("ftb_stcdiv").style.display == "none") {
	    indicator3.style.display = "none";
	}
    }
}
function menuRemove() {
    // remove/hide/turnoff things depend on context
    switch(menu.context) {
    case 1:
	removeBigwigTrack(menu.iY);
	updateAfterRemovetrack();
	break;
    case 2:
	var names = [];
	for(var i=0; i<menu.trackIdxLst.length; i++)
	    names.push(tkLst[menu.trackIdxLst[i]].name);
	for(i=0; i<names.length; i++) {
	    // look for this track's index by its name
	    var idx = getTkidxByname(names[i]);
	    if(idx != -1)
		removeBigwigTrack(idx);
	}
	updateAfterRemovetrack();
	break;
    case 3:
	decorInfo[menu.decorname].mode = "hide";
	toggleDecor(menu.decorname);
	break;
    case 4:
        turnoffHtest();break;
    case 5:
        turnoffPairwisecomp();break;
    case 6:
    	turnoffCorrelation();break;
    case 8:
        if(menu.iX >= mdcategoryOnshow.length)
	    return;
	var term = mdcategoryOnshow[menu.iX];
	// simulate unchecking checkbox to turn off
	mdselect.which = 1; // to indicate this is turning off terms from mcm
	var lst = document.getElementsByName('mdcheckbox');
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].getAttribute('termidx') == term) {
		var e = document.createEvent("MouseEvents");
		e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
		lst[i].dispatchEvent(e);
	    }
	}
	return;
    default:
        fatalError("menuRemove: unknown menu context id");
    }
}
function menuConfig() {
    // context-dependent function, config anything
    switch(menu.context) {
    case 1: // single heatmap bigwig
        qtcpanel_setdisplay(tkLst[menu.iY].qtc,
	    true, // pc
	    true, // nc
	    true, // scale
	    true, // log
            false, // pvcut
	    true, // height
	    true, // alltk
	    "heatmap track",1,'positive value', 'negative value');
        highlighttrack(menu.iY, 3);
	break;
    case 2: // bigwigs via metadata hm
        qtcpanel_setdisplay(null,
	    true, // pc
	    true, // nc
	    true, // scale
	    true, // log
            false, // pvcut
	    true, // height
	    true, // alltk
	    "heatmap tracks",2,'positive value', 'negative value');
        placeIndicator3_menuTklst();
	break;
    case 3: // decor
        var obj = decorInfo[menu.decorname];
	var ft = obj.fileType;
	var mode = obj.mode;
	if(ft==0 || ft==1) {
	    // bigbed
	    if(mode == "density") {
		qtcpanel_setdisplay(decorCanvasHash[menu.decorname].qtc,
		    true, // pc
		    false, // nc
		    true, // scale
		    false, // log
	            false, // pvcut
		    true, // height
		    false, // alltk
		    obj.label,3,'feature density','ya never see this');
	    } else if(mode=="thin" || mode=='full') {
	        stcpanel_setdisplay(menu.decorname);
	    } else { fatalError("menuDecorConfig: unknown decor mode "+mode); }
	} else if(ft == 8) {
	    // ASSume decor bigwig can only be 8
	    qtcpanel_setdisplay(decorCanvasHash[menu.decorname].qtc,
	        true, // pc
		true, // nc
		true, // scale
		true, // log
	        false, // pvcut
		true, // height
		false, // alltk
		obj.label,4,'positive value','negative value');
	} else if(ft==4 || ft==5) {
	    // bam
	    if(mode == 'density') {
		qtcpanel_setdisplay(decorCanvasHash[menu.decorname].qtc,
		    true, // pc
		    false, // nc
		    true, // scale
		    false, // log
		    false, // pvcut
		    true, // height
		    false, // alltk
		    obj.label,3,'read density','ya never see this');
	    } else if(mode=='thin' || mode=='full') {
	        stcpanel_setdisplay(menu.decorname);
	    } else { fatalError("menuDecorConfig: unknown decor mode "+mode); }
	}
	break;
    case 4: // htest pvalue
        qtcpanel_setdisplay(htest.qtc,
	    false, // pc
	    true, // nc
	    false, // scale
	    false, // log
	    true, // pvcut
	    true, // tkh todo
	    false, // alltk 
	    "P-value track",9,'', 'P-value bar color');
	break;
    case 5: // pwc
        qtcpanel_setdisplay(pwc.qtc,
	    true, // pc
	    true, // nc
	    true, // scale
	    false, // log
	    false, // pvcut
	    true, // tkh
	    false, // alltk
	    "pairwise log ratio",6,'grp1 &gt; grp2', 'grp1 &lt; grp2');
	break;
    case 6: // corr
        qtcpanel_setdisplay(correlation.qtc,
	    true, // pc
	    true, // nc
	    false, // scale
	    false, // log
	    false, // pvcut
	    false, // tkh
	    false, // all tk
	    "correlation coef.",7,'corr coef. > 0','corr coef. < 0');
	break;
    case 7:
        bev_config();
	break;
    case 8:
        print2console('Function unavailable yet', 2);
	break;
    default:
        fatalError("menuConfig: unknown menu context id");
    }
}
function menuBirdeyeview() {
    // context-dependent function, bev anything!
    switch(menu.context) {
    case 1:
        // single hmtk
        var obj = tkLst[menu.iY];
        birdsEyeView([[obj.name, obj.isCustom?3:2, obj.label, obj.url, true]], 1);
	break;
    case 2:
        // multiple hmtk
        var lst = [];
        for(var i=0; i<menu.trackIdxLst.length; i++) {
	    var obj = tkLst[menu.trackIdxLst[i]];
	    lst.push([obj.name, obj.isCustom?3:2, obj.label, obj.url, true]);
	}
	birdsEyeView(lst, 1);
	break;
    case 3:
        // decor
	// ASSume decor bigwig can only be 8
	var obj = decorInfo[menu.decorname];
        birdsEyeView([[menu.decorname, obj.fileType, 
		obj.label+(obj.fileType==8?"":" (feature density)"),
		obj.url, true]], 1);
	break;
    case 4:
        // htest
	var lst = [];
	for(var i=1; i<=htest.grpnum; i++) {
	    if(htest['gtn'+i].length == 0) return;
	    for(var j=0; j<htest['gtn'+i].length; j++) {
	        var obj = findTrackByName(htest['gtn'+i][j]);
                lst.push([obj.name, obj.isCustom?3:2, obj.label, obj.url, false]);
	    }
	}
	birdsEyeView(lst, 3);
	break;
    case 5:
        // pwc
        if(pwc.gtn1.length == 0) return;
        if(pwc.gtn2.length == 0) return;
	var lst = [];
	for(var i=0;i<pwc.gtn1.length; i++) {
	    var ii = getTkidxByname(pwc.gtn1[i]);
            lst.push([pwc.gtn1[i], tkLst[ii].isCustom?3:2, tkLst[ii].label, tkLst[ii].url, false]);
	}
	for(i=0;i<pwc.gtn2.length; i++) {
	    var ii = getTkidxByname(pwc.gtn2[i]);
            lst.push([pwc.gtn2[i], tkLst[ii].isCustom?3:2, tkLst[ii].label, tkLst[ii].url, false]);
	}
	birdsEyeView(lst, 2);
	break;
    default:
        fatalError("menuBirdeyeview: unsupported menu.context");
    }
    menuHide();
}
function menuVrearrange() {
    // rearrange things vertically
    var x = parseInt(menu.style.left);
    var y = parseInt(menu.style.top);
    if(menu.context==1 || menu.context==2) {
	vrearrange_invoke(menu.context, x, y);
	if(menu.context == 1)
            setTimeout("highlighttrack(menu.iY, 3)", 100);
	else
	    setTimeout("placeIndicator3_menuTklst()", 100);
    } else if(menu.context == 3) {
        vrearrange_invoke(5, x, y);
	setTimeout('placeIndicator3_menuDecor()', 100);
    } else {
        fatalError('menuVrearrange: unknown menu.context');
    }
}
function menuDecorChangemodethin() {
    // change into thin mode
    decorInfo[menu.decorname].mode = "thin";
    changeSelectByValue(decorInfo[menu.decorname].selectdom, "thin");
    cgiDrawDecor(menu.decorname);
}
function menuDecorChangemodefull() {
    // change into full mode
    decorInfo[menu.decorname].mode = "full";
    changeSelectByValue(decorInfo[menu.decorname].selectdom, "full");
    cgiDrawDecor(menu.decorname);
}
function menuDecorChangemodedensity() {
    // change into density mode
    decorInfo[menu.decorname].mode = "density";
    changeSelectByValue(decorInfo[menu.decorname].selectdom, "density");
    cgiDrawDecor(menu.decorname);
}
function menuDecorMove2top() {
    var ch = document.getElementById("tgt_decorCanvas");
    var hh = document.getElementById("tgt_decorCanvasHeader");
    ch.appendChild(decorCanvasHash[menu.decorname].viewbox);
    hh.appendChild(decorCanvasHash[menu.decorname].header);
    while(ch.firstChild.firstChild.decorname != menu.decorname) {
        ch.appendChild(ch.firstChild);
        hh.appendChild(hh.firstChild);
    }
}
function menuDecorMove2bottom() {
    var ch = document.getElementById("tgt_decorCanvas");
    var hh = document.getElementById("tgt_decorCanvasHeader");
    ch.appendChild(decorCanvasHash[menu.decorname].viewbox);
    hh.appendChild(decorCanvasHash[menu.decorname].header);
}
function menuDecorJuxtapose() {
    // juxtapose on a decor track
    var ft = decorInfo[menu.decorname].fileType;
    if(ft == undefined)
        fatalError("menuDecorJuxtapose: undefined decor file type");
    if(ft == 0) {
	juxtaposition.type = 1;
        juxtaposition.note = decorInfo[menu.decorname].label;
	juxtaposition.what = menu.decorname;
    } else if(ft == 1) {
	juxtaposition.type = 2;
        juxtaposition.note = "custom bigBed track";
	juxtaposition.what = decorInfo[menu.decorname].url;
    } else {
        fatalError("menuDecorJuxtapose: undefined decor file type");
    }
    setDisplaywhichgf();
    juxtaposeHideOptions();
    cloak(viewbox);
    print2console("juxtaposing "+juxtaposition.note+"...", 0);
    ajaxX(displayedRegionParam()+hmtkChoice()+decorParams()+htestParams()+corrParam()+"&changeGF=on");
}
function menuSorttrack() {
    if(menu.context == 6) {
	/* correlation with a heatmap track
	   TODO hm track might contain composite tracks in future
		correlation radio button would be out-dated?
		target will be kept in correlation object in memory
	 */
	if(!correlation.inuse)
	    return;
	// sort track by corr in descending order
	var sorted = tkLst.sort(corrSort);
	tkNameLst = [];
	for(var i=0; i<tkLst.length; i++)
	    tkNameLst.push(tkLst[i].name);
	stuffTrackCanvas2holder();
    } else if(menu.context == 8) {
        mcmSortTrack(menu.iX);
    }
}
function menuMcmflip() {
    mdcholder.attop = !mdcholder.attop;
    mdcholder_place();
}
function menuPicktrack4geneset() {
    /* for right-click on one hmtk
       select current track for geneset sorting, or gene plot
       change option for the two <select>
     */
    var obj = tkLst[menu.iY];
    document.getElementById('genesetsort_tkname').innerHTML = obj.name;
    document.getElementById('genesetsort_tklabel').innerHTML = obj.label;
    document.getElementById('geneplot_tkname').innerHTML = obj.name;
    document.getElementById('geneplot_tklabel').innerHTML = obj.label;
    if(obj.isCustom) {
        document.getElementById('genesetsort_tkiscustom').innerHTML = 1;
	document.getElementById('genesetsort_tkurl').innerHTML = obj.url;
        document.getElementById('geneplot_tkiscustom').innerHTML = 1;
	document.getElementById('geneplot_tkurl').innerHTML = obj.url;
    } else {
        document.getElementById('genesetsort_tkiscustom').innerHTML = 0;
        document.getElementById('geneplot_tkiscustom').innerHTML = 0;
    }
}
function menuHmtkCorr() {
    correlation.targetname = tkLst[menu.iY].name;
    correlation.targetft = tkLst[menu.iY].isCustom ? 3 : 2;
    correlation.where = 0; // from heatmap...
    correlation.inuse = true;
    runCorrelation();
}
function menuDecorCorr() {
    /* correlation against a decor track, which should be in either density or show mode
       check the correlation radio, then call cgiCorrelation

       need to decide track type
       if is server bigbed, correlation radio value is decor track name
       if is custom bigbed, correlation radio value is url
       bigwig unimplemented yet...

       sorry but the logic needs clean up
     */
    var m = decorInfo[menu.decorname].mode;
    if(m!="density" && m!="show") {
        print2console("menuDecorCorr: decor track not in density/show mode");
        return;
    }
    var ft = decorInfo[menu.decorname].fileType;
    correlation.targetft = ft;
    correlation.targetname = menu.decorname;
    correlation.where = 1; // from decor...
    correlation.inuse = true;

    if(ft!=4 && ft!=5) {
	var lst = document.getElementsByName("correlation");
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].value == menu.decorname) {
		lst[i].checked = true;
		break;
	    }
	}
    }
    runCorrelation();
}
function menuGetHtestregions() {
    // open new window, write data at each point neatly

    var grp = {};
    // key: grp id
    // val: list of tracks, [tk label, tkLst id]
    for(var i=1; i<=htest.grpnum; i++) {
        grp[i] = [];
	var lst = document.getElementById("htestgroupdiv_"+i).childNodes;
	if(lst.length == 0)
	    fatalError("menuGetHtestregions: empty group");
	for(var j=0; j<lst.length; j++) {
            var k = getTkidxByname(lst[j].id.split('inhtestgrp')[0]);
	    grp[i].push([tkLst[k].label, k]);
	}
    }

    print2console("generating list...", 0);

    var w = window.open("", "Hypothesis test result");
    var doc = w.document;
    var table = doc.createElement("table");
    table.border = 0;
    table.style.backgroundColor = GRAY;
    table.cellPadding = 3;
    table.cellSpacing = 1;
    // first row
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);
    td.className = 'x';
    td.innerHTML = "Coordinate";
    td.rowSpan = 2;
    /* if(entire.atbplevel) {
        td = doc.createElement("td");
	td.innerHTML = "base";
	td.rowSpan = 2;
	tr.appendChild(td);
    }*/
    td = tr.insertCell(1);
    td.className = 'x';
    td.innerHTML = "P-value";
    td.rowSpan = 2;
    for(i=1; i<=htest.grpnum; i++) {
        td = tr.insertCell(-1);
	td.style.textAlign = "center";
        td.innerHTML = "GROUP "+i;
	td.style.backgroundColor = colorCentral.longlst[i];
	td.colSpan = grp[i].length;
    }
    // second row
    tr = table.insertRow(-1);
    for(i=1; i<=htest.grpnum; i++) {
        for(j=0; j<grp[i].length; j++) {
	    td = tr.insertCell(-1);
	    td.appendChild(makecanvas_verticalstring(grp[i][j][0], false));
	    td.style.backgroundColor = colorCentral.longlst[i];
	    td.style.textAlign = "center";
	    td.vAlign = "bottom";
	}
    }
    // third row and remains
    var cutoff = parseFloat(getSelectValueById("pvcutoff"));
    for(i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++) {
        var start = i==dspBoundary.vstartr ? dspBoundary.vstarts : 0;
	var stop = i==dspBoundary.vstopr ? dspBoundary.vstops : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(j=start; j<stop; j++) {
	    var pv = htest.pvalue[i][j];
	    if(pv > cutoff)
	        continue;
	    tr = table.insertRow(-1);
            td = tr.insertCell(0);
	    td.className = 'x';
	    if(entire.atbplevel) {
	        td.innerHTML = regionLst[i][0]+':'+(regionLst[i][3]+j);
	    } else {
	        var c = getPointCoord(i,j);
	        td.innerHTML = regionLst[i][0]+':'+c+'-'+parseInt(c+entire.summarySize);
	    }
	    td = tr.insertCell(1);
	    td.className = 'x';
	    td.innerHTML = pv;
	    for(var g=1; g<=htest.grpnum; g++) {
	        var kk = grp[g].length;
	        for(k=0; k<kk; k++) {
		    td = tr.insertCell(-1);
		    td.className = 'x';
		    td.innerHTML = tkLst[grp[g][k][1]].data[i][j];
		    if(k == 0) {
		        // set that for -moz-linear-gradient?
		        td.style.background = "-webkit-gradient(linear,left top, right top, from("+colorCentral.longlst[g]+"), to(white))";
			//td.style.borderLeft = "solid 1px "+colorCentral.longlst[g];
		    } else if(k == kk-1) {
		        td.style.background = "-webkit-gradient(linear,left top, right top, from(white), to("+colorCentral.longlst[g]+"))";
		    }
		}
	    }
        }
    }
    doc.body.appendChild(table);
    lst = doc.getElementsByClassName("x");
    for(i=0; i<lst.length; i++)
        lst[i].style.backgroundColor = "white";
    print2console(" done", 0, false);
}
function menuGetonetrackdetails() {
    // must be called by menu on single track
    // fetch detailed track information and display in floatingtoolbox area
    // track index is menu.iY
    if(menu.iY<0 || menu.iY>=tkLst.length)
        return;
    getOnetrackdetails(tkLst[menu.iY].name);
}




/*** FTB floating toolbox
 ***/
function windowverticalscroll() { 
    /*** not used ***/
    // repositioning when window scrolls vertically
    // floating toolbox always maintain same relative y position in window scroll
    // but metadata category canvas holder is different
    var ychange = document.body.scrollTop - floatingtoolbox.oldscrolltop;
    //floatingtoolbox.style.top = parseInt(floatingtoolbox.style.top) + ychange;
    var mdhh = mdcholder.clientHeight;
    if(document.body.scrollTop < iiY-mdhh) {
        mdcholder.style.top = iiY - mdhh;
    } else {
        var mdhy = parseInt(mdcholder.style.top);
        if(ychange > 0) {
            if(document.body.scrollTop > mdhy)
                mdcholder.style.top = mdhy + ychange;
	var maxy = iiY + sumTrackHeight() - mdhh;
        mdhy = parseInt(mdcholder.style.top);
	if(mdhy > maxy)
            mdcholder.style.top = maxy;
        } else {
            if(mdhy > iiY-mdhh)
                mdcholder.style.top = mdhy + ychange;
	}
    }
    //floatingtoolbox.oldscrolltop = document.body.scrollTop;
}



// pathway, KEGG and SOAP
function ajax3(url, callback) {
    // calls soak.py
    // TODO: dbName?
    //       pass db-specific parameters to soak.py, like species name?
    var xmlhttp;
    if(window.XMLHttpRequest)
	xmlhttp = new XMLHttpRequest();
    else
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    xmlhttp.onreadystatechange = function() {
	if(xmlhttp.readyState==4 && xmlhttp.status==200) {
	    try {var data = eval('('+xmlhttp.responseText+')');}
	    catch(err) {
	        // TODO: better error handling here
	        fatalError(err+" (sorry... try refreshing page)");
		return;
	    }
	    callback(data);
	}
    }
    xmlhttp.open("GET", "/cgi-bin/soak.py?"+url, true);
    xmlhttp.send();
}
function keggpathwaykeywordlookup() {
    var w = document.getElementById("pathwaykwinput").value;
    if(w.length==0 || w=="enter keywords") {
        print2console("no keyword given", 2);
	return;
    }
    document.getElementById("gsikeggwrapper").style.display = "block";
	document.getElementById('keggusingkeyword').innerHTML = document.getElementById('pathwaykwinput').value;
    document.getElementById("pathwaytablesaysyes").style.display = "none";
    var tr = document.createElement("tr");
    var td = document.createElement("td");
    td.innerHTML = "<img src=images/loading.gif width=60 style='padding-left: 250px;'>"
    tr.appendChild(td);
    var table = document.getElementById("pathwaytable");
    table.style.display = "block";
    stripChild(table, 0);
    table.appendChild(tr);
    print2console("querying for KEGG pathway by keyword...", 0);
    ajax3("pathwaykeyword="+escape(w)+"&speciesCode="+dbInfo.keggspeciescode, function(data) {
        var table = document.getElementById("pathwaytable");
        stripChild(table, 0);
    	if("abort" in data) {
	    print2console("no pathway found", 2);
	    table.style.display = "none";
	    return;
	}
	document.getElementById("pathwaytablesaysyes").style.display = "block";
	var wrapper = document.getElementById("pathwaytablewrapper");
	if(data.length <= 10) {
            wrapper.style.height = "auto";
	    wrapper.style.overflowY = "auto";
	} else {
            wrapper.style.height = "200px";
	    wrapper.style.overflowY = "scroll";
	}
	var color = "transparent";
	for(var i=0; i<data.length; i++) {
	    color = (color=="transparent") ? "white" : "transparent";

	    var tr = document.createElement("tr");
	    // dissect pathway string
	    var j = data[i].indexOf(' ');
	    if(j == -1) continue;
	    var id = data[i].substr(0,j);
	    var td = document.createElement("td"); // pathway id
	    td.style.backgroundColor = color;
	    td.innerHTML = "<span class=clb onclick=submitGeneset_kegg(\""+id+"\") style='color:#00c;'>"+id+"</span>";
	    tr.appendChild(td);

	    td = document.createElement("td"); // pathway desc
	    td.style.paddingLeft = 10;
	    td.style.backgroundColor = color;
	    // FIXME: if for other organism, change organism name...
            td.innerHTML = data[i].substr(j+1).replace(/ - Homo sapiens \(human\)$/, '');
	    tr.appendChild(td);

	    td = document.createElement("td"); // link out
	    td.style.backgroundColor = color;
            td.innerHTML = "<a href=http://www.kegg.jp/pathway/"+id.split(':')[1]+" target=_blank>&#8599;</a>";
	    tr.appendChild(td);
	    table.appendChild(tr);
	}
	print2console("found "+data.length+" pathways", 1);
    });
}
function submitGeneset_kegg() {
    /* run gene set view on a kegg pathway
       variable argument:
       - if no argument is provided, indicates it is called by pushing button, 
         and pathway id will be obtained from textfield
       - else, pathway id is provided as first argument
     */
    var what = arguments[0];
    if(what == undefined) {
        // should be called by pushing button "use pathway"
        what = document.getElementById("pathwayid").value;
        if(what.length==0 || what=="enter pathway ID") {
            print2console("no KEGG pathway identifier given", 2);
	    return;
        }
	// hide pathway list table
	document.getElementById("gsikeggwrapper").style.display = "none";
    }

    if(ensureNonezerolengthregion(2)) {
        print2console("custom region selector spans 0 bp", 2);
	return;
    }

    // has to set juxNote here??
    juxtaposition.note = "KEGG "+what;

    cloak(viewbox);
    // calling soak.py to fetch kegg genes
    print2console("querying KEGG for pathway genes...", 0);
    document.body.style.cursor = 'wait';
    ajax3("pathwayid="+escape(what), function(data) {
        if("abort" in data) {
	    print2console("invalid pathway identifier or no genes found", 2);
	    unveil(viewbox);
	    return;
	}
	print2console(" done", 0, false);
	var glst = data; // a list of kegg gene names

        /* calling subtleKnife to do collation
	   main trigger is still "itemlist", 
	   but use "keggpathway" to indicate items are kegg genes,
	   and this won't be specified later on

	   statusId is changed to random value here
	   so that submitting new itemlist won't destroy saved record
	 */
	print2console("running juxtaposition...", 0);
        ajax("new=on&itemlist="+glst.join(',')+gss_param(2)+'&gss_says='+document.getElementById('kegg_gss_says').innerHTML+hmtkChoice()+decorParams()+corrParam()+htestParams()+"&dbName="+dbInfo.name, function(data) {
	    juxtaposition.type = 4;
	    juxtaposition.what = "kegg";

	    setDisplaywhichgf();

	    jsonGenesetview(data);
	    unveil(viewbox);
	    print2console(data['alert'], 1);
            document.body.style.cursor = 'auto';
        });
    });
}



// click-drag to zoom in on ideogram div
function ideogramMD(event) {
    /* if at finest zoom in level, will not perform zoom in
       and the color of indicator2 will turn red as sort of warning...
     */
    if(event.button != 0) return; // only process left click
    var d = document.getElementById("indicator2veil");
    if(atfinestlevel()) {
        d.style.backgroundColor = "red";
	d.style.opacity = 0.3;
    } else {
        d.style.backgroundColor = "blue";
	d.style.opacity = 0.1;
    }
    // mouse down
    event.preventDefault();
    document.body.addEventListener("mousemove", ideogramM, false);
    document.body.addEventListener("mouseup", ideogramMU, false);
    indicator2.style.display = "block";
    indicator2.leftarrow.style.display = "block";
    indicator2.rightarrow.style.display = "block";
    var th = sumTrackHeight();
    indicator2.style.height = parseInt(ideogram.viewbox.style.height) + th;
    indicator2.leftarrow.style.top = th/2-indicator2.leftarrow.height/2;
    indicator2.rightarrow.style.top = indicator2.leftarrow.style.top;
    indicator2.style.width = 0;
    ideogram.viewbox.xstart = event.clientX+document.body.scrollLeft;
    indicator2.style.left = ideogram.viewbox.xstart;
    indicator2.style.top = iiY;
}
function ideogramM(event) {
    // mouse move, only process horizontal move
    var currx = event.clientX + document.body.scrollLeft;
    if(currx > ideogram.viewbox.xstart) {
        if(currx < iiX+hmSpan) {
            indicator2.style.width = currx - ideogram.viewbox.xstart;
	}
    } else {
        if(currx >= iiX) {
            indicator2.style.width = ideogram.viewbox.xstart - currx;
	    indicator2.style.left = currx;
	}
    }
}
function ideogramMU(event) {
    // mouse up
    indicator2.style.display = "none";
    indicator2.leftarrow.style.display = "none";
    indicator2.rightarrow.style.display = "none";
    document.body.removeEventListener("mousemove", ideogramM, false);
    document.body.removeEventListener("mouseup", ideogramMU, false);
    if(atfinestlevel()) {
        print2console("already at finest level", 2);
        return;
    }
    var currx = event.clientX + document.body.scrollLeft;
    var x1, x2;
    if(currx > ideogram.viewbox.xstart) {
        x1 = ideogram.viewbox.xstart - iiX;
	x2 = currx - iiX;
	if(x2 >= hmSpan) x2 = hmSpan;
    } else {
	x1 = (currx <= iiX) ? 0 : currx-iiX;
        x2 = ideogram.viewbox.xstart - iiX;
    }
    cgiZoomin(x1, x2);
}




// click-drag to zoom in on ruler canvas
function rulerMD(event) {
    /* if at finest zoom in level, will not perform zoom in */
    if(event.button != 0) return; // only process left click
    var d = document.getElementById("indicator2veil");
    if(atfinestlevel()) {
        d.style.backgroundColor = "red";
	d.style.opacity = 0.3;
    } else {
        d.style.backgroundColor = "blue";
	d.style.opacity = 0.1;
    }
    // mouse down
    event.preventDefault();
    document.body.addEventListener("mousemove", rulerM, false);
    document.body.addEventListener("mouseup", rulerMU, false);
    indicator2.style.display = "block";
    indicator2.leftarrow.style.display = "block";
    indicator2.rightarrow.style.display = "block";
    var th = sumTrackHeight();
    indicator2.style.height = rulercanvas.height + th;
    indicator2.leftarrow.style.top = th/2-indicator2.leftarrow.height/2;
    indicator2.rightarrow.style.top = indicator2.leftarrow.style.top;
    indicator2.style.width = 0;
    rulercanvas.xstart = event.clientX+document.body.scrollLeft;
    indicator2.style.top = iiY - rulercanvas.height;
    indicator2.style.left = rulercanvas.xstart;
}
function rulerM(event) {
    var currx = event.clientX + document.body.scrollLeft;
    if(currx > rulercanvas.xstart) {
        if(currx < iiX+hmSpan) {
            indicator2.style.width = currx - rulercanvas.xstart;
	}
    } else {
        if(currx >= iiX) {
            indicator2.style.width = rulercanvas.xstart - currx;
	    indicator2.style.left = currx;
	}
    }
}
function rulerMU(event) {
    // mouse up
    indicator2.style.display = "none";
    indicator2.leftarrow.style.display = "none";
    indicator2.rightarrow.style.display = "none";
    document.body.removeEventListener("mousemove", rulerM, false);
    document.body.removeEventListener("mouseup", rulerMU, false);
    if(atfinestlevel()) {
        print2console("already at finest level", 2);
        return;
    }
    var currx = event.clientX + document.body.scrollLeft;
    var x1, x2;
    if(currx > rulercanvas.xstart) {
        x1 = rulercanvas.xstart - iiX;
	x2 = currx - iiX;
	if(x2 >= hmSpan) x2 = hmSpan;
    } else {
	x1 = (currx <= iiX) ? 0 : currx-iiX;
        x2 = rulercanvas.xstart - iiX;
    }
    cgiZoomin(x1, x2);
}



// scale bar moving stuff
function scalebararrowMout() {
    // mouse out scalebar.arrow, draw it in foreground color
    var ctx = scalebar.arrow.getContext('2d');
    ctx.strokeStyle = colorCentral.foreground;
    scalebararrowStroke();
    scalebar.beam.style.display = 'none';
}
function scalebararrowMover() {
    // mouse over scalebar.arrow, draw it in red
    var ctx = scalebar.arrow.getContext('2d');
    ctx.strokeStyle = '#f00';
    scalebararrowStroke();
    scalebar.beam.style.display = 'block';
}
function scalebararrowStroke() {
    var x = 6;
    var ctx = scalebar.arrow.getContext('2d');
    ctx.clearRect(0,0,20,16);
    ctx.beginPath();
    ctx.moveTo(x,2);
    ctx.lineTo(x,15);
    ctx.lineTo(1,12);
    ctx.moveTo(x,15);
    ctx.lineTo(x*2-1,12);
    ctx.stroke();
}
function scalebarSliderMD(event) {
    if(event.button != 0) return; // only process left click
    event.preventDefault();
    scalebar.slider.xstart = event.clientX + document.body.scrollLeft;
    document.body.addEventListener('mousemove', scalebarSliderM, false);
    document.body.addEventListener('mouseup', scalebarSliderMU, false);
}
function scalebarSliderM(event) {
    var thisx = event.clientX + document.body.scrollLeft;
    var oldleft = parseInt(scalebar.slider.style.left);
    var newleft = oldleft + thisx - scalebar.slider.xstart;
    if(newleft > oldleft) {
	if(newleft > hmSpan-scalebar.slider.width) {
	    newleft = hmSpan-scalebar.slider.width;
	}
    } else if(newleft < oldleft) {
	if(newleft < 0) {
	    newleft = 0;
	}
    }
    scalebar.slider.style.left = newleft;
    scalebar.beam.style.left = iiX+newleft;
    scalebar.slider.xstart = thisx;
    scalebar.says.style.left = newleft - scalebar.says.clientWidth - 3;
    scalebar.arrow.style.left = newleft + scalebar.slider.width - 6;
    scalebar.beam.style.display='block';
}
function scalebarSliderMU(event) {
    document.body.removeEventListener('mousemove', scalebarSliderM, false);
    document.body.removeEventListener('mouseup', scalebarSliderMU, false);
    scalebar.beam.style.display='none';
}
function scalebarArrowMD(event) {
    if(event.button != 0) return; // only process left click
    event.preventDefault();
    scalebar.arrow.xstart = event.clientX + document.body.scrollLeft;
    document.body.addEventListener('mousemove', scalebarArrowM, false);
    document.body.addEventListener('mouseup', scalebarArrowMU, false);
}
function scalebarArrowM(event) {
    var thisx = event.clientX + document.body.scrollLeft;
    var oldleft = parseInt(scalebar.arrow.style.left);
    var newleft = oldleft + thisx - scalebar.arrow.xstart;
    var oldleft2 = parseInt(scalebar.slider.style.left);
    if(newleft > oldleft) {
        if(oldleft2 + scalebar.slider.width + newleft-oldleft > hmSpan) {
	    newleft = hmSpan;
	}
    } else if(newleft < oldleft) {
        if(scalebar.slider.width < oldleft-newleft) {
	    newleft = oldleft;
	}
    }
    scalebar.arrow.style.left = newleft;
    scalebar.arrow.xstart = thisx;
    scalebar.slider.width += newleft - oldleft;
    scalebar.beam.style.width = scalebar.slider.width;
    drawScalebarSlider();
    scalebarSlider_fill();
    scalebar.beam.style.display='block';
}
function scalebarArrowMU(event) {
    document.body.removeEventListener('mousemove', scalebarArrowM, false);
    document.body.removeEventListener('mouseup', scalebarArrowMU, false);
    scalebar.beam.style.display='none';
}
function drawScalebarSlider() {
    var ctx = scalebar.slider.getContext('2d');
    ctx.fillRect(0,3,1,scalebar.slider.height-5);
    ctx.fillRect(0,8,scalebar.slider.width,1);
}
function scalebarSlider_fill() {
    if(entire.atbplevel) {
        var spanning = scalebar.slider.width / entire.bpwidth;
	scalebar.says.innerHTML = spanning.toFixed(1) + ' bp';
    } else {
	scalebar.says.innerHTML = parseInt(scalebar.slider.width*entire.summarySize) + ' bp';
    }
    scalebar.says.style.left = parseInt(scalebar.slider.style.left) - scalebar.says.clientWidth - 3;
    scalebar.beam.style.width = scalebar.slider.width;
    scalebar.beam.style.height = sumTrackHeight();
    scalebar.beam.style.left = iiX+parseInt(scalebar.slider.style.left);
    scalebar.beam.style.top = iiY;
}


// minichr canvas click-drag to zoom into selected region
function itemlistSeekRight(pxnum) {
    /* only used in moving minichrindicator, and jump to pos in itemlist mode
       seek on genesetview.lst, where 4th element is item plot width
       return item name and coord
     */
    for(var i=0; i<genesetview.lst.length; i++) {
        var r = genesetview.lst[i];
        if(pxnum > r[4])
	    pxnum -= r[4];
	else
	    return [r[0], parseInt(r[2]+(r[3]-r[2])*pxnum/r[4])]
    }
    return [r[0], r[3]];
}




/*** dataset ***/
function jsonParseTkMetadata(data) {
    if(!('trackmetadata' in data)) fatalError("jsonParseTkMetadata: trackmetadata missing");
    hmtk.mdanno = {};
    for(var tk in data['trackmetadata']) {
	var lst = data['trackmetadata'][tk];
	hmtk.mdanno[tk] = {};
	for(var i=0; i<lst.length; i++)
	    hmtk.mdanno[tk][lst[i]] = 1;
    }
}
function jsonParseTkDetail(data) {
    if(!('trackdetail' in data)) fatalError("jsonParseTkDetail: trackdetail missing");
    hmtk.tolabel = {};
    /*
    hmtk.togeo = {};
    hmtk.tobam = {};
    for(var tkn in data['trackdetail']) {
	var lst = data['trackdetail'][tkn];
	hmtk.tolabel[tkn] = lst[0];
	if(lst[1] != "") {
	    hmtk.togeo[tkn] = lst[1].split(',');
	}
	if(lst[2])
	    hmtk.tobam[tkn] = 1;
    }
    */
    for(var tkn in data.trackdetail)
        hmtk.tolabel[tkn] = data.trackdetail[tkn];
}
function toggleOffAllDatasets() {
    var lst = document.getElementsByName("datasetcheckbox");
    for(var i=0; i<lst.length; i++) {
        lst[i].checked = false;
	var what = lst[i].value;
        document.getElementById(what+"notifier").className = "datasetno";
        document.getElementById(what+"saysyes").style.display = "none";
        document.getElementById(what+"saysno").style.display = "inline-block";
    }
}
function toggleOnDataset(what) {
    document.getElementById(what+"notifier").className = "datasetyes";
    checkInputByvalue("datasetcheckbox", what)
    document.getElementById(what+"saysyes").style.display = "inline-block";
    document.getElementById(what+"saysno").style.display = "none";
}
function loaddataset() {
    /* called by pushing "Load data set" button
       will load up tracks, metadata, details in selected dataset
       Note:
       any track on display that does not belong to current datasets will be removed
     */
    var s = []; // selected
    var lst = document.getElementsByName("datasetcheckbox");
    for(var i=0; i<lst.length; i++) {
        if(lst[i].checked)
	    s.push(lst[i].value);
    }
    if(s.length == 0) {
        print2console("No data set selected.", 2);
	return;
    }
    datasetLst = s;
    document.body.style.cursor = "wait";
    print2console("loading dataset...", 0);
    ajax("loaddataset="+s.join(",")+"&dbName="+dbInfo.name, function(data){
        jsonParseTkMetadata(data);
	jsonParseTkDetail(data);
	// remove track that is on display but does not belong to the new dataset
	// make copy of tkNameLst
	var names = [];
	for(var i=0; i<tkNameLst.length; i++)
	    names.push(tkNameLst[i]);
	var anyremoved = false;
	for(i=0; i<names.length; i++) {
	    if(names[i] in hmtk.mdanno)
	        continue;
	    var tkid = getTkidxByname(names[i]);
	    if(tkid != -1) {
	        removeBigwigTrack(tkid);
		anyremoved = true;
	    }
	}
	if(anyremoved)
	    updateAfterRemovetrack(); // will call generateTrackselectionLayout
	else
            generateTrackselectionLayout();
	toggleOffAllDatasets();
	for(i=0; i<datasetLst.length; i++)
	    toggleOnDataset(datasetLst[i]);
        document.body.style.cursor = "auto";
	var b = document.getElementById("loaddatasetbutton");
	b.disabled = true;
	b.innerHTML = "Data set loaded";
	print2console(" done", 0, false);
    });
}


/*** VRE vertical rearrange stuff
     for hmtk, tracks to be rearranged are marked by hmtk.iY
 ***/
function vrearrange_invoke(which, x, y) {
    vrearrangeUtil.holder.style.display = 'block';
    vrearrangeUtil.which = which;
    vrearrangeUtil.holder.style.left = x;
    vrearrangeUtil.holder.style.top = y;
    setTimeout("document.body.addEventListener('mousedown', vrearrange_close, false)", 100);
}
function vrearrange_close() {
    vrearrangeUtil.holder.style.display = 'none';
    switch(vrearrangeUtil.which) {
    case 0:break;
    case 1: 
    case 2:
        indicator3.style.display = 'none';
	break;
    case 3:
    case 4:
        // simulate a click on the td to release...
	var e = document.createEvent("MouseEvents");
	e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
        vrearrangeUtil.scfdtd.dispatchEvent(e);
	break;
    case 5:
        indicator3.style.display = 'none';
	break;
    case 6:
        vrearrangeUtil.gsvtr.style.fontWeight = 'normal';
        vrearrangeUtil.gsvtr.marked2 = false;
	break;
    default: fatalError('vrearrange_close: unknown which');
    }
    vrearrangeUtil.which = 0;
    document.body.removeEventListener('mousedown', vrearrange_close, false);
}
function vrearrange(w2g) {
    /* arg:
       w2g: where to go, 1 - up to top, 2 - up one level, 3 - down one level, 4 - down to bottom
     */
    switch(vrearrangeUtil.which) {
    case 1: // single hmtk
	var toid;
	if(w2g==1 || w2g==2) {
	    if(menu.iY == 0)
	        return;
	    toid = w2g==1 ? 0 : menu.iY-1;
	} else {
	    if(menu.iY == tkLst.length-1)
	        return;
	    toid = w2g==4 ? tkLst.length-1 : menu.iY+1;
	}
	swapTrack(toid, menu.iY);
	stuffTrackCanvas2holder();
	menu.iY = toid;
	highlighttrack(menu.iY, 3);
	return;
    case 2: // group hmtk by mcm
        var tkminid = arrayMin(menu.trackIdxLst);
	var tkmaxid = arrayMax(menu.trackIdxLst);
        if(w2g==1 || w2g==2) {
	    if(tkminid == 0) return;
	    if(w2g == 1) { // to top
	        for(var i=0; i<menu.trackIdxLst.length; i++)
		    swapTrack(0, tkmaxid);
		stuffTrackCanvas2holder();
	        for(i=0; i<menu.trackIdxLst.length; i++)
		    menu.trackIdxLst[i] -= tkminid;
	    } else {
	        swapTrack(tkmaxid, tkminid-1);
		stuffTrackCanvas2holder();
		for(var i=0; i<menu.trackIdxLst.length; i++)
		    menu.trackIdxLst[i]--;
	    }
	} else {
	    if(tkmaxid == tkLst.length-1) return;
	    if(w2g == 4) { // to bottom
	        for(var i=0; i<menu.trackIdxLst.length; i++)
		    swapTrack(tkLst.length-1, tkminid);
		stuffTrackCanvas2holder();
		for(i=0; i<menu.trackIdxLst.length; i++)
		    menu.trackIdxLst[i] += tkLst.length-1-tkmaxid;
	    } else {
	        swapTrack(tkminid, tkmaxid+1);
		stuffTrackCanvas2holder();
		for(i=0; i<menu.trackIdxLst.length; i++)
		    menu.trackIdxLst[i]++;
	    }
	}
	placeIndicator3_menuTklst();
        return;
    case 3: // scaffold cpholder, repetitve with 4
        var lst = scaffold.cpholder.firstChild.childNodes;
	var fromidx=-1, toidx=-1;
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].marked2) {
	        fromidx = i; break;
	    }
	}
	if(fromidx == -1) {
	    vrearrange_close();
	    return;
	}
	if(w2g==1 || w2g==2) {
	    if(fromidx == 0) return;
	    toidx = w2g==1 ? 0 : fromidx-1;
	} else {
	    if(arridx == lst.length-1) return;
	    toidx = w2g==3 ? fromidx+1 : lst.length-1;
	}
	var tmp = [];
	for(i=0; i<lst.length; i++) tmp.push(lst[i]);
	var tt = tmp.splice(fromidx, 1);
	tmp.splice(toidx, 0, tt[0]);
	for(i=0; i<lst.length; i++)
	    scaffold.cpholder.firstChild.appendChild(tmp[i]);
	if(w2g == 1)
	    scaffold.cpholder.parentNode.scrollTop = 0;
	else if(w2g == 4)
	    scaffold.cpholder.parentNode.scrollTop = scaffold.cpholder.clientHeight;
	scaffold.updatebutt.style.display = 'inline';
	scaffold.updatebutt.style.backgroundColor = '#FFE699';
	document.getElementById('scaffold_cancelbutt').style.display = 'inline';
        return;
    case 4: // genomebev scaffold, repetitive with 3
        var lst = bev.scfd.holder.firstChild.childNodes;
	var fromidx=-1, toidx=-1;
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].marked2) {
	        fromidx = i; break;
	    }
	}
	if(fromidx == -1) {
	    vrearrange_close();
	    return;
	}
	if(w2g==1 || w2g==2) {
	    if(fromidx == 0) return;
	    toidx = w2g==1 ? 0 : fromidx-1;
	} else {
	    if(arridx == lst.length-1) return;
	    toidx = w2g==3 ? fromidx+1 : lst.length-1;
	}
	var tmp = [];
	for(i=0; i<lst.length; i++) tmp.push(lst[i]);
	var tt = tmp.splice(fromidx, 1);
	tmp.splice(toidx, 0, tt[0]);
	for(i=0; i<lst.length; i++)
	    bev.scfd.holder.firstChild.appendChild(tmp[i]);
	if(w2g == 1)
	    bev.scfd.holder.parentNode.scrollTop = 0;
	else if(w2g == 4)
	    bev.scfd.holder.parentNode.scrollTop = bev.scfd.holder.clientHeight;
        bev.scfd.updatebutt.style.display = 'inline';
	bev.scfd.updatebutt.style.backgroundColor = '#FFE699';
	document.getElementById('genomebevscfd_cancelbutt').style.display = 'inline';
        return;
    case 5: // single decor
	// figure out decor array index in holders
	var ch = document.getElementById("tgt_decorCanvas");
	var hh = document.getElementById("tgt_decorCanvasHeader");
	var arridx = -1;
	var len = ch.childNodes.length;
	for(var i=0; i<len; i++) {
	    if(ch.childNodes[i].firstChild.decorname == menu.decorname) {
	        arridx = i; break;
	    }
	}
	if(arridx == -1) fatalError('vrearrange: decor canvas not found in tgt_decorCanvas');
	var targetidx;
	if(w2g==1 || w2g==2) {
	    if(arridx == 0) return;
	    targetidx = w2g==1 ? 0 : arridx-1;
	} else {
	    if(arridx == len-1) return;
	    targetidx = w2g==3 ? arridx+1 : len-1;
	}
	// cannot call splice method on childNodes
	var tmp = [];
	for(i=0; i<len; i++) tmp.push(ch.childNodes[i]);
	var tt = tmp.splice(arridx, 1);
	tmp.splice(targetidx, 0, tt[0]);
	for(i=0; i<len; i++) {ch.appendChild(tmp[i]);}
	tmp = [];
	for(i=0; i<len; i++) tmp.push(hh.childNodes[i]);
	tt = tmp.splice(arridx, 1);
	tmp.splice(targetidx, 0, tt[0]);
	for(i=0; i<len; i++) hh.appendChild(tmp[i]);
	placeIndicator3_menuDecor();
        return;
    case 6: // gsv item list
        var lst = genesetview.lstholder.firstChild.childNodes;
	var fromidx=-1, toidx=-1;
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].marked2) {
	        fromidx = i; break;
	    }
	}
	if(fromidx == -1) {
	    vrearrange_close();
	    return;
	}
	if(w2g==1 || w2g==2) {
	    if(fromidx == 0) return;
	    toidx = w2g==1 ? 0 : fromidx-1;
	} else {
	    if(arridx == lst.length-1) return;
	    toidx = w2g==3 ? fromidx+1 : lst.length-1;
	}
	var tmp = [];
	for(i=0; i<lst.length; i++) tmp.push(lst[i]);
	var tt = tmp.splice(fromidx, 1);
	tmp.splice(toidx, 0, tt[0]);
	for(i=0; i<lst.length; i++)
	    genesetview.lstholder.firstChild.appendChild(tmp[i]);
	if(w2g == 1)
	    genesetview.lstholder.parentNode.scrollTop = 0;
	else if(w2g == 4)
	    genesetview.lstholder.parentNode.scrollTop = genesetview.lstholder.clientHeight;
        return;
    default:
        fatalError('vrearrange: uknown which');
    };
}


/*** PWC
     pairwise comparison 
 ***/
function pwc_assigngrp(tkname,grp) {
    /* similar as htest_assigngrp()
       grp is 0/1/2
     */
    var d = document.getElementById(tkname+'inpwcgrp');
    if(d!=null && d.parentNode!=null) {
	d.parentNode.removeChild(d);
    }
    if(grp == 0) {
        if(tkselect.main.style.display=='block') {tkspanel_hmtoggle(tkname);}
	return;
    }
    // assign track to desired group
    d = document.createElement("div");
    d.id = tkname+"inpwcgrp";
    d.setAttribute('tkname',tkname);
    // to work with custom bigwig tracks, as their name do not exist in hmtk.tolabel
    var tkobj = findTrackByName(tkname);
    d.innerHTML = "<span style=\"cursor:pointer;color:#c00;\" onclick=\"pwc_assigngrp('"+tkname+"',0)\">&#10005;</span> "+(tkobj!=null ? tkobj.label : hmtk.tolabel[tkname]);
    //d.addEventListener("mouseover", generictrackdiv_mouseover, false);
    //d.addEventListener("mouseout", generictrackdiv_mouseoout, false);
    document.getElementById("pairwisecompgroup"+grp).appendChild(d);
    //if(pwc.inuse) turnoffPairwisecomp();
}
function turnonPairwisecomp() {
    pwc.inuse = true;
    pwc.holder.style.display = "block";
    pwc.header.style.display = "block";
    document.getElementById("pairwisecompsaysno").style.display = "none";
    document.getElementById("pairwisecompsaysyes").style.display = "block";
}
function turnoffPairwisecomp() {
    pwc.inuse = false;
    pwc.holder.style.display = "none";
    pwc.header.style.display = "none";
    document.getElementById("pairwisecompsaysno").style.display = "block";
    document.getElementById("pairwisecompsaysyes").style.display = "none";
}
function pairwisecompClear() {
    turnoffPairwisecomp();
    stripChild(pwc.grp1, 1);
    stripChild(pwc.grp2, 1);
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<tkLst.length; i++) {
        document.getElementById(tkLst[i].name+"pairwisecompgrpselect").selectedIndex = 0;
    }
}
function pwc_run() {
    /* called by pushing run button
       or during restoring session
       will initialize .gtn1, .gtn2
       and call compute routine
     */
    var lst = pwc.grp1.childNodes;
    if(lst.length == 0) {
        print2console("group 1 has no tracks", 2);
	return;
    }
    pwc.gtn1 = [];
    pwc.gtn2 = [];
    for(var i=0; i<lst.length; i++) {
        pwc.gtn1.push(lst[i].getAttribute('tkname'));
    }
    lst = pwc.grp2.childNodes;
    if(lst.length == 0) {
        print2console("group 2 has no tracks", 2);
	return;
    }
    print2console("running pairwise comparison...", 0);
    for(var i=0; i<lst.length; i++) {
        pwc.gtn2.push(lst[i].getAttribute('tkname'));
    }
    turnonPairwisecomp();
    pwc_compute();
    tkspanel_close();
}
function pwc_compute() {
    /* called by pushing button, or else
       compute log ratio from track score, them call drawing routine
     */

    // gti: tkLst index of tracks in each group
    var gti1=[]; var gti2=[];
    for(var i=0; i<pwc.gtn1.length; i++) {
        gti1.push(getTkidxByname(pwc.gtn1[i]));
    }
    for(i=0; i<pwc.gtn2.length; i++) {
        gti2.push(getTkidxByname(pwc.gtn2[i]));
    }

    var logratio = []; // simulate array of array from first region to dspBoundary.lwr
    for(var i=0; i<=dspBoundary.rwr; i++) {
        logratio.push([]);
    }
    for(i=0; i<dspBoundary.lws; i++) {
        logratio[dspBoundary.lwr].push(0);
    }

    for(i=dspBoundary.lwr; i<=dspBoundary.rwr; i++) {
        var start = (i==dspBoundary.lwr) ? dspBoundary.lws : 0;
	var stop = (i==dspBoundary.rwr) ? dspBoundary.rws : (entire.atbplevel?(regionLst[i][4]-regionLst[i][3]):regionLst[i][5]);
	for(var j=start; j<stop; j++) {
	    var grp1value = [];
	    var grp2value = [];
	    for(var k=0; k<gti1.length; k++) {
	        grp1value.push(tkLst[gti1[k]].data[i][j]);
	    }
	    for(k=0; k<gti2.length; k++) {
	        grp2value.push(tkLst[gti2[k]].data[i][j]);
	    }
	    logratio[i][j] = Math.log(arrayMean(grp1value)/arrayMean(grp2value)) * Math.LOG2E;
	}
    }
    pwc.logratio = logratio;
    pwc_draw();
    print2console(" done", 0, false);
}
function pwc_draw() {
    // set canvas height, viewbox height, draw track, draw header
    var tmp = qtrack_getthreshold(pwc.logratio, pwc.qtc);
    pwc.max = tmp[0];
    pwc.min = tmp[1];

    var c = pwc.canvas;
    c.width = entire.spnum;
    c.height = pwc.qtc.height + densitydecorpaddingtop*2;
    pwc.holder.style.height = c.height;
    pwc.header.height = c.height;

    c.style.left = move.styleLeft;
    var unitwidth = entire.atbplevel ? entire.bpwidth : 1;
    qtrack_plotwiggle(
    	pwc.logratio, 
        c.getContext('2d'),
	pwc.qtc,
	pwc.max,
	pwc.min,
	unitwidth);
    drawPairwiseHeadercanvas();
}
function drawPairwiseHeadercanvas() {
    pwc.header.width = leftColumnWidth;
    var ctx = pwc.header.getContext('2d');
    ctx.font = "8pt Sans-serif";
    ctx.fillText("Pairwise log ratio", 1, 20);
    ctx.fillText("log2(grp1/grp2)", 1, 30);
    drawVerticalAxis(pwc.qtc,pwc.header, pwc.max, pwc.min, true, 'black');
}



var helpAnimId;

function changedb(event) {
    /* called by clicking <td> on species menu (bait3)
       as many html components will be reloaded
       floating stuff like the genestruct selector was once attached to something
       and it will be erased together with its parent when change species
       so need to attach them to document.body to escape from that
       todo: genestruct selector panel float
     */
    if(correlation.inuse)
        turnoffCorrelation();
    d = document.getElementById("genesetoperationdiv");
    d.style.display = "none";
    document.body.appendChild(d);
    d = document.getElementById("geneplotpanel");
    d.style.display = "none";
    document.body.appendChild(d);

    cleanuphtmlholder();

    stripChild(document.getElementById("bev_chrgraphtable").firstChild, 0);

    // additional cleanup
    stripChild(tkselect.decor.grpholder, 0);
    stripChild(tkselect.decor.tkholder, 1);
    if(tkLst.length > 0)
	stripChild(tkselect.hmholder.firstChild, 0);
    tkLst = [];
    tkNameLst = [];
    datasetLst = [];
    scaffold.p2c = {};
    scaffold.c2p = {};
    scaffold.len = {};
    scaffold.toadd = {};
    scaffold.seq2tr = {};
    while(htest.grpnum > 0)
        removehtestgroup(); // turnoffHtest() will be called
    ideogram.cytoband = {};
    juxtaposition.type = 0;
    juxtaposition.note = "genome";
    juxtaposition.what = "genome";
    trackselectionCancel();
    track2addCancel();
    if(pwc.inuse)
        turnoffPairwisecomp();
    pairwisecompClear();
    document.getElementById("geneplotcanvasdiv").style.display = "none";
    document.getElementById("geneplotimage").style.display = "none";
    document.getElementById("googlechartdiv").style.display = "none";
    document.getElementById("googleimagechartdiv").style.display = "none";
    //document.getElementById("geneplot_getdatabutton").style.display = "none";

    // reload database
    dbInfo.name = event.target.dbname;
    toggle3_2();
    readygo(dbInfo.name, true);
}


/*** CONFIG
 ***/
function config_leftcolumnwidth(change) {
    var v;
    if(change == 999) {
        v = 300;
	change = v - leftColumnWidth;
    } else if(change == -999){
        v = 100;
	change = v - leftColumnWidth;
    } else {
       v = leftColumnWidth + change;
       if(v<100 || v>300)
	   return;
    }
    leftColumnWidth = v;
    document.getElementById("corrCanvasholder").style.width = v;

    var l = parseInt(mdcholder.style.left);
    mdcholder.style.left = l+change;

    for(var dn in decorCanvasHash)
        drawDecorHeadercanvas(dn);

    // corr: scale canvas, holder, corr coef canvas for each track
    drawCorrscalecanvas();
    corrHolder.style.width = leftColumnWidth;
    for(var i=0; i<tkLst.length; i++) {
        tkLst[i].coC.width = v;
	initiateCorrCanvasCtx(tkLst[i].coC.ctx);
    }
    if(correlation.inuse)
        drawCorr();

    drawHtestHeadercanvas();

    if(pwc.inuse)
        drawPairwiseHeadercanvas();

    if(ideogram.wiggle1.name != null)
	draw_ideogramWiggleHeader(1);
    if(ideogram.wiggle2.name != null)
	draw_ideogramWiggleHeader(2);

    /* findpos has to be executed as final step
       especially after re-drawing small wiggles for ideogram
       as it might assume old left column width
       and will cause trouble for findpos
     */
    findPos();
}
function config_tracklabelshow() {
    var onshow = document.getElementById("tracklabelshow").checked;
    onshow = !onshow;
    document.getElementById("tracklabelshow").checked = onshow;
    document.getElementById("tracklabelshowsaysno").style.display = onshow ? "none" : "block";
    document.getElementById("tracklabelshowsaysyes").style.display = onshow ? "block" : "none";
    tracklabelholder.style.display = onshow ? "block" : "none";
    viewbox.tknameshow = onshow;
}
function config_todefault() {
    leftColumnWidth = 110;
    config_leftcolumnwidth(0);
}





/* PAL using palette:
   a pair of two functions, 
   - xx_initiator()
     toggles on palette, register xx() for click event
   - xx()
     capture color and do stuff, hide palette, remove event registry
 */
function palette_context_update() {
switch(palette.which) {
case 1: stc_textcolor();return;
case 2: stc_bedcolor(); return;
case 3: stc_forwardcolor();return;
case 4: stc_reversecolor();return;
case 5: stc_mismatchcolor();return;
case 20: document.getElementById('geneplot_s4_pc').style.backgroundColor = palette.output; return;
case 21: document.getElementById('geneplot_s4_nc').style.backgroundColor = palette.output; return;
case 22: document.getElementById('geneplot_s1_lc').style.backgroundColor = palette.output; return;
case 23: document.getElementById('geneplot_s2_lc').style.backgroundColor = palette.output; return;
case 24: document.getElementById('geneplot_s3_promoterc').style.backgroundColor = palette.output; return;
case 25: document.getElementById('geneplot_s3_utr5c').style.backgroundColor = palette.output; return;
case 26: document.getElementById('geneplot_s3_utr3c').style.backgroundColor = palette.output; return;
case 27: document.getElementById('geneplot_s3_exonsc').style.backgroundColor = palette.output; return;
case 28: document.getElementById('geneplot_s3_intronsc').style.backgroundColor = palette.output; return;
case 30: qtc_pcolor(); return;
case 31: qtc_ncolor(); return;
case 32: qtc_pth(); return;
case 33: qtc_nth(); return;
case 34: htest_clc(); return;
default:
fatalError("palette_context_update: unknown palette.which");
}
}
function palettehide() {
    palette.style.display = "none";
    document.body.removeEventListener("mousedown", palettehide, false);
}
function paletteshow(x,y) {
    // x and y should be event.clientX/Y
    palette.style.display = "block";
    palette.style.left = x-80;
    palette.style.top = y+15;
    // clear grove color gradient
}
function palettedyeclick(event) {
    // clicking palette dye
    palettegrove_paint(event.target.style.backgroundColor);
    palette.output = event.target.style.backgroundColor;
    palette_context_update();
}
function palettegrove_paint(color) {
    palette.grove.color = color;
    var ctx = palette.grove.getContext('2d');
    var lingrad = ctx.createLinearGradient(0,0,100,0);
    lingrad.addColorStop(0,'black');
    lingrad.addColorStop(0.5, color);
    lingrad.addColorStop(1, 'white');
    ctx.fillStyle = lingrad;
    ctx.fillRect(0,0,100,20);
}
function palettesliderMD(event) {
    // palette slider md
    event.preventDefault();
    palette.slider.x = event.clientX;
    document.body.addEventListener("mousemove", palettesliderM, false);
    document.body.addEventListener("mouseup", palettesliderMU, false);
}
function palettesliderM(event) {
    var x = event.clientX;
    var oldx = palette.slider.x;
    var l = parseInt(palette.slider.style.left);
    if((x>oldx && l>=100) || (x<oldx && l<=0))
        return;
    palette.slider.style.left = l + x-oldx;
    l = parseInt(palette.slider.style.left);
    if(l > 100)
	palette.slider.style.left = 100;
    else if(l<0)
	palette.slider.style.left = 0;
    palette.slider.x = event.clientX;
}
function palettesliderMU() {
    document.body.removeEventListener("mousemove", palettesliderM, false);
    document.body.removeEventListener("mouseup", palettesliderMU, false);
    var x = parseInt(palette.slider.style.left);
    if(x == 50)
        palette.output = palette.grove.color;
    else if(x < 50)
        palette.output = darkencolor(colorstr2int(palette.grove.color), (100-x*2)/100);
    else
        palette.output = lightencolor(colorstr2int(palette.grove.color), (x-50)/50);
    palette_context_update();
}
function palettegrove_click(event) {
    // clicking on palette grove to pick up a color from the gradient
    var pos = absolutePosition(palette.grove);
    palette.slider.style.left = event.clientX - pos[0];
    var x = parseInt(palette.slider.style.left);
    if(x == 50)
        palette.output = palette.grove.color;
    else if(x < 50)
        palette.output = darkencolor(colorstr2int(palette.grove.color), (100-x*2)/100);
    else
        palette.output = lightencolor(colorstr2int(palette.grove.color), (x-50)/50);
    palette_context_update();
}



/*** 
     config decor 
 ***/
function stcpanel_setdisplay(decorname) {
    /* should always be called by menu option
       only works for bigbed/bam in thin/full modes
       not density mode
       todo: configure all...
     */
    var d = document.getElementById('ftb_stcdiv');
    d.style.display = 'block';
    d.target = decorname;
    document.getElementById('ftb_stcsays').innerHTML = decorInfo[decorname].label;
    // decorname should also be in menu.decorname, for placing indicator3
    placeIndicator3_menuDecor();
    var obj = decorInfo[decorname];

    changeSelectByValue('stc_fontfamily', obj.fontfamily);
    document.getElementById('stc_fontbold').checked = obj.fontbold;
    changeSelectByValue('stc_fontsize', obj.fontsize);
    document.getElementById('stc_textcolor').style.backgroundColor = obj.textcolor;

    if(obj.fileType==0 || obj.fileType==1) { // bigbed
        document.getElementById('stc_bed').style.display = 'block';
	document.getElementById('stc_bam').style.display = 'none';
	document.getElementById('stc_bedcolor').style.backgroundColor = obj.bedcolor;
    } else if(obj.fileType==4 || obj.fileType==5) { // bam
        document.getElementById('stc_bed').style.display = 'none';
	document.getElementById('stc_bam').style.display = 'block';
	document.getElementById('stc_forwardcolor').style.backgroundColor = obj.forwardcolor;
	document.getElementById('stc_reversecolor').style.backgroundColor = obj.reversecolor;
	document.getElementById('stc_mismatchcolor').style.backgroundColor = obj.mismatchcolor;
    }
}
function stcpanel_hide() {
    document.getElementById("ftb_stcdiv").style.display = "none";
    indicator3.style.display = "none";
}
function stc_fontfamily() {
    // config one decor track, called by changing <select>
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname==undefined || !(decorname in decorCanvasHash)) {
        stcpanel_hide();
	print2console("track has been removed", 2);
	return;
    }
    decorCanvasHash[decorname].fontfamily = getSelectValueById('stc_fontfamily');
    drawDecorCanvas(decorname);
}
function stc_fontsize() {
    // config one decor track, called by changing <select>
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname==undefined || !(decorname in decorCanvasHash)) {
        stcpanel_hide();
	print2console("track has been removed", 2);
	return;
    }
    decorCanvasHash[decorname].fontsize = getSelectValueById('stc_fontsize');
    drawDecorCanvas(decorname);
}
function stc_fontbold(event) {
    // config one decor track, called by changing checkbox
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname==undefined || !(decorname in decorCanvasHash)) {
        stcpanel_hide();
	print2console("track has been removed", 2);
	return;
    }
    decorCanvasHash[decorname].fontbold = event.target.checked;
    drawDecorCanvas(decorname);
}
function stc_textcolor_initiator(event) {
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('stc_textcolor').style.backgroundColor);
    palette.which = 1;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_textcolor() {
    // event.target should be <td> in palette
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname!=undefined && (decorname in decorCanvasHash)) {
        decorCanvasHash[decorname].textcolor = palette.output;
        document.getElementById("stc_textcolor").style.backgroundColor = palette.output;
        drawDecorCanvas(decorname);
	return;
    }
    stcpanel_hide();
    print2console("track has been removed", 2);
}
function stc_bedcolor_initiator(event) {
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('stc_bedcolor').style.backgroundColor);
    palette.which = 2;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_bedcolor(event) {
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname!=undefined && (decorname in decorCanvasHash)) {
        decorCanvasHash[decorname].bedcolor = palette.output;
        document.getElementById("stc_bedcolor").style.backgroundColor = palette.output;
        drawDecorCanvas(decorname);
	return;
    }
    stcpanel_hide();
    print2console("track has been removed", 2);
}
function stc_forwardcolor_initiator(event) {
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("stc_forwardcolor").style.backgroundColor);
    palette.which = 3;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_forwardcolor() {
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname!=undefined && (decorname in decorCanvasHash)) {
        decorCanvasHash[decorname].forwardcolor = palette.output;
        drawDecorCanvas(decorname);
        document.getElementById("stc_forwardcolor").style.backgroundColor = palette.output;
	return;
    }
    stcpanel_hide();
    print2console("track has been removed", 2);
}
function stc_reversecolor_initiator(event) {
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("stc_reversecolor").style.backgroundColor);
    palette.which = 4;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_reversecolor() {
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname!=undefined && (decorname in decorCanvasHash)) {
        decorCanvasHash[decorname].reversecolor = palette.output;
        drawDecorCanvas(decorname);
        document.getElementById("stc_reversecolor").style.backgroundColor = palette.output;
	return;
    }
    stcpanel_hide();
    print2console("track has been removed", 2);
}
function stc_mismatchcolor_initiator(event) {
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("stc_mismatchcolor").style.backgroundColor);
    palette.which = 5;
    document.body.addEventListener("mousedown", palettehide, false);
}
function stc_mismatchcolor() {
    var decorname = document.getElementById("ftb_stcdiv").target;
    if(decorname!=undefined && (decorname in decorCanvasHash)) {
        decorCanvasHash[decorname].mismatchcolor = palette.output;
        drawDecorCanvas(decorname);
        document.getElementById("stc_mismatchcolor").style.backgroundColor = palette.output;
	return;
    }
    stcpanel_hide();
    print2console("track has been removed", 2);
}




// htest cutoff line color
function htest_clc_initiator(event) { // htest cutoff line color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('htest_clc').style.backgroundColor);
    palette.which = 34;
    document.body.addEventListener("mousedown", palettehide, false);
}
function htest_clc() {
    var c = palette.output;
    document.getElementById('htest_clc').style.backgroundColor = c;
    if(qtc.which == 9) {
	htest.qtc.pvccolor = c;
	drawHtestCanvas();
    } else if(qtc.which == 8) {
	bev.data[bev.ongoing].qtc.pvccolor = c;
	bev_plot(bev.ongoing);
    } else {fatalError('htest_clc: unknown qtc.which');}
}

// quantitative track config color blobs
function qtc_pcolor_initiator(event) { // positive
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('qtc_pcolor').style.backgroundColor);
    palette.which = 30;
    document.body.addEventListener("mousedown", palettehide, false);
}
function qtc_pcolor() {
    var c = palette.output;
    document.getElementById("qtc_pcolor").style.backgroundColor = c;
    document.getElementById("qtc_pcolordiv").style.backgroundColor = c;
    var lst = colorstr2int(c);
    qtc.pr=lst[0]; qtc.pg=lst[1]; qtc.pb=lst[2];
    qtc.changed = 'pr';
    qtc_update();
}
function qtc_ncolor_initiator(event) { // negative
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('qtc_ncolor').style.backgroundColor);
    palette.which = 31;
    document.body.addEventListener("mousedown", palettehide, false);
}
function qtc_ncolor() {
    var c = palette.output;
    document.getElementById("qtc_ncolor").style.backgroundColor = c;
    document.getElementById("qtc_ncolordiv").style.backgroundColor = c;
    var lst = colorstr2int(c);
    qtc.nr=lst[0]; qtc.ng=lst[1]; qtc.nb=lst[2];
    qtc.changed = 'nr';
    qtc_update();
}
function qtc_pth_initiator(event) { // positive threshold
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('qtc_pth').style.backgroundColor);
    palette.which = 32;
    document.body.addEventListener("mousedown", palettehide, false);
}
function qtc_pth() {
    document.getElementById("qtc_pth").style.backgroundColor = palette.output;
    qtc.pth = palette.output;
    qtc.changed = 'pth';
    qtc_update();
}
function qtc_nth_initiator(event) { // negative threshold
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById('qtc_nth').style.backgroundColor);
    palette.which = 33;
    document.body.addEventListener("mousedown", palettehide, false);
}
function qtc_nth(event) {
    document.getElementById("qtc_nth").style.backgroundColor = palette.output;
    qtc.nth = palette.output;
    qtc.changed = 'nth';
    qtc_update();
}
function qtc_update() {
    switch(qtc.which) {
    case 1:
        // single heatmap track selected by menu
        if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    // but actually updates all hmtk
	    for(var i=0; i<tkLst.length; i++)
	        qtc_paramCopyChange(tkLst[i].qtc);
	    trackHeightChanged(true);
	} else {
	    // only single track involved
	    qtc_paramCopyChange(tkLst[menu.iY].qtc);
	    drawOnehmtk(tkLst[menu.iY]);
	    trackHeightChanged(false);
        }
	break;
    case 2:
        // hmtk selected by mcm color block
        if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    for(var i=0; i<tkLst.length; i++)
	        qtc_paramCopyChange(tkLst[i].qtc);
	    drawHmCanvas();
	    trackHeightChanged(true);
	} else {
	    for(var i=0; i<menu.trackIdxLst.length; i++) {
		var obj = tkLst[menu.trackIdxLst[i]];
		qtc_paramCopyChange(obj.qtc);
		drawOnehmtk(obj);
	    }
	    trackHeightChanged(false);
	}
	break;
    case 3:
        // bigbed density, selected by menu
	if(decorInfo[menu.decorname].mode != "density")
	    return;
	qtc_paramCopyChange(decorCanvasHash[menu.decorname].qtc);
	drawDensityDecorCanvas(menu.decorname);
	break;
    case 4:
        // decor bigwig, selected by menu
	qtc_paramCopyChange(decorCanvasHash[menu.decorname].qtc);
	drawDensityDecorCanvas(menu.decorname);
	break;
    case 5:
        // bam density, selected by menu
	fatalError("oh not there yet");
	break;
    case 6:
        // conventional pwc log ratio
	qtc_paramCopyChange(pwc.qtc);
	pwc_draw();
	break;
    case 7:
        // corr
	qtc_paramCopyChange(correlation.qtc);
        for(var i=0; i<tkLst.length; i++) {
	    initiateCorrCanvasCtx(tkLst[i].coC.ctx);
	    drawCorr_onetrack(tkLst[i]);
	}
	break;
    case 8:
        /* bev
	   if configuring pwc/htest vector, 'alltk' should remain hidden and unchecked
	   only when configuring bigwig/bigbed vectors can 'alltk' option be available
	   if 'alltk' is checked, will only modify bigwig/bigbed vectors
	   else, will only modify bev.ongoing vector
	 */
        if(document.getElementById("qtc_alltrackcheckbox").checked) {
	    /* the "apply to all" should only be issued from bigwig and bigbed vectors
	       this will not be applied to pwc and htest vectors
	     */
	    for(var vn in bev.data) {
	        if(bev.data[vn].filetype!=6 && bev.data[vn].filetype!=7) {
		    qtc_paramCopyChange(bev.data[vn].qtc);
		    if(qtc.changed=="thtype" || qtc.changed=='uselog') {
			bev_updatevector(vn);
		    } else {
			bev_plot(vn);
		    }
		}
	    }
	} else {
	    qtc_paramCopyChange(bev.data[bev.ongoing].qtc);
	    if(qtc.changed=="thtype" || qtc.changed=='uselog') {
	        bev_updatevector(bev.ongoing);
	    } else {
	        bev_plot(bev.ongoing);
	    }
	    /* in case of changing color for pwc/htest vectors, 
	       also need to change background color of participating vectors
	     */
	    if(bev.data[bev.ongoing].filetype==6 || bev.data[bev.ongoing].filetype==7) {
		if(qtc.changed=="pr" || qtc.changed=="nr") {
		    bev_hlvectors(bev.ongoing);
		}
	    }
	}
	break;
    case 9:
        // conventional htest
	qtc_paramCopyChange(htest.qtc);
	drawHtestCanvas();
	break;
    case 10:
        // ideogram wiggle1
	qtc_paramCopyChange(ideogram.wiggle1.qtc);
	draw_ideogramWiggle(1);
	break;
    case 11:
        // ideogram wiggle2
	qtc_paramCopyChange(ideogram.wiggle2.qtc);
	draw_ideogramWiggle(2);
	break;
    default:
        fatalError("qtc_update: unknown qtc.which");
    }
}
function qtc_paramCopy(from,to) {
    /* 'from' 'to' are qtc objects (or equipped with same attributes)
       copy values from one to the other
     */
    for(var p in from) {
        to[p] = from[p];
    }
}
function qtc_paramCopyChange(to) {
    /* 'to' is a qtc object
       copy from qtc object to 'to' object for the changed 
       also copy auxiliary params:
       - pg, pb are with pr
       - ng, nb are with nr
       - thmin, thmax, thpercentile are with thtype
       - logtype is with uselog
     */
    to[qtc.changed] = qtc[qtc.changed];
    if(qtc.changed == 'pr') {
        to.pg = qtc.pg;
	to.pb = qtc.pb;
    } else if(qtc.changed == 'nr') {
        to.ng = qtc.ng;
	to.nb = qtc.nb;
    } else if(qtc.changed == 'thtype') {
        if(qtc.thtype == 1) {
	    to.thmin=qtc.thmin; to.thmax=qtc.thmax;
	} else if(qtc.thtype == 2) {
	    to.thpercentile = qtc.thpercentile;
	}
    } else if(qtc.changed == 'uselog') {
        if(qtc.uselog) {
	    to.logtype = qtc.logtype;
	}
    }
}



/*** bigBed generator 
     via textarea input
 ***/
function bbgsubmit() {
    var t = document.getElementById('bbgtextarea').value;
    if(t.length == 0) {
        print2console("no gene list found in text area", 2);
	return;
    }
    t = t.replace(/\t/g, ' ');
    if(ensureNonezerolengthregion(4)) {
        print2console("custom region selector defined zero length", 2);
	return;
    }
    document.getElementById("bbgwriteshere").innerHTML = "working...";
    ajax("new=on&generatebigbed=on&gss_says=xx&itemlist="+escape(t)+gss_param(4)+"&statusId="+statusId+"&dbName="+dbInfo.name, function(data){
        if('abort' in data) {
            document.getElementById("bbgwriteshere").innerHTML = data['abort'];
            print2console(data['abort'], 3);
            unveil(viewbox);
            return;
        }
        document.getElementById("bbgwriteshere").innerHTML = "<a href=t/"+sessionId+".bigBed>"+window.location.href+"t/"+sessionId+".bigBed</a><br>This file contains "+data["itemnum"]+" items "+
		"<button type=button onclick=bbg2custombigbedtrack(event)>put it up as custom bigBed track</button>";
    });
}
function bbg2custombigbedtrack(event) {
    /* called by pushing button
       the newly generated bigbed file always has same file name and location, so...
       try use session ID + a number as custom track name
     */
    var tknum = 0;
    var tkexists = true;
    while(tkexists) {
        tknum++;
	tkexists = (sessionId+'.'+tknum) in decorCanvasHash;
    }
    document.getElementById("newcustombigbedfileurl").value = window.location.href+"t/"+sessionId+".bigBed";
    document.getElementById("newcustombigbedtkname").value = sessionId+'.'+tknum;
    document.getElementById("newcustombigbedmode").selectedIndex = 1;
    submitNewcustombigbed();
    event.target.disabled = true;
}




/*** GP gene plot
  geneplotpanel has absolute position, but it will be inserted into different holders when used
      - gene set view: to 'genesetinservice'
      - custom bigbed: to 'tgt_customTrack'
      - standalone: to document.body
 ***/
function enableGooglechart(event) {
    document.getElementById('googlechart_load_says').innerHTML = 'Importing library, please wait....';
    var h = document.getElementsByTagName('HEAD')[0];
    var s = document.createElement('script');
    s.type = 'text/javascript';
    s.src = 'https://www.google.com/jsapi';
    h.appendChild(s);
    setTimeout(enableGooglechart2, 500);
}
function enableGooglechart2(event) {
    // for google chart tools
    if(typeof(google) == "undefined") {
        //print2console('failed to include Google Chart API', 2);
	document.getElementById('googlechart_load_says').innerHTML = '<span style="color:#D78585;">Google Chart option is unavailable because the library cannot be imported.</span><br> Please check your network and <button type=button onclick=enableGooglechart()>try again</button>';
    } else {
        //print2console('Google Chart is ready to use!', 2);
        document.getElementById('googlechart_load_says').innerHTML = '<span style="color:#7FD784;">Google Chart is ready to use!</span> Select the option from above drop-down menu.';
	document.getElementById('googlechartopt').disabled = false;
	google.load('visualization', '1', {packages:['corechart', 'table'], callback:function(){}});
    }
}
function closegeneplot() {
    document.getElementById('geneplotpanel').style.display='none';
    document.getElementById('geneplotstandalone_hook').className = 'shortcutbut';
    document.getElementById("pagecloak").style.display = 'none';
}
function invokegeneplot_standalone() {
    /* called by Apps panel option, to invoke gene plot panel standalone mode
     */
    var d = document.getElementById("geneplotpanel");
    if(d.style.display == 'block') {
        closegeneplot();
	return;
    }
    cloakPage();
    d.style.display = "block";
    d.style.top = 100+document.body.scrollTop;
    geneplot.for = 2;
    document.getElementById("geneplotforwhat").innerHTML = "for custom gene set";
    document.getElementById('gpStandalone_holder').style.display = 'block';
    document.getElementById("genesetfyi").style.display = 'none';
    document.getElementById('geneplotstandalone_hook').className = 'shortcutbutMD';
    gp_back2control();
}
function invokegeneplot_geneset() {
    /* called by pushing big button, to invoke gene plot panel
       toggle on geneplotdiv for geneset view
     */
    cloakPage();
    var d = document.getElementById("geneplotpanel");
    d.style.display = "block";
    d.style.paddingLeft = 30;
    d.style.paddingTop = 30;
    d.style.top = 100+document.body.scrollTop;
    geneplot.for = 0;
    d.style.display = 'block';
    document.getElementById("geneplotforwhat").innerHTML = "following Gene Set View";
    document.getElementById('gpStandalone_holder').style.display = 'none';
    var n = genesetview.lst.length;
    d = document.getElementById("genesetfyi");
    d.firstChild.nextSibling.innerHTML = "There are "+n+" items in gene set";
    if(n < 150) {
        d.firstChild.style.color = "#66B266";
	d.firstChild.innerHTML = "Yep";
	d.firstChild.nextSibling.innerHTML += " and you're safe to go";
    } else {
        d.firstChild.style.color = "#FFC266";
	d.firstChild.innerHTML = "Hmm";
	d.firstChild.nextSibling.innerHTML += ", if you run into \"URL too long\" problem when using <b>second</b> plot type, please use R rendering method instead";
    }
    document.getElementById('geneplotstandalone_hook').className = 'shortcutbutMD';
    document.getElementById('geneplot_tkname').innerHTML = 'NONE';
    document.getElementById('geneplot_tklabel').innerHTML = 'NONE';
    gp_back2control();
}
function invokegeneplot_custombigbed(tkname) {
    // called by pushing button to invoke geneplot panel
    if(!(tkname in decorCanvasHash)) {
        print2console("custom bigBed track not found by name: "+tkname, 3);
	return;
    }
    if(decorInfo[tkname].fileType != 1) {
        print2console("invokegeneplot_custombigbed: wrong file type");
	return;
    }
    var d = document.getElementById("geneplotpanel");
    d.style.display = "block";
    d.style.paddingLeft = 15;
    d.style.paddingTop = 15;
    document.getElementById("tgt_customTrack").appendChild(d);
    d.style.left = 0; d.style.top = 35;
    geneplot.for = 1;
    geneplot.forTkname = tkname;
    document.getElementById("geneplotforwhat").innerHTML = 'for custom bigBed track '+tkname;
    document.getElementById('gpStandalone_holder').style.display = 'none';
    d = document.getElementById("genesetfyi");
    d.style.display = 'block';
    var n = decorCanvasHash[tkname].totalitemnumber;
    d.firstChild.nextSibling.innerHTML = "There are "+n+" items in this custom bigBed track";
    if(n > geneplot.maxbigbeditemnumber) {
        d.firstChild.style.color = '#FF6666';
	d.firstChild.innerHTML = "Nope";
	d.firstChild.nextSibling.innerHTML += ", only first "+geneplot.maxbigbeditemnumber+" items will be used for plotting, and it would be dangerous to run <b>second</b> plot type as server will be sending huge amount of data that might halt your computer";
    } else {
        if(n < 150) {
            d.firstChild.style.color = "#66B266";
	    d.firstChild.innerHTML = "Yep";
	    d.firstChild.nextSibling.innerHTML += " and you're safe to go";
        } else {
            d.firstChild.style.color = "#FFC266";
	    d.firstChild.innerHTML = "Hmm";
	    d.firstChild.nextSibling.innerHTML += ", but be careful with second plot type, as the server might send too much data and that will cause trouble to your computer";
	}
    }
    document.getElementById('geneplotstandalone_hook').className = 'shortcutbutMD';
    document.getElementById('geneplot_tkname').innerHTML = 'NONE';
    document.getElementById('geneplot_tklabel').innerHTML = 'NONE';
    gp_back2control();
}
function menuDecorGeneplot() {
    // to invoke geneplot for custom bigbed from context menu
    if(document.getElementById("hook10").style.display == "block")
        toggle10();
    var e = document.createEvent("MouseEvents");
    e.initMouseEvent("mousedown", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
    document.getElementById("cpbar_customTrack").dispatchEvent(e);
    invokegeneplot_custombigbed(menu.decorname);
}
function geneplotchoosestyle(event) {
    /* called by clicking div
       first child node is <radio>
     */
    var lst = document.getElementsByName("geneplotdiv");
    for(var i=0; i<lst.length; i++)
        lst[i].className = "geneplotdiv";
    var tt = event.target;
    if(event.target.tagName == "IMG")
        tt = event.target.parentNode;
    tt.className = "geneplotdiv2";
    tt.firstChild.checked = true;
    lst = document.getElementsByName("geneplottable");
    for(i=0; i<lst.length; i++)
        lst[i].style.display = "none";
    document.getElementById("geneplot_"+tt.firstChild.value).style.display = "block";
    if(tt.firstChild.value == "s4") {
        document.getElementById("geneplotchooserender").style.display = "none";
        document.getElementById("geneplotnotchooserender").style.display = "inline";
    } else {
        document.getElementById("geneplotchooserender").style.display = "inline";
        document.getElementById("geneplotnotchooserender").style.display = "none";
    }
}
function geneplot_s1_lc_initiator(event) {
    // s1 line color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s1_lc").style.backgroundColor);
    palette.which = 22;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s2_lc_initiator(event) {
    // s2 spagetti color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s2_lc").style.backgroundColor);
    palette.which = 23;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_promoterc_initiator(event) {
    // s3 promoter
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_promoterc").style.backgroundColor);
    palette.addEventListener("mousedown", geneplot_s3_promoterc, false);
    palette.which = 24;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_utr5c_initiator(event) {
    // s3 5' utr
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_utr5c").style.backgroundColor);
    palette.which = 25;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_utr3c_initiator(event) {
    // s3 3' utr
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_utr3c").style.backgroundColor);
    palette.which = 26;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_exonsc_initiator(event) {
    // s3 exon color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_exonsc").style.backgroundColor);
    palette.which = 27;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s3_intronsc_initiator(event) {
    // s3 intron color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s3_intronsc").style.backgroundColor);
    palette.which = 28;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s4_pc_initiator(event) {
    // s4 positive value color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s4_pc").style.backgroundColor);
    palette.which = 20;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplot_s4_nc_initiator(event) {
    // s4 negative value color
    paletteshow(event.clientX, event.clientY);
    palettegrove_paint(document.getElementById("geneplot_s4_nc").style.backgroundColor);
    palette.which = 21;
    document.body.addEventListener("mousedown", palettehide, false);
}
function geneplotrenderselectchange(event) {
    // called by changing <select> to choose between google or R
    var isgoogle = event.target.selectedIndex == 0;
    document.getElementById('geneplot_s1_lc').innerHTML = isgoogle ? 'median curve' : 'box color';
    document.getElementById('geneplot_s1_googlesays').style.display = isgoogle ? 'inline' : 'none';
    document.getElementById('geneplot_s1_useR').style.display = isgoogle ? 'none' : 'inline';
    document.getElementById('geneplot_s3_googlesays').style.display = isgoogle ? 'inline' : 'none';
    document.getElementById('geneplot_s3_useR').style.display = isgoogle ? 'none' : 'inline';
    var d1 = document.getElementById('geneplot_s1_biglogo');
    var d3 = document.getElementById('geneplot_s3_biglogo');
    if(isgoogle) {
        d1.innerHTML = '<img src=images/geneplot_s1_g.png height=160 width=160>';
        d3.innerHTML = '<img src=images/geneplot_s3_g.png height=160 width=160>';
    } else {
        d1.innerHTML = '<img src=images/geneplot_s1_b.png height=160 width=160>';
        d3.innerHTML = '<img src=images/geneplot_s3_b.png height=160 width=160>';
    }
}
function makeGeneplot() {
    /* called by pushing button
       geneplot.for should have already been set to indicate running mode
     */

    var type = getValue_by_radioName("geneplotstyle");
    var rendering = getSelectValueById("geneplotrender");

    /* running Google Chart (s2) with many items will be problematic
       need to exclude that
     */
    if(type=='s2' && (rendering=='gc' || rendering=='gic')) {
        var itemnumlimit = 500;
        if(geneplot.for == 0) {
	    if(genesetview.lst.length > itemnumlimit) {
	        print2console("Too many items to plot via Google service, use R instead", 2);
		return;
	    }
	} else if(geneplot.for == 1) {
	    if(decorCanvasHash[geneplot.forTkname].totalitemnumber > itemnumlimit) {
	        print2console("Too many items to plot via Google service, use R instead", 2);
		return;
	    }
	}
    }

    // but first, let's hide everybody
    document.getElementById("haszerosdgene").style.display = "none";
    document.getElementById("geneplot_selectedgenediv").style.display = "none";
    stripChild(document.getElementById("geneplot_kmeansclusterbuttonholder"), 0);
    document.getElementById("geneplotdendrogram").style.display = "none";
    document.getElementById("geneplotcanvasdiv").style.display = "none";
    document.getElementById("googleimagechartdiv").style.display = "none";
    document.getElementById("googlechartdiv").style.display = "none";
    document.getElementById("geneplotimage").style.display = "none";
    document.getElementById("googletablediv").style.display = "none";
    document.getElementById("geneplot_dataplaintext").style.display = "none";
    document.getElementById("geneplotgetdatabuttons").style.display = "none";


    // data track
    var tkname = document.getElementById('geneplot_tkname').innerHTML;
    if(tkname == 'NONE') {
        print2console('You haven\'t selected a track for GenePlot',2);
	return;
    }
    var isCustom = document.getElementById('geneplot_tkiscustom').innerHTML;
    if(isCustom == 'NONE') {
        fatalError('makeGeneplot: geneplot_tkiscustom innerHTML is NONE');
    }
    isCustom = isCustom=='1';
    var tkurl = document.getElementById('geneplot_tkurl').innerHTML;

    // plot-type specific params
    var param = '';
    if(type == "s4") {
        param = "&clustmethod="+getSelectValueById("geneplot_s4_m")+"&kmeanscnum="+getSelectValueById("geneplot_s4_cnum")+"&clustdist="+getSelectValueById("geneplot_s4_dist")+"&clustaglm="+getSelectValueById("geneplot_s4_aglm");
    } else if(rendering=='r') {
        // R rendering params
        param = "&usingR=on&width="+getSelectValueById("geneplot_"+type+"_iw")+"&height="+getSelectValueById("geneplot_"+type+"_ih")+"&lw="+getSelectValueById("geneplot_"+type+"_lw");
	if(type == 's1') {
	    // s1 specific R params
	    var c = document.getElementById("geneplot_"+type+"_lc").style.backgroundColor;
	    param += '&range='+getSelectValueById('geneplot_s1_wrange')+
	        '&lc='+c+
		'&averagelc='+darkencolor(colorstr2int(c), 0.4)+
		'&outlier='+getSelectValueById('geneplot_s1_outlier')+
		(document.getElementById('geneplot_s1_average').checked?'&average=on':'');
	} else if(type=='s2') {
	    // s2 specific R params
	    //param += "&lc="+document.getElementById("geneplot_s2_lc").style.backgroundColor;
	} else if(type=='s3') {
	    // s3 specific R params
	    var pc = document.getElementById("geneplot_"+type+"_promoterc").style.backgroundColor;
	    var uc5 = document.getElementById("geneplot_"+type+"_utr5c").style.backgroundColor;
	    var uc3 = document.getElementById("geneplot_"+type+"_utr3c").style.backgroundColor;
	    var ec = document.getElementById("geneplot_"+type+"_exonsc").style.backgroundColor;
	    var ic = document.getElementById("geneplot_"+type+"_intronsc").style.backgroundColor;
	    param += "&promoterc="+pc+
	    	      "&utr5c="+uc5+
	    	      "&utr3c="+uc3+
	    	      "&exonsc="+ec+
	    	      "&intronsc="+ic+
		      '&average_promoterc='+darkencolor(colorstr2int(pc), 0.4)+
		      '&average_utr5c='+darkencolor(colorstr2int(uc5), 0.4)+
		      '&average_utr3c='+darkencolor(colorstr2int(uc3), 0.4)+
		      '&average_exonsc='+darkencolor(colorstr2int(ec), 0.4)+
		      '&average_intronsc='+darkencolor(colorstr2int(ic), 0.4)+
	              '&range='+getSelectValueById('geneplot_s3_wrange')+
		      '&outlier='+getSelectValueById('geneplot_s3_outlier')+
		      (document.getElementById('geneplot_s3_average').checked?'&average=on':'');
	}
    }

    // positional data
    if(geneplot.for == 0) {
        /* four fields for each: itemname (gene or coord), chr, start, stop */
        var items = [];
        for(var i=0; i<genesetview.lst.length; i++)
            items.push(genesetview.lst[i].slice(0,4).join(','));
	param += "&lst="+items.join(',');
    } else if(geneplot.for == 2) {
        /* textarea input items joined by comma 
	   notice gss param is supplied!
	 */
	var inputvalue = document.getElementById('gpStandalone_textarea').value;
	if(inputvalue.length == 0) {
	    print2console('Please enter gene names or genomic coordinates', 2);
	    return;
	}
	param += '&tainput='+inputvalue.replace(/,/g,'').replace(/\t/g,' ').split('\n').join(',')+gss_param(5);
    } else if(geneplot.for == 1) {
        param += "&forurl="+escape(decorInfo[geneplot.forTkname].url);
    }

    document.body.style.cursor = 'wait';
    document.getElementById('geneplot_butt').innerHTML = 'Running...';
    document.getElementById('geneplot_butt').removeEventListener('click', makeGeneplot, false);

    ajax("makegeneplot=on&plottype="+type+"&spnum="+getSelectValueById("geneplot_"+type+"_spnum")+(isCustom?"&tkurl="+escape(tkurl):"&tkname="+tkname+'&dbName='+dbInfo.name)+param, function(data){
	document.getElementById('geneplot_butt').innerHTML = 'Make gene plot';
        document.getElementById('geneplot_butt').addEventListener('click', makeGeneplot, false);
        if('alert' in data) {
	    print2console(data['alert'], 2);
	}
        if('gpabort' in data) {
            document.body.style.cursor = 'auto';
	    return;
	}
        document.getElementById("geneplotgetdatabuttons").style.display = "block";

	document.getElementById('gp_figure_div').style.display = 'block';
	document.getElementById('gp_option_div').style.display = 'none';

	var rendering = getSelectValueById("geneplotrender");
        var type = getValue_by_radioName("geneplotstyle");
	geneplot.type = type;
	geneplot.data = data['data'];
        var spnum = parseInt(getSelectValueById("geneplot_"+type+"_spnum"));

        var canvasdiv = document.getElementById("geneplotcanvasdiv"); // plot as canvas
	var gcimagediv = document.getElementById("googleimagechartdiv"); // google image chart
	var gcdiv = document.getElementById("googlechartdiv"); // google chart tool, fancier
	var Rimage = document.getElementById("geneplotimage"); // R-generated image

	var imageframe; // for image chart only

        if(type == "s4") {
	    canvasdiv.style.display = "table";
	} else if(rendering == "r") {
	    Rimage.style.display = "block";
	} else if(rendering == "gc") {
	    gcdiv.style.display = "block";
	} else if(rendering == "gic") {
	    gcimagediv.style.display = "block";
	    stripChild(gcimagediv, 0);
	    imageframe = document.createElement("iframe");
	    imageframe.frameBorder = 0;
	    gcimagediv.appendChild(imageframe);
	}


	if(type == "s1") {
	    if(rendering == "gc") {
	        var showaverage = document.getElementById('geneplot_s1_average').checked;
	        var Gdata = new google.visualization.DataTable();
		Gdata.addColumn('number', 'POS'); // X axis index
		Gdata.addColumn('number', 'minimum');
		Gdata.addColumn('number', 'lower quartile');
		Gdata.addColumn('number', 'median');
		if(showaverage)
		    Gdata.addColumn('number', 'average');
		Gdata.addColumn('number', 'upper quartile');
		Gdata.addColumn('number', 'maximum');
		Gdata.addRows(spnum);

		var tmpi;
		for(var i=0; i<spnum; i++) {
		    Gdata.setValue(i, 0, i); // X axis index value
		    var v = data['data'][i];
		    Gdata.setValue(i, 1, v[0]);
		    Gdata.setValue(i, 2, v[1]);
		    Gdata.setValue(i, 3, v[2]);
		    tmpi = 4;
		    if(showaverage)
		        Gdata.setValue(i, tmpi++, v[3]);
		    Gdata.setValue(i, tmpi++, v[4]);
		    Gdata.setValue(i, tmpi++, v[5]);
		}

		// line color
		var lc = document.getElementById("geneplot_s1_lc").style.backgroundColor;
		var clst = colorstr2int(lc);
		var colorlst = [lightencolor(clst, .8), lightencolor(clst, .5), lc];
		if(showaverage)
		    colorlst.push(darkencolor(clst, .4));
	        colorlst.push(lightencolor(clst, .5));
	        colorlst.push(lightencolor(clst, .8));

		new google.visualization.LineChart(gcdiv).draw(Gdata, 
			{width:parseInt(getSelectValueById("geneplot_s1_iw")),
			 height:parseInt(getSelectValueById("geneplot_s1_ih")),
			 lineWidth:parseInt(getSelectValueById("geneplot_s1_lw")),
			 colors:colorlst,
			 hAxis:{'title':"Genomic positions from 5' to 3'"},
			 vAxis:{'title':"Data value distribution"},
			 });
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
	    }
	    if(rendering == "r") {
	        var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
	    }
	}
	if(type == "s2") {
	    if(rendering == "gc") {
	        var Gdata = new google.visualization.DataTable();
		Gdata.addColumn('number', 'POS'); // x axis index
		for(var i=0; i<data['data'].length; i++) {
		    Gdata.addColumn('number', data['data'][i][0]);
		}
		Gdata.addRows(spnum);
		// set x axis index
		for(i=0; i<spnum; i++) {
		    Gdata.setValue(i, 0, i);
		}
		// set data value
		for(i=0; i<data['data'].length; i++) { // for each vector (or column in DataTable)
		    var v = data['data'][i];
		    for(var j=0; j<spnum; j++) {
		        Gdata.setValue(j, i+1, v[j+1]);
		    }
		}
		new google.visualization.LineChart(gcdiv).draw(Gdata, 
			{width:parseInt(getSelectValueById("geneplot_s2_iw")),
			 height:parseInt(getSelectValueById("geneplot_s2_ih")),
			 lineWidth:parseInt(getSelectValueById("geneplot_s2_lw")),
			 colors:[document.getElementById("geneplot_s2_lc").style.backgroundColor],
			 legend:"none",
			 hAxis:{'title':"Genomic positions from 5' to 3'"},
			 vAxis:{'title':"Data point values"},
			 });
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
	        return;
	    }
	    if(rendering == "r") {
	        var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
	    }
	}
	if(type == "s3") {
	    // hard-coded info about gene parts
	    if(rendering == "gc") {
	        var showaverage = document.getElementById('geneplot_s3_average').checked;
	        var Gdata = new google.visualization.DataTable();
		Gdata.addColumn('string', 'POS'); // string index, "promoter 1"
		for(var k=0; k<5; k++) {
		    Gdata.addColumn('number', "minimum");
		    Gdata.addColumn('number', "lower quartile");
		    Gdata.addColumn('number', "median");
		    if(showaverage)
		        Gdata.addColumn('number', 'average');
		    Gdata.addColumn('number', "upper quartile");
		    Gdata.addColumn('number', "maximum");
		}
		var totalNum = spnum*5;
		Gdata.addRows(totalNum);
		// set value for each gene part
		var lst = ['promoter','5\' UTR', 'exons', 'introns', '3\' UTR'];
		var tmpi;
		var m = showaverage ? 6 : 5; // |o|
		for(k=0; k<5; k++) {
		    for(i=0; i<spnum; i++) {
		        var j = i+spnum*k;
		        Gdata.setValue(j, 0, lst[k]+' '+(i+1));
			var v = data['data'][j];
			Gdata.setValue(j, k*m+1, v[0]);
			Gdata.setValue(j, k*m+2, v[1]);
			Gdata.setValue(j, k*m+3, v[2]);
			tmpi = k*m+4;
			if(showaverage)
			    Gdata.setValue(j, tmpi++, v[3]);
			Gdata.setValue(j, tmpi++, v[4]);
			Gdata.setValue(j, tmpi, v[5]);
		    }
		}
		var collst = []; // list of color for all lines
		var col = document.getElementById("geneplot_s3_promoterc").style.backgroundColor;
		var lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_utr5c").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_exonsc").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_intronsc").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		col = document.getElementById("geneplot_s3_utr3c").style.backgroundColor;
		lst = colorstr2int(col);
		collst.push(lightencolor(lst,.8));
		collst.push(lightencolor(lst,.5));
		collst.push(col);
		if(showaverage) collst.push(darkencolor(lst, .4));
		collst.push(lightencolor(lst,.5));
		collst.push(lightencolor(lst,.8));
		new google.visualization.LineChart(gcdiv).draw(Gdata, 
			{width:parseInt(getSelectValueById("geneplot_s3_iw")),
			 height:parseInt(getSelectValueById("geneplot_s3_ih")),
			 lineWidth:parseInt(getSelectValueById("geneplot_s3_lw")),
			 colors:collst,
			 legend:'none',
			 hAxis:{'title':"Genomic positions from 5' to 3'"},
			 vAxis:{'title':"Data value distribution"},
			 });
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
	        return;
	    }
	    if(rendering == "r") {
	        var ll = data["image"].split('/');
		Rimage.src = 't/'+ll[ll.length-1];
                document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		return;
	    }
	}
	if(type == "s4") {
	    var clustmethod = getSelectValueById("geneplot_s4_m");
	    var is_hclust = clustmethod == 'h';
	    var is_kmeans = clustmethod == 'k';
	    var rheight = parseInt(getSelectValueById("geneplot_s4_rh")); // row height
	    var pwidth = parseInt(getSelectValueById("geneplot_s4_dpw")); // data point width
	    geneplot.canvasrheight = rheight;
	    geneplot.canvaspwidth = pwidth;
	    var canvas = document.getElementById("geneplotheatmap");
	    canvas.width = spnum * pwidth;
	    var genenum = 0;
	    var safe2real = {}; // key: safe name, val: real name
	    for(var gname in data.data) {
	        genenum++;
		safe2real[gname] = data.data[gname][0];
	    }
	    geneplot.safe2real = safe2real;
	    if('zerosdgene' in data) {
		var lst = data['zerosdgene'];
		document.getElementById("zerosdgeneholder").innerHTML = lst.join('<br>');
		document.getElementById("zerosdgenenum").innerHTML = lst.length;
		document.getElementById("haszerosdgene").style.display = "block";
	    }
	    canvas.height = genenum * rheight;

	    // use global min/max to render heatmap?
	    var globalth = document.getElementById("geneplot_s4_global").checked;
	    var pth=0; // max of positive
	    var nth=0; // min of negative
	    if(globalth) {
	        max = 0;
	        for(gname in data.data) {
		    var v = data.data[gname].slice(1);
		    for(i=0; i<spnum; i++) {
		        if(v[i] > 0) {
			    if(v[i] > pth)
			        pth = v[i];
			} else {
			    if(v[i] < nth)
			        nth = v[i];
			}
		    }
		}
	    }

	    /* list of integers (0-xx) representing genes
	       or safe names??
	       determines vertical order of appearance of genes in heatmap
	     */
	    var genelst = [];
	    // genenum is just length of genelst

	    if(is_kmeans) {
	        /* assign genes to kmeans clusters, reorder geneplot.genelst for tooltip */
		genelst = data.kmnames;
	        geneplot.kmeansclusters = []; // [0] is undefined, cluster id start from 1
		for(i=0; i<data.kmnamecluster.length; i++) {
		    var cid = data.kmnamecluster[i];
		    if(geneplot.kmeansclusters[cid] == undefined)
		        geneplot.kmeansclusters[cid] = [];
		    geneplot.kmeansclusters[cid].push(genelst[i]);
		}
		// reorder genelst according to cluster order
		genelst = [];
		for(i=1; i<geneplot.kmeansclusters.length; i++)
		    genelst = genelst.concat(geneplot.kmeansclusters[i]);
	    } else {
	        genelst = data.hclustgenelst;
	    }
	    geneplot.genelst = genelst;

	    // render heatmap!
	    var pclst = colorstr2int(document.getElementById("geneplot_s4_pc").style.backgroundColor);
	    var nclst = colorstr2int(document.getElementById("geneplot_s4_nc").style.backgroundColor);
	    var ctx = canvas.getContext("2d");
	    ctx.fillStyle = 'white'; // paint canvas with white, the baseline color
	    ctx.fillRect(0,0, canvas.width, canvas.height);
	    var yoffset = 0;
	    for(var row=0; row<genelst.length; row++) {
		var v = data.data[genelst[row]].slice(1);
		if(!globalth) {
		    // figure out threshold value for each data vector
		    pth = 0;
		    nth = 0;
		    for(i=0; i<v.length; i++) {
		        if(v[i] > 0) {
			    if(v[i] > pth)
			        pth = v[i];
			} else {
			    if(v[i] < nth)
			        nth = v[i];
			}
		    }
		}
		for(i=0; i<spnum; i++) {
		    if(v[i] > 0) {
		        ctx.fillStyle = lightencolor(pclst, 1-v[i]/pth);
		        ctx.fillRect(i*pwidth, yoffset, pwidth, rheight);
		    } else if(v[i] < 0) {
		        ctx.fillStyle = lightencolor(nclst, 1-v[i]/nth);
		        ctx.fillRect(i*pwidth, yoffset, pwidth, rheight);
		    }
		}
	        yoffset += rheight;
	    }

	    if(is_kmeans) {
	        // make buttons for clusters
		var holder = document.getElementById("geneplot_kmeansclusterbuttonholder");
		stripChild(holder, 0);
		for(i=1; i<geneplot.kmeansclusters.length; i++) {
		    var d = document.createElement("div");
		    var h = geneplot.kmeansclusters[i].length*rheight;
		    if(h > 10)
		        d.innerHTML = "<div style='font-size:10px;margin-top:"+((h-10)/2)+";'>cluster "+i+"</div>";
		    else
		        d.innerHTML = "cluster "+i;
		    d.style.height = h;
		    d.className = "kmeansclusterbutton";
		    d.cluster = i;
		    d.addEventListener("click", geneplotkmeansclusterbuttonclick, false);
		    holder.appendChild(d);
		}
	        lst = absolutePosition(canvas);
	        geneplot.canvasX = lst[0];
	        geneplot.canvasY = lst[1];
		document.body.style.cursor = "auto";
		print2console("Gene Plot ready", 1);
		/*** done for kmeans ***/
		return;
	    }


	    /*** dendrogram 
	         layed horizontally, hc$height will be X positions, y need to be determined
		 hc$labels contain R's stubborn list of safe names

		 in hc$merge:
		     - negative integers, negate of which are array index in stubburn list
		     - negative int need to be converted into array index of genelst
		       by the actual safe name
		       but it still need to be kept negative to be different with cluster id
		     - positive integers are cluster id
		     - the array index (start from 1) are cluster id in it
		 in hc$height:
		     array index (start from 1) are cluster id
		     value is height of that cluster
		     here it is horizontal distance of branching point to left border of heatmap

		 genelst array idx (start from 1) is cluster id
	     ***/
	    var hclabels = data.hclustlabels; // stubborn list
	    hclabels.unshift(undefined);
	    var merge = data.hclustmerge;
	    merge.unshift([]);
	    /* convert stubborn array index into genelst array index for hc$merge */
	    for(i=1; i<genenum; i++) {
	        var v = merge[i][0];
	        if(v <0) merge[i][0] = -(getArrIdx(hclabels[-v], genelst)+1);
	        v = merge[i][1];
	        if(v <0) merge[i][1] = -(getArrIdx(hclabels[-v], genelst)+1);
	    }
	    var clusterxraw = data.hclustheight;
	    clusterxraw.unshift(0);
	    var clusterx = []; // array index is cluster id, to hold real plotting x coord
	    var maxX = 0;
	    for(i=1; i<genenum; i++) {
	        if(clusterxraw[i] > maxX)
		    maxX = clusterxraw[i];
	    }
	    // clusterx values will be updated to x plotting coord on canvas
	    var canvaswidth = 200;
	    // scale the canvas width somewhat with genenumber
	    if(genenum > 70)
	        canvaswidth = canvaswidth + genenum-70;
	    if(canvaswidth > 400) canvaswidth = 400;
	    var sc = canvaswidth/maxX; // scaling factor, from hc$height to plotting width

	    /* layout and determine y position of clusters */
	    var clustery = []; // array index is cluster id, to hold raw y plotting coord of clusters
	    for(i=1; i<genenum; i++) {
	        // i is cluster id
		clusterx[i] = canvaswidth - clusterxraw[i]*sc;
		if(clusterx[i] >= canvaswidth) clusterx[i] = canvaswidth-1;
		var c1v = merge[i][0]; // value of child 1
		var c2v = merge[i][1]; // value of child 2
		if(c1v < 0) {
		    // first child is gene
		    if(c2v < 0) {
		        // both children are gene
			clustery[i] = c1v<c2v ? -c2v : -c1v;
		    } else {
		        // second child is cluster
		        clustery[i] = (clustery[c2v]-c1v)/2;
		    }
		} else {
		    // first child is cluster
		    if(c2v < 0) {
		        // second child is gene
			clustery[i] = (clustery[c1v]-c2v)/2;
		    } else {
		        // both children are clusters
			clustery[i] = (clustery[c1v]+clustery[c2v])/2;
		    }
		}
	    }
	    // convert clustery from row index to actual plotting coord
	    for(i=1; i<genenum; i++)
	        clustery[i] *= rheight;

	    geneplot.merge = merge;
	    geneplot.clusterx = clusterx;
	    geneplot.clustery = clustery;
	    geneplot.genenum = genenum;
	    geneplot.highlightcluster = {};
	    geneplot.rheight = rheight;

	    // render dendrogram
	    canvas = document.getElementById("geneplotdendrogram");
	    canvas.style.display = "block";
	    canvas.width = canvaswidth;
	    canvas.height = genenum * rheight;
	    ctx = canvas.getContext("2d");
	    ctx.fillStyle = "black";
	    renderGeneplotDendrogram();

            lst = absolutePosition(canvas);
	    geneplot.dendroX = lst[0];
	    geneplot.dendroY = lst[1];

	    // cache cluster plotting coordinate for clicking
            var ccrd = {}; // see geneplot.ccrd
	    geneplot.ccrd = ccrd;
	    for(i=1; i<genenum; i++) {
	        // use four-pixel square to denote cluster
	        var x=[],y=[];
		if(Math.floor(clusterx[i]) != Math.ceil(clusterx[i])) {
		    x[1] = Math.floor(clusterx[i]);
		    x[0] = x[1]-1;
		    x[2] = x[1]+1;
		    x[3] = x[1]+2;
		} else {
		    x[1] = clusterx[i];
		    x[0] = x[1]-1;
		    x[2] = x[1]+1;
		}
		if(Math.floor(clustery[i]) != Math.ceil(clustery[i])) {
		    y[1] = Math.floor(clustery[i]);
		    y[0] = y[1]-1;
		    y[2] = y[1]+1;
		    y[3] = y[1]+2;
		} else {
		    y[1] = clustery[i];
		    y[0] = y[1]-1;
		    y[2] = y[1]+1;
		}
		//var x0 = parseInt(clusterx[i]), y0 = parseInt(clustery[i]);
		//x = [x0-1, x0, x0+1]; y = [y0-1, y0, y0+1];
		for(j=0; j<x.length; j++) {
		    for(k=0; k<y.length; k++) {
		        if(!(x[j] in ccrd)) ccrd[x[j]]={};
			ccrd[x[j]][y[k]] = i;
		    }
		}
	    }

	    // only do this after dendrogram canvas is made (affects position of heatmap)
	    lst = absolutePosition(document.getElementById("geneplotheatmap"));
	    geneplot.canvasX = lst[0];
	    geneplot.canvasY = lst[1];
            document.body.style.cursor = "auto";
	    print2console("Gene Plot ready", 1);
	    return;
	}
    });
}
function gp_back2control() {
    document.getElementById('gp_option_div').style.display = 'block';
    document.getElementById('gp_figure_div').style.display = 'none';
}
function renderGeneplotDendrogram() {
    var canvas = document.getElementById("geneplotdendrogram");
    var canvaswidth = canvas.width;
    var ctx = canvas.getContext("2d");
    ctx.clearRect(0,0,canvas.width, canvas.height);
    var rheight = geneplot.rheight;
    var clusterx = geneplot.clusterx;
    for(var i=1; i<geneplot.genenum; i++) {
        ctx.fillStyle = (i in geneplot.highlightcluster) ? "red" : "black";
	var y1,y2;
	// plot horizontal line of first child
        var c = geneplot.merge[i][0];
	if(c < 0) {
	    y1 = (-c-0.5) * rheight;
	    ctx.fillRect(clusterx[i], y1, canvaswidth-clusterx[i], 1);
	} else {
	    y1 = geneplot.clustery[c];
	    ctx.fillRect(clusterx[i], y1, clusterx[c]-clusterx[i], 1);
	}
	// plot horizontal line for second child
	c = geneplot.merge[i][1];
	if(c < 0) {
	    y2 = (-c-0.5) * rheight;
	    ctx.fillRect(clusterx[i], y2, canvaswidth-clusterx[i], 1);
	} else {
	    y2 = geneplot.clustery[c];
	    ctx.fillRect(clusterx[i], y2, clusterx[c]-clusterx[i], 1);
	}
	// vertical line between two children
	if(y1 < y2)
	    ctx.fillRect(clusterx[i], y1, 1, y2-y1);
	else
	    ctx.fillRect(clusterx[i], y2, 1, y1-y2);
    }
}
function geneplotdendrogramclick(event) {
    // called by clicking on geneplot dendrogram, detect cluster
    var x = event.clientX+document.body.scrollLeft-geneplot.dendroX;
    var y = event.clientY+document.body.scrollTop-geneplot.dendroY-1;
    //print2console(x+' '+y,0);
    if(x in geneplot.ccrd) {
        if(y in geneplot.ccrd[x]) {
	    var targetcluster = geneplot.ccrd[x][y];
	    geneplot.highlightcluster = {};
	    geneplot.highlightgenes = [];
	    geneplot_getchild_recursive(targetcluster);
	    renderGeneplotDendrogram();
	    geneplot_getselectedgenedef_gotoholder();
	}
    }
}
function geneplotkmeansclusterbuttonclick(event) {
    var cluster = event.target.cluster;
    if(cluster == undefined)
        cluster = event.target.parentNode.cluster;
    // called by clicking on kmeans cluster button
    geneplot.highlightgenes = geneplot.kmeansclusters[cluster];
    geneplot_getselectedgenedef_gotoholder();
}
function geneplot_getchild_recursive(i) {
    geneplot.highlightcluster[i] = 1;
    var c = geneplot.merge[i][0];
    if(c > 0)
        geneplot_getchild_recursive(c);
    else
        geneplot.highlightgenes.push(geneplot.genelst[-c-1]);
    c = geneplot.merge[i][1];
    if(c > 0)
        geneplot_getchild_recursive(c);
    else
        geneplot.highlightgenes.push(geneplot.genelst[-c-1]);
}
function geneplot_getselectedgenedef_gotoholder() {
    if(geneplot.highlightgenes.length == 0) {
        document.getElementById("geneplot_selectedgenediv").style.display = "none";
        return;
    }
    var tmplst = [];
    for(var i=0; i<geneplot.highlightgenes.length; i++) {
        tmplst.push(geneplot.data[geneplot.highlightgenes[i]][0]);
	tmplst.push(0);
	tmplst.push(0);
	tmplst.push(0);
    }
    /* genes are selected by clicking on dendrogram or kmeans cluster
       get their info and display in table
     */
    ajax("getitemlistgenedef=on&lst="+tmplst.join(',')+"&dbName="+dbInfo.name,function(data){
        if(!("lst" in data))
	    fatalError("geneplot_getselectedgenedef_gotoholder: lst missing");
	var lst = data['lst'];
	// elements in this array: [name, desc, genetype]
        var holder = document.getElementById("geneplot_selectedgenediv");
	holder.style.display = "block";
	// table is first child of holder
	stripChild(holder.firstChild.firstChild, 0);
        for(var i=0; i<lst.length; i++) {
	    // content in a row: button, symbol, refseq name, desc, link
            var tr = holder.firstChild.insertRow(-1);
	    //tr.style.backgroundColor = "white";
	    var td = tr.insertCell(0); // name
	    td.innerHTML = lst[i][0];
	    td = tr.insertCell(-1);
	    if(lst[i][1] != undefined) // desc
	        td.innerHTML = lst[i][1];
	    td.style.fontSize = "12px";
	    td = tr.insertCell(-1); // link
	    if(lst[i][2] != undefined)
	        td.innerHTML = "<a href="+decorInfo[lst[i][2]].queryUrl+lst[i][0]+" target=_blank>&#8599;</a>";
        }
    });
}
function geneplot_getdata(tabletype) {
    // called by clicking button
    var plottype = geneplot.type;

    if(tabletype == 1) {
        // use Google Chart to make interactive table
	var holder = document.getElementById("googletablediv");
	holder.style.display = "block";
	document.getElementById("geneplot_dataplaintext").style.display = "none";
	var data = new google.visualization.DataTable();
	if(plottype == "s1") {
	    var nrow = geneplot.data.length;
	    data.addColumn("number", "data point #");
	    data.addColumn("number", "minimum");
	    data.addColumn("number", "lower quartile");
	    data.addColumn("number", "median");
	    data.addColumn("number", "average");
	    data.addColumn("number", "upper quartile");
	    data.addColumn("number", "maximum");
	    data.addRows(nrow);
	    for(var i=0; i<nrow; i++) {
	        data.setCell(i, 0, i+1);
		var v = geneplot.data[i];
	        data.setCell(i, 1, v[0]);
	        data.setCell(i, 2, v[1]);
	        data.setCell(i, 3, v[2]);
	        data.setCell(i, 4, v[3]);
	        data.setCell(i, 5, v[4]);
	        data.setCell(i, 6, v[5]);
	    }
	    new google.visualization.Table(holder).draw(data, {showRowNumber:false,});
	} else if(plottype == "s2") {
	    var nrow = geneplot.data.length;
	    var ncol = geneplot.data[0].length-1;
	    data.addColumn("string", "gene name");
	    for(var i=0; i<ncol; i++)
	        data.addColumn("number", i+1);
	    data.addRows(nrow);
	    for(i=0; i<nrow; i++) {
	        data.setCell(i, 0, geneplot.data[i][0]);
		for(var j=0; j<ncol; j++)
		    data.setCell(i, j+1, geneplot.data[i][j+1]);
	    }
	    new google.visualization.Table(holder).draw(data);
	} else if(plottype == "s3") {
	    data.addColumn("string", "data point");
	    data.addColumn('number', 'minimum');
	    data.addColumn('number', 'lower quartile');
	    data.addColumn('number', 'median');
	    data.addColumn('number', 'average');
	    data.addColumn('number', 'upper quartile');
	    data.addColumn('number', 'maximum');
	    var total = geneplot.data.length;
	    data.addRows(total);
	    var spnum = total/5;
	    var lst = ['promoter', '5\' UTR', 'exons', 'introns', '3\' UTR'];
	    for(var k=0; k<5; k++) {
	        for(var i=0; i<spnum; i++) {
		    var j = k*spnum + i;
		    data.setCell(j, 0, lst[k]+' '+(i+1));
		    var v = geneplot.data[j];
		    data.setCell(j, 1, v[0]);
		    data.setCell(j, 2, v[1]);
		    data.setCell(j, 3, v[2]);
		    data.setCell(j, 4, v[3]);
		    data.setCell(j, 5, v[4]);
		    data.setCell(j, 6, v[5]);
		}
	    }
	    new google.visualization.Table(holder).draw(data);
	} else if(plottype == "s4") {
	    var genes = [];
	    for(var g in geneplot.data)
	        genes.push(g);
	    var ncol = geneplot.data[genes[0]].length-1;
	    data.addColumn("string", "gene name");
	    for(var i=0; i<ncol; i++)
	        data.addColumn("number", i+1);
	    data.addRows(genes.length);
	    for(i=0; i<genes.length; i++) {
	        data.setCell(i, 0, geneplot.safe2real[genes[i]]);
		var v = geneplot.data[genes[i]];
		for(var j=0; j<ncol; j++)
		    data.setCell(i, j+1, v[j+1]);
	    }
	    new google.visualization.Table(holder).draw(data);
	}
	return;
    }
    
    // doing text output
    var holder = document.getElementById("geneplot_dataplaintext");
    holder.style.display = "block";
    document.getElementById("googletablediv").style.display = "none";
    var table = holder.firstChild;
    stripChild(table.firstChild, 0);
    var tr = table.insertRow(0);
    var td = tr.insertCell(0);

    if(plottype == 's1') {
	td.innerHTML = "data point #";
	tr.insertCell(-1).innerHTML = "minimum";
	tr.insertCell(-1).innerHTML = "lower quartile";
	tr.insertCell(-1).innerHTML = "median";
	tr.insertCell(-1).innerHTML = "average";
	tr.insertCell(-1).innerHTML = "upper quartile";
	tr.insertCell(-1).innerHTML = "maximum";
	for(var i=0; i<geneplot.data.length; i++) {
	    tr = table.insertRow(-1);
	    tr.insertCell(0).innerHTML = i+1;
	    var v = geneplot.data[i];
	    tr.insertCell(-1).innerHTML = v[0];
	    tr.insertCell(-1).innerHTML = v[1];
	    tr.insertCell(-1).innerHTML = v[2];
	    tr.insertCell(-1).innerHTML = v[3];
	    tr.insertCell(-1).innerHTML = v[4];
	    tr.insertCell(-1).innerHTML = v[5];
	}
	return;
    }
    if(plottype == 's2') {
        td.innerHTML = "gene name";
	var num = geneplot.data[0].length-1;
	for(i=0; i<num; i++) {
	    td = tr.insertCell(-1);
	    td.innerHTML = i+1;
	}
	for(i=0; i<geneplot.data.length; i++) {
	    tr = table.insertRow(-1);
	    td = tr.insertCell(0); td.innerHTML = geneplot.data[i][0];
	    for(var j=0; j<num; j++) {
	        td = tr.insertCell(-1); td.innerHTML = geneplot.data[i][j+1];
	    }
	}
	return;
    }
    if(plottype == "s3") {
        td.innerHTML = "data point";
	tr.insertCell(-1).innerHTML = "minimum";
	tr.insertCell(-1).innerHTML = "lower quartile";
	tr.insertCell(-1).innerHTML = "median";
	tr.insertCell(-1).innerHTML = "average";
	tr.insertCell(-1).innerHTML = "upper quartile";
	tr.insertCell(-1).innerHTML = "maximum";
	var total = geneplot.data.length;
	var spnum = total/5;
	var lst = ['promoter', '5\' UTR', 'exons', 'introns', '3\' UTR'];
	for(var k=0; k<5; k++) {
	    for(var i=0; i<spnum; i++) {
	        tr = table.insertRow(-1);
		var j = k*spnum + i;
		tr.insertCell(0).innerHTML = lst[k]+' '+(i+1);
		var v = geneplot.data[j];
		tr.insertCell(-1).innerHTML = v[0];
		tr.insertCell(-1).innerHTML = v[1];
		tr.insertCell(-1).innerHTML = v[2];
		tr.insertCell(-1).innerHTML = v[3];
		tr.insertCell(-1).innerHTML = v[4];
		tr.insertCell(-1).innerHTML = v[5];
	    }
	}
        return;
    }
    if(plottype == "s4") {
        td.innerHTML = "gene name";
	var genes = [];
	for(var g in geneplot.data)
	    genes.push(g);
	var num = geneplot.data[genes[0]].length-1;
	for(i=0; i<num; i++) {
	    tr.insertCell(-1).innerHTML = i+1;
	}
	for(i=0; i<genes.length; i++) {
	    tr = table.insertRow(-1);
	    tr.insertCell(0).innerHTML = geneplot.safe2real[genes[i]];
	    var v = geneplot.data[genes[i]];
	    for(var j=0; j<num; j++) {
	        tr.insertCell(-1).innerHTML = v[j+1];
	    }
	}
	return;
    }
}

/* gene plot functions finish here */




function print2console(what, msgtype, isnewline) {
    /* msgtype:
       0 normal
       1 done
       2 user did sth wrong
       3 program error, fatal
     */
    var newline = "<br>";
    if(msgtype==2 || msgtype==3)
        newline = "<br><br>";
    if(isnewline == undefined) {
        msgconsole.innerHTML+= newline + what;
    } else {
        msgconsole.innerHTML += (isnewline?newline:"") + what;
    }

    msgconsole.scrollTop = 9999; // dummy
    if(msgtype == 2) {
        msgconsole.style.backgroundColor = "#fcc";
	setTimeout("msgconsole.style.backgroundColor='#F5F4F3';", 400);
	setTimeout("msgconsole.style.backgroundColor='#fcc';", 800);
	setTimeout("msgconsole.style.backgroundColor='#F5F4F3';", 1200);
	document.getElementById('hook27').style.color = 'red';
	setTimeout("document.getElementById('hook27').style.color='black';", 400);
        return;
    }
    if(msgtype == 3) {
        msgconsole.style.backgroundColor = "#C41B1B";
	msgconsole.style.color = "white";
	setTimeout("msgconsole.style.backgroundColor='#F5F4F3';msgconsole.style.color='black';", 500);
	document.getElementById('hook27').style.color = 'red';
	setTimeout("document.getElementById('hook27').style.color='black';", 400);
        return;
    }
}
function msgconsoleMD(event) {
    event.preventDefault();
    msgconsole.x = event.clientX;
    msgconsole.y = event.clientY;
    document.body.addEventListener('mousemove', msgconsoleM, false);
    document.body.addEventListener('mouseup', msgconsoleMU, false);
}
function msgconsoleM(event) {
    var a = parseInt(msgconsole.style.width);
    if(event.clientX < msgconsole.x) {
        if(a + event.clientX - msgconsole.x < 244) {
	    msgconsole.style.width = 244;
	    return;
	}
    }
    msgconsole.style.width = a + event.clientX - msgconsole.x;
    msgconsole.x = event.clientX;
    a = parseInt(msgconsole.style.height);
    if(event.clientY < msgconsole.y) {
        if(a + event.clientY - msgconsole.y < 100) {
	    msgconsole.style.height = 100;
	    return;
	}
    }
    msgconsole.style.height = a + event.clientY - msgconsole.y;
    msgconsole.y = event.clientY;
}
function msgconsoleMU(event) {
    document.body.removeEventListener('mousemove', msgconsoleM, false);
    document.body.removeEventListener('mouseup', msgconsoleMU, false);
}
function fatalError(brick) {
    print2console(brick, 3);
    throw(brick);
}



/* GSS gene struct selection panel (short for gss) 
 */
function gss_us_MD(event) {
    // us: upstream slider
    event.preventDefault();
    gsselect.upslider.x = event.clientX;
    document.body.addEventListener("mousemove", gss_us_M, false);
    document.body.addEventListener("mouseup", gss_us_MU, false);
}
function gss_us_M(event) {
    var x = event.clientX;
    var oldx = gsselect.upslider.x;
    var l = parseInt(gsselect.upslider.style.left);
    if((x>oldx && l>=130) || (x<oldx && l<=0))
        return;
    gsselect.upslider.style.left = l + x-oldx;
    gsselect.uptrail.style.width = parseInt(gsselect.uptrail.style.width) - x+oldx;
    l = parseInt(gsselect.upslider.style.left);
    if(l > 130) {
	gsselect.upslider.style.left = 130;
	gsselect.uptrail.style.width = 0;
    } else if(l<0) {
	gsselect.upslider.style.left = 0;
	gsselect.uptrail.style.width = 130;
    }
    // set coord display
    l = parseInt(gsselect.upslider.style.left);
    document.getElementById("leftgliderlength").innerHTML = parseInt(5000/130 * (130-l));
    gsselect.upslider.x = event.clientX;
}
function gss_us_MU() {
    document.body.removeEventListener("mousemove", gss_us_M, false);
    document.body.removeEventListener("mouseup", gss_us_MU, false);
    gsr_change();
}
function gss_ds_MD(event) {
    // ds: downstream slider
    event.preventDefault();
    gsselect.downslider.x = event.clientX;
    document.body.addEventListener("mousemove", gss_ds_M, false);
    document.body.addEventListener("mouseup", gss_ds_MU, false);
}
function gss_ds_M(event) {
    var x = event.clientX;
    var oldx = gsselect.downslider.x;
    var l = parseInt(gsselect.downslider.style.left);
    if((x>oldx && l>=130) || (x<oldx && l<=0))
        return;
    gsselect.downslider.style.left = l + x-oldx;
    gsselect.downtrail.style.width = parseInt(gsselect.downtrail.style.width) + x-oldx;
    l = parseInt(gsselect.downslider.style.left);
    if(l > 130) {
	gsselect.downslider.style.left = 130;
	gsselect.downtrail.style.width = 130;
    } else if(l<0) {
	gsselect.downslider.style.left = 0;
	gsselect.downtrail.style.width = 0;
    }
    // set coord display
    l = parseInt(gsselect.downslider.style.left);
    document.getElementById("rightgliderlength").innerHTML = parseInt(5000/130 * l);
    gsselect.downslider.x = event.clientX;
}
function gss_ds_MU() {
    document.body.removeEventListener("mousemove", gss_ds_M, false);
    document.body.removeEventListener("mouseup", gss_ds_MU, false);
    gsr_change();
}
function gss_slider_uplength() {
    // upstream coordinate slider select length in base pair
    var len = 130 - parseInt(gsselect.upslider.style.left);
    if(len == 0) return 0;
    return parseInt((5000/130)*len);
}
function gss_slider_downlength() {
    // downstream coordinate slider select length in base pair
    var len = parseInt(gsselect.downslider.style.left);
    if(len == 0) return 0;
    return parseInt((5000/130)*len);
}
function gssp_close() {
    gsselect.main.style.display = 'none';
    document.body.removeEventListener('mousedown', gssp_close, false);
}
function custgs_invokegss(event) {
    // invoke gene struct selection panel for custom geneset input
    checkInputByvalue('gss_opt', document.getElementById('custgsi_gss_opt').innerHTML);
    checkInputByvalue('gss_origin', document.getElementById('custgsi_gss_origin').innerHTML);
    invokegssp(1, 
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop);
    document.body.addEventListener('mousedown', gssp_close, false);
}
function kegg_invokegss(event) {
    // invoke gene struct selection panel for kegg geneset input
    checkInputByvalue('gss_opt', document.getElementById('kegg_gss_opt').innerHTML);
    checkInputByvalue('gss_origin', document.getElementById('kegg_gss_origin').innerHTML);
    invokegssp(2, 
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop);
    document.body.addEventListener('mousedown', gssp_close, false);
}
function gsedit_invokegss(event) {
    // invoke gene struct selection panel for geneset edit
    checkInputByvalue('gss_opt', document.getElementById('gsedit_gss_opt').innerHTML);
    checkInputByvalue('gss_origin', document.getElementById('gsedit_gss_origin').innerHTML);
    invokegssp(3, 
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop);
    document.body.addEventListener('mousedown', gssp_close, false);
}
function bbg_invokegss(event) {
    // invoke gene struct selection panel for bigbed generator
    checkInputByvalue('gss_opt', document.getElementById('bbg_gss_opt').innerHTML);
    checkInputByvalue('gss_origin', document.getElementById('bbg_gss_origin').innerHTML);
    invokegssp(4, 
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop);
    document.body.addEventListener('mousedown', gssp_close, false);
}
function gpStandalone_invokegss(event) {
    // invoke gss panel for geneplot standalone
    checkInputByvalue('gss_opt', document.getElementById('gpStandalone_gss_opt').innerHTML);
    checkInputByvalue('gss_origin', document.getElementById('gpStandalone_gss_origin').innerHTML);
    invokegssp(5,
        event.clientX+20+document.body.scrollLeft,
        event.clientY-40+document.body.scrollTop);
    document.body.addEventListener('mousedown', gssp_close, false);
}
function invokegssp(which,x,y) {
    // actually invoke gene struct selection panel
    gsselect.which = which;
    gsselect.main.style.display = 'block';
    gsselect.main.style.left = x;
    gsselect.main.style.top = y;
}
function gsr_change() {
    // called by selecting genestruct radio button or sliding the slider
    var v = getValue_by_radioName("gss_opt");
    var says;
    var uplen = gss_slider_uplength();
    var downlen = gss_slider_downlength();
    if(v == 'custom') {
        gsselect.sliderpanel.style.display = 'block';
	says = uplen+' bp upstream and '+downlen+' bp downstream surrounding '+getAlt_by_radioName('gss_origin');
	    
    } else {
        gsselect.sliderpanel.style.display = 'none';
        says = getAlt_by_radioName('gss_opt');
    }
    switch(gsselect.which) {
    case 1: // custom geneset input
        document.getElementById('custgsi_gss_says').innerHTML = says;
        document.getElementById('custgsi_gss_opt').innerHTML = v;
        document.getElementById('custgsi_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
        document.getElementById('custgsi_gss_up').innerHTML = uplen;
        document.getElementById('custgsi_gss_down').innerHTML = downlen;
	break;
    case 2: // kegg geneset input
        document.getElementById('kegg_gss_says').innerHTML = says;
        document.getElementById('kegg_gss_opt').innerHTML = v;
        document.getElementById('kegg_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
        document.getElementById('kegg_gss_up').innerHTML = uplen;
        document.getElementById('kegg_gss_down').innerHTML = downlen;
	break;
    case 3: // geneset edit
        document.getElementById('gsedit_gss_says').innerHTML = says;
        document.getElementById('gsedit_gss_opt').innerHTML = v;
        document.getElementById('gsedit_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
        document.getElementById('gsedit_gss_up').innerHTML = uplen;
        document.getElementById('gsedit_gss_down').innerHTML = downlen;
	break;
    case 4: // bigbed generator
        document.getElementById('bbg_gss_says').innerHTML = says;
        document.getElementById('bbg_gss_opt').innerHTML = v;
        document.getElementById('bbg_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
        document.getElementById('bbg_gss_up').innerHTML = uplen;
        document.getElementById('bbg_gss_down').innerHTML = downlen;
	break;
    case 5: // standalone gene plot
        document.getElementById('gpStandalone_gss_says').innerHTML = says;
        document.getElementById('gpStandalone_gss_opt').innerHTML = v;
        document.getElementById('gpStandalone_gss_origin').innerHTML = getValue_by_radioName('gss_origin');
        document.getElementById('gpStandalone_gss_up').innerHTML = uplen;
        document.getElementById('gpStandalone_gss_down').innerHTML = downlen;
	break;
    default: fatalError('gsr_change: unknown gsselect.which: '+gsselect.which);
    }
}
function ensureNonezerolengthregion(which) {
    /* if using custom region and spanning length is zero, return true
       'which' is same as gsselect.which
     */
    switch(which) {
    case 1:
	if(document.getElementById('custgsi_gss_opt').innerHTML != "custom")
	    return false;
	if(parseInt(document.getElementById('custgsi_gss_up').innerHTML)+parseInt(document.getElementById('custgsi_gss_down').innerHTML) == 0)
	    return true;
	return false;
    case 2:
	if(document.getElementById('kegg_gss_opt').innerHTML != "custom")
	    return false;
	if(parseInt(document.getElementById('kegg_gss_up').innerHTML)+parseInt(document.getElementById('kegg_gss_down').innerHTML) == 0)
	    return true;
	return false;
    case 3:
	if(document.getElementById('gsedit_gss_opt').innerHTML != "custom")
	    return false;
	if(parseInt(document.getElementById('gsedit_gss_up').innerHTML)+parseInt(document.getElementById('gsedit_gss_down').innerHTML) == 0)
	    return true;
	return false;
    case 4:
	if(document.getElementById('bbg_gss_opt').innerHTML != "custom")
	    return false;
	if(parseInt(document.getElementById('bbg_gss_up').innerHTML)+parseInt(document.getElementById('bbg_gss_down').innerHTML) == 0)
	    return true;
	return false;
    default:
        fatalError('ensureNonezerolengthregion: unknown which');
    }
}
function gss_param(which) {
    /* provide gene struct selector parameter for ajax call
       argument is same as gsselect.which
     */
    var p_opt,p_origin,p_up,p_down;
    switch(which) {
    case 1:
        p_opt = 'custgsi_gss_opt';
	p_origin = 'custgsi_gss_origin';
	p_up = 'custgsi_gss_up';
	p_down = 'custgsi_gss_down';
	break;
    case 2:
        p_opt = 'kegg_gss_opt';
	p_origin = 'kegg_gss_origin';
	p_up = 'kegg_gss_up';
	p_down = 'kegg_gss_down';
	break;
    case 3:
        p_opt = 'gsedit_gss_opt';
	p_origin = 'gsedit_gss_origin';
	p_up = 'gsedit_gss_up';
	p_down = 'gsedit_gss_down';
	break;
    case 4:
        p_opt = 'bbg_gss_opt';
	p_origin = 'bbg_gss_origin';
	p_up = 'bbg_gss_up';
	p_down = 'bbg_gss_down';
	break;
    case 5:
        p_opt = 'gpStandalone_gss_opt';
	p_origin = 'gpStandalone_gss_origin';
	p_up = 'gpStandalone_gss_up';
	p_down = 'gpStandalone_gss_down';
	break;
    default:
        fatalError('gss_param: unknown argument value');
    }
    return "&gss_opt="+document.getElementById(p_opt).innerHTML+
	    "&gss_origin="+document.getElementById(p_origin).innerHTML+
	    "&gss_up="+document.getElementById(p_up).innerHTML+
	    "&gss_down="+document.getElementById(p_down).innerHTML;
}


/* sticky note */
var stickynote = {'number':0};
function makestickynote() {
    // return DOM object of the note for further handling
    var note = document.createElement("div");
    document.body.appendChild(note);
    var ta = document.createElement("textarea");
    ta.readOnly = true;
    ta.cols = 15;
    ta.rows = 3;
    note.appendChild(ta);
    note.className = "stickynote";
    note.style.left = Math.random()*800;
    note.style.top = Math.random()*600;
    stickynote.number++;
    note.id = stickynote.number+"stickynote";
    note.addEventListener("mousedown", stickynoteMD, false);
    note.addEventListener("mouseover", stickynoteMOV, false);
    note.addEventListener("mouseout", stickynoteMOT, false);
    // edit and delete buttons
    var but = document.createElement("div");
    note.appendChild(but);
    but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_edit(event)>&#9998;</span> <span style='cursor:pointer;' onclick=stickynote_remove(event)>&#10006;</span>";
    // "done with edit" button
    but = document.createElement("div");
    note.appendChild(but);
    but.innerHTML = "<span style='cursor:pointer;' onclick=stickynote_doneedit(event)>&#10004;</span>";
    return note;
}
function stickynote_remove(event) {
    // delete a note
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    document.body.removeChild(note);
}
function stickynote_edit(event) {
    // open textarea and edit, hide pencil button and disable moving
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    note.childNodes[1].style.display = "none"; // hide pencil buttons
    note.childNodes[2].style.display = "block"; // show "done edit" button
    var ta = note.firstChild;
    ta.readOnly = false;
    ta.style.backgroundColor = "#F0E8B7";
    ta.focus();
    note.removeEventListener("mousedown", stickynoteMD, false);
    note.removeEventListener("mouseover", stickynoteMOV, false);
    note.removeEventListener("mouseout", stickynoteMOT, false);
}
function stickynote_doneedit(event) {
    // done with textarea editing
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    var ta = note.firstChild;
    ta.readOnly = true;
    ta.style.backgroundColor = "transparent";
    note.childNodes[1].style.display = "block"; // show pencil buttons
    note.childNodes[2].style.display = "none"; // hide "done edit" button
    note.addEventListener("mousedown", stickynoteMD, false);
    note.addEventListener("mouseover", stickynoteMOV, false);
    note.addEventListener("mouseout", stickynoteMOT, false);
}
function stickynoteMOV(event) {
    // on mouse over
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    note.childNodes[1].style.display = "block";
}
function stickynoteMOT(event) {
    // on mouse out
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    note.childNodes[1].style.display = "none";
}
function stickynoteMD(event) {
    //event.preventDefault();
    var note = event.target;
    while(note.className != "stickynote")
        note = note.parentNode;
    stickynote.onfocus = note;
    note.addEventListener("mousemove", stickynoteM, false);
    note.addEventListener("mouseup", stickynoteMU, false);
    note.oldX = event.clientX;
    note.oldY = event.clientY;
}
function stickynoteM(event) {
    var n = stickynote.onfocus;
    n.style.left = parseInt(n.style.left) + event.clientX - n.oldX;
    n.style.top = parseInt(n.style.top) + event.clientY - n.oldY;
    n.oldX = event.clientX;
    n.oldY = event.clientY;
}
function stickynoteMU(event) {
    stickynote.onfocus.removeEventListener("mousemove", stickynoteM, false);
    stickynote.onfocus.removeEventListener("mouseup", stickynoteMU, false);
}




/****** SCFD scaffold functions
   different scaffold holders are represented by numbers
   1: the one in control panel controlling heatmap
   2: genome bev
   the numbers would be passed to functions to indicate which holder is been used
 */
function json_scaffoldRuntimeInfo(data) {
    /* all information regarding scaffold has to be ready before calling this
       should be called when restoring status or change genome
     */
    if(!('chrInfo' in data)) fatalError("json_scaffoldRuntimeInfo: chrInfo missing");
    if(!('scaffoldOrder' in data)) fatalError("json_scaffoldRuntimeInfo: chrInfo missing");
    scaffold.seq2tr = {};
    scaffold.toadd = {};
    chrLen = data['chrInfo'];
    scaffold.cptableorder = data.scaffoldOrder;
    scaffold_cptable_fill(1);
}
function scaffold_cptable_fill(holderid) {
    /* insert displayed scaffold into cpholder
       for initiation or restore (clicking cancel button)
     */
    var cpholder;
    var seq2tr;
    var orderlst;
    if(holderid == 1) {
        cpholder = scaffold.cpholder;
	seq2tr = scaffold.seq2tr;
	orderlst = scaffold.cptableorder;
    } else {
        cpholder = bev.scfd.holder;
	seq2tr = bev.scfd.seq2tr;
	orderlst = bev.scfd.order;
    }
    stripChild(cpholder.firstChild, 0);
    seq2tr = {}; // will be refreshed
    for(var i=0; i<orderlst.length; i++) {
        scaffold_cptable_insert(orderlst[i], 'white', holderid);
    }
    var p = cpholder.parentNode;
    if(orderlst.length > 10) {
        p.style.height = 260;
        p.style.overflowY = 'scroll';
    } else {
        p.style.overflowY = 'auto';
	p.style.height = 'auto';
    }
    // hide or disable following things
    if(holderid == 1) {
	scaffold.updatebutt.style.display = 'none';
	document.getElementById('scaffold_cancelbutt').style.display = 'none';
	document.getElementById('scaffold_moveRelocate').style.display = 'none';
    } else {
	bev.scfd.updatebutt.style.display = 'none';
	document.getElementById('genomebevscfd_cancelbutt').style.display = 'none';
    }
}
function scaffold_cptable_insert(which, trbgcolor, holderid) {
    /* insert one sequence into scaffold cptable
       argument:
           which: seq name
	   trbgcolor: background color of <tr>
	   holderid: which holder to insert to
     */
    var tr = holderid==1 ? scaffold.cpholder.insertRow(-1) : bev.scfd.holder.insertRow(-1);
    tr.marked = false; // for removal
    tr.marked2 = false; // for reordering
    tr.style.backgroundColor = trbgcolor;
    tr.seq = which;
    tr.insertCell(0).innerHTML = '<button class=s onclick=toggle31(event)>&#10005;</button>';
    var td = tr.insertCell(-1);
    td.addEventListener('click', scfcptable_td_click, false);
    td.style.cursor='pointer'; td.innerHTML = which;
    td = tr.insertCell(-1);
    td.addEventListener('click', scfcptable_td_click, false);
    td.style.color='#858585'; td.style.cursor='pointer'; td.innerHTML = scaffold.c2p[which];
    td = tr.insertCell(-1);
    td.addEventListener('click', scfcptable_td_click, false);
    td.style.color='#858585'; td.style.cursor='pointer'; td.innerHTML = scaffold.len[which];
    if(holderid == 1)
        scaffold.seq2tr[which] = tr;
    else
        bev.scfd.seq2tr[which] = tr;
}
function scfcptable_td_click(event) {
    /* called by clicking on one <td> in scaffold cptable
       could be any <td> except first one
       will mark the row for reordering
       need to tell which holder is been used
     */
    var tr = event.target.parentNode;
    var holderid = parseInt(tr.parentNode.parentNode.getAttribute('holderid'));
    if(holderid!=1 && holderid!=2)
        fatalError('scfcptable_td_click: unknown holderid');
    if(tr.marked2) {
        // already been clicked, cancel it
	tr.marked2 = false;
        tr.style.fontWeight = 'normal';
	// hide it but don't call _close() function
	vrearrangeUtil.holder.style.display = 'none';
	if(holderid == 1) {
	    document.getElementById('scaffold_moveRelocate').style.display = 'none';
	}
	return;
    }
    var lst = holderid==1 ? scaffold.cpholder.firstChild.childNodes : bev.scfd.holder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        lst[i].style.fontWeight = 'normal';
	lst[i].marked2 = false;
    }
    tr.marked2 = true;
    tr.style.fontWeight = 'bold';
    var pos = absolutePosition(tr);
    var x = pos[0]+200;
    var y = pos[1]+25 - (holderid==1 ? scaffold.cpholder.parentNode.scrollTop : bev.scfd.holder.parentNode.scrollTop);
    if(holderid == 1) {
	vrearrange_invoke(3, x, y);
	document.getElementById('scaffold_moveRelocate').style.display = 'inline';
    } else {
	vrearrange_invoke(4, x, y);
    }
    vrearrangeUtil.scfdtd = tr.childNodes[1]; // creepy shortcut
}
function scaffold_relocate() {
    /* called by clicking relocate button
       after selecting a sequence for move, this button appears, click to jump to that sequence
     */
    var lst = scaffold.cpholder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(lst[i].marked2) {
	    cgiJumpchr(lst[i].seq);
	    return;
	}
    }
}
function scaffold_cptable_update() {
    /* called by pushing Update button
       in control panel holder, not the other one
       first see whether any scaffold in current dsp has been removed
       to tell this, make a list of scaffold still been used,
       go over seqs in regionLst between dspBoundary.vstartr and vstopr,
       if any seq/region is preserved, jump to them,
       else figure out a new region for dsp
       ** need to update border both js and c **
     */
    var lst = scaffold.cpholder.firstChild.childNodes;
    var newlst = [];
    for(var i=0; i<lst.length; i++) {
        if(!lst[i].marked)
	    newlst.push(lst[i].seq);
    }
    if(newlst.length == 0) {
        print2console("No scaffold sequence left for display", 2);
	scaffold.updatebutt.style.display = 'none';
        document.getElementById('scaffold_cancelbutt').style.display = 'none';
	return;
    }

    if(stringLstIsIdentical(scaffold.cptableorder, newlst)) {
        // nothing changed, but still do a re-fill
	scaffold_cptable_fill(1);
        return;
    }

    // now determine dsp
    var dspParam = '';
    if(dspBoundary.vstartr==dspBoundary.vstopr && thinginlist(regionLst[dspBoundary.vstartr][0], newlst)) {
        // very well, currently only showing single region and that region is still in use
	dspParam = '&'+displayedRegionParam();
    } else {
	var preservedRegions = [];
	var oldlookregion = [];
	for(i=dspBoundary.vstartr; i<=dspBoundary.vstopr; i++)
	    oldlookregion.push(regionLst[i][0]);
	for(i=0; i<newlst.length; i++) {
	    if(thinginlist(newlst[i], oldlookregion))
		preservedRegions.push(newlst[i]);
	}
	var dspSeq = null;
	if(preservedRegions.length > 0) {
	    dspSeq = preservedRegions[0];
	} else {
	    dspSeq = newlst[0];
	}
        // just use first sequence but need to make sure not to display too long region
        var totalLength = 0;
	for(i=0; i<newlst.length; i++)
	    totalLength += scaffold.len[newlst[i]];
	var allowed = parseInt(totalLength/3);
	if(allowed <= 80) {
	    print2console("Sorry cannot carry out this operation, please try again by including more scaffold sequences", 2);
	    return;
	}
	allowed = allowed>scaffold.len[dspSeq] ? scaffold.len[dspSeq] : allowed;
	dspParam = '&gftype=genome&startChr='+dspSeq+'&startCoord=0&stopChr='+dspSeq+'&stopCoord='+(allowed>10000?10000:allowed);
    }
    // make some new param strings
    var tmp = [];
    for(i=0; i<newlst.length; i++) { tmp.push(newlst[i]); tmp.push(scaffold.len[newlst[i]]); }
    ajaxX('scaffoldUpdate=on&scaffoldNames='+tmp.join(',')+',&scaffoldCount='+newlst.length+hmtkChoice()+decorParams()+htestParams()+corrParam()+dspParam);
    // update cpholder contents by fake a json object and feed to the function
    var obj = {chrInfo:{}, scaffoldOrder:[]};
    for(i=0; i<newlst.length; i++) {
        obj.chrInfo[newlst[i]] = scaffold.len[newlst[i]];
	obj.scaffoldOrder.push(newlst[i]);
    }
    json_scaffoldRuntimeInfo(obj);
}
function genomebevscfd_update() {
    /* called by pushing button for genome bev scaffold holder
     */
    var newlst = [];
    var lst = bev.scfd.holder.firstChild.childNodes;
    for(var i=0; i<lst.length; i++) {
        if(!lst[i].marked)
	    newlst.push(lst[i].seq);
    }
    if(stringLstIsIdentical(newlst, bev.scfd.order)) {
        // refill it
	scaffold_cptable_fill(2);
        return;
    }
    bev.scfd.order = newlst;
    bev.scfd.hash = {};
    for(i=0; i<newlst.length; i++)
        bev.scfd.hash[newlst[i]] = scaffold.len[newlst[i]];
    bev.scfd.toadd = {};
    scaffold_cptable_fill(2);

    // have to detach all vector canvas from old <td> holder so that they could be inserted to new holder
    //for(var cn in bev.genomeCanvasTd)
    //    stripChild(bev.genomeCanvasTd[cn], 0);
    for(var vn in bev.data)
        bev_initiateVectorcanvas(vn);

    bev.scfd.seq2tr = {};
    genomebev_initiateViewtable();
}
function scfspanel_fillup() {
    // initiate scaffold selection tree
    var holder = document.getElementById('scfspanel_holder');
    stripChild(holder, 0);
    for(var term in scaffold.p2c.ROOT) {
        // iterate over all root level terms
        scfspanel_fillup_recursive(term, holder);
    }
}
function scfspanel_fillup_recursive(term, holder) {
    // iterate over a term, make its subtree
    var li = document.createElement('li');
    holder.appendChild(li);
    if(term in scaffold.len) {
        // this is a real sequence
	li.className = 'tkentry';
	li.setAttribute('name', 'scfseq');
	li.seq = term;
        li.innerHTML = term;
	li.addEventListener('click', scfseq_click, false);
    } else {
        li.innerHTML = '<span class=clb onclick=scfshowhide(event) term='+term+'>&#8862; '+term+'</span>';
        var ul = document.createElement('ul');
	ul.style.display = 'none';
	holder.appendChild(ul);
	for(var cld in scaffold.p2c[term])
	    scfspanel_fillup_recursive(cld, ul);
    }
}
function scfshowhide(event) {
    var li = event.target.parentNode;
    var term = event.target.getAttribute('term');
    if(li.nextSibling.style.display == 'none') {
        li.nextSibling.style.display = 'block';
	event.target.innerHTML = '&#8863; '+term;
    } else {
        li.nextSibling.style.display = 'none';
	event.target.innerHTML = '&#8862; '+term;
    }
}
function cpholder_invokescfsp(event) {
    //document.getElementById('scfspinvokebutt1').innerHTML = 'loading...';
    scfspanel_invoke(1, event.clientX+20+document.body.scrollLeft, event.clientY-40+document.body.scrollTop);
    //document.getElementById('scfspinvokebutt1').innerHTML = 'Add more &#187;';
}
function relocate_invokescfsp(event) {
    scfspanel_invoke(2, event.clientX+20+document.body.scrollLeft, event.clientY-40+document.body.scrollTop);
}
function bevholder_invokescfsp(event) {
    scfspanel_invoke(3, event.clientX+20+document.body.scrollLeft, event.clientY-40+document.body.scrollTop);
}
function scfspanel_invoke(which,x,y) {
    scfspanel_bleach();
    scaffold.which = which;
    scaffold.spanel.style.display = 'block';
    scaffold.spanel.style.left = x;
    scaffold.spanel.style.top = y;
    document.body.addEventListener('mousedown', dbody_scfspanel_close, false);
    scfspanel_paint();
}
function dbody_scfspanel_close() {
    scfspanel_close();
    document.body.removeEventListener('mousedown', dbody_scfspanel_close, false);
}
function scfspanel_close() {
    scaffold.spanel.style.display = 'none';
}
function scfspanel_bleach() {
    // in addition to bleaching, also enable them
    var lst = document.getElementsByName('scfseq');
    for(var i=0; i<lst.length; i++) {
        lst[i].style.backgroundColor = 'transparent';
	lst[i].className = 'tkentry';
    }
}
function scfspanel_paint() {
    var lst = document.getElementsByName('scfseq');
    switch(scaffold.which) {
    case 1:
        var inuse = {};
	var lst2 = scaffold.cpholder.firstChild.childNodes;
	for(var i=0; i<lst2.length; i++)
	    inuse[lst2[i].seq] = 1;
	for(i=0; i<lst.length; i++) {
	    if(lst[i].seq in inuse)
	        lst[i].style.backgroundColor = '#ccf';
	}
	return;
    case 2:
        // only enable those in chrLen, disable everybody else
	for(var i=0; i<lst.length; i++)
	    lst[i].className = (lst[i].seq in chrLen) ? 'tkentry' : 'tkentry_inactive';
        return;
    case 3:
        var inuse = {};
	var lst2 = bev.scfd.holder.firstChild.childNodes;
	for(var i=0; i<lst2.length; i++)
	    inuse[lst2[i].seq] = 1;
	for(i=0; i<lst.length; i++) {
	    if(lst[i].seq in inuse)
	        lst[i].style.backgroundColor = '#ccf';
	}
        return;
    default:
        fatalError('scfspanel_paint: unknown scaffold.which');
    }
}
function scfseq_click(event) {
    /* called by clicking on a seq entry in scaffold.spanel
     */
    if(event.target.className == 'tkentry_inactive')
        return;
    var add = false;
    if(event.target.style.backgroundColor == 'transparent') {
        event.target.style.backgroundColor = '#CCCCFF';
	add = true;
    } else {
        event.target.style.backgroundColor = 'transparent';
    }
    var seq = event.target.seq;
    switch(scaffold.which) {
    case 1: // control panel holder
        if(add) {
	    if(!(seq in scaffold.seq2tr)) {
		scaffold_cptable_insert(seq, '#cfc', 1);
		scaffold.updatebutt.style.display = 'inline';
		scaffold.updatebutt.style.backgroundColor = '#cfc';
                document.getElementById('scaffold_cancelbutt').style.display = 'inline';
		scaffold.toadd[seq] = 1;
	    }
	} else {
	    if(seq in scaffold.toadd) {
	        /* this is a to-be-add item, remove it */
		scaffold.cpholder.firstChild.removeChild(scaffold.seq2tr[seq]);
		delete scaffold.seq2tr[seq];
		delete scaffold.toadd[seq];
	    } else {
	        // this seq is already there, only mark it if is hasn't been marked
		var tr = scaffold.seq2tr[seq];
		if(!tr.marked) {
		    var e = document.createEvent("MouseEvents");
		    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
		    tr.firstChild.firstChild.dispatchEvent(e);
		}
	    }
	}
        return;
    case 2:
        // relocate to show entire seq
	cgiJumpchr(seq);
	scfspanel_close();
        return;
    case 3:
        if(add) {
	    if(!(seq in bev.scfd.seq2tr)) {
		scaffold_cptable_insert(seq, '#cfc', 2);
		bev.scfd.updatebutt.style.display = 'inline';
		bev.scfd.updatebutt.style.backgroundColor = '#cfc';
                document.getElementById('genomebevscfd_cancelbutt').style.display = 'inline';
		bev.scfd.toadd[seq] = 1;
	    }
	} else {
	    if(seq in bev.scfd.toadd) {
	        /* this is a to-be-add item, remove it */
		bev.scfd.holder.firstChild.removeChild(bev.scfd.seq2tr[seq]);
		delete bev.scfd.seq2tr[seq];
		delete bev.scfd.toadd[seq];
	    } else {
	        // this seq is already there, only mark it if is hasn't been marked
		var tr = bev.scfd.seq2tr[seq];
		if(!tr.marked) {
		    var e = document.createEvent("MouseEvents");
		    e.initMouseEvent("click", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
		    tr.firstChild.firstChild.dispatchEvent(e);
		}
	    }
	}
	return;
    default:
        fatalError('scfseq_click: unknown scaffold.which');
    }
}



function cpmoveMD(event) {
    var tab = event.target;
    if(tab.getAttribute('active') == null)
        tab = tab.parentNode;
    if(tab.getAttribute('active') != '1')
        return;
    event.preventDefault();
    gflag.cpmove.dom = document.getElementById(tab.getAttribute('holderid'));
    gflag.cpmove.oldx = event.clientX;
    gflag.cpmove.oldy = event.clientY;
    document.body.addEventListener('mousemove', cpmoveM, false);
    document.body.addEventListener('mouseup', cpmoveMU, false);
}
function cpmoveM(event) {
    var d = gflag.cpmove.dom;
    d.style.left = parseInt(d.style.left) + event.clientX - gflag.cpmove.oldx;
    d.style.top = parseInt(d.style.top) + event.clientY - gflag.cpmove.oldy;
    gflag.cpmove.oldx = event.clientX;
    gflag.cpmove.oldy = event.clientY;
}
function cpmoveMU(event) {
    gflag.cpmove.dom = null;
    document.body.removeEventListener('mousemove', cpmoveM, false);
    document.body.removeEventListener('mouseup', cpmoveMU, false);
}


/** data HUB **/
function loaddatahub() {
    /* also handles the case of loading hub from url parameter
     */
    var url = document.getElementById('datahuburl').value;
    if(url.length==0 || url=='Enter URL of hub descriptor file') {
        print2console('URL to hub descriptor file required', 2);
	return;
    }
    cloak(viewbox);
    document.body.style.cursor = 'wait';
    print2console('loading data hub...', 0);
    document.getElementById('loadhubbutt').disabled = true;
    ajax(displayedRegionParamPrecise()+'&loaddatahub=on&url='+url, function(data){
        if(!('hubdata' in data)) fatalError('loaddatahub: data missing');

	if(data.hubdata.length == 0) {
	    print2console('data hub has no content', 2);
	    document.getElementById('loadhubbutt').disabled = false;
	    return;
	}
	// load metadata first
	var hascustmd = false;
	var newterms = {};
	for(var i=0; i<data.hubdata.length; i++) {
	    var item = data.hubdata[i];
	    if(item[0] == -1) {
		custmdhash[item[1]] = item[2].split(',');
	        displayCustmdattr(item[1]);
		newterms[item[1]] = 1;
		hascustmd = true;
	    }
	}
	if(hascustmd) {
	    mdselect.which = 1;
	    custmd_checkbox_togglevisibility();
	    // have new terms on display in mcm
	    var lst = document.getElementsByName('mdcheckbox');
	    for(i=0; i<lst.length; i++) {
	        if(lst[i].getAttribute('custom') == '1') {
		    if(lst[i].getAttribute('termidx') in newterms) {
			lst[i].checked = true;
			var e = document.createEvent("MouseEvents");
			e.initMouseEvent("change", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
			lst[i].dispatchEvent(e);
		    }
		}
	    }
	}

	// load tracks
	var hashmtk = false;
	for(i=0; i<data.hubdata.length; i++) {
	    var thisitem = data.hubdata[i];
	    if(thisitem[0] == 3) { // bigwig
		gflag.customtmp.name = thisitem[1];
		gflag.customtmp.label = thisitem[2];
		gflag.customtmp.url = thisitem[3];
		gflag.customtmp.mode = thisitem[4];
		// set custom md anno
		gflag.customtmp.custmd = {};
		if(thisitem[6] != undefined) {
		    var lst = thisitem[6].split(',');
		    for(var j=0; j<lst.length; j++) {
		        var lst2 = lst[j].split(':');
			gflag.customtmp.custmd[lst2[0]] = lst2[1];
		    }
		}
		jsonAddOneCustombigwig(thisitem[5]);
		hashmtk = true;
	    } else if(thisitem[0] == 1) { // bigbed
		gflag.customtmp.name = thisitem[1];
		gflag.customtmp.label = thisitem[2];
		gflag.customtmp.url = thisitem[3];
		gflag.customtmp.mode = thisitem[4];
		// set custom md anno
		gflag.customtmp.custmd = {};
		if(thisitem[6] != undefined) {
		    var lst = thisitem[6].split(',');
		    for(var j=0; j<lst.length; j++) {
		        var lst2 = lst[j].split(':');
			gflag.customtmp.custmd[lst2[0]] = lst2[1];
		    }
		}
		jsonAddOneCustombigbed(thisitem[5]);
	    } else if(thisitem[0] == 5) { // bam
		gflag.customtmp.name = thisitem[1];
		gflag.customtmp.label = thisitem[2];
		gflag.customtmp.url = thisitem[3];
		gflag.customtmp.mode = thisitem[4];
		// set custom md anno
		gflag.customtmp.custmd = {};
		if(thisitem[6] != undefined) {
		    var lst = thisitem[6].split(',');
		    for(var j=0; j<lst.length; j++) {
		        var lst2 = lst[j].split(':');
			gflag.customtmp.custmd[lst2[0]] = lst2[1];
		    }
		}
		jsonAddOneCustombam(thisitem[5]);
	    }
	}

	if(hashmtk) {
	    makeTrackAttrAll();
	    mcmSortTrack(sortTrackIdx);
	    drawTrackAttrCanvas();
	    stuffTrackCanvas2holder();
	}
	custmd_makegrid();
	print2console('done', 1);
	document.body.style.cursor = 'auto';
        document.getElementById('loadhubbutt').disabled = false;

	// might need to process additional url parameters
	if(gflag.urlparam.willcontinue) {
	    urlparam_handleTriggers();
	}
    });
}






function oneshot(event) {
    // called by clicking on logo of a genome, will load up the browser to display default data over that genome
    var target = event.target.title;
    document.body.removeChild(document.getElementById('oneshot'));
    document.getElementById('pagecloak').style.display = 'none';
    readygo(target, true);
}
function oneshotDialog(which,msg) {
    /* this is One Shot, 
       fires up the oneshot dialog when the browser needs user to make some choice to start properly
       args:
       which - 1: show list of genome
               2: show saved status under a session
       msg: an additional message to be printed on oneshot panel, warning or further instruction
     */
    cloakPage();
    var d = document.getElementById('oneshot');
    d.style.display = 'block';
    d.style.left = 200;
    d.style.top = 100;
    var d2 = document.getElementById('oneshotmsg');
    if(msg == null) {
        d2.style.display = 'none';
    } else {
        d2.style.display = 'block';
	d2.innerHTML = msg;
    }
    var header = document.getElementById('oneshotheader');
    switch(which) {
    case 1: // select a genome
        header.innerHTML = 'To start, select a genome';
	ajax2('oneshot=on', function(data){
	    var holder = document.getElementById('oneshotbelly');
	    stripChild(holder, 0);
	    var lst = data.split(',');
	    for(var i=0; i<lst.length-1; i+=3) {
		var d = document.createElement('div');
		d.className = 'oneshot';
		var d2 = document.createElement('div');
		d2.style.width=257;d2.style.height=39;
		d2.style.backgroundImage = "url('images/"+lst[i+2]+".png')";
		d2.style.position = 'absolute';d2.style.left=0;d2.style.top=0;
		d2.title=lst[i];
		d.appendChild(d2);
		var d3 = document.createElement('div');
		d3.style.position='absolute';d3.style.left=0;d3.style.bottom=0;
		d3.style.backgroundColor='white';d3.style.color='black';d3.style.fontSize='10px';
		d3.style.border='solid 1px #858585';
		d3.style.borderRightWidth=0;d3.style.borderTopWidth=0;
		d3.style.paddingLeft=5;d3.style.paddingRight=5;
		d3.innerHTML = lst[i+1];
		d3.title=lst[i];
		d.appendChild(d3);
		d.addEventListener('click', oneshot, false);
		holder.insertRow(-1).insertCell(0).appendChild(d);
	    }
	    var d = document.getElementById('oneshot');
	    d.style.left = (document.body.clientWidth-d.clientWidth)/2;
	    d.style.top = (document.body.clientHeight-d.clientHeight)/2;
	});
	return;
    case 2: // list status under a session
        header.innerHTML = 'Click on name to restore past browsing status';
	var d = document.getElementById('oneshot');
	d.style.left = (document.body.clientWidth-d.clientWidth)/2;
	d.style.top = (document.body.clientHeight-d.clientHeight)/2;
        return;
    default: fatalError('oneshotDialog: unknown which');
    }
}

function urlparam_handleTriggers() {
    /* triggers about adding tracks
       but won't call readygo again
       so need to print errors to console

       when doing ajax calls to process triggers,
       must return and exit current function so to let ajax work
       need to delete trigger from urlparam.hash before or during the call
       because the ajax will call this function again to process remaining trigger,
       sort of lazy and recursive
     */
    if('datahub' in gflag.urlparam.hash) {
	if(gflag.urlparam.hash.datahub.length == 0) {
	    print2console('URL parameter error: "datahub" parameter got 0 length value', 2);
	} else {
	    // try to load up the hub
	    document.getElementById('datahuburl').value = gflag.urlparam.hash.datahub;
	    delete gflag.urlparam.hash.datahub;
	    loaddatahub();
	    return;
	}
    }



    /* adding tracks by file type */
    if('hmtk' in gflag.urlparam.hash) { // server bigwig
	if(gflag.urlparam.hash.hmtk.length == 0) {
	    print2console('URL parameter error: "hmtk" parameter got 0 length value', 2);
	} else {
	    var lst = gflag.urlparam.hash.hmtk.split(',');
	    delete gflag.urlparam.hash.hmtk;
	    var lst2 = [];
	    for(var i=0; i<lst.length; i++) {
	        if(lst[i].length > 0) lst2.push(lst[i]);
	    }
	    if(lst2.length == 0) {
	        print2console('URL parameter error: invalid value for "hmtk" parameter', 2);
	    } else {
		ajaxAddnewserverbigwig(lst2);
		return;
	    }
	}
    }
    if('customhmtk' in gflag.urlparam.hash) { // custom bigwig
	if(gflag.urlparam.hash.customhmtk.length == 0) {
	    print2console('URL parameter error: "customhmtk" parameter got 0 length value', 2);
	} else {
	    // parse name/url pairs into hmtk.custom
	    var lst = gflag.urlparam.hash.customhmtk.split(',');
	    var sthwrong = false;
	    var param = [];
	    for(var i=0; i<lst.length; i+=2) {
	        if(lst[i].length==0 || lst[i+1]==undefined || lst[i+1].length==0) {sthwrong=true;break;}
		var n = newcustomtrackname();
		hmtk.custom[n] = {label:lst[i],url:lst[i+1],custmd:{},servermd:{}};
		param.push(n); param.push(lst[i]); param.push(lst[i+1]);
	    }
	    if(sthwrong) {
		delete gflag.urlparam.hash.customhmtk;
		print2console('URL parameter error: invalid "customhmtk" parameter value', 2);
	    } else {
	        cloak(viewbox);
		ajax(displayedRegionParamPrecise()+"&addmulticustombigwig=on&tklst="+param.join(','),function(data){
		    if(!('bwdata' in data)) fatalError('custtkselect_addall: bwdata missing');
		    for(var name in data.bwdata) {
			gflag.customtmp.name = name;
			gflag.customtmp.label = data.bwdata[name][0];
			gflag.customtmp.url = hmtk.custom[name].url;
			gflag.customtmp.mode = 'show';
			gflag.customtmp.servermd = hmtk.custom[name].servermd; // there won't be md anno
			gflag.customtmp.custmd = hmtk.custom[name].custmd;
			jsonAddOneCustombigwig(data.bwdata[name][1]);
			hmtk.custom[name].showbutt.innerHTML = 'hide';
		    }

		    makeTrackAttrAll();
		    mcmSortTrack(sortTrackIdx);
		    stuffTrackCanvas2holder();
		    drawTrackAttrCanvas();
		    delete gflag.urlparam.hash.customhmtk;
		    unveil(viewbox);
		    urlparam_handleTriggers();
		});
		return;
	    }
	}
    }

    /* following adds all decor tracks (0/1/8/4/5) in a single ajax call */
    var decor0lst = []; // server bigbed to be added
    var decor8lst = []; // server bigwig decor
    var decor1lst = []; // custom bigbed
    var decor4lst = []; // server bam
    var decor5lst = []; // custom bam
    if('gftk' in gflag.urlparam.hash) { // native genomic feature tracks, bigwig or bigbed
	if(gflag.urlparam.hash.gftk.length == 0) {
	    print2console('URL parameter error: "gftk" parameter got 0 length value', 2);
	} else {
	    var lst = gflag.urlparam.hash.gftk.split(',');
	    var sthwrong = false;
	    for(var i=0; i<lst.length; i+=2) {
	        if(lst[i].length>0 && lst[i+1]!=undefined && lst[i] in decorInfo && !(lst[i] in decorCanvasHash)) {
		    if(decorInfo[lst[i]].fileType == 0) {
		        if(lst[i+1]=='thin' || lst[i+1]=='full' || lst[i+1]=='density') {
			    decor0lst.push(lst[i]);
			    decor0lst.push(lst[i+1]);
			} else {sthwrong=true;}
		    } else if(decorInfo[lst[i]].fileType == 8) {
			decor8lst.push(lst[i]);
			decor8lst.push('show');
		    } else { fatalError('urlparam_handleTriggers: unknown file type for server decor '+lst[i]);}
		} else { sthwrong=true; }
	    }
	    if(sthwrong)
	        print2console('URL parameter error: invalid value for "gftk" parameter', 2);
	}
	delete gflag.urlparam.hash.gftk;
    }
    if(juxtaposition.type == 1) { // juxtaposing with server bigbed track, bring it up if it isn't there yet
	var dn = juxtaposition.what;
	if(!(dn in decorInfo)) fatalError('urlparam_handleTriggers: bigbed track for juxtaposition '+dn+' not found in decorInfo');
	if(!(dn in decorCanvasHash)) {
	    decor0lst.push(dn);
	    decor0lst.push('full');
	}
    }

    if('customgftk' in gflag.urlparam.hash) { // custom bigbed
	if(gflag.urlparam.hash.customgftk.length == 0) {
	    print2console('URL parameter error: "customgftk" parameter got 0 length value', 2);
	} else {
	    var lst = gflag.urlparam.hash.customgftk.split(',');
	    for(var i=0; i<lst.length; i+=3) {
	        if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
		    // name, url, mode
		    decor1lst.push(newcustomtrackname());
		    decor1lst.push(lst[i]); decor1lst.push(lst[i+1]);decor1lst.push(lst[i+2]);
		} else { sthwrong=true; }
	    }
	    if(sthwrong)
	        print2console('URL parameter error: invalid value for "customgftk" parameter', 2);
	}
	delete gflag.urlparam.hash.customgftk;
    }
    if(juxtaposition.type == 2) { // juxtaposing custom bigbed
	var url = juxtaposition.what;
	var notthere = true;
	for(var i=0; i<decor1lst.length; i+=4) {
	    if(url == decor1lst[i+2]) {notthere=false;break;}
	}
	if(notthere) {
	    // shrinked version of submitNewcustombigbed
	    decor1lst.push(newcustomtrackname());
	    decor1lst.push('Juxtaposition');
	    decor1lst.push(url); decor1lst.push('full');
	}
    }
    if('bam' in gflag.urlparam.hash) { // native bam files
	if(gflag.urlparam.hash.bam.length == 0) {
	    print2console('URL parameter error: "bam" parameter got 0 length value', 2);
	} else {
	    var lst = gflag.urlparam.hash.bam.split(',');
	    var sthwrong = false;
	    for(var i=0; i<lst.length; i+=2) {
	        if(lst[i].length>0 && lst[i+1]!=undefined && (lst[i+1]=='thin' || lst[i+1]=='full' || lst[i+1]=='density')) {
		    decor4lst.push(lst[i]);
		    decor4lst.push(lst[i+1]);
		} else {sthwrong=true;}
	    }
	    if(sthwrong)
	        print2console('URL parameter error: invalid value for "bam" parameter', 2);
	}
	delete gflag.urlparam.hash.bam;
    }
    if('custombam' in gflag.urlparam.hash) { // custom bam
	if(gflag.urlparam.hash.custombam.length == 0) {
	    print2console('URL parameter error: "custombam" parameter got 0 length value', 2);
	} else {
	    var lst = gflag.urlparam.hash.custombam.split(',');
	    for(var i=0; i<lst.length; i+=3) {
	        if(lst[i].length>0 && lst[i+1]!=undefined && lst[i+1].length>0 && lst[i+2]!=undefined && lst[i+2].length>0) {
		    // name, url, mode
		    decor5lst.push(newcustomtrackname());
		    decor5lst.push(lst[i]); decor5lst.push(lst[i+1]);decor5lst.push(lst[i+2]);
		} else { sthwrong=true; }
	    }
	    if(sthwrong)
	        print2console('URL parameter error: invalid value for "custombam" parameter', 2);
	}
	delete gflag.urlparam.hash.custombam;
    }
    // run ajax to retrieve decor tracks
    if(decor0lst.length+decor8lst.length+decor1lst.length+decor4lst.length+decor5lst.length > 0) {
        // first, register server decors, then they will be processed by jsonDecor without problem
	// but not including bam?
        for(var i=0; i<decor0lst.length; i+=2) {
	    decorInfo[decor0lst[i]].mode = decor0lst[i+1];
	    decoruserlist_insert(decor0lst[i]);
	}
        for(i=0; i<decor8lst.length; i+=2) {
	    decorInfo[decor8lst[i]].mode = 'show';
	    decoruserlist_insert(decor8lst[i]);
	}
	ajax(displayedRegionParamPrecise()+
	(decor0lst.length>0 ? '&decor0='+decor0lst.join(',') : '') + 
	(decor8lst.length>0 ? '&decor8='+decor8lst.join(',') : '') +
	(decor1lst.length>0 ? '&decor1='+decor1lst.join(',') : '') +
	(decor4lst.length>0 ? '&addserverbam='+decor4lst.join(',') : '')+
	(decor5lst.length>0 ? '&decor5='+decor5lst.join(',') : ''), function(data){
	    /* anything that cannot be processed by jsonDecor */
	    var nativedata = [];
	    if('decorData' in data) {
		for(var i=0; i<data.decorData.length; i++) {
		    var dt = data.decorData[i];
		    if(dt[1] == 1) { // custom bigbed
			gflag.customtmp.name = dt[0];
			gflag.customtmp.label = dt[2];
			gflag.customtmp.url = dt[3];
			gflag.customtmp.mode = dt[4];
			gflag.customtmp.custmd = {};
			// TODO properly handle # of skipped items
			jsonAddOneCustombigbed([dt[5],0]);
		    } else if(dt[1] == 5) { // custom bam
			gflag.customtmp.name = dt[0];
			gflag.customtmp.label = dt[2];
			gflag.customtmp.url = dt[3];
			gflag.customtmp.mode = dt[4];
			gflag.customtmp.custmd = {};
			jsonAddOneCustombam(dt[5]);
		    } else {
			nativedata.push(dt);
		    }
		}
	    }
	    if(nativedata.length > 0)
		jsonDecor(data);
	    // server bam (jsonDecor cannot handle that??)
	    if('serverbamdata' in data) {
	        for(var i=0; i<data.serverbamdata.length; i++) {
		    jsonAddoneserverbam(data.serverbamdata[i]);
		}
	    }
	    urlparam_handleTriggers(); // go on
	});
	return;
    }

    gflag.urlparam.willcontinue = false;
}




// READY
function readygo() {
    /* optional argument: 
       if supplied, 1st is db name, 2nd is boolean for whether to load default tracks
       else if no arguments supplied, will try to parse url parameter
       if no proper url parameter, will pop up oneshot dialog for choosing genome
     */

    // this seems to be the only thing might be needed during url parameter parsing
    msgconsole = document.getElementById("msgconsole");


    /* decide how to initiate page
	- upon first loading page, readygo() should have no arguments
	  will pop up a window and ask user which genome to load up
	  then the dbname will be passed as argument
	- as url argument browser/?name=val&name2=val2...

	Note: 
	to overcome the problem of colliding with old url parameter when switching genome during browsing,
	function parameter will override url parameter
     */
    if(arguments[0] == undefined) {
        // check if url has param
	if(window.location.href.indexOf('?') == '-1') {
	    // no url parameter, show dialog to prompt user to select db to use
	    oneshotDialog(1,null);
	    return;
	}
	// UP got parameter from url
	var hasnovalidparam = true;
	var lst = window.location.href.split('?')[1].split('&');
	var pmhash = {};
	for(var i=0; i<lst.length; i++) {
	    var t = lst[i].split('=');
	    if(t.length == 2) {
		pmhash[t[0].toLowerCase()] = t[1];
		hasnovalidparam = false;
	    }
	}
	if(hasnovalidparam) {
	    oneshotDialog(1,'Garbled URL parameter:<br>unrecognizable contents after ? in URL');
	    return;
	}
	if(!('genome' in pmhash)) {
	    oneshotDialog(1,'URL parameter error:<br>missing essential parameter "genome"');
	    return;
	}
	if(pmhash.genome.length == 0) {
	    oneshotDialog(1, 'URL parameter error:<br>"genome" parameter got 0 length value');
	    return;
	}
	gflag.urlparam.hash = pmhash;
	// but we need to validate dbname before doing anything
	ajax2('validateurlparam_genome='+gflag.urlparam.hash.genome, function(retext){
	    if(retext == 'NULL') {
	        // invalid dbname
		oneshotDialog(1, 'URL parameter error:<br>invalid value for "genome" parameter');
		return;
	    }
	    /* correct dbname, we can go on */
	    print2console('valid name of genome', 1);
	    gflag.urlparam.dbname = retext;
	    /*** trigger - session ***/
	    if('session' in gflag.urlparam.hash) {
		if(gflag.urlparam.hash.session.length == 0) {
		    oneshotDialog(1, 'URL parameter error:<br>"session" parameter got 0 length value');
		    return;
		}
		// validate if session exists
		ajax2('dbName='+gflag.urlparam.dbname+'&validateurlparam_session=on&session='+gflag.urlparam.hash.session,function(retext) {
		    if(retext == 'NULL') {
		        oneshotDialog(1, 'URL parameter error:<br>invalid value for "session" parameter');
			return;
		    }
		    // session is valid
		    print2console('valid session id', 1);
		    gflag.urlparam.usingsession = true;
		    if(!('statusid' in gflag.urlparam.hash)) {
		        // status id is not provided
			retrieveSession();
			return;
		    }
		    if(gflag.urlparam.hash.statusid.length == 0) {
			retrieveSession();
			return;
		    }
		    /* will load up page and restore status
		       lazy code, will make dummy call of readygo to initiate browser with no tracks,
		       then will call up restoreStatus() to do it
		     */
		    gflag.urlparam.restore2stid = parseInt(gflag.urlparam.hash.statusid);
		    readygo(gflag.urlparam.dbname,false);
		});
		return;
	    }
	    /* processing additional url parameters require loading up empty browser
	       see startupflow.dia for details
	     */
	    gflag.urlparam.willcontinue = true;
	    readygo(gflag.urlparam.dbname, false);
	});
	return;
    }



    pica = document.getElementById("pica");
    picasays = document.getElementById("picasays");
    indicator = document.getElementById("indicator");
    indicator2 = document.getElementById("indicator2");
    indicator3 = document.getElementById("indicator3");
    var c = document.getElementById("indicator2leftarrow");
    indicator2.appendChild(c);
    indicator2.leftarrow = c;
    c = document.getElementById("indicator2rightarrow");
    indicator2.appendChild(c);
    indicator2.rightarrow = c;
    tracklabelholder = document.getElementById("tracklabelholder");

    vrearrangeUtil.holder = document.getElementById('vrearrangeHolder');
    vrearrangeUtil.holder.style.display = 'block';
    var rd = document.getElementById('vrearrange_veil');
    rd.style.width = rd.nextSibling.clientWidth;
    vrearrangeUtil.holder.style.width = rd.nextSibling.clientWidth;
    rd.style.height = rd.nextSibling.clientHeight;
    vrearrangeUtil.holder.style.height = rd.nextSibling.clientHeight;
    vrearrangeUtil.holder.style.display = 'none';


    scaffold.cpholder = document.getElementById('scaffold_cpholder');
    scaffold.spanel = document.getElementById('scfspanel');
    scaffold.updatebutt = document.getElementById('scaffold_updatebutt');

    bev.scfd.holder = document.getElementById('genomebev_scaffoldholder');
    bev.scfd.updatebutt = document.getElementById('genomebevscfd_updatebutt');
    bev.menu = document.getElementById('bevcanvasmenu');
    
    minichrindicator = document.getElementById("minichrindicator");
    minichrindicator.style.height = ideogram.minicanvasheight+4;
    minichrcanvasdiv = document.getElementById("minichrcanvasdiv");
    minichrcanvasdiv.style.height = ideogram.minicanvasheight+5;
    minichrrulerdiv = document.getElementById("minichrrulerdiv");
    rulercanvas = document.getElementById("rulercanvas");
    rulercanvas.ctx = rulercanvas.getContext('2d');
    tksSmallmenu = document.getElementById("tksSmallmenu");

    mdcholder = document.getElementById("mdcholder");
    mdcholder.holder = mdcholder.firstChild.firstChild;
    mdcholder.addEventListener("click", mcmSortTrack, false);
    mdcholder.moved = false;
    mdcholder.attop = true; // tells if holder be placed on top or bottom of mcm

    floatingtoolbox = document.getElementById("floatingtoolbox");
    floatingtoolbox.oldscrolltop = document.body.scrollTop;
    //window.onscroll = windowverticalscroll;

    scalebar.says = document.getElementById('scalebarsays');
    scalebar.slider = document.getElementById('scalebarslider');
    scalebar.arrow = document.getElementById('scalebararrow');
    scalebar.beam = document.getElementById('scalebarbeam');
    drawScalebarSlider();
    scalebararrowMout();
    
    qtc.slider = document.getElementById("qtc_slider");

    mdselect.main = document.getElementById('mdspanel');
    mdselect.cust = document.getElementById('mds_custommdholder');
    mdselect.custedittable = document.getElementById('custbwmd_showholder');
    mdselect.custeditholder = document.getElementById('custmd_editholder');
    newcustmd_setattrvalue();

    tkselect.main = document.getElementById('tkspanel');
    tkselect.hmdiv = document.getElementById('hmtksp_div');
    tkselect.hmholder = document.getElementById('hmtksp_holder');
    tkselect.decor.main = document.getElementById('decorsp_div');
    tkselect.decor.grpholder = document.getElementById('decorgrp_holder');
    tkselect.decor.tkholder = document.getElementById('decortk_holder');
    tkselect.smallmenu = document.getElementById('tkspanelSmallmenu');

    gsselect.main = document.getElementById('gsspanel');
    gsselect.sliderpanel = document.getElementById('gss_sliderpanel');
    gsselect.upslider = document.getElementById('gss_upslider');
    gsselect.uptrail = document.getElementById('gss_upslider_trail');
    gsselect.downslider = document.getElementById('gss_downslider');
    gsselect.downtrail = document.getElementById('gss_downslider_trail');


    document.oncontextmenu = contextMenu; // register right click action
    menu = document.getElementById("contextMenu");
    menu.decorwrapper = document.getElementById("cmoDecorWrapper");
    menu.singletkwrapper = document.getElementById("cmoSingletkWrapper");
    menu.htestwrapper = document.getElementById("cmoHtestWrapper");
    menu.pairwisecompwrapper = document.getElementById("cmoPairwisecomp");
    menu.corrwrapper = document.getElementById("cmoCorr");
    menu.mcmwrapper = document.getElementById("cmo_mcmwrapper");
    menu.context = 0; // context indicator
    menu.c1 = document.getElementById("cmo1");
    menu.c2 = document.getElementById("cmo2");
    menu.c6 = document.getElementById("cmo6");
    menu.c7 = document.getElementById("cmo7");
    menu.c8 = document.getElementById("cmo8");
    menu.c9 = document.getElementById("cmo9");
    //menu.c10 = document.getElementById("cmo10");
    //menu.c11 = document.getElementById("cmo11");
    menu.c12 = document.getElementById("cmo12");
    menu.c13 = document.getElementById("cmo13");
    menu.c14 = document.getElementById("cmo14");
    menu.c15 = document.getElementById("cmo15");
    menu.c16 = document.getElementById("cmo16");
    //menu.c17 = document.getElementById("cmo17");
    menu.c18 = document.getElementById("cmo18");
    menu.c19 = document.getElementById("cmo19");
    menu.c20 = document.getElementById("cmo20");
    menu.c21 = document.getElementById("cmo21");
    menu.c22 = document.getElementById("cmo22");
    //menu.c23 = document.getElementById("cmo23");
    menu.iX = 0; 
    menu.iY = 0;
    menu.trackIdxLst = [];
    menu.decorname = "";

    document.getElementById('geneplot_butt').addEventListener('click', makeGeneplot, false);

    ideogram.canvas = document.getElementById('ideogramCanvas');
    ideogram.canvas.ctx = ideogram.canvas.getContext('2d');
    ideogram.canvas.ctx.font = "bold 10pt Sans-serif";
    ideogram.viewbox = document.getElementById("tgt_chrbarImage");
    ideogram.wiggle1.name = null;
    ideogram.wiggle1.filetype = -1;
    ideogram.wiggle1.url = null;
    ideogram.wiggle1.hcanvas = document.getElementById('ideogram_wiggle1scale');
    ideogram.wiggle1.canvas = document.getElementById('ideogram_wiggle1canvas');
    ideogram.wiggle2.name = null;
    ideogram.wiggle2.filetype = -1;
    ideogram.wiggle2.url = null;
    ideogram.wiggle2.hcanvas = document.getElementById('ideogram_wiggle2scale');
    ideogram.wiggle2.canvas = document.getElementById('ideogram_wiggle2canvas');
    ideogram.wigglemenu = document.getElementById('ideogramwigglemenu');

    // tasks like adding htest group can only be done after html is loaded from CGI
    htest.canvas = document.getElementById('htestCanvas');
    htest.canvas.ctx = htest.canvas.getContext('2d');
    htest.canvas.height = htest.qtc.height + densitydecorpaddingtop*2;
    htest.header = document.getElementById('htestHeaderCanvas');
    htest.header.width = leftColumnWidth;
    htest.header.height = htest.canvas.height;
    htest.holder = document.getElementById('tgt_htestCanvas');
    htest.qtc.pvcutoff = parseFloat(getSelectValueById('pvcutoff'));
    htest.qtc.pvccolor = document.getElementById('htest_clc').style.backgroundColor;

    pwc.canvas = document.getElementById("pairwisecompCanvas");
    pwc.canvas.height = pwc.qtc.height + densitydecorpaddingtop*2;
    pwc.holder = document.getElementById("tgt_pairwisecompCanvas");
    pwc.holder.style.height = pwc.canvas.height;
    pwc.header = document.getElementById("pairwisecompHeaderCanvas");
    pwc.header.height = pwc.canvas.height;

    c = document.getElementById("basepairlegend");
    ctx = c.getContext("2d");
    ctx.fillStyle = ntbcolor.a;
    ctx.fillRect(0,0,15,c.height);
    ctx.fillStyle = ntbcolor.t;
    ctx.fillRect(16,0,15,c.height);
    ctx.fillStyle = ntbcolor.c;
    ctx.fillRect(32,0,15,c.height);
    ctx.fillStyle = ntbcolor.g;
    ctx.fillRect(48,0,15,c.height);
    ctx.fillStyle = ntbcolor.n;
    ctx.fillRect(64,0,15,c.height);
    ctx.fillStyle = "white";
    ctx.font = "bold 10pt Sans-serif";
    ctx.fillText("A", 3,10);
    ctx.fillText("T", 19,10);
    ctx.fillText("C", 35,10);
    ctx.fillText("G", 51,10);
    ctx.fillText("N", 67,10);

    corrHolder = document.getElementById('tgt_corrCanvas');
    corrHolder.style.width = leftColumnWidth;
    tkAttrHolder = document.getElementById('tgt_trackAttr');
    stripChild(tkAttrHolder, 0);
    tkAttrHolder.addEventListener("mouseover", tooltipshow, false);
    tkAttrHolder.addEventListener("mouseout", tooltiphide, false);
    tkAttrHolder.addEventListener("mousemove", tooltipmove, false);
    tkAttrHolder.addEventListener("mousedown", movetkgrpMD, false);
    palette = document.getElementById('palette');
    palette.grove = document.getElementById('palettegrove');
    palette.slider = document.getElementById('paletteslider');

    // correlation scale canvas
    drawCorrscalecanvas();



    /* decide hmSpan
       the 120 is a guess of default width of mdcholder.holder,
       will be determined by # terms shown on default
     */
    var blen = document.body.clientWidth;
    var tobe = blen - leftColumnWidth - 120;
    hmSpan = parseInt(hmSpan/10) * 10; // well, just to cope with letter display
    if(tobe < 800)
        hmSpan = 800;
    else if(tobe > 1200)
        hmSpan = 1200;
    else
        hmSpan = tobe;

    viewbox = document.getElementById('viewbox');
    stripChild(viewbox, 0);
    viewbox.style.width = hmSpan;
    viewbox.addEventListener("mouseover", tooltipshow, false);
    viewbox.addEventListener("mouseout", tooltiphide, false);
    viewbox.addEventListener("mousemove", tooltipmove, false);
    viewbox.addEventListener("mousedown", viewboxMD, false);
    viewbox.tknameshow = false; // tells if hmtk names are shown

    ideogram.minicanvaswidth = hmSpan - parseInt(document.getElementById('hmdspinfoholder').style.width)-10;
    //document.getElementById('minichrinfoholder').style.width = ideogram.minicanvaswidth;


    print2console("page skeleton loaded", 0);

    document.body.style.cursor = "wait";

    print2console("waiting for server...", 0);
    ajax('first=on&dbName='+arguments[0]+(arguments[1]?'':'&noDefaultcontent=on'), function(data){

        print2console("parsing server data...", 0);

	// might need to turn off gene related components
	gflag.hasgene = data.hasGene==1;
	gflag.allowjuxtaposition = data.allowJuxtaposition==1;
	document.getElementById('cpbar_geneset').style.display = gflag.hasgene ? 'block' : 'none';
	document.getElementById('geneplot_apptr').style.display = gflag.hasgene ? 'table-row' : 'none';
	document.getElementById('bbg_apptr').style.display = gflag.hasgene ? 'table-row' : 'none';
	document.getElementById('jumpgene').disabled = !gflag.hasgene;
	document.getElementById('cpbar_juxtapose').style.display = gflag.allowjuxtaposition ? 'block' : 'none';
	//document.getElementById('cmo12').style.display = gflag.allowjuxtaposition ? 'block' : 'none';
	//document.getElementById('cmo2').style.display = gflag.allowjuxtaposition ? 'block' : 'none';


        if('serverload' in data) {
	    var lst = data.serverload.split(' ');
	    document.getElementById('serverload').innerHTML = 'Server load: '+lst[lst.length-3]+' '+lst[lst.length-2]+' '+lst[lst.length-1];
	} else {
	    document.getElementById('serverload').innerHTML = "Server load unavailable";
	}

	geneplot.maxbigbeditemnumber = data['MaxBigbeditem4geneplot'];

	if(!("dblist" in data)) fatalError("readygo: dblist missing");
	var dblist = data.dblist;

	if(!("currentDb" in data))
	    fatalError('readgo: currentDb missing');
	dbInfo = data["currentDb"];

	// stuff species menu
	var bait3 = document.getElementById('bait3');
	stripChild(bait3.firstChild, 0);
	for(var i=0; i<dblist.length; i++) {
	    if(dblist[i][0] == dbInfo.name) {
	        document.getElementById('hook3').style.color = dblist[i][3];
		continue;
	    }
	    var td = bait3.insertRow(-1).insertCell(0);
	    td.className = 'headerTd2';
	    td.style.backgroundImage = "url('images/"+dblist[i][2]+".png')";
	    td.style.width = '257px';
	    td.style.color = dblist[i][3];
	    td.innerHTML = dblist[i][1];
	    td.dbname = dblist[i][0];
	    td.addEventListener('click', changedb, false);
	}
	document.getElementById('hook3').innerHTML = dbInfo.organism + '&nbsp;&nbsp;&#9662;';
	document.getElementById('genomelogoartholder').style.backgroundImage="url('images/"+dbInfo.organism+".png')";


        /**** lots of housekeeping stuff...
	 ****/

	if(!('decorInfo' in data)) fatalError("readygo: decorInfo missing");
	decorInfo = data.decorInfo;

	if(!('gfGrouping' in data)) fatalError("readygo: gfGrouping missing");
	decorGrouping = data.gfGrouping;
	// make sure reserved group names 
	for(var i=0; i<decorGrouping.length; i++) {
	    if(decorGrouping[i][1]=='Custom bigBed tracks' || decorGrouping[i][1]=='Custom BAM track' || decorGrouping[i][1]=='Native BAM track')
	        fatalError('Decor group name collide with reserved names');
	}

        jsonParseTkMetadata(data);
	jsonParseTkDetail(data);

	if(!('mdvidx2attr' in data)) fatalError("readygo: mdvidx2attr missing");
	mdvidx2attr = data['mdvidx2attr'];
	mdvattr2idx = {};
	for(var idx in mdvidx2attr)
	    mdvattr2idx[mdvidx2attr[idx]] = idx;
	if(!('mdvc2p' in data)) fatalError("readygo: mdvc2p missing");
	mdvc2p = data['mdvc2p'];
	mdvp2c = {};
	for(var c in mdvc2p) {
	    var p = mdvc2p[c];
	    if(p in mdvp2c) {
	        mdvp2c[p].push(c);
	    } else {
	        mdvp2c[p] = [c];
	    }
	}
	// find root terms...
	mdvroot = [];
	for(var p in mdvp2c) {
	    if(!(p in mdvc2p))
	        mdvroot.push(p);
	}
	makeMetadataSelectorPanel();


	// scaffold
	if(!('scaffoldInfo' in data)) fatalError('readygo: scaffoldInfo missing');
	for(i=0; i<data.scaffoldInfo.length; i++) {
	    var lst = data.scaffoldInfo[i];
	    scaffold.c2p[lst[1]] = lst[0];
	    if(!(lst[0] in scaffold.p2c))
	        scaffold.p2c[lst[0]] = {};
	    scaffold.p2c[lst[0]][lst[1]] = 1;
	    if(lst[2] > 0) {
	        // child is sequence
		scaffold.len[lst[1]] = lst[2];
	    }
	}
	scfspanel_fillup();
	json_scaffoldRuntimeInfo(data);
	// copy scaffold info to bev.scfd.hash
	bev.scfd.hash = {};
	for(var n in chrLen)
	    bev.scfd.hash[n] = chrLen[n];
	bev.scfd.order = scaffold.cptableorder;
	// fill up genome bev scaffold holder
        scaffold_cptable_fill(2); 



	if('cytoband' in data) {
	    for(var i=0; i<data['cytoband'].length; i+=4) {
	        if(data['cytoband'][i] in ideogram.cytoband)
	            ideogram.cytoband[data['cytoband'][i]].push([data['cytoband'][i+1], data['cytoband'][i+2], data['cytoband'][i+3]]);
	        else
	            ideogram.cytoband[data['cytoband'][i]] = [[data['cytoband'][i+1], data['cytoband'][i+2], data['cytoband'][i+3]]];
	    }
	}
	onetimedeal_drawChromIdeogramAll();

	// greetings
	document.getElementById("greetingmsg").innerHTML = data["greeting"];

	/********************
	     deposit HTML
	 ********************/
	for(var trigger in data) {
	    if(trigger.substr(0,4) == 'tgt_') {
	        var h = document.getElementById(trigger);
		if(h == null) fatalError("missing holder: "+trigger);
	        h.innerHTML = data[trigger];
	    }
	}

	// after depositing HTML...
	var lst = document.getElementsByName('cptab4move');
	for(var i=0; i<lst.length; i++) {
	    if(lst[i].getAttribute('active') == '1') {
	        lst[i].style.cursor = 'move';
		lst[i].addEventListener('mousedown', cpmoveMD, false);
	    }
	}

	onetimedeal_registerserverdecor();

	if(gflag.hasgene)
	    document.getElementById("genelisttextarea").value = data.defaultGenelist;
	if(!("defaultCustombigwig" in data)) fatalError("readygo: defaultCustombigwig missing");
	document.getElementById("newcustombigwigfileurl").value = data["defaultCustombigwig"];
	if(!("defaultCustombigbed" in data)) fatalError("readygo: defaultCustombigbed missing");
	document.getElementById("newcustombigbedfileurl").value = data["defaultCustombigbed"];
	if(!("defaultCustombam" in data)) fatalError("readygo: defaultCustombam missing");
	document.getElementById("newcustombamfileurl").value = data["defaultCustombam"];
	if(!("keggSpeciesCode" in data)) fatalError("readygo: keggSpeciesCode missing");
	dbInfo.keggspeciescode = data["keggSpeciesCode"];
	document.getElementById("examplekeggpathid").innerHTML = "path:"+dbInfo.keggspeciescode+"00010";
	initiateTrackControlpanel();
	mdselect.custpriortable3 = document.getElementById('custpriorholder3');
	mdselect.custpriortable1 = document.getElementById('custpriorholder1');
	mdselect.custpriortable5 = document.getElementById('custpriorholder5');

	document.getElementById('samplehuburl').innerHTML = ('samplehub' in data) ? '<a onclick="document.getElementById(\'datahuburl\').value=\''+data.samplehub+'\'">( click for a sample )</a>' : '';

	if(gflag.hasgene)
	    genesetview.lstholder = document.getElementById('collategenesetholder');

	addhtestgroup();
	addhtestgroup();

	addpwcgroups();
	pwc.grp1 = document.getElementById("pairwisecompgroup1");
	pwc.grp2 = document.getElementById("pairwisecompgroup2");

        if('mdcategoryonshow' in data)
	    mdcategoryOnshow = data.mdcategoryonshow;
        initiateMdcOnshowCanvas();

        // bird's eye view table initiation
	genomebev_initiateViewtable();


	// toggle a select so that R options will be shown
	var e = document.createEvent("MouseEvents");
	e.initMouseEvent("change", true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
	document.getElementById('geneplotrender').dispatchEvent(e);


	// dataset
	if(!("dataset" in data)) fatalError("readygo: missing dataset");
	datasetLst.push(data["dataset"]);
	// toggle the switch
	for(i=0; i<datasetLst.length; i++) {
	    toggleOnDataset(datasetLst[i]);
	}


	if(data.firstdecors != undefined) {
	    // decors that are turned on by start
	    lst = data.firstdecors;
	    for(i=0; i<lst.length; i+=2) {
	        decorInfo[lst[i]].mode = lst[i+1];
	        decoruserlist_insert(lst[i]);
	    }
	}

        setDisplaywhichgf();

	if(!('session' in data)) fatalError("jsonkey session missing");
	sessionId = data['session'];
	document.getElementById('sessionId').innerHTML = sessionId;
	statusId = 1;

	/* set small wiggle for small ideogram
	   small wiggle will be made in jsonXY
	 */
	if('ideogram_wiggle1' in data) {
	    lst = data.ideogram_wiggle1.split(',');
	    var ft = parseInt(lst[1]);
	    if(ft==1 || ft==3 || ft==4 || ft==5) {
	        print2console('upper wiggle filetype not supported', 2);
	    } else {
	        ideogram.wiggle1.name = lst[0];
		ideogram.wiggle1.filetype = ft;
		ideogram.wiggle1.label = ft==0 ? decorInfo[lst[0]].label : hmtk.tolabel[lst[0]];
	    }
	}
	if('ideogram_wiggle2' in data) {
	    lst = data.ideogram_wiggle2.split(',');
	    var ft = parseInt(lst[1]);
	    if(ft==1 || ft==3 || ft==4 || ft==5) {
	        print2console('lower wiggle filetype not supported', 2);
	    } else {
	        ideogram.wiggle2.name = lst[0];
		ideogram.wiggle2.filetype = ft;
		ideogram.wiggle2.label = ft==0 ? decorInfo[lst[0]].label : hmtk.tolabel[lst[0]];
	    }
	}
	if(ideogram.wiggle1.name==null)
	    draw_ideogramWiggle_nothing();
	if(ideogram.wiggle2.name==null) {
	    ideogram.wiggle2.hcanvas.style.display = 'none';
	    ideogram.wiggle2.canvas.style.display = 'none';
	}

	jsonXY(data);

	//helpAnimId = setInterval(hadraw, 30);
        findPos(); // only do when the dust settles down...

	mdcholder.style.left = iiiX;
	mdcholder_place();

        scalebarSlider_fill();

        print2console("browser is up!", 1);

	//if(msgconsole.style.display == 'block')
	//    setTimeout("toggle27()", 1000);

	if(gflag.urlparam.usingsession) {
	    /* just a quick fix
	       work for restoring status by url param request
	     */
	    gflag.urlparam.usingsession = false;
	    document.getElementById('oldSessionId').value = gflag.urlparam.hash.session;
	    retrieveSession();
	    statusId = gflag.urlparam.restore2stid;
	    sessionId = gflag.urlparam.hash.session;
	    document.getElementById('sessionId').innerHTML = sessionId;
	    document.body.removeChild(document.getElementById('oneshot'));
	    document.getElementById('pagecloak').style.display = 'none';
	    ajaxRestorestatus();
	    return;
	}
	if(gflag.urlparam.willcontinue) {
	    /* additional url parameter to be dealt with
	       but don't need to call readygo() again
	     */
	    // add metadata here
	    if('metadata' in gflag.urlparam.hash) {
	        if(gflag.urlparam.hash.metadata.length == 0) {
		    print2console('URL parameter error: "coordinate" parameter got 0 length value', 2);
		} else {
		    var lst = gflag.urlparam.hash.metadata.split(',');
		    var toadd = {};
		    for(var i=0; i<lst.length; i++) {
		        if(lst[i].length > 0) {
			    if(lst[i] in mdvp2c) {
			        // this is non-leaf term
				toadd[lst[i]] = 1;
			    } else {
			        // check if it is leaf term
				for(var id in mdvidx2attr) {
				    if(mdvidx2attr[id] == lst[i]) {toadd[id]=1;break;}
				}
			    }
			}
		    }
		    mdselect.which = 1;
		    lst = document.getElementsByName('mdcheckbox');
		    for(i=0; i<lst.length; i++) {
		        if(lst[i].getAttribute('termidx') in toadd) {
			    lst[i].checked = true;
			    var e = document.createEvent("MouseEvents");
			    e.initMouseEvent("change",true,true,window,0,0,0,0,0,false,false,false,false,0,null);
			    lst[i].dispatchEvent(e);
			}
		    }
		}
		delete gflag.urlparam.hash.metadata;
	    }
	    /*** X axis contents can be determined in following ways
	         * one coordinate (genome or juxtapose over a bigbed track)
		 * gene set view
		 these are exclusive of each other
	     ***/
	    if('coordinate' in gflag.urlparam.hash || 'juxtapose' in gflag.urlparam.hash) {
	        var startchr = regionLst[dspBoundary.vstartr][0];
        	var startcoord = entire.atbplevel?(regionLst[dspBoundary.vstartr][3]+dspBoundary.vstarts):getPointCoord(dspBoundary.vstartr,dspBoundary.vstarts);
		var stopchr = regionLst[dspBoundary.vstopr][0];
        	var stopcoord = entire.atbplevel?(regionLst[dspBoundary.vstopr][3]+dspBoundary.vstops):getPointCoord(dspBoundary.vstopr,dspBoundary.vstops);
		if('coordinate' in gflag.urlparam.hash) {
		    var s = gflag.urlparam.hash.coordinate;
		    var pos = [null, NaN, NaN];
		    if(s.length == 0) {
			print2console('URL parameter error: "coordinate" parameter got 0 length value', 2);
		    } else {
		        // parse user provided coord string, must be in form of chr1:300-400
			if(s.indexOf(':') == -1) {
			    print2console('URL parameter error: irregular "coordinate" parameter value', 2);
			} else {
			    var t1 = s.split(':');
			    pos[0] = t1[0];
			    if(t1[1].indexOf('-') == -1) {
			        print2console('URL parameter error: irregular "coordinate" parameter value', 2);
			    } else {
			        var t2 = t1[1].split('-');
				pos[1] = parseInt(t2[0]); pos[2] = parseInt(t2[1]);
			    }
			}
		    }
		    if(pos[0]!=null && !isNaN(pos[1]) && !isNaN(pos[2])) {
		        startchr = stopchr = pos[0];
			startcoord = pos[1];
			stopcoord = pos[2];
		    }
		}
		var param = 'changeGF=on&dbName='+dbInfo.name+'&startChr='+startchr+'&startCoord='+startcoord+'&stopChr='+stopchr+'&stopCoord='+stopcoord;
		juxtaposition.type = 0;
		juxtaposition.note = 'genome';
		juxtaposition.what = 'genome';


		if('juxtapose' in gflag.urlparam.hash) {
		    var bbf = gflag.urlparam.hash.juxtapose;
		    if(bbf.length == 0) {
			print2console('URL parameter error: "juxtapose" parameter got 0 length value', 2);
			param += '&gftype=genome';
		    } else {
		        if('juxtaposecustom' in gflag.urlparam.hash) {
			    // custom bigbed, TODO validate url?
			    juxtaposition.type = 2;
			    juxtaposition.note = "custom bigBed track";
			    juxtaposition.what = bbf;
			    param += '&gftype='+bbf+'&gfiscustom=on';
			} else {
			    if(bbf in decorInfo && decorInfo[bbf].fileType==0) {
			        // server bigbed
				juxtaposition.type = 1;
				juxtaposition.note = decorInfo[bbf].label;
				juxtaposition.what = bbf;
				param += '&gftype='+bbf;
			    } else {
				print2console('URL parameter error: invalid server bigBed file name provided for "juxtapose"', 2);
				param += '&gftype=genome';
			    }
			}
		    }
		}
		setDisplaywhichgf();
		juxtaposeHideOptions();

		print2console("adjusting displayed region by url parameter...", 0);
		// somewhat duplicative with ajaxX
		ajax(param, function(data){
		    if('newscaffold' in data) {
			chrLen[data.newscaffold[0]] = data.newscaffold[1];
			border.rname = data.newscaffold[0];
			border.rpos = data.newscaffold[1];
			scaffold_cptable_insert(border.rname, 'transparent', 1);
		    }
		    jsonX(data);
		    print2console("done", 1);
		    urlparam_handleTriggers();
		});
		return; // must quit here
	    } else if('geneset' in gflag.urlparam.hash) {
	        var s = gflag.urlparam.hash.geneset;
		if(s.length==0 || s.indexOf(',')==-1) {
		    print2console('URL parameter error: "geneset" parameter got invalid value', 2);
		    // won't quit but will go on to process remaining params
		} else {
		    document.getElementById('genelisttextarea').value = s.split(',').join('\n');
		    submitCustomgeneset();
		    return; // must quit here
		}
	    }
	    /* here means it won't change coordinate, remain as default
	       continue to process triggers 
	     */

	    urlparam_handleTriggers();
	}
    });
}
